$(document).ready(function () {
    $("#Cliente").autocomplete({
        width: 260,
        selectFirst: true,
        scroll: true,
        cacheLength: 100,
        max: 100,
        minLength: 3,
        source: "./busca_cliente.php"
    });

    $('#modalAgendamento form').submit(function (event) {
        event.preventDefault();
    })
});

function criarAgenda() {
    let consultor = $('#Especialista').val();
    let cliente = $("#Cliente").val();
    let horaInicio = $("#horaInicioAgenda").val();
    let horaFinal = $("#horaFimAgenda").val();
    let obsAgenda = $("#obsAgenda").val();
    let dia = $('#diaSelecionado').val();
    let mes = $('#mesSelecionado').val();
    let mesExtenso = $('#mesExtensoSelecionado').val();
    let ano = $('#anoSelecionado').val();
    let sala = $('#Sala').val();

    if (consultor == "" || cliente == "" || horaInicio == "" || horaFinal == "") {
        alert("Todos os campos so obrigatrios.");
        return false;
    } else {
        $.post('./criar_agenda.php', {
            consultor,
            cliente,
            dia,
            mes,
            mesExtenso,
            ano,
            horaInicio,
            horaFinal,
            obsAgenda,
            sala
        }, function (data) {
            let retorno = JSON.parse(data);
            if (retorno.atendimento == false) {
                alert("J existe um agendamento cadastrado dentro do horrio informado para esse especialista");
            } else {

                $("#modalAgendamento").modal('hide');

                if (retorno.idAgendamento != '') {
                    carregarAgendamento();

                    let qtdAgenda = $(`.day[data-dia=${dia}] .qtdAgendamento`).html();
                    if (qtdAgenda >= 1) {
                        qtdAgenda = parseFloat(qtdAgenda) + 1;
                        $(`.day[data-dia=${dia}] .qtdAgendamento`).html(qtdAgenda)
                    } else {

                        $(`.day[data-dia=${dia}]`).addClass('bordaAgendamento')

                        $(`.day[data-dia=${dia}]`).append(`
                        <span class="qtdAgendamento">1</span>
                    `)
                    }
                }
            }
        })
    }
}

function carregarAgendamento() {

    $("#dataAgenda").html('');
    $("#agendamentos").html('');

    let dia = $('#diaSelecionado').val();
    let diaExtenso = $('#diaExtensoSelecionado').val();
    let mes = $('#mesSelecionado').val();
    let mesExtenso = $('#mesExtensoSelecionado').val();
    let ano = $('#anoSelecionado').val();
    $.post('./carregar_agendamento.php', {
        dia,
        mes,
        ano
    }, function (data) {
        let retorno = JSON.parse(data)

        if (retorno.length == 0) {
            $("#dataAgenda").append(`
                <div class="d-flex fs-5 gap-2 m-1">
                    <div>
                        <span>${diaExtenso}</span>
                    </div>
                    <div>
                        <span>${dia} - ${mesExtenso[0].toUpperCase()}${mesExtenso.substr(1)} - ${ano}</span>
                    </div>
                </div>
                    <div>
                        <p class="text-danger">Nenhum agendamento encontrado!</p>
                    </div>
                `)
            return;
        } else {
            $("#dataAgenda").append(`
                <div class="d-flex fs-5 gap-2 m-1">
                    <div>
                        <span>${diaExtenso}, </span>
                    </div>
                    <div>
                        <span>${dia} - ${mesExtenso[0].toUpperCase()}${mesExtenso.substr(1)} - ${ano}</span>
                    </div>
                </div>
                `)
        }
        retorno.map((agendamento) => {
            $("#agendamentos").append(`
                <div class="container">
                    <div class="d-flex row rounded-1 informacaoAgendamento ${agendamento.status == 'Finalizado' ? 'agendamentoFinalizado' : 'agendamentoAberto'}" style="padding:5px 10px" data-id='${agendamento.idAgendamento}'>
                        <div class="col-8 p-1">
                            <div class="d-flex">
                                <span class="w-25"><i class="bi bi-clock"></i> ${agendamento.horaInicio} - ${agendamento.horaFinal}</span>
                                <span>${agendamento.cliente}</span>
                            </div>
                            <div class="d-flex">
                                <span class="w-25"><i class="bi bi-door-open"></i>${agendamento.sala}</span>
                                <span>${agendamento.especialista}</span>
                            </div>
                        </div>
                        <div class="col-2 d-flex justify-content-start align-items-center gap-3">
                            <a href="./zap.php?id_agenda=${agendamento.idAgendamento}" target="_blank"><img class="iconeAgendamentos" src="../imagem/whatsapp.png" title="Whatsapp" alt="Whatsapp" border="0" /></a>
                            ${agendamento.status != 'Finalizado' ? `<a class="btnAlterar" href='#'><img class="iconeAgendamentos" src="../imagem/bt_editar.png" title="Alterar" alt="Alterar" border="0" /></a>` : ''}
                            ${agendamento.prontuario == true ? `<a class="btnVizualizar" href="./ver_prontuario.php?id_prontuario=${agendamento.idProntuario}"  target="_blank"><img class="iconeAgendamentos" src="../imagem/bt_visualizar.png" title="Vizualizar Pronturio" alt="Vizualizar Pronturio" border="0" /></a>` : ''}
                            <a class="btnExcluir" href='#'><img class="iconeAgendamentos" src="../imagem/bt_excluir.png" title="Cancelar Agenda" alt="Cancelar Agenda" border="0" /></a>
                            <a class="btnConverter" href='#'><img class="iconeAgendamentos" src="../imagem/bt_pedido.png" title="Converter em Venda" alt="Converter em Venda" border="0" /></a>
                            ${agendamento.status != 'Finalizado' ? `<a class="btnFinalizar" href='#'><img class="iconeAgendamentos" src="../imagem/bt_lida.png" title="Finalizar Agenda" alt="Finalizar Agenda" border="0" /></a>` : ''}
                            <a href="./declaracao.php?id_agenda=${agendamento.idAgendamento}" target="_blank"><img class="iconeAgendamentos" src="../imagem/bt_pedido.png" title="Declarao" alt="Declarao" border="0" /></a>

                        </div>
                    </div>
                </div>
            `)
        })
    })
}

$('body').on('click', '.day', function () {
    let dia = $(this).attr('data-dia');
    let diaExtenso = $(this).attr('data-diaextenso');
    let mes = $(this).attr('data-mes');
    let mesExtenso = $(this).attr('data-mesextenso');
    let ano = $(this).attr('data-ano');

    $('#diaSelecionado').val(dia);
    $('#diaExtensoSelecionado').val(diaExtenso);
    $('#mesSelecionado').val(mes);
    $('#mesExtensoSelecionado').val(mesExtenso);
    $('#anoSelecionado').val(ano);

    carregarAgendamento();

})

$('body').on('click', '#agendar', function () {
    $('#modalAgendamento').modal('show');
});

const modalAgendamento = document.getElementById('modalAgendamento');
modalAgendamento.addEventListener('show.bs.modal', () => {
    $('#modalListAgenda').css('z-index', 1040)
})
modalAgendamento.addEventListener('hide.bs.modal', () => {
    $('#modalListAgenda').css('z-index', 1055)
    $('#modalAgendamento form')[0].reset()
})


const modalListAgenda = document.getElementById('modalListAgenda')
modalListAgenda.addEventListener('hide.bs.modal', () => {
    $("#dataAgenda").html('');
    $("#agendamentos").html('');
})


$('body').on('click', '.btnAlterar', function () {
    let idAgendamento = $(this).parents('.informacaoAgendamento').attr('data-id');
    $.post('./busca_dados_agendamento.php', {
        idAgendamento
    }, function (data) {
        let retorno = JSON.parse(data);

        // preencher os campos do modal com os dados do agendamento
        $("#Especialista").val(retorno.especialista);
        $("#Cliente").val(retorno.codigoCliente + ` : ` + retorno.cliente);
        $("#horaInicioAgenda").val(retorno.horaInicio);
        $("#horaFimAgenda").val(retorno.horaFinal);
        $("#obsAgenda").val(retorno.obs);
        $("#Sala").val(retorno.sala);

        $("#criarAgendamento").removeAttr("onclick");
        $("#criarAgendamento").attr('onclick', `alterarAgenda('${retorno.idAgendamento}');`);

        // mostrar o modal para alterar dados
        $('#modalAgendamento').modal('show');
    })
});

function alterarAgenda(id) {
    let consultor = $('#Especialista').val();
    let cliente = $("#Cliente").val();
    let horaInicio = $("#horaInicioAgenda").val();
    let horaFinal = $("#horaFimAgenda").val();
    let obsAgenda = $("#obsAgenda").val();
    let sala = $('#Sala').val();

    if (consultor == "" || cliente == "" || horaInicio == "" || horaFinal == "") {
        alert("Todos os campos so obrigatrios.");
        return false;
    } else {
        $.post('./alterar_agenda.php', {
            consultor,
            cliente,
            horaInicio,
            horaFinal,
            obsAgenda,
            sala,
            id
        }, function (data) {
            let retorno = JSON.parse(data);

            // limpando modal
            $("#Especialista").val('');
            $("#Cliente").val('');
            $("#horaInicioAgenda").val('');
            $("#horaFimAgenda").val('');
            $("#obsAgenda").val('');
            $('#Sala').val('');


            $("#modalAgendamento").modal('hide');

            if (retorno.idAgendamento != '') {
                carregarAgendamento();
            }
        })
    }
}

$('body').on('click', '.btnExcluir', function () {
    let resultado = confirm('Deseja cancelar este agendamento ?');

    if (resultado == true) {
        let idAgendamento = $(this).parents('.informacaoAgendamento').attr('data-id');
        $.post('./cancelar_agenda.php', {
            idAgendamento
        }, function (data) {
            location.reload();
        })
    }
});

$('body').on('click', '.btnFinalizar', function () {
    let resultado = confirm('Deseja finalizar este agendamento ?');

    if (resultado == true) {
        let idAgendamento = $(this).parents('.informacaoAgendamento').attr('data-id');
        $.post('./finalizar_agenda.php', {
            idAgendamento
        }, function (data) {
            location.reload();
        })
    }
});

$('body').on('click', '.btnConverter', function () {
    let resultado = confirm('Deseja converter este agendamento ?');

    if (resultado == true) {
        let idAgendamento = $(this).parents('.informacaoAgendamento').attr('data-id');
        $.post('./converter_agenda.php', {
            idAgendamento
        }, function (data) {
            let retorno = JSON.parse(data);

            alert(`Agendamento convertido para venda N ${retorno.lancamento} !`)
        })
    }
});


let arrayIdProfissional = [];

$('input:checkbox').click(function () {
    let dia = $('#diaSelecionado').val();
    let mes = $('#mesSelecionado').val();
    let ano = $('#anoSelecionado').val();
    let checked = $(this).is(':checked');
    let idProfissional = $(this).val();


    if (checked == true) {
        arrayIdProfissional.push(idProfissional);
    } else {
        let index = arrayIdProfissional.indexOf(idProfissional);
        if (index > -1) {
            arrayIdProfissional.splice(index, 1);
        }
    }

    $.post('./filtrar_agendamento.php', {
        arrayIdProfissional,
        dia,
        mes,
        ano
    }, function (data) {
        $("#agendamentos").html('');
        let retorno = JSON.parse(data);

        retorno.map((agendamento) => {
            $("#agendamentos").append(`
                <div class="container">
                    <div class="d-flex row rounded-1 informacaoAgendamento ${agendamento.status == 'Finalizado' ? 'agendamentoFinalizado' : 'agendamentoAberto'}" style="padding:5px 10px" data-id='${agendamento.idAgendamento}'>
                        <div class="col-8 p-1">
                            <div class="d-flex">
                                <span class="w-25"><i class="bi bi-clock"></i> ${agendamento.horaInicio} - ${agendamento.horaFinal}</span>
                                <span>${agendamento.cliente}</span>
                            </div>
                            <div class="d-flex">
                                <span class="w-25"><i class="bi bi-door-open"></i>${agendamento.sala}</span>
                                <span>${agendamento.especialista}</span>
                            </div>
                        </div>
                        <div class="col-2 d-flex justify-content-start align-items-center gap-3">
                            ${agendamento.status != 'Finalizado' ? `<a class="btnAlterar" href='#'><img class="iconeAgendamentos" src="../imagem/bt_editar.png" title="Alterar" alt="Alterar" border="0" /></a>` : ''}
                            ${agendamento.prontuario == true ? `<a class="btnVizualizar" href="./ver_prontuario.php?id_prontuario=${agendamento.idProntuario}"  target="_blank"><img class="iconeAgendamentos" src="../imagem/bt_visualizar.png" title="Vizualizar Prontuario" alt="Vizualizar Prontuario" border="0" /></a>` : ''}
                            <a class="btnExcluir" href='#'><img class="iconeAgendamentos" src="../imagem/bt_excluir.png" title="Cancelar Agenda" alt="Cancelar Agenda" border="0" /></a>
                            <a class="btnConverter" href='#'><img class="iconeAgendamentos" src="../imagem/bt_pedido.png" title="Converter em Venda" alt="Converter em Venda" border="0" /></a>
                            ${agendamento.status != 'Finalizado' ? `<a class="btnFinalizar" href='#'><img class="iconeAgendamentos" src="../imagem/bt_lida.png" title="Finalizar Agenda" alt="Finalizar Agenda" border="0" /></a>` : ''}
                            <a href="./declaracao.php?id_agenda=${agendamento.idAgendamento}" target="_blank"><img class="iconeAgendamentos" src="../imagem/bt_pedido.png" title="Declarao" alt="Declarao" border="0" /></a>
                        </div>
                    </div>
                </div>
            `)
        })
    })

});


