<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa

if(isset($_GET['id']) && isset($_GET['tipo'])) {
    $id = addslashes($_GET['id']);
    $tipo = addslashes($_GET['tipo']);
}
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Catlogo Restaurante</title>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tableless.css" />
    <link rel="stylesheet" href="./css/style.css">
    <link rel="stylesheet" href="./css/composicao.css">
    <link rel="stylesheet" type="text/css" href="../js/jquery-ui/jquery-ui.min.css" />
</head>
<body>
    <div class="conteudo envolve">
        <h2>Catlogo de Itens</h2>
        <div class="composicao">
            <div class="d-flex flex-column gap-1 w-30">
                <h3>Composio</h3>
                <?php
                if(isset($_GET['tipo']) && $_GET['tipo'] == 'composicao') {
                    $getIdProduto = $con->query("SELECT Id_Produto FROM produto_composicao WHERE md5(Id) = '$id'");
                    $idProduto = $getIdProduto->fetch_assoc()['Id_Produto'];
                    $getProduto = $con->query("SELECT Codigo, Titulo FROM produto WHERE Id = '$idProduto'");
                    $produto = $getProduto->fetch_assoc();
                }?>
                <div class="d-flex flex-column gap-10px">
                    <label class="subtitulo">Produto</label>
                    <input type="text" class="pesquisarProduto" id="produtoIngrediente" value="<?=isset($produto) ? "{$produto["Codigo"]} : {$produto["Titulo"]}" : "";?>">
                </div>
            </div>
            <div class="d-flex flex-column gap-1 w-50">
                <h3>Ingredientes</h3>
                <div class="d-flex gap-2">
                    <div class="d-flex flex-column gap-10px w-50">
                        <label class="subtitulo">Categoria</label>
                        <?php
                        $getCategorias = $con->query("SELECT Id, Titulo FROM categoria_produto
                            WHERE Ativo = 'Sim' AND Ingrediente = 'Sim' AND Id_Pai = 0 ORDER BY Titulo");
                        $categorias = $getCategorias->fetch_all(MYSQLI_ASSOC);
                        ?>
                        <select id="categoriaIngredientes">
                            <option value="" disabled selected>Selecione</option>
                            <?php
                            foreach ($categorias as $categoria) {?>
                                <option value="<?=$categoria['Id'];?>"><?=$categoria['Titulo'];?></option>
                                <?php
                            }?>
                        </select>
                    </div>
                    <div class="d-flex flex-column gap-10px w-50">
                        <label class="subtitulo">Subcategoria</label>
                        <select id="subcategoriaIngredientes" disabled>
                            <option value="" disabled selected>Selecione</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="ingrediantesProduto">
                <div class="d-flex flex-column gap-10px">
                    <span class="subtitulo">No adicionados</span>
                    <div class="listaIngredientes" id="adicionarIngredientes">
                    </div>
                </div>
                <img src="../imagem/seta-direita.png" alt="">
                <div class="d-flex flex-column gap-10px">
                    <span class="subtitulo">Adicionados</span>
                    <div class="listaIngredientes" id="ingredientesAdicionados">
                        <?php
                        if(isset($_GET['tipo']) && $_GET['tipo'] == 'composicao') {
                            $getIngredientes = $con->query("SELECT produto.Id, produto.Titulo, produto_composicao_ingrediente.Qtd_Minima,
                                produto_composicao_ingrediente.Qtd_Maxima, produto_composicao_ingrediente.Qtd_Padrao FROM produto
                                INNER JOIN produto_composicao_ingrediente on produto_composicao_ingrediente.Id_Produto_Complemento = produto.Id
                                WHERE md5(produto_composicao_ingrediente.Id_Composicao) = '$id'") or die($con->error);
                            $ingredientes = $getIngredientes->fetch_all(MYSQLI_ASSOC);

                            foreach ($ingredientes as $indice => $ingrediente){?>
                                <div class="ingrediente" data-idProduto="<?=$ingrediente["Id"];?>">
                                    <span class="nomeIngrediente"><?=$ingrediente["Titulo"];?></span>
                                    <div class="qtdIngrediente">
                                        <span class="qtdMinimaIngrediente">Mn: <?=$ingrediente['Qtd_Minima'];?></span>
                                        <span class="qtdMaximaIngrediente">Mx: <?=$ingrediente['Qtd_Maxima'];?></span>
                                        <span class="qtdPadraoIngrediente">Pad: <?=$ingrediente['Qtd_Padrao'];?></span>
                                    </div>
                                    <div class="botoes-ingrediente">
                                        <button class="removerIngrediente">
                                            <img src="../imagem/bt_sair.png" alt="">
                                        </button>
                                    </div>
                                    <input name='ingredientes[<?=$indice;?>][qtdMinimaIngrediente]' type="hidden" value="<?=$ingrediente['Qtd_Minima'];?>">
                                    <input name='ingredientes[<?=$indice;?>][qtdMaximaIngrediente]' type="hidden" value="<?=$ingrediente['Qtd_Maxima'];?>">
                                    <input name='ingredientes[<?=$indice;?>][qtdPadraoIngrediente]' type="hidden" value="<?=$ingrediente['Qtd_Padrao'];?>">
                                </div>
                                <?php
                            }
                        }
                        ?>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center">
                <button class="botao" id="salvarIngredientes">Salvar</button>
            </div>
        </div>
        <div class="comboProduto" style="margin-top:25px">
            <div class="d-flex flex-column gap-1">
                <h3>Combo</h3>
                <div class="d-flex gap-2">
                    <?php
                    if(isset($_GET['tipo']) && $_GET['tipo'] == 'combo') {
                        $getComboProduto = $con->query("SELECT Id_Produto, Qtd_Maxima FROM produto_combo WHERE md5(Id) = '$id'");
                        $comboProduto = $getComboProduto->fetch_assoc();
                        $getProduto = $con->query("SELECT Codigo, Titulo FROM produto WHERE Id = '{$comboProduto['Id_Produto']}'");
                        $produtoCombo = $getProduto->fetch_assoc();
                    }?>
                    <div class="d-flex flex-column w-30 gap-10px">
                        <label class="subtitulo">Produto</label>
                        <input type="text" class="pesquisarProduto" id="produtoCombo" value="<?=isset($produtoCombo) ? "{$produtoCombo["Codigo"]} : {$produtoCombo["Titulo"]}" : "";?>">
                    </div>
                    <div class="d-flex flex-column gap-10px">
                        <label class="subtitulo">Quantidade Mxima</label>
                        <input type="text" id="qtdMaximaCombo" value="<?=isset($comboProduto) ? "{$comboProduto["Qtd_Maxima"]}" : "";?>">
                    </div>
                </div>
            </div>
            <div class="d-flex flex-column gap-1 w-30">
                <h3>Produtos</h3>
                <div class="d-flex flex-column gap-10px">
                    <label class="subtitulo">Categoria</label>
                    <?php
                    $getCategorias = $con->query("SELECT Id, Titulo FROM categoria_produto
                        WHERE Ativo = 'Sim' AND Combo = 'Sim' ORDER BY Titulo");
                    $categorias = $getCategorias->fetch_all(MYSQLI_ASSOC);?>
                    <select id="categoriaProduto">
                        <option value="" disabled selected>Selecione</option>
                        <?php
                        foreach ($categorias as $categoria) {?>
                            <option value="<?=$categoria['Id'];?>"><?=$categoria['Titulo'];?></option>
                            <?php
                        }?>
                    </select>
                </div>
            </div>
            <div class="produtosCombo">
                <div class="d-flex flex-column gap-10px">
                    <span class="subtitulo">No adicionados</span>
                    <div class="listaProdutos" id="adicionarProdutos">
                    </div>
                </div>
                <img src="../imagem/seta-direita.png" alt="">
                <div class="d-flex flex-column gap-10px">
                    <span class="subtitulo">Adicionados</span>
                    <div class="listaProdutos" id="produtosAdicionados">
                        <?php
                        if(isset($_GET['tipo']) && $_GET['tipo'] == 'combo') {
                            $getCategoriasCombo = $con->query("SELECT produto_combo_categoria.Id, produto_combo_categoria.Id_Categoria_Produto,
                                produto_combo_categoria.Id_Produto_Padrao, produto_combo_categoria.Qtd_Minima, produto_combo_categoria.Qtd_Maxima,
                                produto_combo_categoria.Qtd_Padrao, categoria_produto.Titulo as Titulo_Categoria
                                FROM produto_combo_categoria
                                INNER JOIN categoria_produto ON categoria_produto.Id = produto_combo_categoria.Id_Categoria_Produto
                                WHERE md5(produto_combo_categoria.Id_Combo) = '$id'");
                            $categoriasCombo = $getCategoriasCombo->fetch_all(MYSQLI_ASSOC);

                            foreach ($categoriasCombo as $indice => $categoriaCombo) {?>
                                <div class="grupoProduto" data-idCategoria="<?=$categoriaCombo["Id_Categoria_Produto"];?>">
                                    <div class="categoriaProdutos">
                                        <span class="nomeCategoria"><?=$categoriaCombo["Titulo_Categoria"];?></span>
                                        <button class="removerCategoria">
                                            <img src="../imagem/bt_sair.png">
                                        </button>
                                    </div>
                                    <?php
                                    $getProdutosCategoria = $con->query("SELECT produto.Id, produto.Titulo FROM produto_combo_produto
                                        INNER JOIN produto ON produto.Id = produto_combo_produto.Id_Produto
                                        WHERE produto_combo_produto.Id_Combo_Categoria = '{$categoriaCombo['Id']}'");
                                    $produtosCategoria = $getProdutosCategoria->fetch_all(MYSQLI_ASSOC);

                                    foreach ($produtosCategoria as $produtoCategoria) {?>
                                        <div class="nomeProduto" data-idProduto="<?=$produtoCategoria["Id"];?>" data-padrao="<?=$produtoCategoria["Id"] == $categoriaCombo["Id_Produto_Padrao"] ? "true" : "false";?>">
                                            <span class="tituloProduto"><?=$produtoCategoria["Titulo"];?></span>
                                            <div class="botoes-produto">
                                                <button class="removerProduto">
                                                    <img src="../imagem/bt_sair.png">
                                                </button>
                                            </div>
                                        </div>
                                        <?php
                                    }?>
                                    <input name='categorias[<?=$indice;?>][qtdMinimaProdutos]' type="hidden" value="<?=$categoriaCombo["Qtd_Minima"];?>">
                                    <input name='categorias[<?=$indice;?>][qtdMaximaProdutos]' type="hidden" value="<?=$categoriaCombo["Qtd_Maxima"];?>">
                                    <input name='categorias[<?=$indice;?>][qtdPadraoProdutos]' type="hidden" value="<?=$categoriaCombo["Qtd_Padrao"];?>">
                                </div>
                                <?php
                            }
                        }?>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center">
                <button class="botao" id="salvarCombo">Salvar</button>
            </div>
        </div>
    </div>
    <dialog id="modalIngrediente">
        <form class="conteudoModal">
            <div class="cabecalhoModal">
                <h3>Configuraes do Ingrediente</h3>
            </div>
            <div class="corpoModal gap-2">
                <h3 id="nomeIngrediente"></h3>
                <div class="d-flex justify-content-between">
                    <div class="quantidadeIngrediente">
                        <label class="subtitulo">Quantidade Mnima</label>
                        <input type="text" name="qtdMinimaIngrediente">
                    </div>
                    <div class="quantidadeIngrediente">
                        <label class="subtitulo">Quantidade Mxima</label>
                        <input type="text" name="qtdMaximaIngrediente">
                    </div>
                    <div class="quantidadeIngrediente">
                        <span class="subtitulo">Quantidade Padro</span>
                        <input type="text" name="qtdPadraoIngrediente">
                    </div>
                </div>
            </div>
            <div class="rodapeModal">
                <input type="hidden" id="idIngrediente">
                <button type="button" class="btnFecharModal" id="fecharModalIngrediente">Fechar</button>
                <button class="btnSalvar">Salvar</button>
            </div>
        </form>
    </dialog>
    <dialog id="modalCombo">
        <div class="conteudoModal">
            <div class="cabecalhoModal">
                <h3 id="tituloCategoria"></h3>
            </div>
            <div class="corpoModal">
                <div class="d-flex flex-column gap-2">
                    <div class="d-flex" style="gap: 8rem;">
                        <div class="d-flex flex-column gap-10px" id="quantidadeProdutos">
                            <div class="d-flex gap-2">
                                <div class="d-flex flex-column gap-10px">
                                    <label class="subtitulo">Quantidade Mnima</label>
                                    <input type="text" name="qtdMinimaProdutos">
                                </div>
                                <div class="d-flex flex-column gap-10px">
                                    <label class="subtitulo">Quantidade Mxima</label>
                                    <input type="text" name="qtdMaximaProdutos">
                                </div>
                                <div class="d-flex flex-column gap-10px">
                                    <span class="subtitulo">Quantidade Padro</span>
                                    <input type="text" name="qtdPadraoProdutos">
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="d-flex flex-column gap-10px">
                        <span class="subtitulo">Produto Padro</span>
                        <div id="indicarProdutoPadrao">
                        </div>
                    </div>
                </div>
            </div>
            <div class="rodapeModal">
                <input type="hidden" id="idCategoriaProduto">
                <button class="btnFecharModal" id="fecharModalCombo">Fechar</button>
                <button class="btnSalvar" id="salvarProdutos">Salvar</button>
            </div>
        </div>
    </dialog>
    <script src="../js/jquery-3.3.1.min.js"></script>
    <script src="../js/jquery-ui/jquery-ui.min.js"></script>
    <script src="./js/composicao.js"></script>
</body>
</html>