<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Catlogo Restaurante</title>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tableless.css" />
    <link rel="stylesheet" href="./css/style.css">
    <link rel="stylesheet" href="./css/inicio.css">
</head>
<body>
    <div class="conteudo">
        <div class="d-flex flex-column gap-1">
            <div class="tituloPagina">
                <span>Catlogo Restaurante</span>
            </div>
            <div class="d-flex justify-content-between">
                <div class="botoes-cima gap-1">
                    <button type="button" class="btnLink" href="">
                        <img src="../imagem/bt_voltar.png" width="16">
                        <span>Voltar</span>
                    </button>
                    <button type="button" class="btnLink" href="./composicao_produto.php">
                        <img src="../imagem/bt_incluir.png" width="16">
                        <span>Cadastro</span>
                    </button>
                </div>
                <form class="d-flex gap-1" id="filtro">
                    <div class="d-flex">
                        <label>Busca:</label>
                        <input type="text" name="titulo">
                    </div>
                    <div class="d-flex">
                        <label>Ordernar Por:</label>
                        <select name="ordenar">
                            <option value="Titulo">Titulo</option>
                            <option value="Codigo">Cdigo</option>
                        </select>
                    </div>
                    <select name="status">
                        <option value="Ativos">Ativos</option>
                        <option value="Inativos">Inativos</option>
                        <option value="Todos">Todos</option>
                    </select>
                    <select name="ordem">
                        <option value="Crescente">Crescente</option>
                        <option value="Decrescente">Decrescente</option>
                    </select>
                    <button>Ok</button>
                </form>
            </div>
        </div>
        <div class="tabelaProduto">
            <div class="cabecalhoTabela">
                <div class="codigoProduto">
                    <span>Cdigo</span>
                </div>
                <div class="tituloProduto">
                    <span>Produto</span>
                </div>
                <div class="tipoProduto">
                    <span>Tipo</span>
                </div>
                <div class="categoriaProduto">
                    <span>Categoria</span>
                </div>
                <div class="acoesProduto">
                    <span>Aes</span>
                </div>
            </div>
            <div class="corpoTabela">
                <?php

                $getProdutos = $con->query("SELECT produto_combo.Id AS Id_Tipo, produto_combo.Id_Produto, produto_combo.Qtd_Maxima, produto.Titulo, produto.Codigo,
                    categoria_produto.Titulo AS Titulo_Categoria FROM produto_combo
                    INNER JOIN produto ON produto.Id = Id_Produto
                    INNER JOIN categoria_produto ON categoria_produto.Id = produto.Id_Categoria_Produto
                    UNION SELECT produto_composicao.Id AS Id_Tipo, Id_Produto, NULL, produto.Titulo, produto.Codigo, categoria_produto.Titulo AS Titulo_Categoria
                    FROM produto_composicao
                        INNER JOIN produto ON produto.Id = Id_Produto
                        INNER JOIN categoria_produto ON categoria_produto.Id = produto.Id_Categoria_Produto
                    ") or die($con->error);
                $produtos = $getProdutos->fetch_all(MYSQLI_ASSOC);
                foreach ($produtos as $produto) { ?>
                    <div class="produto">
                        <div class="codigoProduto">
                            <span><?=$produto['Codigo'];?></span>
                        </div>
                        <div class="tituloProduto">
                            <span><?=$produto['Titulo'];?></span>
                        </div>
                        <div class="tipoProduto">
                            <span><?=is_null($produto['Qtd_Maxima']) ? "Composio" : "Combo";?></span>
                        </div>
                        <div class="categoriaProduto">
                            <span><?=$produto['Titulo_Categoria'];?></span>
                        </div>
                        <div class="acoesProduto">
                            <a href="./composicao_produto.php?id=<?=md5($produto['Id_Tipo']);?>&tipo=<?=is_null($produto['Qtd_Maxima']) ? 'composicao' : 'combo';?>" class="btn-editar">
                                <img src="../imagem/bt_editar.png" width="18">
                            </a>
                            <a href="" class="btn-excluir" data-id="<?=md5($produto['Id_Tipo']);?>" data-tipo="<?=is_null($produto['Qtd_Maxima']) ? 'composicao' : 'combo';?>">
                                <img src="../imagem/bt_excluir.png" width="18">
                            </a>
                        </div>
                    </div>
                    <?php
                }?>
            </div>
        </div>
    </div>
    <script src="../js/jquery-3.3.1.min.js"></script>
    <script src="./js/inicio.js"></script>
</body>
</html>