$(document).ready(function() {
    const modalIngrediente = document.querySelector("#modalIngrediente");
    const modalCombo = document.querySelector("#modalCombo");
    const parametros = new URLSearchParams(location.search);

    if(parametros.get("tipo") != null) {
        if(parametros.get("tipo") == "combo") {
            $("html, body").animate({
                scrollTop: Number($(".comboProduto").offset().top)
            });
        }
    }

    $(".pesquisarProduto").autocomplete({
        width: 260,
        selectFirst: true,
        scroll: false,
        cacheLength: 100,
        max: 100,
        minLength: 3,
        source: "./buscar_produto.php"
    });

    $("#categoriaIngredientes").on("change", function() {
        let idCategoria = $(this).val();

        $.ajax({
            url: `./buscar_subcategorias.php?idCategoria=${idCategoria}`,
            method: "GET",
            dataType: "json",
            accepts: ["application/json"],
            success: function(response) {
                let categorias = response;
                $("#subcategoriaIngredientes").removeAttr("disabled").html("<option value='' disabled selected>Selecione</option>");

                categorias.map(categoria => {
                    $("#subcategoriaIngredientes").append(`
                        <option value="${categoria.Id}">${categoria.Titulo}</option>
                    `);
                });
            }
        });
    });

    $("#subcategoriaIngredientes").on("change", function() {
        let idCategoria = $("#categoriaIngredientes option:selected").attr("value");
        let idSubcategoria = $(this).val();

        $.ajax({
            url: `./buscar_ingredientes_subcategoria.php?idCategoria=${idCategoria}&idSubcategoria=${idSubcategoria}`,
            method: "GET",
            dataType: "json",
            accepts: ["application/json"],
            success: function(response) {
                let produtos = response;
                $("#adicionarIngredientes").html("");
                
                produtos.map(produto => {
                    $("#adicionarIngredientes").append(`
                        <div class="ingrediente" data-idProduto="${produto.Id}">
                            <span class="nomeIngrediente">${produto.Titulo}</span>
                        </div>
                    `);
                });
            }
        });
    });

    $("body").on('dblclick', "#adicionarIngredientes .ingrediente", function() {
        let idIngrediente = $(this).attr("data-idProduto");
        let nomeIngrediente = $(this).find(".nomeIngrediente").html();

        $("#modalIngrediente #nomeIngrediente").html(nomeIngrediente);
        $("#modalIngrediente #idIngrediente").val(idIngrediente);
        modalIngrediente.showModal();
    });

    $("#modalIngrediente form").on("submit", function(e){
        e.preventDefault();
        let idIngrediente = $("#modalIngrediente #idIngrediente").val();
        let qtdMinimaIngrediente = $("#modalIngrediente input[name='qtdMinimaIngrediente']").val();
        let qtdMaximaIngrediente = $("#modalIngrediente input[name='qtdMaximaIngrediente']").val();
        let qtdPadraoIngrediente = $("#modalIngrediente input[name='qtdPadraoIngrediente']").val();
        let ingredienteAdicionado = $(`#ingredientesAdicionados .ingrediente[data-idProduto="${idIngrediente}"]`)

        if(ingredienteAdicionado.length < 1) {
            let ingrediente = $(`#adicionarIngredientes .ingrediente[data-idProduto="${idIngrediente}"]`);
            let qtdIngredientesAdicionados = $("#ingredientesAdicionados .ingrediente").length;

            $(ingrediente).append(`
                <div class="qtdIngrediente">
                    <span class="qtdMinimaIngrediente">Mn: ${qtdMinimaIngrediente}</span>
                    <span class="qtdMaximaIngrediente">Mx: ${qtdMaximaIngrediente}</span>
                    <span class="qtdPadraoIngrediente">Pad: ${qtdPadraoIngrediente}</span>
                </div>
                <div class="botoes-ingrediente">
                    <button class="removerIngrediente">
                        <img src="../imagem/bt_sair.png" alt="">
                    </button>
                </div>
                <input name='ingredientes[${qtdIngredientesAdicionados}][qtdMinimaIngrediente]' type="hidden" value="${qtdMinimaIngrediente}">
                <input name='ingredientes[${qtdIngredientesAdicionados}][qtdMaximaIngrediente]' type="hidden" value="${qtdMaximaIngrediente}">
                <input name='ingredientes[${qtdIngredientesAdicionados}][qtdPadraoIngrediente]' type="hidden" value="${qtdPadraoIngrediente}">
            `);
            $("#ingredientesAdicionados").append($(ingrediente));
            $(`#adicionarIngredientes .ingrediente[data-idProduto="${idIngrediente}"]`).remove();
        } else {
            $(ingredienteAdicionado).find(".qtdMinimaIngrediente").html(`Mn: ${qtdMinimaIngrediente}`);
            $(ingredienteAdicionado).find(".qtdMaximaIngrediente").html(`Mx: ${qtdMaximaIngrediente}`);
            $(ingredienteAdicionado).find(".qtdPadraoIngrediente").html(`Pad: ${qtdPadraoIngrediente}`);
            $(ingredienteAdicionado).find("input[name*='qtdMinimaIngrediente']").val(qtdMinimaIngrediente);
            $(ingredienteAdicionado).find("input[name*='qtdMaximaIngrediente']").val(qtdMaximaIngrediente);
            $(ingredienteAdicionado).find("input[name*='qtdPadraoIngrediente']").val(qtdPadraoIngrediente);
        }
        $("#subcategoriaIngredientes").val("");
        modalIngrediente.close();
        $("#modalIngrediente form")[0].reset();
    });

    $("body").on('click', "#ingredientesAdicionados .ingrediente", function(e) {
        if(e.target.classList.contains("removerIngrediente") || e.target.parentElement.classList.contains("removerIngrediente")){
            $(this).find(".botoes-ingrediente").remove();
            $(this).find(".qtdIngrediente").remove();
            let categoriaSelecionada = $("#categoriaIngredientes option:selected").attr("value");
            let ingrediente = $(this);
            $(this).remove();

            if($(ingrediente).attr("data-idCategoria") == categoriaSelecionada) {
                $("#adicionarIngredientes").append($(ingrediente));
            }
        } else {
            let nomeIngrediente = $(this).find(".nomeIngrediente").html();
            let qtdMinimaIngrediente = $(this).find("input[name*='qtdMinimaIngrediente']").val();
            let qtdMaximaIngrediente = $(this).find("input[name*='qtdMaximaIngrediente']").val();
            let qtdPadraoIngrediente = $(this).find("input[name*='qtdPadraoIngrediente']").val();
            let idIngrediente = $(this).attr("data-idProduto");

            $("#modalIngrediente input[name='qtdMinimaIngrediente']").val(qtdMinimaIngrediente);
            $("#modalIngrediente input[name='qtdMaximaIngrediente']").val(qtdMaximaIngrediente);
            $("#modalIngrediente input[name='qtdPadraoIngrediente']").val(qtdPadraoIngrediente);
            $("#modalIngrediente #idIngrediente").val(idIngrediente);
            $("#modalIngrediente #nomeIngrediente").html(nomeIngrediente);

            modalIngrediente.showModal();
        }
    });
    
    $("#fecharModalIngrediente").on("click", function() {
        modalIngrediente.close();
        $("#modalIngrediente #nomeIngrediente").html('');
        $(this).parents("dialog").find("form")[0].reset();
    });

    $("#salvarIngredientes").on("click", async function() {
        $(this).attr("disabled", true).html("Aguarde...");

        let produtoIngrediente = $("#produtoIngrediente").val();
        let ingredientes = [];

        Array.from($("#ingredientesAdicionados .ingrediente")).map(ingrediente => {
            let idIngrediente = $(ingrediente).attr("data-idProduto");
            let qtdMinimaIngrediente = $(ingrediente).find("input[name*='qtdMinimaIngrediente']").val();
            let qtdMaximaIngrediente = $(ingrediente).find("input[name*='qtdMaximaIngrediente']").val();
            let qtdPadraoIngrediente = $(ingrediente).find("input[name*='qtdPadraoIngrediente']").val();

            ingredientes.push({
                idIngrediente: idIngrediente,
                qtdMinimaIngrediente: qtdMinimaIngrediente,
                qtdMaximaIngrediente: qtdMaximaIngrediente,
                qtdPadraoIngrediente: qtdPadraoIngrediente
            });
        });

        let dados = {
            produto: produtoIngrediente,
            ingredientes: ingredientes
        };

        if(parametros.get('id') != null) {
            if(parametros.get('tipo') == "composicao") {
                dados.id = parametros.get('id')
            }
        }

        await $.ajax({
            url: "./salvar_ingredientes.php",
            method: parametros.get('id') != null ? "PUT" : "POST",
            dataType: "json",
            accepts: ["application/json"],
            contentType: "application/json",
            data: JSON.stringify(dados),
            success: function(response) {
                let { status, mensagem } = response;
                alert(mensagem);

                if(status == "ok") {
                    $("#produtoIngrediente").val("");
                    $("#categoriaIngredientes").val("");
                    $("#subcategoriaIngredientes").attr("disabled", true).html("<option value='' disabled selected>Selecione</option>");
                    $("#ingredientesAdicionados").html("");

                    if(parametros.get('id') != null) {
                        history.back();
                        parametros.delete('id');
                        parametros.delete('tipo');
                    }
                }
            }
        })


        $(this).removeAttr("disabled", true).html("Salvar");
    });

    $("#categoriaProduto").on("change", async function() {
        let idCategoria = $(this).val();
        $(this).attr("disabled", true);

        await $.ajax({
            url: `./buscar_produtos_categoria.php?idCategoria=${idCategoria}`,
            method: "GET",
            dataType: "json",
            accepts: ["application/json"],
            success: function(response) {
                let produtos = response;
                $("#adicionarProdutos").html("");

                produtos.map(produto => {
                    $("#adicionarProdutos").append(`
                        <div class="produto" data-idProduto="${produto.Id}" data-idCategoria="${idCategoria}">
                            <span class="tituloProduto">${produto.Titulo}</span>
                        </div>
                    `);
                });
            }
        });

        $(this).removeAttr("disabled");
    });

    $("body").on('dblclick', "#adicionarProdutos .produto", function() {
        let idProduto = $(this).attr("data-idProduto");
        let idCategoria = $(this).attr("data-idCategoria");

        if($(`#produtosAdicionados .produto[data-idProduto="${idProduto}"]`).length < 1) {
            let nomeProduto = $(this).find(".tituloProduto").html();
            let grupoCategoria = $(`#produtosAdicionados .grupoProduto[data-idCategoria="${idCategoria}"]`);

            if(grupoCategoria.length > 0) {
                $(`#produtosAdicionados .grupoProduto[data-idCategoria="${idCategoria}"]`).append(`
                    <div class="nomeProduto" data-idProduto="${idProduto}" data-padrao="false">
                        <span class="tituloProduto">${nomeProduto}</span>
                        <div class="botoes-produto">
                            <button class="removerProduto">
                                <img src="../imagem/bt_sair.png">
                            </button>
                        </div>
                    </div>
                `);
            } else {
                let nomeCategoria = $(`#categoriaProduto option[value="${idCategoria}"]`).html();
                let qtdCategorias = $("#produtosAdicionados .grupoProduto").length;

                $("#produtosAdicionados").append(`
                    <div class="grupoProduto" data-idCategoria="${idCategoria}">
                        <div class="categoriaProdutos">
                            <span class="nomeCategoria">${nomeCategoria}</span>
                            <button class="removerCategoria">
                                <img src="../imagem/bt_sair.png">
                            </button>
                        </div>
                        <div class="nomeProduto" data-idProduto="${idProduto}" data-padrao="false">
                            <span class="tituloProduto">${nomeProduto}</span>
                            <div class="botoes-produto">
                                <button class="removerProduto">
                                    <img src="../imagem/bt_sair.png">
                                </button>
                            </div>
                        </div>
                        <input name='categorias[${qtdCategorias}][qtdMinimaProdutos]' type="hidden" value="">
                        <input name='categorias[${qtdCategorias}][qtdMaximaProdutos]' type="hidden" value="">
                        <input name='categorias[${qtdCategorias}][qtdPadraoProdutos]' type="hidden" value="">
                    </div>
                `);
            }

            $(this).remove();
        }
    });

    $("body").on('click', "#produtosAdicionados .grupoProduto", function(e) {
        if(e.target.classList.contains("removerCategoria") || e.target.parentElement.classList.contains("removerCategoria")) {
            $(this).remove();
        }
        else if(e.target.classList.contains("removerProduto") || e.target.parentElement.classList.contains("removerProduto")) {
            let elementoHtml = $(e.target);
            $(elementoHtml).parents(".nomeProduto").remove();
            
            if($(this).find(".nomeProduto").length == 0) {
                $(this).remove();
            }
        } else {
            let idCategoriaProduto = $(this).attr("data-idCategoria");
            let nomeCategoria = $(this).find(".nomeCategoria").html();
            let qtdMinimaProdutos = $(this).find("input[name*='qtdMinimaProdutos']").val();
            let qtdMaximaProdutos = $(this).find("input[name*='qtdMaximaProdutos']").val();
            let qtdPadraoProdutos = $(this).find("input[name*='qtdPadraoProdutos']").val();
            
            $("#modalCombo #tituloCategoria").html(nomeCategoria);
            $("#modalCombo input[name*='qtdMinimaProdutos']").val(qtdMinimaProdutos);
            $("#modalCombo input[name*='qtdMaximaProdutos']").val(qtdMaximaProdutos);
            $("#modalCombo input[name*='qtdPadraoProdutos']").val(qtdPadraoProdutos);
            $("#modalCombo #idCategoriaProduto").val(idCategoriaProduto);

            Array.from($(this).find(".nomeProduto")).map(produto => {
                let nomeProduto = $(produto).find(".tituloProduto").html();
                let idProduto = $(produto).attr("data-idProduto");
                let padrao = $(produto).attr("data-padrao");

                $(`#indicarProdutoPadrao`).append(`
                    <div class="produtoPadrao">
                        <input type="radio" name="produtoPadrao" data-idProduto="${idProduto}" ${padrao == "true" ? 'checked' : ''}>
                        <span>${nomeProduto}</span>
                    </div>
                `);
            });
        
            modalCombo.showModal();
        }
    });

    $("body").on("click", ".produtoPadrao", function() {
        $(this).find("input[name=produtoPadrao]").prop("checked", true);
        $(".produtoPadraoEscolhido").removeClass("produtoPadraoEscolhido");
        $(this).addClass("produtoPadraoEscolhido");
    });

    $("#fecharModalCombo").on("click", function() {
        modalCombo.close();
        $("#modalCombo #tituloCategoria").html("");
        $("#modalCombo input").val('');
        $(`#modalCombo #indicarProdutoPadrao`).html("");
    });

    $("#modalCombo #salvarProdutos").on("click", function() {
        let qtdMinimaProdutos = $("#modalCombo input[name*='qtdMinimaProdutos']").val();
        let qtdMaximaProdutos = $("#modalCombo input[name*='qtdMaximaProdutos']").val();
        let qtdPadraoProdutos = $("#modalCombo input[name*='qtdPadraoProdutos']").val();
        let idProdutoPadrao = $("#modalCombo input[name='produtoPadrao']:checked").attr("data-idProduto");
        let idCategoriaProduto = $("#modalCombo #idCategoriaProduto").val();

        $(`.grupoProduto[data-idCategoria="${idCategoriaProduto}"] .nomeProduto[data-idProduto!='${idProdutoPadrao}']`).attr("data-padrao", "false");
        $(`.grupoProduto[data-idCategoria="${idCategoriaProduto}"] .nomeProduto[data-idProduto='${idProdutoPadrao}']`).attr("data-padrao", "true");
        $(`.grupoProduto[data-idCategoria="${idCategoriaProduto}"] input[name*='qtdMinimaProdutos`).val(qtdMinimaProdutos);
        $(`.grupoProduto[data-idCategoria="${idCategoriaProduto}"] input[name*='qtdMaximaProdutos`).val(qtdMaximaProdutos);
        $(`.grupoProduto[data-idCategoria="${idCategoriaProduto}"] input[name*='qtdPadraoProdutos`).val(qtdPadraoProdutos);

        modalCombo.close();
        $("#modalCombo #tituloCategoria").html("");
        $("#modalCombo input").val('');
        $(`#modalCombo #indicarProdutoPadrao`).html("");
    });

    $("#salvarCombo").on("click", async function() {
        $(this).attr("disabled", true).html("Aguarde...");

        let produtoCombo = $("#produtoCombo").val();
        let qtdMaximaCombo = $("#qtdMaximaCombo").val();
        let categorias = [];

        Array.from($("#produtosAdicionados .grupoProduto")).map(categoriaProdutos => {
            let idCategoria = $(categoriaProdutos).attr("data-idCategoria");
            let qtdMinimaProdutos = $(categoriaProdutos).find(`input[name*='qtdMinimaProdutos']`).val();
            let qtdMaximaProdutos = $(categoriaProdutos).find(`input[name*='qtdMaximaProdutos']`).val();
            let qtdPadraoProdutos = $(categoriaProdutos).find(`input[name*='qtdPadraoProdutos']`).val();
            let produtosCategoria = [];
            let idProdutoPadrao = "";
            
            Array.from($(categoriaProdutos).find(".nomeProduto")).map(produto => {
                if($(produto).attr("data-padrao") == "true") {
                    idProdutoPadrao = $(produto).attr("data-idProduto");
                }

                produtosCategoria.push({
                    id: $(produto).attr("data-idProduto"),
                });
            });

            categorias.push({
                id: idCategoria,
                qtdMinimaProdutos: qtdMinimaProdutos,
                qtdMaximaProdutos: qtdMaximaProdutos,
                qtdPadraoProdutos: qtdPadraoProdutos,
                idProdutoPadrao: idProdutoPadrao,
                produtos: produtosCategoria,
            });
        });

        let dados = {
            categorias: categorias,
            produto: produtoCombo,
            qtdMaxima: qtdMaximaCombo
        };

        if(parametros.get('id') != null) {
            if(parametros.get('tipo') == 'combo') {
                dados.id = parametros.get('id')
            }
        }

        await $.ajax({
            url: "salvar_combo.php",
            method: parametros.get('id') != null ? "PUT" : "POST",
            dataType: "json",
            accepts: ["application/json"],
            contentType: "application/json",
            data: JSON.stringify(dados),
            success: function(response) {
                let { status, mensagem } = response;
                alert(mensagem);

                if(status == "ok") {
                    $("#produtoCombo").val("");
                    $("#qtdMaximaCombo").val("");
                    $("#categoriaProduto").val("");
                    $(".listaProdutos").html("");

                    if(parametros.get('id') != null) {
                        history.back();
                        parametros.delete('id');
                        parametros.delete('tipo');
                    }
                }
            }
        });

        $(this).removeAttr("disabled").html("Salvar");
    });

    $("#qtdMaximaCombo").on("keypress", (e) => somenteNumeros(e));
    $(".conteudoModal input[type='text']").on("keypress", (e) => somenteNumeros(e));

    $("#modalCombo input[type='text']").on("change", function() {
        $(this).removeClass("inputIncorreto");

        let qtdMaximaCombo = parseFloat($("#qtdMaximaCombo").val().replace('.', '').replace(',', '.'));
        let quantidade = parseFloat($(this).val().replace('.', '').replace(',', '.'));
        let nomeInput = $(this).attr("name");
        let idCategoriaProduto = $("#idCategoriaProduto").val();

        if(nomeInput != "qtdMaximaProdutos") {
            Array.from($(`.grupoProduto input[name*='${nomeInput}']`)).map(inputQuantidade => {
                if($(inputQuantidade).parents(".grupoProduto").attr("data-idCategoria") != idCategoriaProduto) {
                    quantidade += parseFloat($(inputQuantidade).val().replace('.', '').replace(',', '.'));
                }
            });
    
            if(quantidade > qtdMaximaCombo) {
                alert("Quantidade dos itens no pode ser maior que a quantidade mxima do combo");
                $(this).val("").addClass("inputIncorreto");
            }
        }
    });

    $("#modalCombo input[name='qtdMaximaProdutos']").on("change", function() {
        $(this).removeClass("inputIncorreto");

        let qtdMaxima = parseFloat($(this).val().replace('.', '').replace(',', '.'));
        let qtdMaximaCombo = parseFloat($("#qtdMaximaCombo").val().replace('.', '').replace(',', '.'));

        if(qtdMaxima > qtdMaximaCombo) {
            alert("Quantidade dos itens no pode ser maior que a quantidade mxima do combo");
            $(this).val("").addClass("inputIncorreto");
        }
    });
})

function somenteNumeros(e) {
    let charCode = (e.which) ? e.which : e.keyCode
    if (charCode > 31 && (charCode < 48 || charCode > 57) && (charCode != 44 && charCode != 46)) {
        e.preventDefault();
    }
}
// let produtoIngrediente = document.querySelector("#produtoIngrediente");
// produtoIngrediente.addEventListener("keyup", function(e) {
//     let value = e.target.value;
//     console.log(value.replace(/[^0-9]/g, ""));
// })