function filtrarProdutos() {
    let dados = $("#filtro").serialize();

    $.ajax({
        url: "./filtrar_produtos.php",
        data: dados,
        accepts: ["application/json"],
        dataType: "json",
        success: function(response){
            $(".corpoTabela").html("");

            let produtos = response;

            produtos.map(produto => {
                $(".corpoTabela").append(`
                    <div class="produto">
                        <div class="codigoProduto">
                            <span>${produto.Codigo}</span>
                        </div>
                        <div class="tituloProduto">
                            <span>${produto.Titulo}</span>
                        </div>
                        <div class="tipoProduto">
                            <span>${produto.Qtd_Maxima == null ? "Composio" : "Combo"}</span>
                        </div>
                        <div class="categoriaProduto">
                            <span>${produto.Titulo_Categoria}</span>
                        </div>
                        <div class="acoesProduto">
                            <a href="./composicao_produto.php?id=${produto.Id_Tipo}&tipo=${produto.Qtd_Maxima ? 'composicao' : 'combo'}" class="btn-editar">
                                <img src="../imagem/bt_editar.png" width="18">
                            </a>
                            <a href="" class="btn-excluir" data-id"=${produto.Id_Tipo}" data-tipo="${produto.Qtd_Maxima ? 'composicao' : 'combo'}">
                                <img src="../imagem/bt_excluir.png" width="18">
                            </a>
                        </div>
                    </div>
                `);
            });
        }
    })
}

$(document).ready(function(){
    $(".btnLink").on("click", function(){
        let link = $(this).attr("href");
        window.location.href = link;
    });

    $("#filtro").on("submit", function(e){
        e.preventDefault();
        filtrarProdutos();
    });

    $("#filtro select").on("change", function(){
        filtrarProdutos();
    });

    $("body").on("click", ".produto .btn-excluir", function(e) {
        e.preventDefault();
        let id = $(this).attr("data-id");
        let tipo = $(this).attr("data-tipo");
        let produto = $(this).parents(".produto");
        let confirmacao = confirm("Tem certeza que deseja excluir?");

        if(confirmacao) {
            $.ajax({
                url: `excluir_item.php?id=${id}&tipo=${tipo}`,
                method: "DELETE",
                accepts: ["application/json"],
                dataType: "json",
                statusCode: {
                    204: function() {
                        $(produto).remove();
                    }
                }
            });
        }
    });
});