<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Endereo mais prximo utilizando a API do Google Maps | Por Lucas Martins</title>
<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=ABQIAAAAh-4-WXT7vryB4zWcSDKIThSuBLcACnbYAIBxS9eHfruCpUv1BBRZi-GSNoVlnTofbgShokT-TgG8BA" type="text/javascript"></script>
<script type="text/javascript">
/*
    varives globais / globals vars
*/
var geocoder = new GClientGeocoder();
var map;
var directionsPanel;
var directions;
var gdir = new GDirections();
var addr = new Array(3);
var distances = new Array(3);
 
// Ao carregar / After load
window.onload = function() {
 
    // Seta o pas que ser usado na API / Set the country that will be used in the API
    geocoder.setBaseCountryCode("pt_BR");
 
    map = new GMap2(document.getElementById('map'), { size: new GSize(710,480) })
    map.addControl(new GLargeMapControl());
    map.setCenter(new GLatLng(-23.547779, -46.639366), 12); // So Paulo / Sao Paulo (brazilian city)
 
    // Adiciona marcao dos endereos das bibliotecas pblicas de So Paulo / Add marks of addresses of public libraries in Sao Paulo
    showAddress("Rua Cisplatina, 505 - Ipiranga, So Paulo - SP, 04211-040", 1);
    showAddress("Rua Arsnio Tavolieri, 45 - Jabaquara, So Paulo - SP, 04321-030", 2);
    showAddress("Rua Sena Madureira, 298 - Vila Mariana, So Paulo - SP, 04021-050", 3);
 
    // No clique do boto / On click of button
    document.getElementById("trace_route").onclick = function() {
 
        // Verifica o endereo digitado pelo usurio / Check the address entered by the User
        geocoder.getLocations(
            document.getElementById("myAddress").value,
            function(point) {
                // Verifica se o endereo que o usurio digitou  vlido e existente / Check if the address that the user entered is valid and existing
                if(point.Placemark) {
 
                    // Cria o objeto GLatLng e grava a latitude e longitude do endereo digitado pelo usurio
                    // Creates the GLatLng object and records the latitude and longitude of the address entered by the User
                    var a = new GLatLng(point.Placemark[0].Point.coordinates[1], point.Placemark[0].Point.coordinates[0]);
 
                    /*
                        usa mtodo da classe GLatLng() que retorna a distncia, em metros, entre
                        duas coordenadas de latitude/longitude
 
                        use method of the GLatLng() which returns the distance in meters between
                        two latitude / longitude
                    */
                    var b = new GLatLng(addr[0][1], addr[0][0]); // inicia no primeiro ponto / start in the first point
                    var x = b.distanceFrom(a);
 
                    /*
                        variveis que sero usadas para comparar distncias entre coordenadas
                        de latitude e longitude
 
                        variables that will be used to compare distances between coordinates
                        latitude and longitude
                    */
                    var smallestDist = x;
                    var smallestDistId = 0;
 
                    //
                    for(var i = 0; i < 3; i++) {
 
                        b = new GLatLng(addr[i][1], addr[i][0]);
                        x = b.distanceFrom(a);
 
                        // Verifica qual dos endereos tem menor distncia entre um ponto e outro
                        // Check It addresses which is less distance between one point and another
                        if(x < smallestDist || i == 0) {
                            smallestDist = x;
                            smallestDistId = i;
                        }
                    }
 
                    /*
                        cria um array de dois objetos GLatLng, com as coordenadas do endereo digitado pelo
                        usurio e o endereo do ponto mais prximo a esse endereo
 
                        creates an array of two GLatLng objects, with the coordinates of the address entered by
                        User and address of the nearest point to this address
                    */
 
                    var pointsArray = [a, new GLatLng(addr[smallestDistId][1], addr[smallestDistId][0])]
                    directions = new GDirections(map); // instancia objetos / instance objects
                    // usa o array de pontos para traar a rota entre os dois endereos / uses the array of points to trace the route between two addresses
                    directions.loadFromWaypoints(pointsArray, {"locale":"pt_BR"});
                }
            }
        );
    }
}
 
/*
    funo que ser usada para manipular endereos
    function that will be used to manipulate addresses
*/
function showAddress(address, k) {
    geocoder.getLocations(
        address,
        function(point) {
            addMarker(point, k);
        }
    );
}
 
/*
    funo que ser usada para marcar o mapa
    function that will be used to mark the map
*/
function addMarker(response, k) {
    if(!response.Placemark) { return; }
    place = response.Placemark[0];
    if(k) {
        // salva a latitude/longitude do endereo / save the latitute/longitude of address
        addr[k-1] = place.Point.coordinates;
    }
    point = new GLatLng(place.Point.coordinates[1], place.Point.coordinates[0]);
    var marker = createMarker(point, place.address, k); // cria o marcador no mapa / creates the marker on the map
    map.addOverlay(marker); // adiciona o marcador no mapa / adds the marker on the map
}
 
/*
    funo que ser usada para criar os marcadores
    function that will be used for creating markers
*/
function createMarker(point,html, k) {
    var marker = new GMarker(point, false);
    return marker;
}
</script>
</head>
 
<body>
<form action="#" method="POST">
    <fieldset>
        <label for="from">Seu endereo:</label>
        <input type="text" name="myAddress" id="myAddress" />
    </fieldset>
    <input type="button" class="button" id="trace_route" value="Encontrar biblioteca prxima" />
</form>
<div id="map"></div>
</body>
</html>