<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
include_once '../menu_movimento.php';
?>
<?php
//error_reporting(E_ALL);
//ini_set('display_errors', 'On');
require_once '../nfephp/bootstrap.php';
require_once '../nfephp/config/config.php';
require_once '../nfephp/config/certificado.php';

use NFePHP\NFe\Tools;
use NFePHP\Common\Certificate;
use NFePHP\NFe\Common\Standardize;

if ($_SERVER['REQUEST_METHOD'] == "GET") {

    $dados_cert = geraCertificado($_GET["Unidade"]);
    //carrega o conteudo do certificado.
    $content = file_get_contents($dados_cert['pathCertsFiles'] . $dados_cert['certPfxName']);

    $certificate = Certificate::readPfx($content, $dados_cert['certPassword']);
    $tools = new Tools(geraConfig($_GET["Unidade"]), $certificate);
    $tools->model('55');

    //se for manual
    if ($_GET["Manual"] == 'S') {

        //baixando a nota e salvando na tabelas de notas
        $resp = $tools->sefazDownload(
            $_GET["Chave"]
        );
        $st = new Standardize();
        $std = $st->toStd($resp);

        $xml_nota = gzdecode(base64_decode($std->loteDistDFeInt->docZip));
        $xml = simplexml_load_string($xml_nota);


        if (isset($xml->chNFe)) {

            $chNFe = mysqli_query($con, "SELECT chNFe FROM compra_nfe WHERE chNFe='" . $xml->chNFe . "' ");

            if (mysqli_num_rows($chNFe) == 0) {

                $cpf_cnpj = ($xml->CNPJ != '') ? $xml->CNPJ : $xml->CPF;

                mysqli_query($con, "INSERT INTO compra_nfe (
                                chNFe,
                                CNPJ,
                                xNome,
                                IE,
                                dhEmi,
                                digVal,
                                dhRecibo,
                                nProt,
                                tpEvento,
                                descEvento,
                                Manifesto,
                                Compra,
                                Compra_Nova,
                                Id_Unidade,
                                " . $padraoCampos . ")
                                values(
                                '" . $xml->chNFe . "',
                                '" . $cpf_cnpj . "',
                                '" . limpaNome($xml->xNome) . "',
                                '" . $xml->IE . "',
                                '" . $xml->dhEmi . "',
                                '" . $xml->digVal . "',
                                '" . $xml->dhRecbto . "',
                                '" . $xml->nProt . "',
                                '" . $xml->tpEvento . "',
                                '" . $xml->descEvento . "',
                                '1',
                                '0',
                                '0',
                                '" . $_GET["Unidade"] . "',
                                " . $padraoPost . ")")
                    or die("Erro no comando SQL:" . mysqli_error($con));


                $resp = $tools->sefazManifesta(
                    $_GET["Chave"],
                    Tools::EVT_CIENCIA,
                    '' // deve apenas ser preenchido na operao nao realizada
                );
                $resp = $tools->sefazManifesta(
                    $_GET["Chave"],
                    Tools::EVT_CONFIRMACAO,
                    '' // deve apenas ser preenchido na operao nao realizada
                );

                $st = new Standardize();
                $std = $st->toStd($resp);

                if ($std->retEvento->infEvento->cStat == '650') { //nfe cancelada
                    mysqli_query($con, "UPDATE compra_nfe SET Manifesto = '2' WHERE chNFe='" . $_GET["Chave"] . "' ");
                    $nfe_cancelada = 'S';
                } elseif ($std->retEvento->infEvento->cStat == '573') { //Duplicidade de evento
                    mysqli_query($con, "UPDATE compra_nfe SET Manifesto = '1' WHERE chNFe='" . $_GET["Chave"] . "' ");
                } elseif ($std->retEvento->infEvento->cStat == '135') { //requisiao aceita
                    mysqli_query($con, "UPDATE compra_nfe SET Manifesto = '1' WHERE chNFe='" . $_GET["Chave"] . "' ");
                }
            }
        }
    } //fim manual


    if ($nfe_cancelada == 'S') {
        echo "<script>alert('NFe Cancelada!');window.close();</script>";
        exit();
    }

    //header('Content-type: text/xml');
    //header('Content-type: text/plain');
    $resp = $tools->sefazDownload(
        $_GET["Chave"]
    );
    $st = new Standardize();
    $std = $st->toStd($resp);

    $xml = gzdecode(base64_decode($std->loteDistDFeInt->docZip));
    $nota = simplexml_load_string($xml);


    $c = 1;
    foreach ($nota as $chave) {

        if ($c == 1) {
            $cnpj_xml = ($chave->infNFe->emit->CNPJ != '') ? $chave->infNFe->emit->CNPJ : $chave->infNFe->emit->CPF;
            $sql_for = mysqli_query($con, "Select Id FROM fornecedor WHERE Cpf_Cnpj='" . $cnpj_xml . "' LIMIT 1");
            $id_for = mysqli_fetch_assoc($sql_for);

            ###--- cadastro do fornecedor ---###
            if ($id_for["Id"] == '') {

                $busca_codigo = mysqli_query($con, "SELECT Codigo FROM fornecedor ORDER BY Data_Cadastro DESC LIMIT 1");
                $busca_codigo = mysqli_fetch_assoc($busca_codigo);
                $Codigo_Emit = str_pad(($busca_codigo['Codigo'] + 1), 4, "0", STR_PAD_LEFT);

                if ((strlen($cnpj_xml)) == '14') {
                    $pess = 'PJ';
                } else {
                    $pess = 'PF';
                }

                $Codigo_Forncedor = md5($cnpj_xml . microtime());
                mysqli_query($con, "INSERT INTO fornecedor (Id,
                            Codigo,
                            Cpf_Cnpj,
                            Razao_Social,
                            Titulo,
                            Estadual,
                            Rua,
                            Numero,
                            Bairro,
                            Id_Cidade,
                            Cidade,
                            Estado,
                            Cep,
                            Codigo_Pais,
                            Pais,
                            Fone1,
                            Natureza,
                            Tipo,
                            Ativo,
                            " . $padraoCampos . ")
                            values('$Codigo_Forncedor',
                            '" . $Codigo_Emit . "',
                            '" . $cnpj_xml . "',
                            '" . limpaNome($chave->infNFe->emit->xNome) . "',
                            '" . limpaNome($chave->infNFe->emit->xNome) . "',
                            '" . $chave->infNFe->emit->IE . "',
                            '" . $chave->infNFe->emit->enderEmit->xLgr . "',
                            '" . $chave->infNFe->emit->enderEmit->nro . "',
                            '" . $chave->infNFe->emit->enderEmit->xBairro . "',
                            '" . $chave->infNFe->emit->enderEmit->cMun . "',
                            '" . $chave->infNFe->emit->enderEmit->xMun . "',
                            '" . $chave->infNFe->emit->enderEmit->UF . "',
                            '" . $chave->infNFe->emit->enderEmit->CEP . "',
                            '1058',
                            'BRASIL',
                            '" . $chave->infNFe->emit->enderEmit->fone . "',
                            '" . $pess . "',
                            'F',
                            'Sim',
                            " . $padraoPost . ")");

                mysqli_query($con, "UPDATE fornecedor SET Id_Cidade = (SELECT Id FROM cidade_ibge WHERE cidade_ibge.Codigo=fornecedor.Id_Cidade LIMIT 1)
                        WHERE fornecedor.Id = '" . $Codigo_Forncedor . "' ");

                $id_for["Id"] = $Codigo_Forncedor;
            }
            ###--- fim do fornecedor ---###
        }
        $c++;
    }

    $criar_fornecedor = mysqli_query($con, "Select Id,
                                    Titulo,
                                    Cpf_Cnpj,
                                    Email,
                                    Rua,
                                    Numero,
                                    Complemento,
                                    Ponto_Referencia,
                                    Cep,
                                    Bairro,
                                    Id_Cidade,
                                    Codigo_Cidade,
                                    Cidade,
                                    Estado,
                                    Fone1,
                                    Fone2,
                                    Natureza,
                                    Razao_Social,
                                    Estadual,
                                    Codigo,
                                    Id_Categoria_Fornecedor,
                                    Id_Categoria_Fornecedor_Filho
                                    FROM fornecedor WHERE Id='" . $id_for["Id"] . "' LIMIT 1");
    $criar_f = mysqli_fetch_assoc($criar_fornecedor);

    $_POST["Id_Fornecedor"] = $criar_f["Id"];
    $_POST["Titulo"] = $criar_f["Titulo"];
    $_POST["Cpf"] = $criar_f["Cpf_Cnpj"];
    $_POST["Cnpj"] = $criar_f["Cpf_Cnpj"];
    $_POST["Email"] = $criar_f["Email"];
    $_POST["Rua"] = $criar_f["Rua"];
    $_POST["Numero"] = $criar_f["Numero"];
    $_POST["Complemento"] = $criar_f["Complemento"];
    $_POST["Ponto_Referencia"] = $criar_f["Ponto_Referencia"];
    $_POST["Cep"] = $criar_f["Cep"];
    $_POST["Bairro"] = $criar_f["Bairro"];
    $_POST["Cidade"] = $criar_f["Id_Cidade"];
    $_POST["Estado"] = $criar_f["Estado"];
    $_POST["Fone1"] = $criar_f["Fone1"];
    $_POST["Fone2"] = $criar_f["Fone2"];
    $_POST["Natureza"] = $criar_f["Natureza"];
    $_POST["Razao_Social"] = $criar_f["Razao_Social"];
    $_POST["Estadual"] = $criar_f["Estadual"];
    $_POST["Categoria_Fornecedor"] = $criar_f["Id_Categoria_Fornecedor"];
    $_POST["Categoria_Fornecedor_Filho"] = $criar_f["Id_Categoria_Fornecedor_Filho"];
}



if ($_SERVER['REQUEST_METHOD'] == "POST") {


    if ($_POST["Natureza"] == "PF") {
        $Cpf_Cnpj = $_POST["Cpf"];
        $_POST["Razao_Social"] = $_POST["Titulo"];
    } else {
        $Cpf_Cnpj = $_POST["Cnpj"];
    }

    if (!empty($_POST["Email"])) {
        $_POST["Email"] = tratamento_email($_POST["Email"]);
        $verify_email = verifica_email($_POST["Email"]);
    }


    if (
        (
            ($_POST["Titulo"]) && ($_POST["Fone1"]) && (CNPJ_FORNECEDOR == 'No') && ($verify_email !== false)
        )
        or
        (
            ($_POST["Titulo"]) && ($_POST["Fone1"]) && (CNPJ_FORNECEDOR == 'Sim') && ($Cpf_Cnpj) && ($verify_email !== false)
        )
    ) {

        $_POST["Cep"] = CaracteresEspeciais($_POST["Cep"], "Sim");
        $Cpf_Cnpj = CaracteresEspeciais($Cpf_Cnpj, "Sim");

        if ($_POST["Razao_Social"] == '')
            $_POST["Razao_Social"] = $_POST["Titulo"];


        $cidade = mysqli_query($con, "Select Id,Titulo,Codigo from cidade_ibge WHERE Codigo='" . $_POST["Cidade"] . "' LIMIT 1 ");
        $cidade = mysqli_fetch_assoc($cidade);
        $id_cidade = $cidade["Id"];
        $nome_cidade = $cidade["Titulo"];
        $codigo_cidade = $cidade["Codigo"];


        mysqli_query($con, "UPDATE fornecedor SET
                            Titulo = '" . limpaNome(trim($_POST["Titulo"])) . "',
                            Cpf_Cnpj = '" . $Cpf_Cnpj . "',
                            Email = '" . trim($_POST["Email"]) . "',
                            Cep = '" . $_POST["Cep"] . "',
                            Rua= '" . limpaNome($_POST["Rua"]) . "',
                            Numero= '" . limpaNome($_POST["Numero"]) . "',
                            Complemento= '" . limpaNome($_POST["Complemento"]) . "',
                            Bairro = '" . limpaNome($_POST["Bairro"]) . "',
                            Fone1 = '" . trim($_POST["Fone1"]) . "',
                            Fone2 = '" . trim($_POST["Fone2"]) . "',
                            Fone3 = '" . trim($_POST["Fone3"]) . "',
                            Natureza = '" . $_POST["Natureza"] . "',
                            Razao_Social = '" . limpaNome($_POST["Razao_Social"]) . "',
                            Estadual = '" . $_POST["Estadual"] . "',
                            Ativo = 'Sim',
                            Id_Categoria_Fornecedor = '" . $_POST["Categoria_Fornecedor"] . "',
                            Id_Categoria_Fornecedor_Filho = '" . $_POST["Categoria_Fornecedor_Filho"] . "',
                            Pais = 'BRASIL',
                            Codigo_Pais = '1058',
                            Contato = '" . $_POST["Contato"] . "',
                            Id_Unidade = '" . $_POST["Unidade"] . "',
                            Ponto_Referencia = '" . $_POST["Ponto_Referencia"] . "',
                            Cidade = '" . limpaNome($nome_cidade) . "',
                            Id_Cidade = '" . $id_cidade . "',
                            Codigo_Cidade = '" . $codigo_cidade . "',
                            Estado = '" . $_POST["Estado"] . "',
                            Id_Estado = '" . $_POST["Id_Estado"] . "',
                            Tipo = 'F',
                            " . $padraoUpd . "
                            WHERE Id='" . $_POST["Id_Fornecedor"] . "' ")
            or die("Erro no comando SQL:" . mysqli_error($con));

        echo "<script>location.href='importar_produto.php?Chave=" . $_POST["Chave"] . "&Unidade=" . $_POST["Unidade"] . "&Id_Fornecedor=" . $_POST["Id_Fornecedor"] . "'</script>";
    } else {
        //alerta de campos obrigatrios
        if (!$_POST["Titulo"]) {
            $obrig .= 'Nome, ';
        }
        if (!$_POST["Fone1"]) {
            $obrig .= 'Telefone 1, ';
        }
        if (!$_POST["Email"]) {
            $obrig .= 'Email, ';
        }
        if ($verify_email === false) {
            $obrig .= 'Email Errado, ';
        }
        //cnpj obrigatorio
        if (CNPJ_FORNECEDOR == 'Sim') {
            if (!$Cpf_Cnpj) {
                $obrig .= 'Cnpj ou Cpf, ';
            }
        }
        $obrig = substr($obrig, 0, -2);

        $msg = "Faltou Preencher: " . $obrig;
    }
}

if ($cnpj_xml == '' && $_SERVER['REQUEST_METHOD'] != "POST") {
    echo "<script>alert('Erro da Nota!');</script>";
    $_POST["Id_Fornecedor"] = '';
    $_GET["Chave"] = '';
    $_GET["Unidade"] = '';
    echo "<script>location.href='importar_compra.php';</script>";
}
?>
<html>

<head>
    <title>Gw - Gesto Web</title>
    <?php include 'cabecalho.php'; ?>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tableless.css" />
    <script language="javascript" type="text/javascript" src="../js/jquery.js"></script>
    <script language="javascript" type="text/javascript" src="../js/script.js"></script>
    <script type="text/javascript" language="javascript" src="../js/meiomask/meiomask.js"></script>
    <?php include '../include/script_cabeca.php'; ?>
    <?php include '../include/script_campo.php'; ?>
    <script type="text/javascript" language="javascript">
        $(document).ready(function() {
            $("#Titulo_Fornecedor").focus();
        });
    </script>
    <script type="text/javascript" language="javascript">
        $(document).ready(function() {
            $('input[name="Cpf"]').setMask('cpf'); // cpf
            $('input[name="Cnpj"]').setMask('cnpj'); // cnpj
            $('input[name="Cep"]').setMask('cep'); // cep
        });
    </script>
    <script type="text/javascript" language="javascript">
        function comboEstado(valor) {
            $.post("../fornecedor/busca_cidade.php", {
                    Id: valor
                },
                function(data) {
                    $("#divCidade").html(data);
                });
        };
    </script>
    <script type="text/javascript" language="javascript">
        function centroCusto(valor) {
            $.post("../fornecedor/busca_categoria_fornecedor.php", {
                    Categoria_Fornecedor: valor
                },
                function(data) {
                    $("#div_cc").html(data);
                });
        }
    </script>
</head>

<body>

    <fieldset class="envolve">

        <form action="" method="post" name="status">
            <input type="hidden" name="Id_Fornecedor" id="Id_Fornecedor" value="<?php echo $_POST["Id_Fornecedor"]; ?>" />
            <input type="hidden" name="Chave" id="Chave" value="<?php echo $_GET["Chave"]; ?>" />
            <input type="hidden" name="Unidade" id="Unidade" value="<?php echo $_GET["Unidade"]; ?>" />

            <fieldset class="grupo">
                <legend>Fornecedor</legend>
                <div class="campo" style="width: 80%">
                    <label for="Titulo">* Nome</label>
                    <input type="text" name="Titulo" id="Titulo" value="<?php echo $_POST["Titulo"]; ?>" />
                </div>
                <div class="campo" style="width: 40%">
                    <label for="Fone1">* Telefone</label>
                    <input type="text" name="Fone1" id="Fone1" value="<?php echo $_POST["Fone1"]; ?>" />
                </div>
                <div class="campo" style="width: 40%">
                    <label for="Fone2">Telefone 2</label>
                    <input type="text" name="Fone2" id="Fone2" value="<?php echo $_POST["Fone2"]; ?>" />
                </div>
                <div class="campo" style="width: 50%">
                    <label for="Email">Email</label>
                    <input type="text" name="Email" id="Email" value="<?php echo $_POST["Email"]; ?>" />
                </div>
                <div class="campo" style="width: 30%">
                    <?php
                    if ($_POST["Natureza"] == "PF") {
                        $exibirPF = "block";
                        $exibirPJ = "none";
                        $marcPF = "checked";
                    } else if ($_POST["Natureza"] == "PJ") {
                        $exibirPJ = "block";
                        $exibirPF = "none";
                        $marcPJ = "checked";
                    } else {
                        $exibirPF = "none";
                        $exibirPJ = "block";
                        $marcPF = "checked";
                    }
                    ?>
                    <label for="Natureza" key="Natureza" class="tr">Natureza</label>
                    <?php
                    $vetor = array('PJ' => '&nbsp;&nbsp; PJ &nbsp;&nbsp;', 'PF' => '&nbsp;&nbsp; PF &nbsp;&nbsp;');
                    select_tela("Natureza", "Natureza", $_POST["Natureza"], $vetor, "onchange='PfPj(this.value);'", "");
                    ?>
                </div>
            </fieldset>

            <div style="display:<?php echo $exibirPF; ?>;" id="P_F">

                <fieldset class="grupo">
                    <div class="campo">
                        <?php
                        if (CNPJ_CLIENTE == 'Sim') {
                            $ast_pf = '*';
                        }
                        if (VALIDAR_CNPJ_CLIENTE == 'Sim') {
                            $v_cpf = "validarCpf(this.value);";
                        }
                        ?>
                        <label for="Cpf" key="Cpf" class="tr"><?php echo $ast_pf; ?> CPF</label>
                        <input type="text" name="Cpf" id="Cpf" value="<?php echo $_POST["Cpf"]; ?>" onblur="fazSenha(this.value);<?php echo $v_cpf; ?>">
                    </div>
                </fieldset>

            </div>


            <div style="display:<?php echo $exibirPJ; ?>;" id="P_J">

                <fieldset class="grupo">
                    <div class="campo" style="width:40%">
                        <?php
                        if (CNPJ_CLIENTE == 'Sim') {
                            $ast_pj = '*';
                        }
                        if (VALIDAR_CNPJ_CLIENTE == 'Sim') {
                            $v_cnpj = "validarCnpj(this.value);";
                        }
                        ?>
                        <label for="Cnpj" key="Cnpj" class="tr"><?php echo $ast_pj; ?> CNPJ</label>
                        <input type="text" name="Cnpj" id="Cnpj" value="<?php echo $_POST["Cnpj"]; ?>" onblur="fazSenha(this.value);<?php echo $v_cnpj; ?>">
                    </div>
                    <div class="campo" style="width:40%">
                        <label for="Razao_Social" key="Razao_Social" class="tr">Razo Social</label>
                        <input type="text" name="Razao_Social" id="Razao_Social" value="<?php echo $_POST["Razao_Social"]; ?>">
                    </div>
                    <div class="campo">
                        <label for="Estadual" key="Estadual" class="tr">Insc Estadual</label>
                        <input type="text" name="Estadual" id="Estadual" value="<?php echo $_POST["Estadual"]; ?>">
                    </div>
                </fieldset>

            </div>

            <fieldset class="grupo">
                <div class="campo">
                    <label for="Categoria_Fornecedor" key="Categoria_Fornecedor" class="tr">Categoria</label>
                    <?php
                    echo select_banco(
                        "Select Id, Titulo from categoria_fornecedor WHERE Id_Pai='' order by Titulo",
                        "Categoria_Fornecedor",
                        "Categoria_Fornecedor",
                        $_POST["Categoria_Fornecedor"],
                        "onchange='centroCusto(this.value);' style='width:200px'",
                        ""
                    )
                    ?>
                </div>
                <div class="campo">
                    <label for="Categoria_Cliente_Filho" key="Categoria_Fornecedor_Filho" class="tr">Sub Categoria</label>
                    <div id="div_cc">
                        <?php
                        echo select_banco(
                            "Select Id, Titulo from categoria_fornecedor WHERE Id_Pai = '" . $_POST["Categoria_Fornecedor"] . "' order by Titulo",
                            "Categoria_Fornecedor_Filho",
                            "Categoria_Fornecedor_Filho",
                            $_POST["Categoria_Fornecedor_Filho"],
                            "style='width:200px'",
                            ""
                        )
                        ?>
                    </div>
                </div>
            </fieldset>

            <fieldset class="grupo">
                <div class="campo">
                    <label for="Cep" key="Cep" class="tr">CEP</label>
                    <input type="text" name="Cep" id="Cep" value="<?php echo $_POST["Cep"]; ?>">
                </div>
                <div class="campo" style="width:60%;">
                    <label for="Rua" key="Rua" class="tr">Endereo</label>
                    <input type="text" name="Rua" id="Rua" value="<?php echo $_POST["Rua"]; ?>">
                </div>
                <div class="campo">
                    <label for="Numero" key="Numero" class="tr">Nmero</label>
                    <input type="text" name="Numero" id="Numero" value="<?php echo $_POST["Numero"]; ?>">
                </div>
                <div class="campo">
                    <label for="Rua" key="Bairro" class="tr">Bairro</label>
                    <input type="text" name="Bairro" id="Bairro" value="<?php echo $_POST["Bairro"]; ?>">
                </div>
                <div class="campo" style="width:60%;">
                    <label for="Complemento" key="Complemento" class="tr">Complemento</label>
                    <input type="text" name="Complemento" id="Complemento" value="<?php echo $_POST["Complemento"]; ?>">
                </div>
            </fieldset>

            <fieldset class="grupo">
                <div class="campo">
                    <label for="Cidade" key="Cidade" class="tr">Cidade</label>
                    <div id="divCidade">
                        <?php
                        $cidade = mysqli_query($con, "SELECT Codigo FROM cidade_ibge WHERE Id = '" . $_POST['Cidade'] . "' ");
                        $nome_cidade = mysqli_fetch_assoc($cidade);
                        $_POST["Cidade"] = $nome_cidade["Codigo"];

                        //eu troco o ID do select para funcionar o WebService
                        $cidadeUf = ((empty($_POST["Estado"])) ? null : "AND Uf='" . $_POST["Estado"] . "'");
                        echo select_banco(
                            "Select Codigo as Id,Titulo from cidade_ibge WHERE 1=1 $cidadeUf order by Titulo",
                            "Cidade",
                            "Ibge",
                            $_POST["Cidade"],
                            '',
                            ""
                        );
                        ?>
                    </div>
                </div>
                <div class="campo">
                    <label for="Estado" key="Estado" class="tr">Estado</label>
                    <?php
                    $vetor = array(
                        '' => 'Estados', 'AC' => 'Acre', 'AL' => 'Alagoas', 'AP' => 'Amap', 'AM' => 'Amazonas', 'BA' => 'Bahia',
                        'CE' => 'Cear', 'DF' => 'Distrito Federal', 'GO' => 'Gois', 'ES' => 'Esprito Santo',
                        'MA' => 'Maranho', 'MT' => 'Mato Grosso', 'MS' => 'Mato Grosso do Sul',
                        'MG' => 'Minas Gerais', 'PA' => 'Par', 'PB' => 'Paraba', 'PR' => 'Paran',
                        'PE' => 'Pernambuco', 'PI' => 'Piau', 'RJ' => 'Rio de Janeiro',
                        'RN' => 'Rio Grande do Norte', 'RS' => 'Rio Grande do Sul',
                        'RO' => 'Rondnia', 'RR' => 'Rorima', 'SP' => 'So Paulo',
                        'SC' => 'Santa Catarina', 'SE' => 'Sergipe', 'TO' => 'Tocantis',
                        'EX' => 'EX'
                    );
                    select_tela("Estado", "Estado", $_POST["Estado"], $vetor, 'onchange="comboEstado(this.value);"', "");
                    ?>
                    <input type="hidden" name="Id_Estado" id="Id_Estado" value="<?php echo $_POST["Estado"]; ?>">
                </div>
            </fieldset>


            <br /><br />

            <button class="bt_cadastro" type="submit" name="Cadastrar" value="Cadastrar">Atualizar</button>
            <button class="botao" type="button" name="Cancelar" value="Cancelar" onclick="window.close();">Cancelar</button>

        </form>

        <br /><br />

    </fieldset>

    <?php include "../include/rodape.php"; ?>
</body>

</html>