<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
use Sicacred\App\Model\Sicacred;
use Sicacred\App\Config\Unidade;
use SicaCred\App\Model\Integration\SicaPrm;
use Sicacred\App\Model\Integration\SicaCli;
use Sicacred\App\Model\Integration\SicaCpr;
use Sicacred\App\Model\Integration\SicaDoc;
use Sicacred\App\Model\Integration\SicaFmp;
use Sicacred\App\Model\Integration\SicaFmpMap;
use Sicacred\App\Model\Integration\DtoSicaIntegrator;

$autorizadosSicacred = [
    "tupanfarmaatacado",
    "tupanfarmadistribuidora",
    "tupansaude",
    "gw"
];
if(in_array(CLIENTE_EMAIL, $autorizadosSicacred)) {
    $teste = $con->query("SELECT Titulo, Prazo01 FROM tipo_pagamento WHERE Id=111");
    $teste = $teste->fetch_assoc();
    $teste['Titulo'] = strtolower($teste['Titulo']);

    if($_SERVER['REQUEST_METHOD'] == 'POST') {
        $ultimoEnvio = Sicacred::consultarDatas();
        $dataInicial = new DateTime($ultimoEnvio->DataEnvioArquivo);
        $dataFinal = new DateTime();
        $request = file_get_contents("php://input");
        $request = json_decode($request);
        $unidade = new Unidade();
        $codigoFonte = $unidade->codigoFonte();
        $DtoSicaIntegrator = new DtoSicaIntegrator();
        $DtoSicaIntegrator->Producao = false;
        $DtoSicaIntegrator->SicaPrm = new SicaPrm(
            $codigoFonte,
            (int) $unidade->usuario(),
            $dataFinal->format("Y-m-d"),
            $dataInicial->format("Y-m-d"),
            $dataFinal->format("Y-m-d")
        );
        $tpPagamentosSica = [
            "AV" => " VISTA",
            "CH" => "CHEQUE PR-DATADO",
            "CD" => "CHEQUE DEVOLVIDO",
            "DP" => "DUPLICATA",
            "NP" => "NOTA PROMISSRIA",
            "BL" => "BOLETO BANCARIO",
            "DB" => "DEPSITO BANCARIO",
            "CA" => "CARTO",
            "CT" => "CARTEIRA"
        ];

        $sqlVenda = "SELECT venda.Id, venda.Lancamento, venda.Id_Tipo_Pagamento, venda.Id_Cliente, venda.Data_Venda, venda.Valor_Original,
        tipo_pagamento.Titulo Tipo_Pagamento, venda.Data_Conclusao FROM venda 
        LEFT JOIN tipo_pagamento ON tipo_pagamento.Id = venda.Id_Tipo_Pagamento 
        WHERE venda.Id_Cliente NOT IN ('84c09c43f28bc1c9823907b038508c7c','') AND venda.Valor_Original > 0";
        
        $sqlCliente = "SELECT Codigo, Data_Cadastro, Razao_Social, Titulo, Cpf_Cnpj, Endereco, Bairro, Cidade, Estado, Cep, Fone1, Email,
        Ativo, Inadimplente, Limite_Credito FROM cliente";

        switch($request->tipoRemessa) {
            case "clientes":
                $clientes = $con->query("$sqlCliente WHERE Id NOT IN('84c09c43f28bc1c9823907b038508c7c', '') AND 
                Date(Data_Cadastro_Upd) BETWEEN DATE('{$dataInicial->format('Y-m-d')}') AND DATE('{$dataFinal->format('Y-m-d')}')");
                $DtoSicaIntegrator->SicaCli = [];

                while($cliente = $clientes->fetch_assoc()) {
                    $dataCadastro = new DateTime($cliente['Data_Cadastro']);
                    $situacao = $cliente['Inadimplente'] == "Sim" ? "Negativo" : ($cliente['Ativo'] == "Sim" ? "Ativo" : "Inativo");
                    array_push($DtoSicaIntegrator->SicaCli,
                        new SicaCli(
                            $codigoFonte,
                            $cliente['Codigo'],
                            $dataCadastro->format("Y-m-d"),
                            utf8_encode($cliente['Razao_Social']),
                            utf8_encode($cliente['Titulo']),
                            $cliente['Cpf_Cnpj'],
                            utf8_encode($cliente['Endereco']),
                            utf8_encode($cliente['Bairro']),
                            utf8_encode($cliente['Cidade']),
                            $cliente['Estado'],
                            $cliente['Cep'],
                            $cliente['Fone1'],
                            $cliente['Email'],
                            $situacao,
                            (float) $cliente['Limite_Credito']
                        )
                    );
                }
                break;
            case "titulos":
                $sqlVenda .= " AND venda.Status='Finalizado' AND 
                DATE(venda.Data_Conclusao) BETWEEN DATE('{$dataInicial->format('Y-m-d')}') AND DATE('{$dataFinal->format('Y-m-d')}')";
        }
        
        if($request->tipoRemessa != "clientes") {
            $clientesLidos = [];
            $tpPagamentosLidos = [];
            $codigoPagamentoLido = [];
            $DtoSicaIntegrator->SicaCli = [];
            $DtoSicaIntegrator->SicaFmp = [];
            $DtoSicaIntegrator->SicaFmpMap = [];
            $DtoSicaIntegrator->SicaCpr = [];
            $DtoSicaIntegrator->SicaDoc = [];
            $vendas = $con->query($sqlVenda);
            
            if($vendas->num_rows > 0) {
                while($venda = $vendas->fetch_assoc()) {
                    $cliente = $con->query("$sqlCliente WHERE Id = '{$venda['Id_Cliente']}'");
                    $cliente = $cliente->fetch_assoc();
                    $venda['Tipo_Pagamento'] = strtolower($venda['Tipo_Pagamento']);
                    $pagamentoSica = (strpos($venda['Tipo_Pagamento'], "cartao") !== false || strpos($venda['Tipo_Pagamento'], "carto") !== false ||
                    strpos($venda['Tipo_Pagamento'], "credito") > 0) ? "CA" : "";
    
                    if(empty($pagamentoSica)) {
                        $pagamentoSica = (strpos($venda['Tipo_Pagamento'], "dinheiro") !== false || strpos($venda['Tipo_Pagamento'], "pix") !== false || 
                        strpos($venda['Tipo_Pagamento'], "debito") !== false || strpos($venda['Tipo_Pagamento'], "dbito") !== false) ? "AV" : "";
                        if(strpos($venda['Tipo_Pagamento'], "cheque") !== false) {
                            $pagamentoSica = $pagamentoSica['Prazo01'] == 0 ? "AV" : "CH";
                        }
                    }
                    if(empty($pagamentoSica)) {
                        $pagamentoSica = strpos($venda['Tipo_Pagamento'], "boleto") !== false ? "BL" : ""; 
                    }
                    if(empty($pagamentoSica)) {
                        $pagamentoSica = (strpos($venda['Tipo_Pagamento'], "deposito") !== false || strpos($venda['Tipo_Pagamento'], "depsito") !== false) ? "DB" : "";
                    }
                    $pagamentoSica = empty($pagamentoSica) ? "BL" : $pagamentoSica;
    
                    if(!in_array($venda['Id_Cliente'], $clientesLidos)) {
                        $dataCadastro = new DateTime($cliente['Data_Cadastro']);
                        $situacao = $cliente['Inadimplente'] == "Sim" ? "Negativo" : ($cliente['Ativo'] == "Sim" ? "Ativo" : "Inativo");
                        array_push($DtoSicaIntegrator->SicaCli,
                            new SicaCli(
                                $codigoFonte,
                                $cliente['Codigo'],
                                $dataCadastro->format("Y-m-d"),
                                utf8_encode($cliente['Razao_Social']),
                                utf8_encode($cliente['Titulo']),
                                $cliente['Cpf_Cnpj'],
                                utf8_encode($cliente['Endereco']),
                                utf8_encode($cliente['Bairro']),
                                utf8_encode($cliente['Cidade']),
                                $cliente['Estado'],
                                $cliente['Cep'],
                                $cliente['Fone1'],
                                utf8_encode($cliente['Email']),
                                $situacao,
                                (float) $cliente['Limite_Credito']
                            )
                        );
                        array_push($clientesLidos, $venda['Id_Cliente']);
                    }
                    if(empty($venda['Id_Tipo_Pagamento'])) {
                        $tipoPagamento =  $con->query("SELECT conta_receber.Id_Tipo_Pagamento FROM conta_receber WHERE Id_Externo='{$venda['Id']}' LIMIT 1");
                        if($tipoPagamento->num_rows > 0) {
                            $tipoPagamento = $tipoPagamento->fetch_assoc()['Id_Tipo_Pagamento'];
                        }
                        else {
                            $tipoPagamento = $con->query("SELECT Id FROM tipo_pagamento WHERE Titulo LIKE '%BOLETO%' LIMIT 1");
                            $tipoPagamento = $tipoPagamento->fetch_assoc()['Id'];
                        }
                        $venda['Id_Tipo_Pagamento'] = $tipoPagamento;
                    }
                    if(!in_array($tpPagamentosSica[$pagamentoSica], $tpPagamentosLidos)) {
                        array_push($DtoSicaIntegrator->SicaFmp,
                            new SicaFmp(
                                $pagamentoSica,
                                utf8_encode($tpPagamentosSica[$pagamentoSica])
                            )
                        );
        
                        array_push($tpPagamentosLidos, $tpPagamentosSica[$pagamentoSica]);
                    }
                    if(!in_array($venda['Id_Tipo_Pagamento'], $codigoPagamentoLido)) {
                        array_push($DtoSicaIntegrator->SicaFmpMap,
                            new SicaFmpMap(
                                $codigoFonte,
                                $venda['Id_Tipo_Pagamento'],
                                $pagamentoSica
                            )
                        );
                        array_push($codigoPagamentoLido, $venda['Id_Tipo_Pagamento']);
                    }

                    array_push($DtoSicaIntegrator->SicaCpr,
                        new SicaCpr(
                            $codigoFonte,
                            $venda['Lancamento'],
                            $cliente['Codigo'],
                            $venda['Data_Conclusao'],
                            $venda['Valor_Original'],
                            $pagamentoSica == "AV" ? "N" : "S",
                            $venda['Id_Tipo_Pagamento'] //$pagamentoSica
                        )
                    );
            
                    $contasReceber = $con->query("SELECT conta_receber.Lancamento, conta_receber.Data_Cadastro, conta_receber.Id_Tipo_Pagamento,
                    conta_receber.Data_Emissao, conta_receber.Data_Vencimento, conta_receber.Data_Pagamento, conta_receber.Valor_Original,
                    conta_receber.Valor_Pago, conta_receber.Parcela, conta_receber.Id_Cliente, tipo_pagamento.Id Codigo_Pagamento,
                    tipo_pagamento.Titulo Tipo_Pagamento FROM conta_receber JOIN tipo_pagamento 
                    ON tipo_pagamento.Id = conta_receber.Id_Tipo_Pagamento
                    WHERE conta_receber.Id_Externo='{$venda['Id']}' AND conta_receber.Valor_Original > 0 AND 
                    (conta_receber.Status = 'Aberto' OR (conta_receber.Status = 'Liquidado' AND 
                    DATE(conta_receber.Data_Pagamento) BETWEEN DATE('{$dataInicial->format('Y-m-d')}') AND DATE('{$dataFinal->format('Y-m-d')}')))");

                    if($contasReceber->num_rows > 0) {
                        while($titulo = $contasReceber->fetch_assoc()) {
                            $pagamentoSica = (strpos($titulo['Codigo_Pagamento'], "cartao") !== false || strpos($titulo['Codigo_Pagamento'], "carto") !== false ||
                            strpos($titulo['Codigo_Pagamento'], "credito") > 0) ? "CA" : "";
            
                            if(empty($pagamentoSica)) {
                                $pagamentoSica = (strpos($titulo['Codigo_Pagamento'], "dinheiro") !== false || strpos($titulo['Codigo_Pagamento'], "pix") !== false || 
                                strpos($titulo['Codigo_Pagamento'], "debito") !== false || strpos($titulo['Codigo_Pagamento'], "dbito") !== false) ? "AV" : "";
                                if(strpos($titulo['Codigo_Pagamento'], "cheque") !== false) {
                                    $pagamentoSica = $pagamentoSica['Prazo01'] == 0 ? "AV" : "CH";
                                }
                            }
                            if(empty($pagamentoSica)) {
                                $pagamentoSica = strpos($titulo['Codigo_Pagamento'], "boleto") !== false ? "BL" : ""; 
                            }
                            if(empty($pagamentoSica)) {
                                $pagamentoSica = (strpos($titulo['Codigo_Pagamento'], "deposito") !== false ||
                                strpos($titulo['Codigo_Pagamento'], "depsito") !== false) ? "DB" : "";
                            }
                            $pagamentoSica = empty($pagamentoSica) ? "BL" : $pagamentoSica;
                            if(!in_array($tpPagamentosSica[$pagamentoSica], $tpPagamentosLidos)) {
                                array_push($DtoSicaIntegrator->SicaFmp,
                                    new SicaFmp(
                                        $pagamentoSica,
                                        utf8_encode($tpPagamentosSica[$pagamentoSica])
                                    )
                                );
                
                                array_push($tpPagamentosLidos, $tpPagamentosSica[$pagamentoSica]);
                            }
                            if(!in_array($titulo['Codigo_Pagamento'], $codigoPagamentoLido)) {
                                array_push($DtoSicaIntegrator->SicaFmpMap,
                                    new SicaFmpMap(
                                        $codigoFonte,
                                        $titulo['Codigo_Pagamento'],
                                        $pagamentoSica
                                    )
                                );
                                array_push($codigoPagamentoLido, $titulo['Codigo_Pagamento']);
                            }
                            array_push($DtoSicaIntegrator->SicaDoc,
                                new SicaDoc(
                                    $codigoFonte,
                                    $titulo['Lancamento'],
                                    $cliente['Codigo'],
                                    $titulo['Data_Emissao'],
                                    $titulo['Data_Vencimento'],
                                    $titulo['Data_Pagamento'],
                                    $titulo['Valor_Original'],
                                    $titulo['Valor_Pago'],
                                    $titulo['Codigo_Pagamento'] //$pagamentoSica
                                )
                            );
                        }
                    }
                }
            }
        }
        // echo json_encode($DtoSicaIntegrator);
        $postFile = Sicacred::postFile($DtoSicaIntegrator);
        echo json_encode($postFile);
        return;
    }
    ?>
    <!DOCTYPE html>
    <html>
    <head>
        <title>Remessa Sicacred</title>
        <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN ;?>/tableless.css" />
        <style>
            form {
                display:flex;
                width:100%;
                min-height:100vh;
                margin:0!important;
                align-items: center;
                flex-direction: column;
            }
            .d-flex {
                display: flex;
            }
            .flex-column {
                flex-direction: column;
            }
            input {
                padding: 5px;
            }
            .tipo-filtro {
                display: flex;
                margin: 20px 0;
                width: 95%;
                justify-content: space-around;
                background-color: #baaaff;
                padding: 20px 0;
                border-radius: 5px;
            }
            label {
                font-weight: bolder;
            }
        </style>
    </head>
    <body>
        <form class="envolve" id="remessaSicacred" method="post">
            <h2 style="margin-top:20px">Remessa Sicacred</h2>
            <div class="tipo-filtro">
                <label style="text-align: center;">
                    <input type="radio" name="tipoRemessa" value="clientes">
                    Cadastro Cliente
                </label>
                <label style="text-align: center;">
                    <input type="radio" name="tipoRemessa" value="titulos">
                    Contas a Receber
                </label>
            </div>
            <div>
                <button class="botao" type="submit" style="margin-top:45px">Enviar</button>
            </div>
        </form>
        <script>
            document.getElementById("remessaSicacred").addEventListener("submit", async function(e) {
                e.preventDefault();

                if(!document.querySelector("input[name=tipoRemessa]:checked")) {
                    alert("Selecione o tipo da remessa");
                    return;
                }
                let tipoRemessa = document.querySelector("input[name=tipoRemessa]:checked").getAttribute("value");
                document.querySelector("button[type=submit]").setAttribute("disabled", true);
                document.querySelector("button[type=submit]").innerHTML = "Aguarde...";
                document.querySelector("button[type=submit]").style.cursor = "default";

                await fetch("./remessa_sicacred.php", {
                    method: "POST",
                    headers: {
                        "Content-Type": "application/json"
                    },
                    body: JSON.stringify({
                        tipoRemessa: tipoRemessa
                    }),
                }).then(response => response.json())
                .then(response => {
                    alert(response.MensagemRetorno);
                    if(response.MensagemRetorno == "Enviado com sucesso!") {
                        document.getElementById("remessaSicacred").reset();
                    }
                }).catch(error => {
                    console.log('request failed', error);
                    alert("H problemas com os dados encontrados");
                });
                document.querySelector("button[type=submit]").removeAttribute("disabled");
                document.querySelector("button[type=submit]").innerHTML = "Enviar";
                document.querySelector("button[type=submit]").style.cursor = "pointer";
            })
        </script>
    </body>
    </html>
 <?php } ?>