<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa

error_reporting(E_ALL);

function __backup_mysql_database($params){
	$tabelas = [];
	$contents = "-- Database: `{$params['db_to_backup']}` --\n";
	
	$mysqli = new mysqli($params['db_host'], $params['db_uname'], $params['db_password'], $params['db_to_backup']);
	if ($mysqli->connect_error) {
		die("Error : ($mysqli->connect_errno) $mysqli->connect_error");
	}
	
	$results = $mysqli->query("SHOW TABLES");
	
	while($row = $results->fetch_array(MYSQLI_NUM)){
		//if (!in_array($row[0], $params['db_exclude_tables'])){
			$tabelas[] = $row[0];
		//}
	}
	foreach($tabelas as $table){
		$contents .= "-- Table `$table` --\n";
		
		$results = $mysqli->query("SHOW CREATE TABLE $table");
		while($row = $results->fetch_array(MYSQLI_ASSOC)){
			$contents .= "{$row['Create Table']};\n\n";
		}

		$results = $mysqli->query("SELECT * FROM $table");
		$row_count = $results->num_rows;
		$fields = $results->fetch_fields();
		$fields_count = count($fields);
		
		$insert_head = "INSERT INTO `$table` (";
		for($i=0; $i < $fields_count; $i++){
			$insert_head  .= $i < $fields_count - 1 ? "`{$fields[$i]->name}`, " : "`{$fields[$i]->name}`";
		}
		$insert_head .=  ")";
		$insert_head .= " VALUES\n";		
	
		if($row_count > 0){
			$r = 0;
			while($row = $results->fetch_array(MYSQLI_NUM)){
				if(($r % 400)  == 0){
					$contents .= $insert_head;
				}
				$contents .= "(";
				for($i=0; $i < $fields_count; $i++){
					$row_content = 	str_replace("\n","\\n",$mysqli->real_escape_string($row[$i]));
					
					switch($fields[$i]->type){
						case 8: case 3:
							$contents .=  empty($row_content) ? "''" : $row_content;
							break;
						default:
							$contents .= "'". str_replace("\'", "", $row_content) ."'";
					}
					if($i < $fields_count-1){
						$contents  .= ', ';
					}
				}
				$contents .= ($r + 1 == $row_count || ($r % 400) == 399) ? ");\n\n" : "),\n";
				$r++;
			}
		}
	}
	
	//if (!is_dir ( $params['db_backup_path'] )) {
            //mkdir ( $params['db_backup_path'], 0777, true );
        //}
	
	$backup_file_name = "sql-backup-".date( "d-m-Y").".sql";
		 
	$fp = fopen($backup_file_name ,'w+');
	if (($result = fwrite($fp, $contents))) {
            //echo "--Backup file created '--$backup_file_name' ($result) \n"; 
	}
	fclose($fp);
        
	return $backup_file_name;    
}

$para = array(
	'db_host'=> $host,  //mysql host
	'db_uname' => $usuario,  //user
	'db_password' => $password, //pass
	'db_to_backup' => $dbname, //database name
	//'db_backup_path' => '/home/my_wordpress/', //where to backup
	//'db_exclude_tables' => array('wp_comments','wp_w3tc_cdn_queue') //tables to exclude
);
$nome_arquivo = __backup_mysql_database($para);

// Configuramos os headers que sero enviados para o browser
header('Content-Description: File Transfer');
header('Content-Disposition: attachment; filename="'.$nome_arquivo.'"');
header('Content-Type: application/octet-stream');
header('Content-Transfer-Encoding: binary');
header('Content-Length: ' . filesize($nome_arquivo));
header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
header('Pragma: public');
header('Expires: 0');

// Envia o arquivo para o cliente
readfile($nome_arquivo);

//copiando e deletando o arquivo
//$origem = 'arquivo.txt';
//$destino = 'pasta/example.txt';
//copy($origem, $destino);
unlink($nome_arquivo);
?>