
const handlePhone = (event) => {
    let input = event.target
    input.value = phoneMask(input.value)
  }
  
  const phoneMask = (value) => {
    if (!value) return ""
    value = value.replace(/\D/g,'')
    value = value.replace(/(\d{2})(\d)/,"($1) $2")
    value = value.replace(/(\d)(\d{4})$/,"$1-$2")
    return value
  }



async function buscarEndereco({ cep }) {
    let endereco = await $.get(`https://viacep.com.br/ws/${cep}/json/`)
    return endereco;
}

function formatarCep(e) {

    var v = e.target.value.replace(/\D/g, "")
    v = v.replace(/^(\d{5})(\d)/, "$1-$2")
    e.target.value = v;
}
$(document).ready(function () {

    $("#cepEndereco").keyup(async function (e) {
        formatarCep(e)
        let cep = $(this).val();

        if (cep.length == 9) {
            cep = cep.match(/\d+/g).join('');
            let endereco = await buscarEndereco({
                cep: cep
            });
            if (!endereco.erro) {
                $("#ruaEndereco").val(endereco.logradouro);
                $("#bairroEndereco").val(endereco.bairro);
                $("#cidadeEndereco").val(endereco.localidade);
                $("#estadoEndereco").val(endereco.uf);
                $("#ibge").val(endereco.ibge);
                $("#complementoEndereco").val(endereco.complemento);
            }
        }
    });

})


function cadastrarEndereco() {
    let idCliente = $("#idCliente").val();
    let nomeContato = $("#nomeContato").val();
    let telefoneContato = $("#telefoneContato").val();
    let cepEndereco = $("#cepEndereco").val();
    let ruaEndereco = $("#ruaEndereco").val();
    let cidadeEndereco = $("#cidadeEndereco").val();
    let bairroEndereco = $("#bairroEndereco").val();
    let numeroEndereco = $("#numeroEndereco").val();
    let estadoEndereco = $("#estadoEndereco").val();
    let complementoEndereco = $("#complementoEndereco").val();
    let ibge = $("#ibge").val();
    let idEndereco = $("#idEndereco").val();

    let url = idEndereco.length == 0 ? 'criar_endereco_entrega.php' : 'alterar_endereco_entrega.php';

    if (idCliente && nomeContato != '' && ruaEndereco != '' && cepEndereco != '' && numeroEndereco != '' && telefoneContato != '') {
        $.post(url, {
            idCliente,
            nomeContato,
            telefoneContato,
            cepEndereco,
            ruaEndereco,
            cidadeEndereco,
            bairroEndereco,
            numeroEndereco,
            estadoEndereco,
            complementoEndereco,
            ibge,
            idEndereco
        },
            function (data) {

                let retorno = JSON.parse(data);

                if (retorno.status == true) {
                    $("#nomeContato").val('');
                    $("#telefoneContato").val('');
                    $("#cepEndereco").val('');
                    $("#ruaEndereco").val('');
                    $("#cidadeEndereco").val('');
                    $("#bairroEndereco").val('');
                    $("#numeroEndereco").val('');
                    $("#estadoEndereco").val('');
                    $("#complementoEndereco").val('');

                    $("#cadastrarEndereco").modal('hide');

                    if (idEndereco.length == 0) {
                        $("#outrosEnderecos").append(`
                            <div class="endereco" data-idEndereco='${retorno.id}'>
                                <div class="d-flex gap-2">
                                    <div class="d-flex">
                                        <input type="radio" name="enderecoPadrao" id="${retorno.id}">
                                    </div>
                                    <div class="d-flex flex-column">
                                        <span class="contato fw-medium">${retorno.contato}</span>
                                        <span class="ruaEndereco ">${retorno.rua}, ${retorno.numero}</span>
                                        <span class="bairroEndereco ">${retorno.bairro}, ${retorno.cidade}-${retorno.estado}</span>
                                        <span class="telefone ">Telefone: ${retorno.telefone}</span>
                                    </div>
                                </div>

                                <div class="d-flex flex-column justify-content-around w-25">
                                    <button type="button" class="btn btn-outline-primary excluirEndereco" data-idEndereco="${retorno.id}">Excluir</button>
                                    <button type="button" class="btn btn-outline-primary editarEndereco" data-idEndereco="${retorno.id}">Editar</button>
                                </div>
                            </div>
                            `)
                    } else {
                        $(`.endereco[data-idEndereco='${retorno.id}'] .contato`).html(retorno.contato)
                        $(`.endereco[data-idEndereco='${retorno.id}'] .ruaEndereco`).html(`${retorno.rua}, ${retorno.numero}`)
                        $(`.endereco[data-idEndereco='${retorno.id}'] .bairroEndereco`).html(`${retorno.bairro}, ${retorno.cidade}-${retorno.estado}`)
                        $(`.endereco[data-idEndereco='${retorno.id}'] .telefone`).html(retorno.telefone)

                    }
                } else {
                    alert('No foi possvel cadastrar o endereo. Tente novamente.');
                }

            })
    }
}

$("body").on('click', '.editarEndereco', function () {
    let idEndereco = $(this).attr('data-idEndereco');

    $.post("buscar_endereco_entrega.php", {
        idEndereco
    }, function (data) {
        let retorno = JSON.parse(data);

        $("#nomeContato").val(retorno.contato);
        $("#telefoneContato").val(retorno.telefone);
        $("#cepEndereco").val(retorno.cep);
        $("#ruaEndereco").val(retorno.rua);
        $("#cidadeEndereco").val(retorno.cidade);
        $("#bairroEndereco").val(retorno.bairro);
        $("#numeroEndereco").val(retorno.numero);
        $("#estadoEndereco").val(retorno.estado);
        $("#complementoEndereco").val(retorno.complemento);
        $("#idEndereco").val(retorno.id);

        $("#cadastrarEndereco").modal("show");

    })
});

$("body").on('click', '.excluirEndereco', function () {
    let idEndereco = $(this).attr('data-idEndereco');
    let resultado = confirm('Deseja excluir este endereco ?');

    if (resultado == true) {
        $.post("apagar_endereco_entrega.php", {
            idEndereco
        }, function () {
            location.reload();
        })
    }
});

$('body').on('click','input[name="enderecoPadrao"]', function () {
    let idEndereco = $(this).attr('id');
    $.post("./marcar_endereco_padrao.php", {
        idEndereco
    }, function (data) {
        let retorno = JSON.parse(data);

        if (retorno.status == true) {
            location.reload();
        }
    })
});


