<?php
include_once '../include/conecta.php';
session_start();

if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST["Cancelar"])) {
    mysqli_query($con, "DELETE FROM etiqueta");
}

function geraCodigoBarra($numero) {
    $fino = 1;
    $largo = 4.8;
    $altura = 40;

    $barcodes = [
        '00110', '10001', '01001', '11000', '00101', '10100', '01100', '00011', '10010', '01010'
    ];

    for ($f1 = 9; $f1 >= 0; $f1--) {
        for ($f2 = 9; $f2 >= 0; $f2--) {
            $texto = '';
            for ($i = 1; $i < 6; $i++) {
                $texto .= substr($barcodes[$f1], ($i - 1), 1) . substr($barcodes[$f2], ($i - 1), 1);
            }
            $barcodes[($f1 * 10) + $f2] = $texto;
        }
    }

    echo '<img src="imagens/p.gif" width="'.$fino.'" height="'.$altura.'" border="0">';
    echo '<img src="imagens/b.gif" width="'.$fino.'" height="'.$altura.'" border="0">';
    echo '<img src="imagens/p.gif" width="'.$fino.'" height="'.$altura.'" border="0">';
    echo '<img src="imagens/b.gif" width="'.$fino.'" height="'.$altura.'" border="0">';

    $texto = str_pad($numero, (strlen($numero) % 2 ? strlen($numero) + 1 : strlen($numero)), "0", STR_PAD_LEFT);

    while (strlen($texto) > 0) {
        $i = (int) substr($texto, 0, 2);
        $texto = substr($texto, 2);
        $f = $barcodes[$i] ?? '';
        
        for ($j = 1; $j < 11; $j += 2) {
            echo '<img src="imagens/p.gif" width="'.($f[$j - 1] == '0' ? $fino : $largo).'" height="'.$altura.'" border="0">';
            echo '<img src="imagens/b.gif" width="'.($f[$j] == '0' ? $fino : $largo).'" height="'.$altura.'" border="0">';
        }
    }

    echo '<img src="imagens/p.gif" width="'.$largo.'" height="'.$altura.'" border="0">';
    echo '<img src="imagens/b.gif" width="'.$fino.'" height="'.$altura.'" border="0">';
    echo '<img src="imagens/p.gif" width="1" height="'.$altura.'" border="0">';
}

$produto = mysqli_query($con,"SELECT produto.Titulo AS Produto, 
                                        produto.Descricao_Etiqueta, 
                                        produto.Codigo_Barras,
                                        produto.Codigo, 
                                        produto.Codigo_Fornecedor 
                   FROM etiqueta
                   LEFT JOIN produto ON produto.Id = etiqueta.Id_Produto
                   WHERE etiqueta.Tipo = '1'
                   ORDER BY produto.Titulo");
?>
<!DOCTYPE html>
<html lang="pt-br">
<head>
    <meta charset="UTF-8">
    <title>Etiquetas</title>
    <style>
        @media print {
            body { margin: 0; padding: 0; }
            .etiqueta-container {
                width: 60mm;
                display: flex;
                page-break-inside: avoid;
            }
            .etiqueta {
                width: 60mm;
                height: 40mm;
                padding: 8mm;
                box-sizing: border-box;
                text-align: center;
                font-size: 12px;

            }
            .etiqueta:nth-child(2n) { margin-right: 0; }
        }
    </style>
</head>
<body>
    <div class="etiqueta-container">
        <?php foreach ($produto as $chave): ?>
            <div class="etiqueta">
                <b>Beiradeiro</b><br>
                <?= $chave["Descricao_Etiqueta"] ?><br>
                Cod: <?= $chave["Codigo"] ?><br>
                Ref: <?= $chave["Codigo_Fornecedor"] ?><br>
                <?php geraCodigoBarra($chave["Codigo_Barras"]); ?>
            </div>
        <?php endforeach; ?>
    </div>
</body>
</html>
