<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
include_once '../menu_movimento.php';

if ($_GET["Ok"]) {

    if ($_GET["Ano"]) {
        $ano = "AND YEAR(venda.Data_Conclusao) = '" . $_GET["Ano"] . "' ";
        $anoP = "AND YEAR(pdv.Data_Pdv) = '" . $_GET["Ano"] . "' ";
    }

    $produto = mysqli_query($con, "Select produto.Id,
                                          produto.Titulo as 'Produto',
                                      SUM(venda_produto.Qtd) as 'Qtd'
                                    from (
                                            (SELECT Id FROM venda WHERE 1=1 $ano AND Status='Finalizado' AND Financeiro <> 'No' ) 
                                        UNION
                                            (SELECT Id FROM pdv WHERE 1=1 $anoP AND Status='Finalizado' AND Financeiro <> 'No' ) 
                                            )as venda
                              INNER JOIN (
                                            (SELECT Id,Qtd,Id_Produto,Id_Venda, Comissao_Paga as Cancelado FROM venda_produto WHERE Cancelado <> 'Sim')
                                       UNION
                                            (SELECT Id,Qtd,Id_Produto,Id_Pdv as Id_Venda,Cancelado FROM pdv_produto WHERE Cancelado <> 'Sim')
                                         ) as venda_produto ON venda.Id = venda_produto.Id_Venda
                               LEFT JOIN (SELECT Id,Titulo FROM produto) produto ON venda_produto.Id_Produto = produto.Id
                                 group by produto.Id
                                 order by Qtd DESC LIMIT 10");

    $labels = array();
    $valores = array();
    $volta = '0';
    while ($res = mysqli_fetch_assoc($produto)) {

        array_push($labels, CaracteresEspeciais($res['Produto']));
        array_push($valores, number_format($res['Qtd'],2,".",""));
        $volta++;
    }
}
?>
<html>
    <head>
        <title>Gw - Gesto Web</title>
        <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tabelas.css" />
        <style type="text/css">
            table.tabela{
                border-collapse: collapse;
            }
            table.tabela tr td{
                border:1px solid #000000;
            }
            .azul{
                background:#3A5FCD;
            }
            .azul-tr{
                background:#B4CDCD;
            }
            .cinza{
                background:#CFCFCF;
            }
        </style>
        <script language="javascript" src="../js/jquery.js"></script>
        <script language="javascript" src="../js/script.js"></script>
        <script language="javascript" src="../js/chartjs/Chart.js"></script>
        <script language="javascript" src="../js/chartjs/chartjs-plugin-datalabels.js"></script>
        <script type="text/javascript" language="javascript" >
            $(function () {
                // Line chart
                new Chart(document.getElementById("chart"), {
                    type: 'bar',
                    data: {
                        labels: <?php echo json_encode($labels); ?>,
                        datasets: [
                            {
                                label: "Qty",
                                backgroundColor: <?php echo json_encode(cores_hexa($volta)); ?>,
                                //borderColor: <?php echo json_encode(cores_hexa($volta)); ?>,
                                //borderWidth: 1,
                                data: <?php echo json_encode($valores); ?>
                            }
                        ]
                    },
                    options: {
                        legend: {
                            display: true,
                            position: 'top'
                        },
                        responsive: true,
                        title: {
                            display: true,
                            text: 'Os 10 Melhores Produtos'
                        },
                        plugins: {
                            datalabels: {
                                color: 'black',
                                display: function (context) {
                                    return context.dataset.data[context.dataIndex] > 15;
                                },
                                font: {
                                    weight: 'bold'
                                },
                                //formatter: Math.round
                            }
                        },
                        scales: {
                            xAxes: [{
                                    stacked: true
                                }],
                            yAxes: [{
                                    stacked: true
                                }]
                        }

                    }
                });

            });
        </script>
    </head>
    <body>
        <form action="" method="get">
            <table width="100%"><!-- TABELA Q ENVOLVE TODO O CONTEUDO -->
                <tr>
                    <td align="left">Ano : 
                        <?php
                        if (!$_POST["Ano"])
                            $_POST["Ano"] = date('Y');
                        $vetor = array((date('Y') - 2) => (date('Y') - 2),
                            (date('Y') - 1) => (date('Y') - 1),
                            date('Y') => date('Y'),
                            (date('Y') + 1) => (date('Y') + 1),
                            (date('Y') + 2) => (date('Y') + 2));
                        select_tela("Ano", "Ano", $_POST["Ano"], $vetor, '');
                        ?>
                    </td>
                    <td align="right">
                        <input type="submit" value="Ok" name="Ok">
                    </td>
                </tr>
            </table>
        </form>
        <table width="100%">
            <tr>
                <td align="center">
                    <?php if ($_GET["Ok"]) { ?>
                        <canvas id="chart" width="700" height="400"></canvas>
                        <?php } ?>
                </td>
                <!--
                <td align="center">
                <?php if ($_GET["Ok"]) { ?>
                        <img src="../phplot/10produto.php?<?php echo $_SERVER["QUERY_STRING"] ?>" 
                                 alt="Os 10 Melhores Produtos" 
                                 title="Os 10 Melhores Produtos" />
                <?php } ?>
                </td>
                -->
            </tr>
        </table>
        <br>
    </body>
</html>