$(document).ready(function() {
    $(".modal").on("click", function (e) {
        if(e.target.classList.contains("modal-dialog")) {
            $(this).find("input").val('');
            $(this).find(".modal-header > h3").html('');
            $(this).css({'display': 'none', 'z-index': -1});
        }
    });

    $("#cliente").on("keyup", async function(e) {
        let cliente = e.target.value;
        if(cliente.length >= 4) {
            $("#clientes").html('');
            $.post("./venda_buscar_clientes.php", {cliente}, function(response) {
                let {clientes} = JSON.parse(response);

                clientes.map(cliente => {
                    $("#clientes").append(`
                        <option id-cliente="${cliente.Id}" value="${cliente.Codigo} : ${cliente.Titulo}">${cliente.Codigo} : ${cliente.Titulo}</option>
                    `)
                })
            })
        }
        else {
            $("#clientes").html('')
        }
    });

    $("#cliente").on("change", function(e) {
        let cliente = $(this).val();
        $("input[name=IdCliente]").val($(`#clientes option[value="${cliente}"]`).attr("id-cliente"));
    });

    $("#produto").on("keyup", function(e) {
        let produto = e.target.value;
        if(produto.length >= 4) {
            $("#pesquisarProdutos").css('display', 'flex').html('');
            $.post("./venda_buscar_produtos.php", {produto}, function(response){
                let { produtos } = JSON.parse(response);
                produtos.map(produto => {
                    $("#pesquisarProdutos").append(`
                        <div class="produtoPesquisado" id-produto="${produto.Id}">
                            <div class="tituloProduto">
                                ${produto.Codigo} : ${produto.Titulo}
                            </div>
                            <div class="acoesProduto">
                                <div class="qtdProduto">
                                    <button type="button" data-acao="subtrair">-</button>
                                    <input type="text" value="1" class="valorQtd">
                                    <button type="button" data-acao="somar">+</button>
                                </div>
                                <input type="checkbox">
                            </div>
                        </div>
                    `);
                })
            });
        }
        else {
            $(`#pesquisarProdutos`).css('display', 'none').html('');
        }
    });

    $("body").on("click", ".produtoPesquisado .qtdProduto > button[type=button]", function() {
        let qtdProduto = Number($(this).parents(".qtdProduto").find(".valorQtd").val());
        let acao = $(this).attr("data-acao");
        
        if(acao == "subtrair" && qtdProduto > 1 || acao == "somar") {
            qtdProduto =  acao == "subtrair" ? qtdProduto - 1 : qtdProduto + 1;
            $(this).parents(".qtdProduto").find(".valorQtd").val(qtdProduto);
        }
    });

    $("body").on("click", ".produtoPesquisado .acoesProduto > input[type=checkbox]", function() {
        let input = $(this);
        let idProduto = $(this).parents(".produtoPesquisado").attr("id-produto");
        let qtdProduto = $(this).parents(".produtoPesquisado").find(".valorQtd").val();
        let idCliente = $("input[name=IdCliente]").val();
        let idVenda = $("input[name=Codigo_Venda]").val();
        let idUnidade = $("select[name=unidade]").val();
        let lancamento = $("input[name=Lancamento]").val();
        let produtoAdicionado = $(`.bloco-produtos .card-produto[id-produto="${idProduto}"]`).length;

        if(produtoAdicionado) {
            $(this).parents(".produtoPesquisado").remove();
            alert("Produto j adicionado");
        }
        else {
            $.post("./criar_linha.php", {
                    idProduto,
                    idCliente,
                    qtdProduto,
                    idVenda,
                    idUnidade,
                    lancamento
                },
                function(response) {
                    let retorno = JSON.parse(response);
    
                    if(retorno.status == 'erro') {
                        input.prop('checked', false);
                        alert(retorno.mensagem);
                    }
                    else {
                        let produto = retorno.produto;

                        $(".bloco-produtos").append(`
                            <div class="card-produto" id-venda-produto="${produto.vendaProduto}">
                                <div class="produto">${produto.Codigo} : ${produto.Titulo}</div>
                                <div class="qtd">${produto.Qtd}</div>
                                <div class="preco">R$${produto.Total}</div>
                            </div>
                        `);
                        input.parents(".produtoPesquisado").remove();

                        let valorTotal = Number($("input[name=valorPago]").val().replace('R$', '').replace('.', '').replace(',', '.'));
                        valorTotal += Number(produto.Total.replace('.', '').replace(',', '.'));
                        $("input[name=valorPago]").val(valorTotal.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));

                        if($("#tipoPagamento").val() != 'Selecione') {
                            gerarParcelas();
                        }
                    }
                }
            );
        }
    });

    $("body").on("click", ".card-produto", function() {
        let idVendaProduto = $(this).attr("id-venda-produto");

        $.get(`./buscar_informacoes_produto.php?idVendaProduto=${idVendaProduto}`,
            function(response) {
                let retorno = JSON.parse(response);
                if(retorno?.status) {
                    alert(retorno.mensagem);
                }
                else {
                    let {produto} = retorno;
                    $("#modalProduto .modal-header > h3").html(`${produto.Codigo} : ${produto.Titulo}`);
                    $("#modalProduto input[name=preco]").val(produto.Preco);
                    $("#modalProduto input[name=qtdProduto]").val(produto.Qtd);
                    $("#modalProduto input[name=desconto]").val(produto.Desconto);
                    $("#modalProduto input[name=descontoReal]").val(produto.Desconto_Real);
                    $("#modalProduto input[name=idVendaProduto]").val(idVendaProduto);
                    $("#modalProduto select[name=idTabelaPreco]").val(produto.Id_Tabela_Preco);
                }
            }
        )
        $(".modal").css({'display': 'block', 'z-index': 1});
    });

    $("#fecharProduto").on("click", function() {
        $("#modalProduto").css({'display': 'none', 'z-index': -1});
    });

    $("#modalProduto select[name=idTabelaPreco]").on("change", function() {
        let idTabelaPreco = $(this).val();
        let idVendaProduto = $(this).parents("form").find("input[name=idVendaProduto]").val();

        $.get(`./preco_tabela_produto.php?idTabelaPreco=${idTabelaPreco}&idVendaProduto=${idVendaProduto}`,
            function(response) {
                let { Preco } = JSON.parse(response);
                $("#modalProduto input[name=preco]").val(Preco);
            }
        )
    })

    $("#modalProduto #formSalvarProduto").on("submit", function(e) {
        e.preventDefault();
        let data = $(this).serialize();
        let form = $(this);

        $.post("./atualizar_venda_produto.php", data, function(response) {
            let { status, mensagem } = JSON.parse(response);
            
            if(status == 'erro') {
                alert(mensagem);
            }
            else {
                let idVendaproduto = $(form).find("input[name=idVendaProduto]").val();
                let novoPreco = Number($(form).find('input[name=preco]').val().replace('.', '').replace(',', '.'));
                let novaQtd = Number($(form).find('input[name=qtdProduto]').val().replace('.', '').replace(',', '.'));
                let percentualDesconto = Number($(form).find('input[name=desconto]').val().replace('.', '').replace(',', '.'));
                let novoTotalProduto = novaQtd * novoPreco;
                let descontoPercentual = percentualDesconto > 0 ? (novoTotalProduto * percentualDesconto) / 100 : 0;
                let descontoReal = Number($(form).find('input[name=descontoReal]').val().replace('.', '').replace(',', '.'));
                novoTotalProduto -= descontoPercentual + descontoReal;
                
                let cardProduto = $(`.card-produto[id-venda-produto="${idVendaproduto}"]`);
                let totalAnteriorProduto = Number($(cardProduto).find(".preco").html().replace("R$&nbsp;", "").replace('.', '').replace(',', '.'));
                let totalAnteriorVenda = Number($("input[name=valorPago]").val().replace("R$", "").replace('.', '').replace(',', '.'));
                let novoTotalVenda = (totalAnteriorVenda - totalAnteriorProduto) + novoTotalProduto;

                $("input[name=valorPago]").val(novoTotalVenda.toLocaleString("pt-BR", {style: "currency", currency: "BRL"}));
                $(cardProduto).find(".qtd").html($(form).find('input[name=qtdProduto]').val());
                $(cardProduto).find(".preco").html(novoTotalProduto.toLocaleString("pt-BR", {style: "currency", currency: "BRL"}));
                
                $("#modalProduto").css({'display': 'none', 'z-index': -1});
                $("#modalProduto input").val('');
                $("#modalProduto .modal-header > h3").html('');
            }
        });
    });

    $("#tipoPagamento").on("change", gerarParcelas);
})

function gerarParcelas() {
    let idTipoPagamento = $("#tipoPagamento").val();
    let valorPago = $("input[name=valorPago]").val().replace("R$", "");

    $.post("./gerar_parcelas_pagamento.php", {
            idTipoPagamento,
            valorPago
        },
        function(response) {
            let {parcelas} = JSON.parse(response);
            $(".parcelas").html("");

            parcelas.forEach((parcela, index) => {
                $(".parcelas").append(`
                    <div class="parcela">
                        <div class="vencimento-parcela">
                            <label>${index + 1} Vencimento</label>
                            <input type="text" value="${parcela.dataVencimento}" name="parcelas[${index}][dataVencimento]">
                        </div>
                        <div class="valor-parcela">
                            <label>Valor</label>
                            <input type="text" value="${parcela.valor}" name="parcelas[${index}][valor]">
                        </div>
                    </div>
                `);
            });
        }
    )
}