<?php
/*
**----------------------------No Apagar esta Seo -------------------------
**	Paginator 
**	Paginao de resultados de consulta com PHP e MySQL
**
**	Verso 1.6.3
**
**	Nome do arquivo	:
**		paginatorbr.inc.php
**
**	Autor/Tradutor	:
**		Jorge Pinedo Rosas (Autor)
**		Com a colaborao dos usurio do frum de PHP do www.forosdelweb.com
**		Especialmente de dooky que postou a base desse script.
**      
**      Jonathan Lamim Antunes (Tradutor)
**      Profissional de Informtica desde 2004, atua na rea de desenvolvimento web.
**
**	Descrio :
**      Retorna o resultado de uma consulta dividido em pginas e uma barra de navegao para as mesmas		
**      Este script foi escrito com fins didticos, por isso est todo comentado
**
**	Licena : 
**		GPL com as seguintes extenses:
** 			*Use-o com o fim que quiser (pessoal ou lucrativo).
**			*Se encontrar erros no cdigo, ou melhor-lo, envie-me um e-mail (lamim.informatica@gmail.com) informando.
**			*Este script no possui nenhuma garantia. Os criadores no se responsabilizam pelo mau uso do script ou falhas do     **           mesmo. 
**
**----------------------------------------------------------------------*/

/**
 * Variveis que podem ser definidas antes de incluir o script via inlude():
 * ------------------------------------------------------------------------
 * $_pagi_sql 					OBRIGATRIA.	Deve conter uma instruo SQl vlida (e sem a clusula "LIMIT").
 
 * $_pagi_cuantos				OPCIONAL.		(Inteiro) Nmero de resultados que queremos obter por pgina.
 *                              Se no for definido um valor, ser 20, que  o valor padro.
											
 * $_pagi_nav_num_enlaces		OPCIONAL		(Inteiro) Quantidade de links(pginas) mostrados na barra de navegao. 
 *                              Por padro so mostrados todos.
											
 * $_pagi_mostrar_errores		OPCIONAL		(Booleano) Define se so mostrados ou no os erros de MySQL que venham a surgir.
 *                              Por padro est como "true".
											
 * $_pagi_propagar				OPCIONAL       (Array) Contm os nomes das variveis que se quer enviar pela URL.
 *                              Por padro so enviadas todas as que j venham pela URL(GET).

 * $_pagi_conteo_alternativo	OPCIONAL(Booleano) Define se os registros so contados pelo PHP com mysqli_num_rows()(true) ou pelo *                              MySQL, com COUNT (*)(false). Por padro est em "false". 
 *                               recomendado que seja mantido com false, a no ser que aconteam erros de contagem ou resultados * *                             inesperados. 

 * $_pagi_separador				OPCIONAL		Smbolo que separa os links numricos na barra de navegao entre as pginas.
 								Por padro se utiliza " | ".
								
 * $_pagi_nav_estilo			OPCIONAL		Contm o nome do estilo CSS para os links de paginao da barra de navegao.
 *                              Por padro no se especifica o estilo. 
 
 * $_pagi_nav_anterior			OPCIONAL       Contm o que deve aparecer como link para a pgina anterior. Pode ser uma tag <img>.
                                Por padro se utiliza "&laquo; Anterior".
								
 * $_pagi_nav_siguiente			OPCIONAL		Contm o que deve aparecer como link para a prxima pgina. Pode ser uma tag <img>.
                                Por padro se utiliza "Prxima &raquo;".
								
 * $_pagi_nav_primera			OPCIONAL        Contm o que deve aparecer como link para a primeira pgina. Pode ser uma tag <img>
                                Por padro se utiliza "&laquo;&laquo; Primeira".
								
 * $_pagi_nav_ultima			OPCIONAL		Contm o que deve aparecer como link para a ltima pgina. Pode ser uma tag <img>.
                                Por padro se utiliza "ltima &raquo;&raquo;".
--------------------------------------------------------------------------
*/


/*
 * Verificao dos parmetros obrigatrios e opcionais
 *------------------------------------------------------------------------
 */
 if(empty($_pagi_sql)){
	// Se no for definido $_pagi_sql... erro grave!
	// Este erro  apresentado assim (j que no  um erro de mysql)
	die("<b>Mensagem de Erro: </b>A varivel \$_pagi_sql no foi definida.");
 }
 
 if(empty($_pagi_cuantos)){
	// Se no for especificado um valor para a varivel
	// $_pagi_cuantos, o nmero de registros por pgina ser 20, que  o padro.
	$_pagi_cuantos = 20;
 }
 
 if(!isset($_pagi_mostrar_errores)){
	// Se no for definido um valor para
	// $_pagi_errores ser por padro true. (os erros sero apresentados na tela)
	$_pagi_mostrar_errores = true;
 }

 if(!isset($_pagi_conteo_alternativo)){
	// Se no for especificado o tipo de contagem de registros
	// ser realizada contagem pelo mysql usando COUNT(*)
	$_pagi_conteo_alternativo = false;
 }
 
 if(!isset($_pagi_separador)){
	// Se no for definido um separador
	// o separador utilizado ser o padro.
	$_pagi_separador = " &nbsp; ";
 }
 
  if(isset($_pagi_nav_estilo)){
	// Se for definido um estilo para os links, ser gerado o atributo "class" para o link
	$_pagi_nav_estilo_mod = "class=\"$_pagi_nav_estilo\"";
 }else{
 	// Se no for definido, ser utilizado como vazio.
 	$_pagi_nav_estilo_mod = "";
 }
 
 if(!isset($_pagi_nav_anterior)){
	// Se no for definido um smbolo ou imagem para a opo "Anterior"
	// Ser por padro o descrito abaixo.
	$_pagi_nav_anterior = "&laquo; Anterior";
 } 
 
 if(!isset($_pagi_nav_siguiente)){
	// Se no for definido um smbolo ou imagem para a opo "Prxima"
	// Ser por padro o descrito abaixo.
	$_pagi_nav_siguiente = "Prxima &raquo;";
 } 

 if(!isset($_pagi_nav_primera)){
	// Se no for definido um smbolo ou imagem para a opo "Primeira"
	// Ser por padro o descrito abaixo.
	$_pagi_nav_primera = "&laquo;&laquo; Primeira";
 } 
 
 if(!isset($_pagi_nav_ultima)){
	// Se no for definido um smbolo ou imagem para a opo "ltima"
	// Ser por padro o descrito abaixo.
	$_pagi_nav_ultima = "&Uacute;ltima &raquo;&raquo;";
 } 
 
//------------------------------------------------------------------------


/*
 * Estabelecimento da pgina atual
 *------------------------------------------------------------------------
 */
 if (empty($_GET['_pagi_pg'])){
	// Se no houver sido clicado em nenhuma pgina especfica
	// Ou seja, se a primeira vez que se executa o script
    	// $_pagi_actual  a pgina atual-->ser por padro a primeira.
	$_pagi_actual = 1;
 }else{
	// Se foi venda uma pgina especfica:
	// A pgina atual ser a que foi pedida.
    	$_pagi_actual = $_GET['_pagi_pg'];
 }
//------------------------------------------------------------------------


/*
 * Estabelecendo o nmero de pginas e o total de registros.
 *------------------------------------------------------------------------
 */
 // Contamos o total de registros no BD (para saber quantas pginas sero)
 // A forma de se fazer essa contagem depender da varivel $_pagi_conteo_alternativo
 if($_pagi_conteo_alternativo == false){
 	$_pagi_sqlConta = eregi_replace("select[[:space:]](.*)[[:space:]]from", "SELECT COUNT(*) FROM", $_pagi_sql);
 	$_pagi_result2 = mysqli_query($con,$_pagi_sqlConta);
	// Se ocorreu erros e foram mostrados, a exibio dos erros est ativada
 	if($_pagi_result2 == false && $_pagi_mostrar_errores == true){
		die (" Erro de contagem de registros: $_pagi_sqlConta. Mysql informa: <b>".mysqli_error($con)."</b>");
 	}
 	$_pagi_totalReg = old_mysql_result($_pagi_result2,0,0);//total de registros
 }else{
	$_pagi_result3 = mysqli_query($con,$_pagi_sql);
	// Se ocorreu erros e foram mostrados, a exibio dos erros est ativada
 	if($_pagi_result3 == false && $_pagi_mostrar_errores == true){
		die (" Erro na contagem alternativa de registros: $_pagi_sql. Mysql informa: <b>".mysqli_error($con)."</b>");
 	}
	$_pagi_totalReg = mysqli_num_rows($_pagi_result3);
 }
 // Calculamos o nmero de pginas (retornar um decimal)
 // com ceil() arredondamos e $_pagi_totalPags ser o nmero total (inteiro) de pginas que teremos
 $_pagi_totalPags = ceil($_pagi_totalReg / $_pagi_cuantos);

//------------------------------------------------------------------------


/*
 * Envio das variveis pela URL.
 *------------------------------------------------------------------------
 */
 // A idia  passar tambm nos links as variveis recebidas pela URL.
 $_pagi_enlace = $_SERVER['PHP_SELF'];
 $_pagi_query_string = "?";
 
 if(!isset($_pagi_propagar)){
 	//Se no foi definido que variveis sero enviadas, ser enviado o $_GET (por compatibilidade com verses anteriores)
	//Todo menos a varivel _pagi_pg
	if (isset($_GET['_pagi_pg'])) unset($_GET['_pagi_pg']); // Eliminamos essa varivel do $_GET
	$_pagi_propagar = array_keys($_GET);
 }elseif(!is_array($_pagi_propagar)){
	// Se $_pagi_propagar no for um array... erro grave!
	die("<b>PaginatorBR informa: </b>A varivel \$_pagi_propagar deve ser um array");
 }
 // Este foreach foi retirado da Classe Paginado de webstudio
 // (http://www.forosdelweb.com/showthread.php?t=65528)
 foreach($_pagi_propagar as $var){
 	if(isset($GLOBALS[$var])){
		// Se a varivel  global ao script
		$_pagi_query_string.= $var."=".$GLOBALS[$var]."&";
	}elseif(isset($_REQUEST[$var])){
		// Se no  global (ou register globals est em OFF)
		$_pagi_query_string.= $var."=".$_REQUEST[$var]."&";
	}
 }

 // Enviamos a isntruo SQl pela URL.
 $_pagi_enlace .= $_pagi_query_string;
 
//------------------------------------------------------------------------


/*
 * Gerao dos lnks de paginao.
 *------------------------------------------------------------------------
 */
 // A varivel $_pagi_navegacion conter os links para as pginas.
 $_pagi_navegacion_temporal = array();
 if ($_pagi_actual != 1){
	// Se no estamos na pgina 1. Colocamos o link "primeira"
	$_pagi_url = 1; //ser o nmero da pgina que linkamos
	$_pagi_navegacion_temporal[] = "<a ".$_pagi_nav_estilo_mod." href='".$_pagi_enlace."_pagi_pg=".$_pagi_url."'>$_pagi_nav_primera</a>";

	// Se no estamos na pgina 1. Colocamos o link "anterior"
	$_pagi_url = $_pagi_actual - 1; //ser o nmero da pgina que linkamos
	$_pagi_navegacion_temporal[] = "<a ".$_pagi_nav_estilo_mod." href='".$_pagi_enlace."_pagi_pg=".$_pagi_url."'>$_pagi_nav_anterior</a>";
 }
 
 // A varivel $_pagi_nav_num_enlaces serve para definir quantos links com 
 // nmeros de pginas sero mostrados.
 // Obs: sempre ser mostrado um nmero mpar de links. Mais informaes na documentao.
 
 if(!isset($_pagi_nav_num_enlaces)){
	// Se no foi definida a varivel $_pagi_nav_num_enlaces
	// Sero mostrados todos os nmeros de pginas nos links.
	$_pagi_nav_desde = 1;//Desde la primera
	$_pagi_nav_hasta = $_pagi_totalPags;//at a ltima
 }else{
	// Se foi definida a varivel $_pagi_nav_num_enlaces
	// Calculamos o intervalo para dividir e somar a partir da pgina atual
	$_pagi_nav_intervalo = ceil($_pagi_nav_num_enlaces/2) - 1;
	
	// Calculamos a partir de que nmero de pgina ser mostrado
	$_pagi_nav_desde = $_pagi_actual - $_pagi_nav_intervalo;
	// Calculamos at que nmero de pgina ser mostrado
	$_pagi_nav_hasta = $_pagi_actual + $_pagi_nav_intervalo;
	
	// Ajustamos os valores anteriores caso sejam resultados invlidos
	
	// Se $_pagi_nav_desde for um nmero negativo
	if($_pagi_nav_desde < 1){
		// O subtramos a quantidade restante para manter o nmero de links que se quer mostrar. 
		$_pagi_nav_hasta -= ($_pagi_nav_desde - 1);
		// Establecemos $_pagi_nav_desde como 1.
		$_pagi_nav_desde = 1;
	}
	// Se $_pagi_nav_hasta for um nmero maior que o total de pginas
	if($_pagi_nav_hasta > $_pagi_totalPags){
		// O subtramos a quantidade excedida ao comeao para manter o nmero de links que se quer mostrar.
		$_pagi_nav_desde -= ($_pagi_nav_hasta - $_pagi_totalPags);
		// Establecemos $_pagi_nav_hasta como o total de pginas.
		$_pagi_nav_hasta = $_pagi_totalPags;
		// Fazemos o ltimo ajuste verificando que ao enviar $_pagi_nav_desde no haja um valor invlido.
		if($_pagi_nav_desde < 1){
			$_pagi_nav_desde = 1;
		}
	}
 }

 for ($_pagi_i = $_pagi_nav_desde; $_pagi_i<=$_pagi_nav_hasta; $_pagi_i++){//Da pgina 1 at a ltima pgina ($_pagi_totalPags)
	if ($_pagi_i == $_pagi_actual) {
		// Se o nmero de pgina  o atual ($_pagi_actual). Escreve-se o nmero, mas sem link e em negrito.
		$_pagi_navegacion_temporal[] = "<span ".$_pagi_nav_estilo_mod.">$_pagi_i</span>";
	}else{
		// Se for qualquer outro. Se escreve o link e o nmeor da pgina.
		$_pagi_navegacion_temporal[] = "<a ".$_pagi_nav_estilo_mod." href='".$_pagi_enlace."_pagi_pg=".$_pagi_i."'>".$_pagi_i."</a>";
	}
 }

 if ($_pagi_actual < $_pagi_totalPags){
	// Se no estamos na ltima pgina. Colocamos o link "Seguinte"
	$_pagi_url = $_pagi_actual + 1; //ser o nmero da pgina que linkamos
	$_pagi_navegacion_temporal[] = "<a ".$_pagi_nav_estilo_mod." href='".$_pagi_enlace."_pagi_pg=".$_pagi_url."'>$_pagi_nav_siguiente</a>";

	// Se no estamos na ltima pgina. Colocamos o link "ltima"
	$_pagi_url = $_pagi_totalPags; //ser o nmero da pgina que linkamos
	$_pagi_navegacion_temporal[] = "<a ".$_pagi_nav_estilo_mod." href='".$_pagi_enlace."_pagi_pg=".$_pagi_url."'>$_pagi_nav_ultima</a>";
 }
 $_pagi_navegacion = implode($_pagi_separador, $_pagi_navegacion_temporal);

//------------------------------------------------------------------------


/*
 * Obteno dos resgistros que sero mostrados na pgina atual.
 *------------------------------------------------------------------------
 */
 // Calculamos a partir de qu registro ser mostrado na pgina
 // Lembre que o contatdor comea em ZERO.
 $_pagi_inicial = ($_pagi_actual-1) * $_pagi_cuantos;
 
 // Consulta SQL. Retorna $cantidad registros comeando a partir de $_pagi_inicial
 $_pagi_sqlLim = $_pagi_sql." LIMIT $_pagi_inicial,$_pagi_cuantos";
 $_pagi_result = mysqli_query($con,$_pagi_sqlLim);
 // Se ocorreu erro e for mostrado,  porque a exibio de erros est ativada
 if($_pagi_result == false && $_pagi_mostrar_errores == true){
 	die ("Erro na consulta: $_pagi_sqlLim. Mysql informa: <b>".mysqli_error($con)."</b>");
 }

//------------------------------------------------------------------------


/*
 * Gerao da informao sobre os registros mostrados.
 *------------------------------------------------------------------------
 */
 // Nmero do primeiro registro da pgina atual
 $_pagi_desde = $_pagi_inicial + 1;
 
 // Nmeor do ltimo registro da pgina atual.
 $_pagi_hasta = $_pagi_inicial + $_pagi_cuantos;
 if($_pagi_hasta > $_pagi_totalReg){
 	// Se estivermos na ltima pgina
	// O ltimo registro da pgina atual ser igual ao nmero de registros.
 	$_pagi_hasta = $_pagi_totalReg;
 }
 
 
if(PAIS=='USA'){
    $_pagi_info = "From $_pagi_desde up to $_pagi_hasta a total of $_pagi_totalReg results";
}else{
    $_pagi_info = "De $_pagi_desde at&eacute; $_pagi_hasta de um total de $_pagi_totalReg resultados";
}

//------------------------------------------------------------------------


/**
 * Variveis que ficam disponveis aps incluir o script via include():
 * ------------------------------------------------------------------------
 
 * $_pagi_result		Identificador do resultado da consulta ao BD para os registros da pgina atual. 
 				Pronto para ser passado por uma funo como mysqli_fetch_row(), mysqli_fetch_array(), 
				mysqli_fetch_assoc(), etc.
							
 * $_pagi_navegacion		Varivel que contem a barra de navegao com os links para as pginas de resultados.
 				Exemplo: "<<Primeira | <Anterior | 1 | 2 | 3 | 4 | Prxima> | ltima>>".
							
 * $_pagi_info			Varivel que contm informaes sobre os registros da pgina atual.
 				Exemplo: "De 16 at 30 de um total de 123";				

*/
?>