<?php
namespace Bling\App\Config;

use Bling\App\Config\Http\Request;
use Bling\App\Config\Http\Api;

class Autenticacao {
    private $clientId;
    private $clientSecret;
    private $grantType;
    private $accessToken;
    private $refreshToken;

    public function __construct($atualizacao = true){
        global $con;
        $credenciais = $con->query("SELECT Client_Id_Bling, Client_Secret_Bling, Validade_Token_Bling, Token_Bling, Token_Atualizacao_Bling FROM opcao") or die($con->error);
        $credenciais = $credenciais->fetch_assoc();
        $this->clientId = $credenciais['Client_Id_Bling'];
        $this->clientSecret = $credenciais['Client_Secret_Bling'];
        $this->accessToken = $credenciais['Token_Bling'];
        $this->refreshToken = $credenciais['Token_Atualizacao_Bling'];

        if(strtotime($credenciais['Validade_Token_Bling']) < strtotime(date('Y-m-d H:i:s')) && $atualizacao) {
            $this->atualizarToken();
        }
    }

    public function gerarToken(string $code) {
        $url = Api::getUrl();
        $codigoAutorizacao = base64_encode("$this->clientId:$this->clientSecret");
        $this->grantType = "authorization_code";
        $gerarTokenAcesso = Request::post("$url/oauth/token", [
                "Content-Type: application/x-www-form-urlencoded",
                "Authorization: Basic $codigoAutorizacao"
            ],
            "grant_type=$this->grantType&code=$code"
        );
        return $gerarTokenAcesso->body;
    }

    private function salvarToken(string $token, string $validadeToken, string $tokenAtualizacao) {
        global $con;
        $con->query("UPDATE opcao SET Token_Bling = '$token', Validade_Token_Bling = '$validadeToken', Token_Atualizacao_Bling = '$tokenAtualizacao'");
    }

    public function atualizarToken() {
        $url = Api::getUrl();
        $codigoAutorizacao = base64_encode("$this->clientId:$this->clientSecret");
        $gerarTokenAcesso = Request::post("$url/oauth/token", [
                "Content-Type: application/x-www-form-urlencoded",
                "Authorization: Basic $codigoAutorizacao"
            ],
            "grant_type=refresh_token&refresh_token=$this->refreshToken"
        );
        if($gerarTokenAcesso->http_code == 200) {
            $validadeToken = date("Y-m-d H:i:s", strtotime(date("Y-m-d H:i:s")) + $gerarTokenAcesso->body->expires_in);
            $this->salvarToken($gerarTokenAcesso->body->access_token, $validadeToken, $gerarTokenAcesso->body->refresh_token);
            $this->accessToken = $gerarTokenAcesso->body->access_token;
            $this->refreshToken = $gerarTokenAcesso->body->refresh_token;
        };
    }

    public function getAccessToken() {
        return $this->accessToken;
    }
}
?>