<?php
namespace Bling\App\Config\Http;

class Request {
    private static $curl;

    function __construct(){}

    /**
     * @param string $url Endpoint de destino
     * @param string $cabecalho Cabecalho da requisição
     * @param string $corpo Corpo da requisição
     * @return object Código http e body da resposta
     */
    public static function post($url, $cabecalho = [], $corpo = "") {
        self::$curl = curl_init();
        curl_setopt_array(self::$curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_HTTPHEADER => $cabecalho,
            CURLOPT_POSTFIELDS => $corpo,
        ]);
          
        $response = curl_exec(self::$curl);
        $httpcode = curl_getinfo(self::$curl)['http_code'];
        curl_close(self::$curl);
        return (object)["http_code"=> $httpcode, "body"=> json_decode($response)];
    }

    /**
     * @param string $url Endpoint de destino
     * @param string $cabecalho Cabecalho da requisição
     * @param string $corpo Corpo da requisição
     * @return object Código http e body da resposta
     */
    public static function put($url, $cabecalho = [], $corpo = "") {
        self::$curl = curl_init();
        curl_setopt_array(self::$curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'PUT',
            CURLOPT_HTTPHEADER => $cabecalho,
            CURLOPT_POSTFIELDS => $corpo,
        ]);
          
        $response = curl_exec(self::$curl);
        $httpcode = curl_getinfo(self::$curl)['http_code'];
        curl_close(self::$curl);
        return (object)["http_code"=> $httpcode, "body"=> json_decode($response)];
    }

    /**
     * @param string $url Endpoint de destino
     * @param string $cabecalho cabecalho da requisição
     * @return object Código http e body da resposta
     */
    public static function get($url, $cabecalho) {
        self::$curl = curl_init();
        curl_setopt_array(self::$curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => $cabecalho,
        ]);
          
        $response = curl_exec(self::$curl);
        $httpcode = curl_getinfo(self::$curl)['http_code'];
        curl_close(self::$curl);

        return (object)["http_code"=> $httpcode, "body"=> json_decode($response)];
    }

    /**
     * @param string $url Endpoint de destino
     * @param string $cabecalho cabecalho da requisição
     * @return object Código http e body da resposta
     */
    public static function delete($url, $cabecalho) {
        self::$curl = curl_init();
        curl_setopt_array(self::$curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'DELETE',
            CURLOPT_HTTPHEADER => $cabecalho,
        ]);
          
        $response = curl_exec(self::$curl);
        $httpcode = curl_getinfo(self::$curl)['http_code'];
        curl_close(self::$curl);

        return (object)["http_code"=> $httpcode, "body"=> json_decode($response)];
    }
}