<?php
namespace Bling\App\Model;

use Bling\App\Config\Autenticacao;
use Bling\App\Config\Http\Api;
use Bling\App\Config\Http\Request;

class EstoqueProdutoDTO {
    public $id;

    public function __construct(int $id) {
        $this->id = $id;
    }
}
class DepositoProdutoDTO {
    public $id;

    public function __construct(int $id) {
        $this->id = $id;
    }
}
class Estoque {
    public $produto;
    public $deposito;
    public $operacao;
    public $preco;
    public $custo;
    public $quantidade;
    public $observacoes;

    /**
     * @param string $operacao B- Balanço | E- Entrada | S- Saída
     */
    public function __construct(EstoqueProdutoDTO $produto, DepositoProdutoDTO $deposito, string $operacao, float $quantidade, ?float $preco = null,
        ?float $custo = null, ?string $observacoes = null)
    {
        $this->produto = $produto;
        $this->deposito = $deposito;
        $this->operacao = $operacao;
        $this->preco = $preco;
        $this->custo = $custo;
        $this->quantidade = $quantidade;
        $this->observacoes = $observacoes;
    }

    public function cadastrar() {
        $url = Api::getUrl();
        $autenticacao = new Autenticacao();
        $tokenAcesso = $autenticacao->getAccessToken();
        $response = Request::post("$url/estoques", [
                "Content-Type: application/json",
                "Authorization: Bearer $tokenAcesso",
                "Accept: application/json"
            ],
            $this->toString()
        );
        return $response->http_code == 201 ? $response->body->data : $response->body;
    }

    public function toString() {
        $categoria = [];
        foreach($this as $chave => $valor) {
            if($chave != "id" && $valor !== null) {
                $categoria[$chave] = $valor;
            }
        }
        return json_encode($categoria);
    }
}
?>