<?php
namespace Bling\App\Model\Type\Contact;

class FiltroContato {
    public $pagina;
    public $limite;
    public $pesquisa;
    public $criterio;
    public $idTipoContato;
    public $idVendedor;
    public $uf;
    public $telefone;
    public $idsContatos;
    public $numeroDocumento;

    /**
     * @param ?string $pesquisa Nome | CPF/CNPJ | fantasia | e-mail | código do contato
     * @param ?string $numeroDocumento CPF/CNPJ
     * @param ?string $criterio 1 - Todos | 2 - Excluídos | 3 - Últimos incluídos | 4 - Sem movimento
     */
    public function __construct(int $pagina, int $limite, ?string $pesquisa = null, ?string $numeroDocumento = null, ?string $criterio = null,
        ?int $idTipoContato = null, ?int $idVendedor = null, ?array $idsContatos = null, ?string $uf = null, ?string $telefone = null)
    {
        $this->pagina = $pagina;
        $this->limite = $limite;
        $this->pesquisa = $pesquisa;
        $this->criterio = $criterio;
        $this->idTipoContato = $idTipoContato;
        $this->idVendedor = $idVendedor;
        $this->uf = $uf;
        $this->telefone = $telefone;
        $this->idsContatos = $idsContatos;
        $this->numeroDocumento = $numeroDocumento;
    }

    public function toUrlEncode() {
        $qtdParametrosInseridos = 0;
        $queryParams = "";

        foreach($this as $chave => $valor) {
            if($valor !== null) {
                $queryParams .= $qtdParametrosInseridos == 0 ? "?$chave=$valor" : "&$chave=$valor";
                $qtdParametrosInseridos++;
            }
        }
        return $queryParams;
    }
}

?>