<?php
namespace Bling\App\Model\Type\Contact;

use Bling\App\Config\Http\Request;
use Bling\App\Config\Autenticacao;
use Bling\App\Config\Http\Api;

class TipoContato {
    public $id;
    public $descricao;

    public function __construct(int $id, ?string $descricao = null) {
        $this->id = $id;
        $this->descricao = $descricao;
    }

    /**
     * @return TipoContato[]|ApiError
     */
    public static function buscarTodos() {
        $url = Api::getUrl();
        $autenticacao = new Autenticacao();
        $tokenAcesso = $autenticacao->getAccessToken();
        $response = Request::get("$url/contatos/tipos", [
                "Content-Type: application/json",
                "Authorization: Bearer $tokenAcesso",
                "Accept: application/json"
            ],
        );
        return $response->http_code == 200 ? $response->body->data : $response->body;
    }
}
?>