<?php
namespace Bling\App\Model\Type\Product;

class FiltroProduto {
    public $pagina;
    public $limite;
    public $criterio;
    public $codigo;
    public $idCategoria;
    public $idLoja;
    public $tipo;
    public $dataInclusaoInicial;
    public $dataInclusaoFinal;
    public $dataAlteracaoInicial;
    public $dataAlteracaoFinal;
    public $nome;
    public $idsProdutos;
    public $idComponente;

    /**
     * @param ?int $criterio 1- Últimos incluídos | 2- Ativos | 3- Inativos | 4- Excluídos | 5- Todos
     * @param ?string $tipo T- Todos | P- Produtos | S- Serviços | E- Composições | PS- Produtos simples | C- Com variações | V- Variações
     * 
     */
    public function __construct(int $pagina, ?int $limite = null, ?int $criterio = null, ?string $codigo = null, ?int $idCategoria = null, ?int $idLoja = null,
        ?string $tipo = null, ?string $dataInclusaoInicial = null, ?string $dataInclusaoFinal = null, ?string $dataAlteracaoInicial = null,
        ?string $dataAlteracaoFinal = null, ?string $nome = null, ?array $idsProdutos = null, ?int $idComponente = null)
    {
        $this->pagina = $pagina;
        $this->limite = $limite;
        $this->criterio = $criterio;
        $this->codigo = $codigo;
        $this->idCategoria = $idCategoria;
        $this->idLoja = $idLoja;
        $this->tipo = $tipo;
        $this->dataInclusaoInicial = $dataInclusaoInicial;
        $this->dataInclusaoFinal = $dataInclusaoFinal;
        $this->dataAlteracaoInicial = $dataAlteracaoInicial;
        $this->dataAlteracaoFinal = $dataAlteracaoFinal;
        $this->nome = $nome;
        $this->idsProdutos = $idsProdutos;
        $this->idComponente = $idComponente;
    }

    public function toUrlEncode() {
        $qtdParametrosInseridos = 0;
        $queryParams = "";

        foreach($this as $chave => $valor) {
            if($valor !== null) {
                $queryParams .= $qtdParametrosInseridos == 0 ? "?$chave=$valor" : "&$chave=$valor";
                $qtdParametrosInseridos++;
            }
        }
        return $queryParams;
    }
}
?>