<?php
namespace Ifood\App\Config;
use Ifood\App\Config\Http\Request;

class Autenticacao {
    private $clientId;
    private static $grantType = "client_credentials";
    private $clientSecret;
    public $token;
    public $tokenValidity;

    public function __construct(){
        global $con;
        $credenciaisAplicacao = $con->query("SELECT Client_Id_Ifood, Client_Secret_Ifood FROM opcao");
        $credenciaisAplicacao = $credenciaisAplicacao->fetch_assoc();
        $this->clientId = $credenciaisAplicacao['Client_Id_Ifood'];
        $this->clientSecret = $credenciaisAplicacao['Client_Secret_Ifood'];

        $credenciaisUnidade = $con->query("SELECT Validade_Token_Ifood, Token_Autenticacao_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
        $credenciaisUnidade = $credenciaisUnidade->fetch_assoc();

        if(strtotime($credenciaisUnidade['Validade_Token_Ifood']) > strtotime(date('Y-m-d H:i:s'))) {
            $this->token = $credenciaisUnidade['Token_Autenticacao_Ifood'];
        }
        else {
            $this->setToken();
        }
    }

    private function getToken() {
        $gerarToken = Request::post("https://merchant-api.ifood.com.br/authentication/v1.0/oauth/token", null,
        "clientId=$this->clientId&grantType=".self::$grantType."&clientSecret=$this->clientSecret", "x-www-form-urlencoded");

        if($gerarToken->http_code == 200) {
            $getToken = $gerarToken->body;
            return (object)['token'=> $getToken->accessToken, 'validade'=> $getToken->expiresIn];
        }
        return null;
    }

    private function setToken() {
        $gerarToken = $this->getToken();

        if(isset($gerarToken->token)) {
            $this->token = $gerarToken->token;
            $this->salvarToken($this->token, $gerarToken->validade);
        }
    }

    /**
     * Salvar token de acesso
     *
     * @param string $token Token de acesso
     * @param int $validade Validade em segundos
     * @return bool
     */
    private function salvarToken($token, $validade) {
        global $con;
        $validade = number_format((($validade / 60) / 60), 0);
        $validade = date('Y-m-d H:i:s', strtotime("+$validade hour", strtotime(date('Y-m-d H:i:s'))));
        $con->query("UPDATE unidade SET Token_Autenticacao_Ifood='$token', Validade_Token_Ifood='$validade' WHERE Id='{$_COOKIE['Unidade']}'");
        $this->tokenValidity = $validade;
    }
}