<?php
namespace Ifood\App\Model;
use Ifood\App\Config\Http\Request;
use Ifood\App\Config\Autenticacao;
use Ifood\App\Config\Http\Api;

class Categoria {
    public function __construct(){}

    /**
     * Cadastra uma categoria no ifood
     *
     * @param array $dados
     * @return bool
     */
    public static function cadastrar($dados) {
        global $con;
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl();
            $versaoApi = Api::getVersao("catalog");
            $catalogos = self::catalogos($autenticacao->token);
            $idCatalogo = $catalogos[0]->catalogId;
            $idLojaIfood = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
            $idLojaIfood = $idLojaIfood->fetch_assoc()['Merchant_Id_Ifood'];

            $cadastrarCategoria = Request::post("$url/catalog/$versaoApi/merchants/$idLojaIfood/catalogs/$idCatalogo/categories", $autenticacao->token,
                json_encode($dados), "json");

            if($cadastrarCategoria->http_code == 201) {
                $categoria = $cadastrarCategoria->body;
                $con->query("UPDATE categoria_produto SET Id_Ifood='$categoria->id' WHERE Id='$categoria->externalCode'");
                return true;
            }
            return false;
        }
    }

    public static function detalhes(string $idIfood) {
        global $con;
        $autenticacao = new Autenticacao();

        if($autenticacao->token) {
            $url = Api::getUrl();
            $versaoApi = Api::getVersao("catalog");
            $idLojaIfood = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'") or die($con->error);
            $idLojaIfood = $idLojaIfood->fetch_assoc()['Merchant_Id_Ifood'];
            $catalogos = self::catalogos($autenticacao->token);
            $idCatalogo = $catalogos[0]->catalogId;
            $buscaCategorias = Request::get("$url/catalog/$versaoApi/merchants/$idLojaIfood/catalogs/$idCatalogo/categories/$idIfood", $autenticacao->token);
            return $buscaCategorias->http_code == 200 ? $buscaCategorias->body : (object)[];
        }
    }

    /**
     * Lista todas as categorias cadastradas no ifood
     *
     * @return array Lista de categorias
     */
    public static function listar() {
        global $con;
        $autenticacao = new Autenticacao();

        if($autenticacao->token) {
            $url = Api::getUrl();
            $versaoApi = Api::getVersao("catalog");
            $idLojaIfood = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'") or die($con->error);
            $idLojaIfood = $idLojaIfood->fetch_assoc()['Merchant_Id_Ifood'];
            $catalogos = self::catalogos($autenticacao->token);
            $idCatalogo = $catalogos[0]->catalogId;
            $buscaCategorias = Request::get("$url/catalog/$versaoApi/merchants/$idLojaIfood/catalogs/$idCatalogo/categories", $autenticacao->token);
            return $buscaCategorias->http_code == 200 ? $buscaCategorias->body : [];
        }
    }

    public static function catalogos($token) {
        global $con;
        $idLojaIfood = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
        $idLojaIfood = $idLojaIfood->fetch_assoc()['Merchant_Id_Ifood'];
        $url = Api::getUrl();
        $versaoApi = Api::getVersao("catalog");

        $buscaCatalogos = Request::get("$url/catalog/$versaoApi/merchants/$idLojaIfood/catalogs", $token);
        return $buscaCatalogos->http_code == 200 ? $buscaCatalogos->body : [];
    }

    /**
     * Importa categorias do ifood para o sistema
     *
     * @return int Quantidade de categorias cadastradas
     */
    public static function importar(): int {
        global $con;
        $categorias = self::listar();
        $qtdCategoriasCadastradas = 0;

        foreach($categorias as $categoria) {
            $idUsuario = $_COOKIE['Id'];
            $idUnidade = $_COOKIE['Unidade'];
            $con->query("SELECT Id FROM categoria_produto WHERE Id_Ifood='$categoria->id'");

            if($con->affected_rows == 0) {
                $nomeCategoria = mb_convert_encoding($categoria->name, "ISO-8859-1", "UTF-8");
                $con->query("INSERT INTO categoria_produto SET Titulo='$nomeCategoria', Tipo='Pode vender', Tipo_Categoria='P',
                Site='Sim', Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario', Data_Cadastro=NOW(), Data_Cadastro_Upd=NOW(),
                Id_Unidade='$idUnidade', Ifood='Sim', Id_Ifood='$categoria->id'");
                
                if($con->affected_rows > 0) {
                    $qtdCategoriasCadastradas++;
                }
            }
        }
        return $qtdCategoriasCadastradas;
    }
}
?>