<?php
namespace Ifood\App\Model;
use Ifood\App\Config\Http\Request;
use Ifood\App\Config\Autenticacao;
use Ifood\App\Config\Http\Api;
use Ifood\App\Model\Produto;
use Ifood\App\Model\Imagem;
use Ifood\App\Model\Categoria;
error_reporting(E_ALL);
        ini_set('display_errors', 'On');

class Pedido {
    function __construct(){}

    public static function polling() {
        global $con;
        $status = [
            'PLC'=> 'NOVO',
            'CFM'=> 'CONFIRMADO',
            'PRS'=> 'EM_PREPARO',
            'DSP'=> 'A_CAMINHO',
            'CON'=> 'ENTREGUE',
            'CAN'=> 'CANCELADO',
            'RTP'=> 'PRONTO_RETIRADA',
            'RDR'=> 'ENTREGADOR_SOLICITADO',
            'RDS'=> 'ENTREGADOR_CONFIRMADO',
            'GTO'=> 'ENTREGADOR_A_CAMINHO',
            'ADR'=> 'DETALHES_ENTREGADOR',
            'HSD'=> 'SOLICITACAO_CANCELAMENTO',
            'HSS'=> 'ATUALIZACAO_DISPUTA',
            'CCR'=> 'Evento cancelamento',
            'OPA'=> 'ALTERACAO_PEDIDO'
        ];

        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/events:polling";
            $getIdLojaIfood = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
            $idLojaIfood = $getIdLojaIfood->fetch_assoc()['Merchant_Id_Ifood'];

            $buscaPedidos = Request::get($url, $autenticacao->token, true, $idLojaIfood);
            if($buscaPedidos->http_code == 200) {
                $notificacoesPedidos = $buscaPedidos->body;
                $pedidosNovos = [];
                $pedidosConfirmados = [];
                $pedidosPreparo = [];
                $pedidosACaminho = [];
                $pedidosEntregues = [];
                $pedidosCancelados = [];
                $entregadoresSolicitados = [];
                $entregadoresConfirmados = [];
                $detalhesEntregadores = [];
                $eventosCancelamento = [];
                $atualizacoesDisputas = [];
                $notificacoesDescartar = [];
                $pedidosAlterados = [];

                foreach($notificacoesPedidos as $notificacao) {
                    if(isset($status[$notificacao->code])) {
                        switch($status[$notificacao->code]) {
                            case 'NOVO':
                                array_push($pedidosNovos, $notificacao);
                                break;
                            case 'CONFIRMADO':
                                array_push($pedidosConfirmados, $notificacao);
                                break;
                            case 'EM_PREPARO':
                                array_push($pedidosPreparo, $notificacao);
                                break;
                            case 'A_CAMINHO':
                                array_push($pedidosACaminho, $notificacao);
                                break;
                            case 'ENTREGUE':
                                array_push($pedidosEntregues, $notificacao);
                                break;
                            case 'CANCELADO':
                                array_push($pedidosCancelados, $notificacao);
                                break;
                            case 'ENTREGADOR_SOLICITADO': case 'ENTREGADOR_A_CAMINHO':  case 'PRONTO_RETIRADA':
                                array_push($entregadoresSolicitados, $notificacao);
                                break;
                            case 'ENTREGADOR_CONFIRMADO':
                                array_push($entregadoresConfirmados, $notificacao);
                                break;
                            case 'DETALHES_ENTREGADOR':
                                array_push($detalhesEntregadores, $notificacao);
                                break;
                            case 'SOLICITACAO_CANCELAMENTO':
                                array_push($eventosCancelamento, $notificacao);
                                break;
                            case 'ATUALIZACAO_DISPUTA':
                                array_push($atualizacoesDisputas, $notificacao);
                                break;
                            case 'ALTERACAO_PEDIDO':
                                array_push($pedidosAlterados, $notificacao);
                                break;
                        }
                    } else {
                        array_push($notificacoesDescartar, ['id'=> $notificacao->id]);
                    }
                }

                if(sizeof($notificacoesDescartar) > 0) {
                    Pedido::reconhecerNotificacoes($notificacoesDescartar);
                }
                Pedido::novos($pedidosNovos);
                Pedido::confirmados($pedidosConfirmados);
                Pedido::emPreparo($pedidosPreparo);
                Pedido::aCaminho($pedidosACaminho);
                Pedido::entregues($pedidosEntregues);
                Pedido::cancelados($pedidosCancelados);
                Pedido::reconhecerEntregadores($entregadoresSolicitados);
                Pedido::confirmarEntregadores($entregadoresConfirmados);
                Pedido::salvarEntregadores($detalhesEntregadores);
                Pedido::eventosCancelamento($eventosCancelamento);
                Pedido::atualizarDisputas($atualizacoesDisputas);
                Pedido::alterarPedidos($pedidosAlterados);
            }
        }
    }

    public static function detalhes($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido";
            $detalhesPedido = Request::get($url, $autenticacao->token);
            if($detalhesPedido->http_code == 200) {
                return $detalhesPedido->body;
            }
            return [];
        }
    }

    public static function confirmar($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido/confirm";
            $detalhesPedido = Request::post($url, $autenticacao->token, '');
            return $detalhesPedido->http_code == 202 ? true : false;
        }
    }

    public static function iniciarPreparo($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido/startPreparation";
            $detalhesPedido = Request::post($url, $autenticacao->token, '');
            
            return $detalhesPedido->http_code == 202 ? true : false;
        }
    }

    public static function enviar($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido/dispatch";
            $detalhesPedido = Request::post($url, $autenticacao->token, '');
            return $detalhesPedido->http_code == 202 ? true : false;
        }
    }

    public static function prontoRetirada($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido/readyToPickup";
            $detalhesPedido = Request::post($url, $autenticacao->token, '');
            return $detalhesPedido->http_code == 202 ? true : false;
        }
    }

    public static function cancelar(string $idPedidoIfood, string $razao, string $codigo) {
        $autenticacao = new Autenticacao();
        
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedidoIfood/requestCancellation";
            $cancelarPedido = Request::post($url, $autenticacao->token,
                json_encode([
                    "reason"=> mb_convert_encoding($razao, "UTF-8", "ISO-8859-1"),
                    "cancellationCode"=> "$codigo"
                ]),
                "json"
            );
            return $cancelarPedido->http_code == 202 ? true : false;
        }
    }

    public static function aceitarCancelamento($idPedido) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/orders/$idPedido/acceptCancellation";
            $cancelarPedido = Request::post($url, $autenticacao->token,'');
            return $cancelarPedido->http_code == 202 ? true : false;
        }
    }

    public static function reconhecerNotificacoes(Array $notificacoes) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/".Api::getVersao()."/events/acknowledgment";
            $dados = json_encode($notificacoes);
            $reconhecerPedido = Request::post($url, $autenticacao->token, $dados, 'json');
            return $reconhecerPedido->http_code == 202 ? true : false;
        }
    }

    private static function novos($notificacoesNovas) {
        global $con;
        $notificacoesReconhecer = [];
        $configPedido = $con->query("SELECT Pedidos_Automatico_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
        $pedidosAutomatico = $configPedido->fetch_assoc()['Pedidos_Automatico_Ifood'];
        $pedidosNovos = [];

        foreach ($notificacoesNovas as $notificacao) {
            if($pedidosAutomatico == "Sim") {
                $pedido = Pedido::detalhes($notificacao->orderId);
                $pedido->notificationId = $notificacao->id;
                $pedido->notificationStatus = "Novo";
                array_push($pedidosNovos, $pedido);
            }
            else {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($pedidosNovos) > 0) {
            Pedido::importar($pedidosNovos);
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    private static function confirmados($notificacoesConfirmadas) {
        $pedidosConfirmados = [];

        foreach ($notificacoesConfirmadas as $notificacao) {
            $pedido = Pedido::detalhes($notificacao->orderId);
            $pedido->notificationId = $notificacao->id;
            $pedido->notificationStatus = "Confirmado";
            array_push($pedidosConfirmados, $pedido);
        }
        if(sizeof($pedidosConfirmados) > 0) {
            Pedido::importar($pedidosConfirmados);
        }
    }

    private static function emPreparo($notificacoesEmPreparo) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesEmPreparo as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $con->query("UPDATE venda SET Status_Pedido = 'Em preparo', Notificacao_Ifood = 'No Lido', Data_Cadastro_Upd = '$dataCadastro'
                WHERE Id_Ifood = '$notificacao->orderId'");
            
            if($con->affected_rows > 0) {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    private static function aCaminho($notificacoesACaminho) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesACaminho as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $horaSaida = date("H:i:s", strtotime($notificacao->createdAt));
            $con->query("UPDATE venda SET Status_Pedido = 'A caminho', Hora_Caminho = '$horaSaida', Notificacao_Ifood = 'No Lido',
                Data_Cadastro_Upd = '$dataCadastro' WHERE Id_Ifood = '$notificacao->orderId'");
            if($con->affected_rows > 0) {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }
    
    private static function entregues($notificacoesEntregues) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesEntregues as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $horaEntregue = date("H:i:s");
            $con->query("UPDATE venda SET Status_Pedido = 'Entregue', Notificacao_Ifood = 'No Lido', Data_Cadastro_Upd = '$dataCadastro',
                Hora_Entregue = '$horaEntregue' WHERE Id_Ifood = '$notificacao->orderId'");
            if($con->affected_rows > 0) {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    private static function cancelados($notificacoesCancelados) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesCancelados as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $motivoCancelamento = isset($notificacao->metadata->CANCEL_REASON) ? mb_convert_encoding($notificacao->metadata->CANCEL_REASON, "ISO-8859-1", "UTF-8") : '';

            $con->query("UPDATE venda SET Status = 'Cancelado', Status_Pedido = 'Cancelado', Data_Cadastro_Upd = '$dataCadastro',
                Motivo_Cancelamento='$motivoCancelamento' WHERE Id_Ifood = '$notificacao->orderId'");
            
            if($con->affected_rows > 0) {
                $idPedido = $con->query("SELECT Id FROM venda WHERE Id_Ifood='$notificacao->orderId'");
                $idPedido = $idPedido->fetch_assoc()['Id'];
                $contasReceber = $con->query("SELECT Id FROM conta_receber WHERE Id_Externo='$idPedido'");
                while($contaReceber = $contasReceber->fetch_assoc()) {
                    $con->query("UPDATE conta_receber SET Status = 'Cancelado' WHERE Id='{$contaReceber['Id']}'");
                    $con->query("UPDATE caixa SET Tipo = 'Cancelado' WHERE Id_Externo='{$contaReceber['Id']}'");
                }
                $con->query("UPDATE estoque SET Concluido='Cancelado' WHERE Id_Externo='$idPedido'");
                
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
            if(isset($notificacao->metadata->CANCEL_REASON)) {
                $idDisputaIfood = $con->query("SELECT Id_Disputa_Ifood FROM ifood_disputa_pedido
                    WHERE Id_Venda = (SELECT Id FROM venda WHERE Id_Ifood = '$notificacao->orderId')");
                $idDisputaIfood = $idDisputaIfood->fetch_assoc()['Id_Disputa_Ifood'];
                $con->query("UPDATE ifood_disputa_pedido SET Motivo = '$motivoCancelamento' WHERE Id_Disputa_Ifood = '$idDisputaIfood'");
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    private static function reconhecerEntregadores(array $notificacoesEntregadores) {
        $notificacoesReconhecer = [];

        foreach ($notificacoesEntregadores as $notificacao) {
            array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    private static function confirmarEntregadores(array $notificacoesEntregadores) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesEntregadores as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $con->query("UPDATE venda SET Entregador_Solicitado_Ifood = 'Sim', Data_Cadastro_Upd = '$dataCadastro' WHERE Id_Ifood = '$notificacao->orderId'");
            if($con->affected_rows > 0) {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }
    
    private static function salvarEntregadores(array $notificacoesEntregadores) {
        global $con;
        $notificacoesReconhecer = [];

        foreach ($notificacoesEntregadores as $notificacao) {
            $dataCadastro = date("Y-m-d H:i:s");
            $con->query("UPDATE venda SET Entregador_Ifood = '{$notificacao->metadata->workerName}', Data_Cadastro_Upd = '$dataCadastro' WHERE Id_Ifood = '$notificacao->orderId'");
            if($con->affected_rows > 0) {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    public static function motivosCancelamento(string $idPedidoIfood): array {
        $autenticacao = new Autenticacao();
        $url = Api::getUrl();
        $versaoApi = Api::getVersao();
        $getMotivosCancelamento = Request::get("$url/order/$versaoApi/orders/$idPedidoIfood/cancellationReasons", $autenticacao->token);

        return $getMotivosCancelamento->http_code == 200 ? $getMotivosCancelamento->body : [];
    }

    public static function getIdIfoodProduto(array $categoriasIfood, string $idItem) {
        foreach($categoriasIfood as $categoria) {
            if(isset($categoria->items)) {
                foreach($categoria->items as $item) {
                    if($item->id == $idItem){
                        return $item->productId;
                    }
                }
            }
        }
        return null;
    }

    public static function importar($pedidos) {
        global $con, $dbname;
        $idUsuario = $_COOKIE['Id'];
        $idFuncionario = $_COOKIE['Id_Funcionario'];
        $notificacoesReconhecer = [];
        $categoriasIfood = Categoria::listar();
        $idUnidade = $_COOKIE['Unidade'];

        foreach($pedidos as $pedido) {
            $unidade = $con->query("SELECT Id FROM unidade WHERE Merchant_Id_Ifood = '{$pedido->merchant->id}' AND Id = '$idUnidade");
            if($unidade && $unidade->num_rows < 1) continue;

            $con->query("SELECT Id FROM venda WHERE Id_Ifood='$pedido->id'");

            if($con->affected_rows == 0) {
                $dataPedido = date("Y-m-d H:i:s", strtotime($pedido->createdAt));
                $dataVenda = date("Y-m-d", strtotime($pedido->createdAt));
                $horaEntrega = date("H:i", strtotime($pedido->delivery->deliveryDateTime));
                $idVenda = md5($pedido->id);
                $totalVenda = number_format($pedido->total->orderAmount, 2, '.', '');
                $totalPago = number_format($pedido->payments->prepaid, 2, '.', '');
                $valorFrete = number_format($pedido->total->deliveryFee, 2, '.', '');
                $tipoPedidoIfood = $pedido->orderType == "TAKEOUT" ? "Retirada" : "Entrega";
                $idClienteIfood = $pedido->customer->id;
                $enderecoEntrega = $tipoPedidoIfood == "Entrega" ? $pedido->delivery->deliveryAddress : "";
                // $responsavelEntrega = $pedido->delivery->deliveredBy;
                $verificaCliente = $con->query("SELECT Id FROM cliente WHERE Id_Ifood='$idClienteIfood'");
                $pagamentoEntrega = $pedido->payments->methods[0]->type == "OFFLINE" ? "Sim" : "No";
                $trocoEntrega = $pagamentoEntrega == "Sim" && isset($pedido->payments->methods[0]->cash) ? $pedido->payments->methods[0]->cash->changeFor : 0;
                $dataPagamento = "";
                $lancamentoVenda = $con->query("SHOW TABLE STATUS FROM $dbname LIKE 'venda'");
                $lancamentoVenda = $lancamentoVenda->fetch_assoc()['Auto_increment'];
                $cfopPadraoRestaurante = $con->query("SELECT Id_Cfop_Restaurante FROM opcao");
                $cfopPadraoRestaurante = $cfopPadraoRestaurante->fetch_assoc()['Id_Cfop_Restaurante'];
                $enderecoComanda = $tipoPedidoIfood == "Entrega" ? utf8_decode($enderecoEntrega->formattedAddress) : "";
                $observacaoPedido = $pedido->observations ?? "";
                $descontos = isset($pedido->benefits) ? array_column($pedido->benefits, 'value') : [];
                $descontoReal = 0;
                $taxaServico = number_format($pedido->total->additionalFees, 2, '.', '');
                $codigoColeta = isset($pedido->delivery->pickupCode) ? $pedido->delivery->pickupCode : "";
                $cpfCnpjEmissao = "";
                $subtotalVenda = $pedido->total->subTotal;

                foreach ($descontos as $desconto) {
                    $descontoReal += $desconto;
                }
                $descontoReal = str_replace(",", ".", $descontoReal);

                if($verificaCliente->num_rows == 0) {
                    $idCliente = md5($idClienteIfood);
                    $cliente = $pedido->customer;
                    $nomeCliente = utf8_decode($cliente->name);
                    $telefoneCliente = $cliente->phone->number;
                    $cpfCnpj = isset($cliente->documentNumber) ? $cliente->documentNumber : "";
                    $getCodigoCliente = $con->query("SELECT Codigo FROM cliente ORDER BY Data_Cadastro DESC LIMIT 1");
                    $codigo = intval(mysqli_fetch_assoc($getCodigoCliente)['Codigo']);
                    $codigo += 1;
                    $codigoCliente = str_pad("$codigo", 4, '0', STR_PAD_LEFT);
                    $dataCadastroCliente = date("Y-m-d H:i:s");
                    $cidadeCliente = mb_convert_encoding($enderecoEntrega->city, "ISO-8859-1", 'UTF-8');
                    $bairroCliente = mb_convert_encoding($enderecoEntrega->neighborhood, "ISO-8859-1", 'UTF-8');
                    
                    $con->query("INSERT INTO cliente SET Id='$idCliente', Titulo='$nomeCliente', Cpf_Cnpj='$cpfCnpj', Codigo='$codigoCliente',
                        Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario', Data_Cadastro='$dataCadastroCliente', Data_Cadastro_Upd='$dataCadastroCliente',
                        Id_Funcionario='$idFuncionario', Id_Unidade='$idUnidade', Fone1='$telefoneCliente', Cep_Entrega='$enderecoEntrega->postalCode',
                        Bairro_Entrega='$bairroCliente', Natureza='PF', Cidade_Entrega='$cidadeCliente', Estado_Entrega='$enderecoEntrega->state',
                        Id_Ifood='$idClienteIfood'");
                }
                else {
                    $cpfCnpjEmissao = isset($pedido->customer->documentNumber) ? $pedido->customer->documentNumber : "";
                    $idCliente = mysqli_fetch_assoc($verificaCliente)['Id'];
                }
                $sqlVenda = "INSERT INTO venda SET Id='$idVenda', Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario', Data_Cadastro='$dataPedido',
                    Data_Cadastro_Upd='$dataPedido', Id_Unidade='$idUnidade', Data_Venda='$dataVenda', Status_Pedido='Confirmado', Origem='Ifood',
                    Id_Cliente='$idCliente', Status='Finalizado', Valor_Original='$totalVenda', Id_Cfop='$cfopPadraoRestaurante', Valor_Frete='$valorFrete',
                    Valor_Pago='$totalPago', Id_Funcionario='$idFuncionario', Entrega_Comanda='$enderecoComanda', Numero_Pedido='$pedido->displayId',
                    Id_Ifood='$pedido->id', Entregador_Solicitado_Ifood = 'No', Pagamento_Entrega='$pagamentoEntrega', Troco_Entrega = '$trocoEntrega',
                    Obs='$observacaoPedido', Data_Entrega=NOW(), Hora_Entrega = '$horaEntrega', Tipo_Pedido_Ifood = '$tipoPedidoIfood',
                    Aplicar_Taxa_Servico_Restaurante = 'No', Aplicar_Taxa_Couvert_Artistico = 'No', Numero_Comanda = '$lancamentoVenda', Fatura='$lancamentoVenda',
                    Descricao = '$lancamentoVenda', Tipo_Frete='0', Desconto_Real = '$descontoReal', Taxa_Servico_Restaurante = '$taxaServico',
                    Codigo_Entrega_Ifood = '$codigoColeta', Cpf_Cnpj_Emissao = '$cpfCnpjEmissao'";

                if(isset($pedido->extraInfo)) {
                    $sqlVenda .= ", Obs = '$pedido->extraInfo'";
                }

                if($pedido->orderTiming == "SCHEDULED") {
                    $horarioAgendado = json_encode([
                        "dataEntrega"=> date("d/m/Y", strtotime($pedido->schedule->deliveryDateTimeStart)),
                        "horario"=> [
                            "inicial"=> date("H:i", strtotime($pedido->schedule->deliveryDateTimeStart)),
                            "final"=> date("H:i", strtotime($pedido->schedule->deliveryDateTimeEnd))
                        ]
                    ]);
                    $sqlVenda .= ", Horario_Agendamento_Ifood = '$horarioAgendado'";
                }
                $tiposPagamentoIfood = array_column($pedido->payments->methods, "type");

                if(in_array("ONLINE", $tiposPagamentoIfood) && $pedido->payments->pending == 0) {
                    $dataPagamento = date("Y-m-d", strtotime($pedido->createdAt));
                    $sqlVenda .= ", Data_Pagamento='$dataPagamento'";
                }
                $con->query($sqlVenda) or die($con->error);

                if($con->affected_rows > 0) {
                    array_push($notificacoesReconhecer, ["id"=> $pedido->notificationId]);
                    if($pedido->notificationStatus == "Novo") {
                        Pedido::confirmar($pedido->id);
                    }
                    
                    $getComissaoVendedor = $con->query("SELECT Comissao_Avista FROM funcionario WHERE Id='$idFuncionario'");
                    $comissaoVendedor = $getComissaoVendedor->fetch_assoc()["Comissao_Avista"];
                    $freteRateado = $pedido->total->deliveryFee / $subtotalVenda;
                    $freteRateado = number_format($freteRateado, 10, ".", "");
                    // $freteRateado = str_replace('.', '', $freteRateado);
                    $descontoRateado = number_format($descontoReal / $subtotalVenda, 10, '.', '');

                    foreach($pedido->items as $produto) {
                        $idIfoodProduto = Pedido::getIdIfoodProduto($categoriasIfood, $produto->id);

                        if($idIfoodProduto == null) continue;

                        $getProduto = $con->query("SELECT Id, Preco1, Id_Unidade, Cozinha, Id_Cfop_Venda, Id_Local_Estoque_Saida, Custo,
                            Situacao_Tributaria, Comissao, Aliquota, Descricao, Gtin FROM produto WHERE Id_Ifood='$idIfoodProduto'");

                        if($getProduto->num_rows > 0) {
                            $produtoInterno = $getProduto->fetch_assoc();
                            $idVendaProduto = md5($idVenda.microtime());
                            $precoProduto = number_format($produto->unitPrice, 2, '.', '');
                            $dataHoraCadastroProduto = date("Y-m-d H:i:s");
                            $cfopProduto = $produtoInterno['Id_Cfop_Venda'];
                            $observacaoProduto = isset($produto->observations) ? mb_convert_encoding($produto->observations, "ISO-8859-1", "UTF-8") : "";
                            if(!$cfopProduto || empty($cfopProduto)) {
                                $cfopProduto = $cfopPadraoRestaurante;
                            }
                            $comissaoProduto = COMISSAO_TIPO == 'Venda' ? $comissaoVendedor : $produtoInterno['Comissao'];
                            if ($comissaoProduto == 0 && COMISSAO_TIPO == 'Venda') {
                                $comissaoProduto = $produtoInterno['Comissao'];
                            }
                            $impostoProduto = Produto::impostos($produtoInterno['Id'], $idCliente, $idUnidade);
                            $vBCSTRet = 0;
                            $vICMSSTRet = 0;
                            $vICMSDeson = 0;
                            $freteProduto = number_format(($freteRateado * $produto->totalPrice), 2, '.', '');
                            $descontoRealProduto = 0;

                            if ($descontoReal > 0) {
                                $descontoRealProduto = number_format($produto->price * $descontoRateado, 2, ".", "");
                            }

                            $con->query("INSERT INTO venda_produto SET Id='$idVendaProduto', Id_Venda='$idVenda', Id_Funcionario='$idFuncionario',
                                Id_Produto='{$produtoInterno['Id']}', Preco='$precoProduto', Preco_Custo = '{$produtoInterno['Custo']}', Qtd='$produto->quantity',
                                Id_Unidade='$idUnidade', Ipi = '{$impostoProduto['Aliquota_Ipi']}', CST_Ipi = '{$impostoProduto['CST_Ipi']}',
                                Aliquota_Pis = '{$impostoProduto['Aliquota_Pis']}', CST_Pis = '{$impostoProduto['CST_Pis']}', Comissao = '$comissaoProduto',
                                Aliquota_Cofins = '{$impostoProduto['Aliquota_Cofins']}', CST_Cofins = '{$impostoProduto['CST_Cofins']}', Gtin='{$produtoInterno['Gtin']}',
                                Icms = '{$impostoProduto['Aliquota_Icms']}', Icms_Sub = '{$impostoProduto['Icms_Sub']}', Mva = '{$impostoProduto['Mva']}',
                                Reducao = '{$impostoProduto['Reducao_Icms']}', ReducaoBC = '{$impostoProduto['Reducao_BC']}', ST_Icms = '{$impostoProduto['Codigo_ST']}',
                                Id_Cfop='$cfopProduto', Situacao_Tributaria='{$produtoInterno['Situacao_Tributaria']}', Preco_Tabela = '$precoProduto',
                                vBCSTRet='$vBCSTRet', vICMSSTRet='$vICMSSTRet', vICMSDeson='$vICMSDeson', motDesICMS='0', Aliquota='{$produtoInterno['Aliquota']}',
                                C_Produto='{$produtoInterno['Descricao']}', Id_Cliente='$idCliente', Origem_ST='0', Impresso_Cozinha = 'No', Id_Usuario='$idUsuario',
                                Id_Ifood = '$produto->uniqueId', Obs_Produto = '$observacaoProduto', Frete = '$freteProduto', Desconto_Real = '$descontoRealProduto',
                                Id_Usuario_Upd='$idUsuario', Data_Cadastro='$dataHoraCadastroProduto', Data_Cadastro_Upd='$dataHoraCadastroProduto'")
                                    or die($con->error);
                            
                            if (MODULO_COZINHA == 'Sim' && $produtoInterno['Cozinha'] == 'Sim') {
                                $con->query("INSERT INTO cozinha_produto SET Id_Produto = '{$produtoInterno['Id']}', Id_Venda_Produto = '$idVendaProduto',
                                    Data_Cadastro = '$dataHoraCadastroProduto', Data_Cadastro_Upd = '$dataHoraCadastroProduto',
                                    Id_Usuario = '{$_COOKIE['Id']}', Id_Usuario_Upd = '{$_COOKIE['Id']}', Status = 'Confirmado'");
                            }

                            Produto::baixarEstoque($produtoInterno['Id'], -$produto->quantity, $produtoInterno['Id_Local_Estoque_Saida'], $produtoInterno['Custo'],
                                (float)$precoProduto, $cfopProduto, $impostoProduto['Aliquota_Icms'], $impostoProduto['Aliquota_Ipi'], "Restaurante", "Sim",
                                $idVenda, $idUnidade, $impostoProduto['Icms_Sub'], $impostoProduto['Mva'], $impostoProduto['Reducao_Icms']
                            );
                        }

                        if(isset($produto->options)) {
                            foreach($produto->options as $produtoExtra) {
                                if(isset($produtoExtra->id)) {
                                    $getProdutoExtra = $con->query("SELECT Id, Custo, Id_Cfop_Venda, Id_Local_Estoque_Saida, Situacao_Tributaria, Comissao,
                                        Aliquota, Descricao, Gtin FROM produto WHERE Id='$produtoExtra->id'");
    
                                    if($getProdutoExtra->num_rows > 0) {
                                        $produtoInternoExtra = $getProdutoExtra->fetch_assoc();
                                        $idVendaProduto = md5($idVenda.microtime());
                                        $cfopProdutoExtra = $produtoInternoExtra['Id_Cfop_Venda'];
                                        $dataHoraCadastroProduto = date("Y-m-d H:i:s");
                                        if(!$cfopProdutoExtra || empty($cfopProdutoExtra)) {
                                            $cfopProdutoExtra = $cfopPadraoRestaurante;
                                        }
                                        $impostoProdutoExtra = Produto::impostos($produtoInternoExtra['Id'], $idCliente, $idUnidade);
                                        $comissaoProdutoExtra = COMISSAO_TIPO == 'Venda' ? $comissaoVendedor : $produtoInternoExtra['Comissao'];
                                        if ($comissaoProdutoExtra == 0 && COMISSAO_TIPO == 'Venda') {
                                            $comissaoProdutoExtra = $produtoInternoExtra['Comissao'];
                                        }
    
                                        $con->query("INSERT INTO venda_produto SET Id='$idVendaProduto', Id_Venda='$idVenda', Id_Funcionario='$idFuncionario',
                                            Id_Produto='{$produtoInternoExtra['Id']}', Preco='$produtoExtra->unitPrice', Preco_Custo = '{$produtoInternoExtra['Custo']}',
                                            Preco_Tabela = '$produtoExtra->unitPrice', Qtd='$produtoExtra->quantity', Ipi='{$impostoProdutoExtra['Aliquota_Ipi']}',
                                            Icms = '{$impostoProdutoExtra['Aliquota_Icms']}', Icms_Sub = '{$impostoProdutoExtra['Icms_Sub']}',
                                            Mva = '{$impostoProdutoExtra['Icms_Sub']}', Reducao = '{$impostoProdutoExtra['Reducao_Icms']}',
                                            ReducaoBC = '{$impostoProdutoExtra['Reducao_BC']}', ST_Icms = '{$impostoProdutoExtra['Codigo_ST']}',
                                            Id_Local_Estoque = '{$produtoInternoExtra['Id_Local_Estoque_Saida']}', Comissao = '$comissaoProdutoExtra',
                                            Id_Unidade = '$idUnidade', Embalagem_Primaria='KIT', Aliquota='{$produtoInternoExtra['Aliquota']}', Origem_ST='0',
                                            C_Produto='{$produtoInternoExtra['Descricao']}', Id_Cfop='$cfopProdutoExtra', Id_Venda_Produto_Origem='$idVendaProduto',
                                            Id_Cliente='$idCliente', Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario', Data_Cadastro= '$dataHoraCadastroProduto',
                                            Data_Cadastro_Upd= '$dataHoraCadastroProduto'");
    
                                        Produto::baixarEstoque($produtoInternoExtra['Id'], -$produtoExtra->quantity, $produtoInternoExtra['Id_Local_Estoque_Saida'],
                                            $produtoInternoExtra['Custo'], (float)$produtoExtra->unitPrice, $cfopProdutoExtra, $impostoProdutoExtra['Aliquota_Icms'],
                                            $impostoProdutoExtra['Aliquota_Ipi'], "Restaurante", "Sim", $idVenda, $idUnidade, $impostoProdutoExtra['Icms_Sub'],
                                            $impostoProdutoExtra['Mva'], $impostoProdutoExtra['Reducao_Icms']
                                        );
                                    }
                                }
                            }
                        }
                    }

                    if ($descontoReal > 0) {
                        $ultimoItem = $con->query("SELECT Id FROM venda_produto WHERE Id_Venda = '$idVenda' ORDER BY (Qtd * Preco) DESC");
                        $ultimoItem = $ultimoItem->fetch_assoc();
                
                        $totalDescontoAplicado = $con->query("SELECT SUM(Desconto_Real) as Valor_Total_Desconto FROM venda_produto
                            WHERE Id_Venda = '$idVenda' AND Id != '{$ultimoItem["Id"]}'");
                        $totalDescontoAplicado = $totalDescontoAplicado->fetch_assoc()['Valor_Total_Desconto'];
                
                        $descontoUltimoItem = number_format($descontoReal - $totalDescontoAplicado, 2, '.', '');
                        $con->query("UPDATE venda_produto SET Desconto_Real = '$descontoUltimoItem' WHERE Id = '{$ultimoItem["Id"]}'");
                    }

                    $sqlDescontosPedido = "INSERT INTO ifood_beneficio_pedido (Id_Venda, Valor_Total, Valor_Ifood, Valor_Loja, Origem, Responsavel) VALUES ";
                    $origemBeneficios = [
                        "CART"=> "Carrinho",
                        "DELIVERY_FEE", "Taxa Entrega",
                        "ITEM"=> "Produto",
                        "PROGRESSIVE_DISCOUNT_ITEM"=> "Progressivo Produto"
                    ];
                    if(isset($pedido->benefits)) {
                        foreach($pedido->benefits as $indiceBeneficio => $beneficio) {
                            $origemBeneficio = $origemBeneficios[$beneficio->target];
                            $valorIfood = 0;
                            $valorLoja = 0;
                            foreach($beneficio->sponsorshipValues as $valorBeneficio) {
                                if($valorBeneficio->name == "IFOOD") {
                                    $valorIfood += $valorBeneficio->value;
                                }
                                else {
                                    $valorLoja += $valorBeneficio->value;
                                }
                            }
                            $responsavelBeneficio = $valorIfood > 0 ? "Ifood" : "Restaurante";
                            $sqlDescontosPedido .= ($indiceBeneficio > 0 ? "," : "")."('$idVenda', $beneficio->value, $valorIfood, $valorLoja, '$origemBeneficio', '$responsavelBeneficio')";
                        }
                        if(sizeof($pedido->benefits) > 0) {
                            $con->query($sqlDescontosPedido);
                        }
                    }

                    $lancamentoFinanceiro = $con->query("SELECT Lancamento FROM financeiro_pedido ORDER BY Lancamento DESC LIMIT 1");
                    $lancamentoFinanceiro = $lancamentoFinanceiro->fetch_assoc()['Lancamento'] + 1;
                    $sqlFinanceiroPedido = "INSERT INTO financeiro_pedido SET Id_Externo='$idVenda', Tipo='Venda', Lancamento='$lancamentoFinanceiro',
                        Ordem='1', Data_Cadastro=NOW(), Data_Cadastro_Upd=NOW(), Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario'";
                    $qtdPagamentos = sizeof($pedido->payments->methods);

                    foreach($pedido->payments->methods as $indicePagamento => $metodoPagamento) {
                        $nomeTipoPagamento = "";
                        switch($metodoPagamento->method) {
                            case "CREDIT": case "DEBIT":
                                $nomeTipoPagamento = "{$metodoPagamento->card->brand} {$metodoPagamento->method}O";
                                break;
                            case "CASH":
                                $nomeTipoPagamento = "DINHEIRO";
                                break;
                            case "DIGITAL_WALLET":
                                $nomeTipoPagamento = "CARTEIRA DIGITAL";
                                break;
                            default:
                                $nomeTipoPagamento = $metodoPagamento->method;
                                break;
                        }
                        $sqlTipoPagamento = "SELECT Id, Titulo, Gerar_Financeiro, Baixa_Caixa, Id_Conta FROM tipo_pagamento
                            WHERE Titulo = '$nomeTipoPagamento' AND Ativo = 'Sim'";

                        $getTipoPagamento = $con->query($sqlTipoPagamento);

                        if($getTipoPagamento->num_rows < 1) {
                            $idTipoPagamento = $metodoPagamento->method.microtime();
                            $contaPagamento = $con->query("SELECT Id FROM conta WHERE Ativo = 'Sim' AND Padrao = 'Sim' AND Id_Unidade='$idUnidade'");
                            $idContaPagamento = $contaPagamento->fetch_assoc()['Id'] ?? 1;
                            $pagamentoGeraFinanceiro = $metodoPagamento->prepaid && $metodoPagamento->type == "ONLINE" ? "Sim" : "No";
                            $getLancamentoPagamento = $con->query("SHOW TABLE STATUS FROM $dbname LIKE 'tipo_pagamento'");
                            $getLancamentoPagamento = $getLancamentoPagamento->fetch_assoc();
                            $lancamentotipoPagamento = $getLancamentoPagamento['Auto_increment'];

                            $con->query("INSERT INTO tipo_pagamento SET Id = '$idTipoPagamento', Codigo = '$lancamentotipoPagamento', Titulo = '$nomeTipoPagamento',
                                Restaurante = 'Sim', Gerar_Financeiro = '$pagamentoGeraFinanceiro', Cupom = 'CA', Data_Cadastro = NOW(), Data_Cadastro_Upd = NOW(),
                                Baixa_Caixa = '$pagamentoGeraFinanceiro', Id_Conta = '$idContaPagamento'");
                            $getTipoPagamento = $con->query($sqlTipoPagamento);
                        }
                        $tipoPagamento = $getTipoPagamento->fetch_assoc();
                
                        $idVendaPagamento = md5("{$tipoPagamento['Id']}$metodoPagamento->value".microtime());
                        $valorPagoTipoPagamento = number_format($metodoPagamento->value, 2, '.', '');
                        $dataPagamentoMetodo = $metodoPagamento->type == "ONLINE" && $metodoPagamento->prepaid ? date("Y-m-d") : "";
                        $ordemPagamento = $indicePagamento + 1;
                        $valorMetodo = $metodoPagamento->type == "ONLINE" && $metodoPagamento->prepaid ? $totalVenda : number_format($metodoPagamento->value, 2, '.', '');
                        $valorPagoMetodo = $metodoPagamento->type == "ONLINE" && $metodoPagamento->prepaid ? number_format($metodoPagamento->value, 2, '.', '') : 0;
                        $trocoMetodo = isset($metodoPagamento->cash->changeFor) ? number_format($metodoPagamento->cash->changeFor - $metodoPagamento->value, 2, '.', '') : 0;
                        
                        $con->query("INSERT INTO venda_tipo_pagamento SET Id='$idVendaPagamento', Data_Cadastro=NOW(), Id_Venda='$idVenda',
                            Id_Cliente='$idCliente', Id_Tipo_Pagamento='{$tipoPagamento['Id']}', Valor_Pago='$valorPagoMetodo', Valor='$valorMetodo',
                            Ordem='$ordemPagamento', Id_Unidade='$idUnidade', Data_Pagamento='$dataPagamentoMetodo', Id_Funcionario='$idFuncionario',
                            Qtd_Parcelas = '1', Tipo_Pagamento = 'Total', Valor_Troco = '$trocoMetodo'") or die($con->error);

                        $funcionario = $con->query("SELECT Titulo FROM funcionario WHERE Id='$idFuncionario'");
                        $funcionario = $funcionario->fetch_assoc()['Titulo'];
                        $ordemFinanceiro = str_pad($ordemPagamento, 2, '0', STR_PAD_LEFT);

                        if($tipoPagamento['Gerar_Financeiro'] == "Sim" && $pedido->payments->pending == 0) {
                            $sqlFinanceiroPedido .=  ", Id_Tipo_Pagamento$ordemFinanceiro='{$tipoPagamento['Id']}', Valor$ordemFinanceiro='$valorPagoTipoPagamento',
                                Data$ordemFinanceiro='$dataPagamentoMetodo'";
                            
                            $idContaReceber = md5($tipoPagamento['Id'].microtime());
                            $idContaPagamento = $tipoPagamento['Id_Conta'];
                            $idContaPagamento = empty($idContaPagamento) ? '1' : $idContaPagamento;
                            $statusContaReceber = $tipoPagamento['Baixa_Caixa'] == "Sim" ? "Liquidado" : "Aberto";
                            $valorContaReceber = $tipoPagamento['Baixa_Caixa'] == "Sim" ? $valorPagoTipoPagamento : 0;
                            $faturaContaReceber = "$lancamentoVenda-$ordemFinanceiro/$qtdPagamentos";
    
                            $con->query("INSERT INTO conta_receber SET Id='$idContaReceber', Id_Usuario='{$_COOKIE['Id']}', Id_Usuario_Upd='{$_COOKIE['Id']}',
                                Data_Cadastro=NOW(), Data_Cadastro_Upd=NOW(), Id_Cliente='$idCliente', Descricao='$lancamentoVenda', Fatura='$faturaContaReceber',
                                Data_Emissao='$dataVenda', Data_Vencimento='$dataPagamento', Data_Pagamento='$dataPagamento',Valor_Original='$valorPagoTipoPagamento',
                                Valor_Pago='$valorContaReceber', Valor_Inicial='$valorPagoTipoPagamento', Id_Funcionario='$idFuncionario', Id_Conta='$idContaPagamento',
                                Status='$statusContaReceber', Parcela='1', Origem='REST', Id_Tipo_Pagamento='{$tipoPagamento['Id']}', Id_Unidade='$idUnidade',
                                Id_Externo='$idVenda'");
    
                            if($tipoPagamento['Baixa_Caixa'] == "Sim") {
                                $idCaixa = md5($idContaReceber.microtime());
                                $colunaCliente = CLIENTE_RAZAO_SOCIAL ? "Razao_Social" : "Titulo";
                                $nomeCliente = $con->query("SELECT $colunaCliente AS Cliente FROM cliente WHERE Id = '$idCliente'");
                                $nomeCliente = $nomeCliente->fetch_assoc()['Cliente'];
                                $obs = "$dataPagamento $lancamentoVenda $nomeCliente";
    
                                $con->query("INSERT INTO caixa SET Id='$idCaixa', Id_Usuario='{$_COOKIE['Id']}', Id_Usuario_Upd='{$_COOKIE['Id']}',
                                    Data_Cadastro=NOW(), Data_Cadastro_Upd=NOW(), Tipo='Entrada', Valor='$valorPagoTipoPagamento', Data_Caixa='$dataPagamento',
                                    Obs='$obs', Tipo_Pagamento='{$tipoPagamento['Titulo']}', Id_Tipo_Pagamento='{$tipoPagamento['Id']}', Funcionario='$funcionario',
                                    Id_Funcionario='$idFuncionario', Id_Externo='$idContaReceber', Origem='CR', Id_Unidade='$idUnidade',
                                    Id_Conta='$idContaPagamento', Id_Atividade='', Id_Centro_Custo='', Fatura='', Banco='', Agencia='', Cc='', Numero='',
                                    Id_Cliente='$idCliente'");
                            }
                        }

                        if($indicePagamento + 1 == sizeof($pedido->payments->methods) && $pedido->payments->pending == 0) {
                            $con->query($sqlFinanceiroPedido);
                        }
                    }
                }
            }
            else {
                array_push($notificacoesReconhecer, ["id"=> $pedido->notificationId]);
            }
        }
        Pedido::reconhecerNotificacoes($notificacoesReconhecer);
    }

    public static function solicitarEntregador(string $idPedido) {
        $url = Api::getUrl()."/shipping/".Api::getVersao()."/orders/$idPedido/deliveryAvailabilities";
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $detalhesEntrega = Request::get($url, $autenticacao->token);
            return $detalhesEntrega->body;
        }
        return null;
    }

    public static function aceitarEntregador(string $idPedido, string $idEntrega) {
        $url = Api::getUrl()."/shipping/".Api::getVersao()."/orders/$idPedido/requestDriver";
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $dados = json_encode([
                "quoteId"=> $idEntrega
            ]);
            $aceitarEntrega = Request::post($url, $autenticacao->token, $dados, "json");
            return $aceitarEntrega->http_code == 202;
        }
        return false;
    }

    public static function detalhesDisputa(string $idDisputa) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            // $url = Api::getUrl()."/".
        }
    }

    public static function cadastrarContrapropostas(int $idDisputa, array $contrapropostas) {
        global $con;

        $sqlContraproposta = "INSERT INTO ifood_contraproposta_pedido (Id_Disputa, Id_Ifood, Tipo, Valor_Maximo) VALUES ";
        foreach($contrapropostas as $indiceProposta => $contraproposta) {
            $tipoContraproposta = $contraproposta->type == "REFUND" ? "Reembolso" : ($contraproposta->type == "BENEFIT" ? "Benefcio" : "Tempo Adicional");
            $valorContraproposta = number_format($contraproposta->metadata->maxAmount->value / 100, 2, '.', '');
            $sqlContraproposta .= ($indiceProposta > 0 ? "," : "")."('$idDisputa', '$contraproposta->id', '$tipoContraproposta', '$valorContraproposta')";
        }
        if(sizeof($contrapropostas) > 0) {
            $con->query($sqlContraproposta);
        }
    }

    public static function cadastrarProdutosDisputa(int $idDisputa, array $produtos, array $produtosExtras){
        global $con;
        $sqlProdutosCancelados = "INSERT INTO ifood_disputa_pedido_produto (Id_Disputa, Id_Produto, Id_Produto_Pai, Quantidade, Valor, Motivo) VALUES ";
        $totalCancelado = 0;
    
        foreach($produtos as $indiceProduto => $produtoCancelado) {
            $getIdProduto = $con->query("SELECT Id_Produto FROM venda_produto WHERE Id_Ifood = '$produtoCancelado->uniqueId'");
            $idProduto = $getIdProduto->fetch_assoc()['Id_Produto'];
            $valorProduto = number_format($produtoCancelado->amount->value / 100, 2, '.', '');
            $motivoCancelamento = $produtoCancelado->reason ?? '';

            $sqlProdutosCancelados .= ($indiceProduto > 0 ? "," : "")."('$idDisputa', '$idProduto', NULL,
                $produtoCancelado->quantity, '$valorProduto', '$motivoCancelamento')";
            $totalCancelado += ($valorProduto * $produtoCancelado->quantity);
        }

        foreach($produtosExtras as $indiceProduto => $produtoCancelado) {
            $getIdProduto = $con->query("SELECT Id_Produto FROM venda_produto WHERE Id_Ifood = '$produtoCancelado->uniqueId'");
            $idProduto = $getIdProduto->fetch_assoc()['Id_Produto'];

            $getProdutoPai = $con->query("SELECT Id_Produto_Pai FROM produto WHERE Id = '$idProduto'");
            $idProdutoPai = $getProdutoPai->fetch_assoc()['Id_Produto_Pai'] ?? '';

            $valorProduto = number_format($produtoCancelado->amount->value / 100, 2, '.', '');
            $motivoCancelamento = $produtoCancelado->reason ?? '';
            $sqlProdutosCancelados .= ($indiceProduto > 0 ? "," : "")."($idDisputa, '$idProduto', '$idProdutoPai',
                $produtoCancelado->quantity, '$valorProduto', '$motivoCancelamento')";
            $totalCancelado += ($valorProduto * $produtoCancelado->quantity);
        }

        if(sizeof($produtos) > 0 || sizeof($produtosExtras) > 0) {
            $con->query($sqlProdutosCancelados) or die($con->error);
            $totalCancelado = str_replace(",", ".", $totalCancelado);
            $con->set_charset("latin1");
            $con->query("UPDATE ifood_contraproposta_pedido SET Valor = '$totalCancelado' WHERE Id_Disputa = '$idDisputa' AND Tipo IN('Reembolso','Benefcio')");
        }
    }

    public static function eventosCancelamento(array $eventosCancelamento) {
        global $con;
        $con->set_charset("utf8mb4");
        $notificacoesReconhecer = [];
        $tiposDisputa = [
            "AFTER_DELIVERY"=> "Aps Entrega",
            "DELAY"=> "Atraso",
            "PREPARATION_TIME"=> "Em Preparo",
            "AFTER_DELIVERY_PARTIALLY"=> "Parcial Aps Entrega"
        ];
        $acoesAutomaticas = [
            "ACCEPT_CANCELLATION"=> "Aceitar",
            "REJECT_CANCELLATION"=> "Rejeitar",
            "VOID"=> "Nenhuma"
        ];
        $acoesDisputa = [
            "CANCELLATION"=> "Cancelamento",
            "PARTIAL_CANCELLATION"=> "Cancelamento Parcial",
            "PROPOSED_AMOUNT_REFUND"=> "Cancelamento Com Proposta"
        ];

        foreach ($eventosCancelamento as $eventoCancelamento) {
            $dataValidade = date("Y-m-d H:i:s", strtotime($eventoCancelamento->metadata->expiresAt));
            $mensagem = $eventoCancelamento->metadata->message ?? '';
            $tipoDisputa = mb_convert_encoding($tiposDisputa[$eventoCancelamento->metadata->handshakeType], "UTF-8", "ISO-8859-1");

            $sqlDisputa = "INSERT INTO ifood_disputa_pedido SET Id_Venda = (SELECT Id FROM venda WHERE Id_Ifood = '$eventoCancelamento->orderId'),
            Id_Disputa_Ifood = '{$eventoCancelamento->metadata->disputeId}', Mensagem = '$mensagem', Validade= '$dataValidade',
            Tipo_Disputa = '$tipoDisputa', Acao = '{$acoesDisputa[$eventoCancelamento->metadata->action]}',
            Acao_Automatica= '{$acoesAutomaticas[$eventoCancelamento->metadata->timeoutAction]}', Tipo = 'Reembolso'";

            if(!isset($eventoCancelamento->metadata->alternatives)) {
                $getTotalVenda = $con->query("SELECT Valor_Original FROM venda WHERE Id_Ifood = '$eventoCancelamento->orderId'");
                $totalVenda = $getTotalVenda->fetch_assoc()['Valor_Original'];
                $sqlDisputa .= ", Valor = '$totalVenda'";
            }

            $registrarDisputa = $con->query($sqlDisputa);
            $idDisputa = $con->insert_id;
            
            if($registrarDisputa) {
                if(isset($eventoCancelamento->metadata->alternatives)) {
                    Pedido::cadastrarContrapropostas($idDisputa, $eventoCancelamento->metadata->alternatives);
                }

                if(isset($eventoCancelamento->metadata->metadata->evidences)) {
                    $sqlImagens = "INSERT INTO ifood_imagem_cancelamento (Id_Disputa, Nome) VALUES ";
                    $qtdImagensSalvas = 0;

                    foreach($eventoCancelamento->metadata->metadata->evidences as $indiceImagem => $imagem) {
                        $diretorio = "../../../../restaurante_login/imagem";
                        $caminho = __DIR__."/$diretorio";
                        $extensoesImagem = [
                            "image/jpg"=> "jpg",
                            "image/jpeg"=> "jpeg",
                            "image/png"=> "png",
                        ];
                        $nomeFoto = md5($eventoCancelamento->metadata->disputeId.microtime());
                        $caminho = str_replace("\\", "/", realpath($caminho));
                        $salvarImagem = Imagem::salvar($imagem->url, $caminho, $nomeFoto, $extensoesImagem[$imagem->contentType]);
                        
                        if($salvarImagem) {
                            $sqlImagens .= ($indiceImagem > 0 ? "," : "")."('$idDisputa', '$nomeFoto.{$extensoesImagem[$imagem->contentType]}')";
                            $qtdImagensSalvas++;
                        }
                    }

                    if($qtdImagensSalvas > 0) {
                        $con->query($sqlImagens);
                    }
                }
                Pedido::cadastrarProdutosDisputa(
                    $idDisputa,
                    $eventoCancelamento->metadata->metadata->items ?? [],
                    $eventoCancelamento->metadata->metadata->garnishItems ?? [],
                );
                array_push($notificacoesReconhecer, ["id"=> $eventoCancelamento->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    public static function atualizarDisputas(array $atualizacoesDisputas) {
        global $con;
        $con->set_charset("utf8mb4");
        $notificacoesReconhecer = [];

        $status = [
            "ACCEPTED"=> "Aceita",
            "REJECTED"=> "Rejeitada",
            "EXPIRED"=> "Expirada",
            "ALTERNATIVE_REPLIED"=> "Proposta Enviada"
        ];
        $tipos = [
            "REFUND"=> "Reembolso",
            "BENEFIT"=> "Benefcio"
        ];

        foreach($atualizacoesDisputas as $notificacao) {
            $getDisputa = $con->query("SELECT Id, Id_Venda, Acao_Automatica, Acao, Status FROM ifood_disputa_pedido
                WHERE Id_Venda = (SELECT Id FROM venda WHERE Id_Ifood = '{$notificacao->orderId}')");
            $disputaExiste = $getDisputa->num_rows > 0;
        
            if($disputaExiste) {
                $disputa = $getDisputa->fetch_assoc();
                $disputaAtualizada = false;

                if($notificacao->metadata->status == "EXPIRED") {
                    if(is_null($disputa['Status'])) {
                        $con->query("UPDATE ifood_disputa_pedido SET Status = '{$status[$notificacao->metadata->status]}'
                            WHERE Id = '{$disputa['Id']}'");
                        $disputaAtualizada = $con->affected_rows > 0;
                    }
                }
                else {
                    $statusDisputa = $status[$notificacao->metadata->status];
                    
                    switch($statusDisputa) {
                        case 'Aceita':
                            $motivo = isset($notificacao->metadata->reason) ? $notificacao->metadata->reason : '';
                            // if($disputa['Acao'] == 'Cancelamento') {
                            //     $getValorVenda = $con->query("SELECT Valor_Original FROM venda WHERE Id = '{$disputa['Id_Venda']}'");
                            //     $valorDisputa = $getValorVenda->fetch_assoc()['Valor_Original'];
                            //     //cancelar venda e financeiro
                            // }
                            $con->query("UPDATE ifood_disputa_pedido SET Status = '$statusDisputa', Motivo = '$motivo' WHERE Id = '{$disputa['Id']}'");
                            $disputaAtualizada = $con->affected_rows > 0;
                            break;
                        case 'Proposta Enviada':
                            $contraproposta = $notificacao->metadata->selectedDisputeAlternative;
                            $valorDisputa = str_replace(",", ".", $contraproposta->metadata->amount->value / 100);

                            $con->query("UPDATE ifood_disputa_pedido SET Valor = '$valorDisputa', Tipo = '{$tipos[$contraproposta->type]}'
                                WHERE Id = '{$disputa['Id']}'");
                            $disputaAtualizada = $con->affected_rows > 0;
                            $con->query("UPDATE ifood_contraproposta_pedido SET Valor = '$valorDisputa' WHERE Id_Ifood = '{$contraproposta->id}'");
                            break;
                        case 'Rejeitada':
                            $con->query("UPDATE ifood_disputa_pedido SET Status = 'Rejeitada' WHERE Id = '{$disputa['Id']}'");
                            $disputaAtualizada = $con->affected_rows > 0;
                            break;
                    }
                }
                if($disputaAtualizada) {
                    array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
                }
            }
            else {
                array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }

    public static function aceitarDisputaCancelamento(string $idDisputa) {
        global $con;

        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/v1.0/disputes/$idDisputa/accept";
            $aceitarProposta = Request::post($url, $autenticacao->token, null);
            if($aceitarProposta->http_code == 201) {
                $con->query("UPDATE ifood_disputa_pedido SET Status = 'Aceita' WHERE Id_Disputa_Ifood = '$idDisputa'");
                return $con->affected_rows > 0;
            }
        }
        return false;
    }

    public static function rejeitarDisputaCancelamento(string $idDisputa, string $motivo) {
        global $con;

        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/v1.0/disputes/$idDisputa/reject";
            $corpoRequisicao = json_encode([
                "reason" => $motivo
            ]);
            $rejeitarDisputa = Request::post($url, $autenticacao->token, $corpoRequisicao, "json");
            if($rejeitarDisputa->http_code == 201) {
                $con->query("UPDATE ifood_disputa_pedido SET Status = 'Rejeitada' WHERE Id_Disputa_Ifood = '$idDisputa'");
                return $con->affected_rows > 0;
            }
        }
        return false;
    }

    public static function enviarContrapropostaDisputa(string $idDisputa, string $idContraproposta, float $valor) {
        global $con;

        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/order/v1.0/disputes/$idDisputa/alternatives/$idContraproposta";
            $getContraproposta = $con->query("SELECT * FROM ifood_contraproposta_pedido WHERE Id_Ifood = '$idContraproposta'");
            $contraproposta = $getContraproposta->fetch_assoc();
            $tiposContraproposta = [
                "Reembolso"=> "REFUND",
                "Benefcio"=> "BENEFIT",
                "Tempo Adicional"=> "ADDITIONAL_TIME"
            ];
            $corpoRequisicao = [
                "type" => $tiposContraproposta[$contraproposta['Tipo']],
            ];

            if($contraproposta['Tipo'] == "Tempo Adicional") {
                $corpoRequisicao["metadata"] = [
                    "additionalTimeInMinutes"=> 0,
                    "additionalTimeReason"=> ""
                ];
            } else {
                $corpoRequisicao["metadata"] = [
                    "amount"=> [
                        "value"=> str_replace(",", ".", $valor * 100),
                        "currency"=> "BRL"
                    ]
                ];
            }
            $corpoRequisicao = json_encode($corpoRequisicao);
            $enviarContraproposta = Request::post($url, $autenticacao->token, $corpoRequisicao, "json");
            
            return $enviarContraproposta->http_code == 201;
        }
        return false;
    }

    private static function alterarProdutosCancelados(array $produtosCancelados): int {
        global $con;

        $idUsuario = $_COOKIE['Id'];
        $idFuncionario = $_COOKIE['Id_Funcionario'];
        $dataHoraCadastro = date("Y-m-d H:i:s");
        $qtdProdutosCancelados = 0;

        foreach($produtosCancelados as $itemCancelado) {
            $vendaProduto = $con->query("SELECT Id, Qtd, Id_Venda, Id_Produto, Preco, Preco_Custo, Preco_Tabela, Qtd, Ipi, Icms,
                Icms_Sub, Mva, Reducao, ReducaoBC, ST_Icms, Situacao_Tributaria, vBCSTRet, vICMSSTRet, vICMSDeson, Obs_Produto,
                Id_Local_Estoque, Comissao, Id_Unidade, Embalagem_Primaria, CST_Ipi, Aliquota, Origem_ST, C_Produto, Id_Cfop,
                Id_Venda_Produto_Origem, Id_Cliente FROM venda_produto WHERE Id_Ifood = '$itemCancelado->uniqueId'");
            $vendaProduto = $vendaProduto->fetch_assoc();

            if(isset($itemCancelado->quantity)) {
                $quantidadeCancelados = $itemCancelado->quantity;
                $idVendaProduto = md5($itemCancelado->uniqueId.microtime());

                if($quantidadeCancelados == $vendaProduto['Qtd']) {
                    $con->query("UPDATE venda_produto SET Cancelado = 'Sim' WHERE Id = '{$vendaProduto['Id']}'");
                    $qtdProdutosCancelados += $quantidadeCancelados;
                } else {
                    $con->query("INSERT INTO venda_produto SET Id = '$idVendaProduto', Id_Venda = '{$vendaProduto['Id_Venda']}',
                        Id_Funcionario = '$idFuncionario', Id_Produto = '{$vendaProduto['Id_Produto']}', Preco = '{$vendaProduto['Preco']}',
                        Preco_Custo = '{$vendaProduto['Preco_Custo']}', Preco_Tabela = '{$vendaProduto['Preco_Tabela']}', Qtd = '$quantidadeCancelados',
                        Ipi = '{$vendaProduto['Ipi']}', CST_Ipi = '{$vendaProduto['CST_Ipi']}', Aliquota_Pis = '{$vendaProduto['Aliquota_Pis']}',
                        CST_Pis = '{$vendaProduto['CST_Pis']}', Aliquota_Cofins = '{$vendaProduto['Aliquota_Cofins']}',
                        CST_Cofins = '{$vendaProduto['CST_Cofins']}', Gtin = '{$vendaProduto['Gtin']}', Icms = '{$vendaProduto['Icms']}',
                        Icms_Sub = '{$vendaProduto['Icms_Sub']}', Situacao_Tributaria = '{$vendaProduto['Situacao_Tributaria']}',
                        Mva = '{$vendaProduto['Mva']}', Reducao = '{$vendaProduto['Reducao']}', ReducaoBC = '{$vendaProduto['ReducaoBC']}',
                        ST_Icms = '{$vendaProduto['ST_Icms']}', vBCSTRet = '{$vendaProduto['vBCSTRet']}', vICMSSTRet = '{$vendaProduto['vICMSSTRet']}',
                        vICMSDeson = '{$vendaProduto['vICMSDeson']}', motDesICMS = '0', Obs_Produto = '{$vendaProduto['Obs_Produto']}',
                        Id_Local_Estoque = '{$vendaProduto['Id_Local_Estoque']}', Comissao = '{$vendaProduto['Comissao']}',
                        Id_Unidade = '{$vendaProduto['Id_Unidade']}', Aliquota = '{$vendaProduto['Aliquota']}', Origem_ST = '0',
                        C_Produto = '{$vendaProduto['C_Produto']}', Id_Cfop = '{$vendaProduto['Id_Cfop']}', Id_Venda_Produto_Origem = '{$vendaProduto['Id']}',
                        Id_Cliente = '{$vendaProduto['Id_Cliente']}', Id_Usuario = '$idUsuario', Id_Usuario_Upd = '$idUsuario', Data_Cadastro = '$dataHoraCadastro',
                        Data_Cadastro_Upd = '$dataHoraCadastro', Cancelado = 'Sim'");

                    $qtdNova = $vendaProduto['Qtd'] - $quantidadeCancelados;
                    $con->query("UPDATE venda_produto SET Qtd = '$qtdNova' WHERE Id = '{$vendaProduto['Id']}'");
                    $qtdProdutosCancelados += $quantidadeCancelados;
                }
            } else {
                $con->query("UPDATE venda_produto SET Cancelado = 'Sim' WHERE Id = '{$vendaProduto['Id']}'");
                $qtdProdutosCancelados++;
            }
        }
        return $qtdProdutosCancelados;
    }

    private static function processarProdutosAlterados(array $produtosAlterados) {
        global $con;

        $idUsuario = $_COOKIE['Id'];
        $idFuncionario = $_COOKIE['Id_Funcionario'];
        $dataHoraCadastro = date("Y-m-d H:i:s");
        $qtdProdutosAlterados = 0;

        foreach($produtosAlterados as $produtoAlterado) {
            $vendaProduto = $con->query("SELECT Id, Qtd, Id_Venda, Id_Produto, Preco, Preco_Custo, Preco_Tabela, Qtd, Ipi, Icms, Aliquota_Pis,
                CST_Pis, Aliquota_Cofins, CST_Cofins, Icms_Sub, Mva, Reducao, ReducaoBC, ST_Icms, Situacao_Tributaria, vBCSTRet, vICMSSTRet,
                vICMSDeson, Obs_Produto, Id_Local_Estoque, Comissao, Id_Unidade, Embalagem_Primaria, CST_Ipi, Aliquota, Origem_ST, C_Produto, Id_Cfop,
                Gtin, Id_Venda_Produto_Origem, Id_Cliente FROM venda_produto WHERE Id_Ifood = '$produtoAlterado->uniqueId'");
            $vendaProduto = $vendaProduto->fetch_assoc();
            $idVendaProduto = md5($produtoAlterado->uniqueId.microtime());
            $qtdAlterados = $produtoAlterado->changes->quantity->to;

            $con->query("INSERT INTO venda_produto SET Id = '$idVendaProduto', Id_Venda = '{$vendaProduto['Id_Venda']}',
                Id_Funcionario = '$idFuncionario', Id_Produto = '{$vendaProduto['Id_Produto']}', Preco = '{$vendaProduto['Preco']}',
                Preco_Custo = '{$vendaProduto['Preco_Custo']}', Preco_Tabela = '{$vendaProduto['Preco_Tabela']}', Qtd = '$qtdAlterados',
                Ipi = '{$vendaProduto['Ipi']}', CST_Ipi = '{$vendaProduto['CST_Ipi']}', Aliquota_Pis = '{$vendaProduto['Aliquota_Pis']}',
                CST_Pis = '{$vendaProduto['CST_Pis']}', Aliquota_Cofins = '{$vendaProduto['Aliquota_Cofins']}',
                CST_Cofins = '{$vendaProduto['CST_Cofins']}', Gtin = '{$vendaProduto['Gtin']}', Icms = '{$vendaProduto['Icms']}',
                Icms_Sub = '{$vendaProduto['Icms_Sub']}', Situacao_Tributaria = '{$vendaProduto['Situacao_Tributaria']}',
                Mva = '{$vendaProduto['Mva']}', Reducao = '{$vendaProduto['Reducao']}', ReducaoBC = '{$vendaProduto['ReducaoBC']}',
                ST_Icms = '{$vendaProduto['ST_Icms']}', vBCSTRet = '{$vendaProduto['vBCSTRet']}', vICMSSTRet = '{$vendaProduto['vICMSSTRet']}',
                vICMSDeson = '{$vendaProduto['vICMSDeson']}', motDesICMS = '0', Obs_Produto = '{$vendaProduto['Obs_Produto']}',
                Id_Local_Estoque = '{$vendaProduto['Id_Local_Estoque']}', Comissao = '{$vendaProduto['Comissao']}',
                Id_Unidade = '{$vendaProduto['Id_Unidade']}', Aliquota = '{$vendaProduto['Aliquota']}', Origem_ST = '0',
                C_Produto = '{$vendaProduto['C_Produto']}', Id_Cfop = '{$vendaProduto['Id_Cfop']}', Id_Venda_Produto_Origem = '{$vendaProduto['Id']}',
                Id_Cliente = '{$vendaProduto['Id_Cliente']}', Id_Usuario = '$idUsuario', Id_Usuario_Upd = '$idUsuario', Data_Cadastro = '$dataHoraCadastro',
                Data_Cadastro_Upd = '$dataHoraCadastro', Cancelado = 'Sim'");

            $qtdNova = $vendaProduto['Qtd'] - $qtdAlterados;
            $con->query("UPDATE venda_produto SET Qtd = '$qtdNova' WHERE Id = '{$vendaProduto['Id']}'");
            $qtdProdutosAlterados += $qtdAlterados;
        }

        return $qtdProdutosAlterados;
    }

    public static function alterarPedidos(array $notificacoesAlteracoes) {
        global $con;
        $con->set_charset("utf8mb4");

        $notificacoesReconhecer = [];
        $idUsuario = $_COOKIE['Id'];

        foreach($notificacoesAlteracoes as $notificacao) {
            $qtdProdutosCancelados = 0;

            foreach($notificacao->metadata->changes as $alteracao) {
                switch($alteracao->changeType) {
                    case "DELETE_ITEMS":
                        $qtdProdutosCancelados += Pedido::alterarProdutosCancelados($alteracao->items);
                        break;
                    case "EDIT_ITEMS":
                        $qtdProdutosCancelados += Pedido::processarProdutosAlterados($alteracao->items);
                        break;
                }
            }

            if($qtdProdutosCancelados > 0) {
                $getVenda = $con->query("SELECT Id, Valor_Pago, Valor_Frete, Taxa_Servico_Restaurante FROM venda WHERE Id_Ifood = '$notificacao->orderId'");
                $venda = $getVenda->fetch_assoc();
                $totalVenda = $notificacao->metadata->total->subtotal->to;
                $totalVenda += ($venda['Valor_Frete'] + $venda['Taxa_Servico_Restaurante']);
                $totalVenda = str_replace(",", ".", $totalVenda);
                $totalCancelado = $notificacao->metadata->total->subtotal->from - $notificacao->metadata->total->subtotal->to;
                $valorPago = $venda['Valor_Pago'] > 0 ? str_replace(",", ".", $venda['Valor_Pago'] - $totalCancelado) : 0;
                $dataCadastro = date("Y-m-d H:i:s");
                $sqlVenda = "UPDATE venda SET Valor_Original = '$totalVenda', Valor_Pago = '$valorPago', Id_Usuario_Upd = '$idUsuario',
                    Data_Cadastro_Upd = '$dataCadastro'";
                
                if($notificacao->metadata->total->subtotal->to == 0) {
                    $sqlVenda .= ", Status = 'Cancelado', Status_Pedido = 'Cancelado'";
                }
                $atualizarVenda = $con->query("$sqlVenda WHERE Id_Ifood = '$notificacao->orderId'");

                if($atualizarVenda === true) {
                    $contasReceber = $con->query("SELECT Id, Valor_Original, Valor_Pago, Valor_Inicial, Status FROM conta_receber
                        WHERE Id_Externo = '{$venda['Id']}' ORDER BY Valor_Original DESC");
                    $contasReceber = $contasReceber->fetch_all(MYSQLI_ASSOC);

                    if($notificacao->metadata->total->subtotal->to == 0) {
                        $idsContasReceber = implode("','", array_column($contasReceber, 'Id'));
                        $con->query("UPDATE conta_receber SET Status = 'Cancelado' WHERE Id_Externo = '{$venda['Id']}', Id_Usuario_Upd = '$idUsuario',
                            Data_Cadastro_Upd = '$dataCadastro'");
                        $con->query("UPDATE caixa SET Tipo = 'Cancelado' WHERE Id_Externo IN('$idsContasReceber')");
                    } else {
                        foreach($contasReceber as $contaReceber) {
                            $valorOriginal = str_replace(",", ".", $contaReceber['Valor_Original'] - $totalCancelado);

                            if($valorOriginal < 0) {
                                $totalCancelado = -1 * ($valorOriginal);
                                $con->query("UPDATE conta_receber SET Status = 'Cancelado' WHERE Id = '{$contaReceber['Id']}', Id_Usuario_Upd = '$idUsuario',
                                    Data_Cadastro_Upd = '$dataCadastro'");
                                $con->query("UPDATE caixa SET Tipo = 'Cancelado' WHERE Id_Externo = '{$contaReceber['Id']}'");
                            } else {
                                $valorPago = $contaReceber['Valor_Pago'] > 0 ? $contaReceber['Valor_Pago'] - $totalCancelado : 0;
                                $valorPago = str_replace(",", ".", $valorPago);
                                $con->query("UPDATE conta_receber SET Valor_Original = '$valorOriginal', Valor_Pago = '$valorPago', Valor_Inicial = '$valorOriginal',
                                    Id_Usuario_Upd = '$idUsuario', Data_Cadastro_Upd = '$dataCadastro' WHERE Id = '{$contaReceber['Id']}'");

                                if($contaReceber['Status'] == 'Liquidado') {
                                    $con->query("UPDATE caixa SET Valor = '$valorPago', Id_Usuario_Upd = '$idUsuario', Data_Cadastro_Upd = '$dataCadastro'
                                        WHERE Id_Externo = '{$contaReceber['Id']}'");
                                }
                                break;
                            }
                        }
                        $getPagamentos = $con->query("SELECT Id, Valor_Pago FROM venda_tipo_pagamento WHERE Id_Venda = '{$venda['Id']}' ORDER BY Valor_Pago DESC");
                        $pagamentosVenda = $getPagamentos->fetch_all(MYSQLI_ASSOC);
                        $totalCancelado = $notificacao->metadata->total->subtotal->from - $notificacao->metadata->total->subtotal->to;

                        foreach ($pagamentosVenda as $pagamento) {
                            $valorPago = str_replace(",", ".", $pagamento['Valor_Pago'] - $totalCancelado);

                            if($valorPago < 0) {
                                $totalCancelado = -1 * ($valorOriginal);
                                $con->query("DELETE FROM venda_tipo_pagamento WHERE Id = '{$pagamento['Id']}'");
                            } else {
                                $con->query("UPDATE venda_tipo_pagamento SET Valor_Pago = '$valorPago', Valor = '$totalVenda' WHERE Id = '{$pagamento['Id']}'");
                            }
                        }
                    }
                    array_push($notificacoesReconhecer, ["id"=> $notificacao->id]);
                }
            }
        }
        if(sizeof($notificacoesReconhecer) > 0) {
            Pedido::reconhecerNotificacoes($notificacoesReconhecer);
        }
    }
}

?>