<?php
namespace Ifood\App\Model;

use Ifood\App\Config\Http\Request;
use Ifood\App\Config\Autenticacao;
use Ifood\App\Config\Http\Api;
use Ifood\App\Model\Categoria;

class Produto {
    public function __construct(){}

    public static function cadastrar($dados) {
        global $con;
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $getMerchantId = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
            $merchantId = $getMerchantId->fetch_assoc()['Merchant_Id_Ifood'];
            $precoProduto = $dados['price'];
            $categoriaProduto = $dados['category'];
            unset($dados['category']);
            unset($dados['price']);
            $url = Api::getUrl()."/catalog/".Api::getVersao("catalog")."/merchants/$merchantId/products";
            $cadastrarProduto = Request::post($url, $autenticacao->token, json_encode($dados), "json");

            if($cadastrarProduto->http_code == 201) {
                $produto = $cadastrarProduto->body;
                $con->query("UPDATE produto SET Id_Ifood='$produto->id' WHERE Id='$produto->externalCode'");
                self::associarCategoria($merchantId, $produto->externalCode, $produto->id, $categoriaProduto, $precoProduto);
                return true;
            }
            return false;
        }
        return false;
    }

    public static function atualizar(array $produto) {
        global $con;
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $getMerchantId = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
            $merchantId = $getMerchantId->fetch_assoc()['Merchant_Id_Ifood'];
            $precoProduto = $produto['price'];
            $categoriaProduto = $produto['category'];
            unset($produto['id'], $produto['category'], $produto['price']);
            $url = Api::getUrl()."/catalog/".Api::getVersao("catalog")."/merchants/$merchantId/products/{$produto['id']}";
            $cadastrarProduto = Request::put($url, $autenticacao->token, json_encode($produto), "json");

            if($cadastrarProduto->http_code == 200) {
                $produto = $cadastrarProduto->body;
                $con->query("UPDATE produto SET Id_Ifood='$produto->id' WHERE Id='$produto->externalCode'");
                self::associarCategoria($merchantId, $produto->externalCode, $produto->id, $categoriaProduto, $precoProduto);
                return true;
            }
            return false;
        }
        return false;
    }

    public static function listar($pagina, $limite) {
        global $con;
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $getMerchantId = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
            $merchantId = $getMerchantId->fetch_assoc()['Merchant_Id_Ifood'];
            $url = Api::getUrl()."/catalog/".Api::getVersao("catalog")."/merchants/$merchantId/products?page=$pagina&limit=$limite";
            $buscaProdutos = Request::get($url, $autenticacao->token);
            return $buscaProdutos->http_code == 200 ? $buscaProdutos->body : [];
        }
    }

    public static function associarCategoria($merchantId, $idInternoProduto, $idProdutoIfood, $idCategoriaIfood, $precoProduto) {
        $autenticacao = new Autenticacao();
        if($autenticacao->token) {
            $url = Api::getUrl()."/catalog/".Api::getVersao("catalog")."/merchants/$merchantId/categories/$idCategoriaIfood/products/$idProdutoIfood";
            $dados = json_encode([
                "status"=> "AVAILABLE",
                "price"=> [
                    "value"=> $precoProduto,
                    "scalePrices"=> []
                ],
                "externalCode"=> "$idInternoProduto"
            ]);
            $criarAssociacao = Request::post($url, $autenticacao->token, $dados, "json");
            return $criarAssociacao->http_code == 201 ? true : false;
        }
        return false;
    }

    public static function montaImagem(string $caminhoFoto, string $nomeImagem, string $codigoProduto) {
        $codigoProduto =  str_replace('.', '', $codigoProduto);
        $getExtensaoArquivo = explode(".", $nomeImagem);
        $extensaoArquivo = end($getExtensaoArquivo);
        $caminho = realpath(__DIR__."../../../../../produto/fotos/$codigoProduto/original/$nomeImagem");

        if(file_exists($caminho)) {
            $conteudoArquivo = base64_encode(file_get_contents($caminho, true));
            return "data:image/$extensaoArquivo;base64,$conteudoArquivo";
        }

        stream_context_set_default( [
            'ssl' => [
                'verify_peer' => false,
                'verify_peer_name' => false,
            ],
        ]);

        $url = "https://$caminhoFoto/produto/fotos/$codigoProduto/original/$nomeImagem";
        $urlValida = get_headers($url);
        if($urlValida[0] == "HTTP/1.1 200 OK" || $urlValida[0] == "HTTP/1.0 200 OK"){
            $encodeBytes = base64_encode(file_get_contents($url));
            return "data:image/$extensaoArquivo;base64,$encodeBytes";
        }

        $bytesImagem = file_get_contents("https://i1.wp.com/spassodourado.com.br/wp-content/uploads/2015/01/default-placeholder.png?resize=300%2C300&ssl=1");
        $encodeBytes = base64_encode($bytesImagem);
        return "data:image/png;base64,$encodeBytes";
    }

    public static function catalogos($token) {
        global $con;
        $getMerchantId = $con->query("SELECT Merchant_Id_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
        $merchantId = $getMerchantId->fetch_assoc()['Merchant_Id_Ifood'];
        $url = Api::getUrl()."/catalog/".Api::getVersao("catalog")."/merchants/$merchantId/catalogs";

        $buscaCatalogos = Request::get($url, $token);
        return $buscaCatalogos->http_code == 200 ? $buscaCatalogos->body : [];
    }
    
    public static function categoriaProdutoIfood($categorias, $idProdutoIfood) {
        foreach($categorias as $categoria) {
            if(isset($categoria->items)) {
                foreach($categoria->items as $item) {
                    if($item->productId == $idProdutoIfood){
                        return [
                            "idExternoCategoria"=> $categoria->id,
                            "preco"=> $item->price->value
                        ];
                    }
                }
            }
        }
        return null;
    }

    /**
     * Importa produtos do ifood para o sistema
     *
     * @return int Quantidade de produtos importados
     */
    public static function importar(): int {
        global $con;
        $pagina = 1;
        $itensPorPagina = 200;
        $categorias = Categoria::listar();
        $idUsuario = $_COOKIE['Id'];
        $idUnidade = $_COOKIE['Unidade'];
        $produtos = self::listar($pagina, $itensPorPagina);
        $qtdprodutosCadastrados = 0;
        $produtosRestantes = $produtos->count;
        $codigoProduto = 0;
        $getCodigoProduto = $con->query("SELECT Codigo FROM produto ORDER BY Data_Cadastro DESC LIMIT 1");
        $codigo = $getCodigoProduto->num_rows > 0 ? $getCodigoProduto->fetch_assoc()['Codigo'] : 1;
        $codigo = str_pad($codigo, 4, "0", STR_PAD_LEFT);
        $getDadosUnidade = $con->query("SELECT Estado, Id_Tabela_Preco_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
        $dadosUnidade = $getDadosUnidade->fetch_assoc();
        $idTabelaPreco = $dadosUnidade['Id_Tabela_Preco_Ifood'];
        $tabelaPreco = $con->query("SELECT Valor FROM produto_tabela WHERE Id = '$idTabelaPreco'");
        $tabelaPreco = (int)$tabelaPreco->fetch_assoc()['Valor'];

        while ($produtos->count == $itensPorPagina || ($produtos->count < $itensPorPagina && $produtosRestantes > 0)) {
            foreach($produtos->elements as $produto) {
                $produtosRestantes--;
                if($produtosRestantes == 0 && $produtos->count == $itensPorPagina) {
                    $pagina++;
                    $produtos = Produto::listar($pagina, $itensPorPagina);
                    $produtosRestantes = $produtos->count;
                }
                $con->query("SELECT Id FROM produto WHERE Id_Ifood='$produto->id'");
                if($con->affected_rows == 0) {
                    $dadosProduto = self::categoriaProdutoIfood($categorias, $produto->id);
                    if(!isset($dadosProduto["idExternoCategoria"])) continue;
                    $getCategoriaInterna = $con->query("SELECT Id FROM categoria_produto WHERE Id_Ifood = '{$dadosProduto["idExternoCategoria"]}'");
                    $categoriaProduto = $getCategoriaInterna->fetch_assoc()['Id'];
                    $precoProduto = str_replace(",", ".", $dadosProduto['preco']);
                    $extensaoImagem = "";
                    $foto = "";
                    $codigoProduto = str_pad(intval($codigoProduto) + 1, 4, '0', STR_PAD_LEFT);
                    $idProduto = md5($produto->id);
                    $tituloProduto = mb_convert_encoding($produto->name, "ISO-8859-1", "UTF-8");
                    $descricaoProduto = mb_convert_encoding($produto->description ?? $produto->name, "ISO-8859-1", "UTF-8");
                    $getDiretorioSistema = explode("/", $_SERVER['REQUEST_URI']);
                    $diretorioSistema = $getDiretorioSistema[1];
                    $caminhoFoto = $_SERVER['HTTP_HOST']."/$diretorioSistema";
                    if(!empty($produto->image)) {
                        $getExtImagem = explode(".", $produto->image);
                        $extensaoImagem = end($getExtImagem);
                        $foto = "$idProduto.$extensaoImagem";
                    }
                    $con->query("INSERT INTO produto SET Id='$idProduto', Titulo='$tituloProduto', Descricao_Ifood='$descricaoProduto', Codigo='$codigoProduto',
                        Preco$tabelaPreco='$precoProduto', Id_Categoria_Produto='$categoriaProduto', Site='Sim', Id_Usuario='$idUsuario', Id_Usuario_Upd='$idUsuario',
                        Data_Cadastro=NOW(), Data_Cadastro_Upd=NOW(), Id_Unidade='$idUnidade', Tipo_Categoria='Pode vender', Tipo_Produto='P', Foto='$foto',
                        Caminho_Foto='$caminhoFoto',Ifood='Sim', Id_Ifood='$produto->id', Descricao_Etiqueta='$tituloProduto', Id_Cfop_Venda='289',
                        UFCons = '{$dadosUnidade['Estado']}'");

                    if($con->affected_rows > 0) {
                        $qtdprodutosCadastrados++;
                        if(!empty($produto->image)) {
                            $bytesImagem = file_get_contents($produto->image);
                            if(!file_exists("../../produto/fotos/$codigoProduto/original")) {
                                mkdir("../../produto/fotos/$codigoProduto/original/", 0777, true);
                            }
                            file_put_contents("../../produto/fotos/$codigoProduto/original/$idProduto.$extensaoImagem", $bytesImagem);
                        }
                    }
                }
            }
        }
        return $qtdprodutosCadastrados;
    }

    public static function impostos(string $idInternoProduto, string $idInternoCliente, int $idUnidade) {
        global $con;
        $infoProduto = $con->query("SELECT CST_Ipi, Aliquota_Ipi, CST_Pis, Aliquota_Pis, CST_Cofins, Aliquota_Cofins, Tabela_Icms, Regime_ST,
            Aliquota_Simples, Codigo_ST, Codigo_ST2, Id_Ncm FROM produto WHERE Id='$idInternoProduto'");
        $infoProduto = $infoProduto->fetch_assoc();
        $infoProduto['Aliquota_Icms'] = 0;
        $infoProduto['Icms_Sub'] = $icmsSub ?? 0;
        $infoProduto['Mva'] = 0;
        $infoProduto['Reducao_Icms'] = 0;
        $infoProduto['Reducao_BC'] = 0;
        $cliente = $con->query("SELECT Estado, Id_Regime_Especial FROM cliente WHERE Id = '$idInternoCliente'");
        $cliente = $cliente->fetch_assoc();
        $ufUnidade = $con->query("SELECT Estado FROM unidade WHERE Id = '$idUnidade'");
        $ufUnidade = $ufUnidade->fetch_assoc()['Estado'];
                
        if(!empty($infoProduto["Id_Ncm"])){
            if(empty($cliente["Id_Regime_Especial"]) || $cliente["Id_Regime_Especial"] == 0){
                $cliente["Id_Regime_Especial"] = 1;
            }
            
            $ncm = $con->query("SELECT * FROM ncm INNER JOIN ncm_estado ON ncm_estado.Id_Ncm = ncm.Id WHERE ncm.Ncm = '{$infoProduto['Id_Ncm']}' 
                AND ncm.Id_Regime_Especial = '{$cliente['Id_Regime_Especial']}' AND ncm_estado.Id_Unidade = '$idUnidade' 
                AND Estado_Dentro = '$ufUnidade' AND Estado_Fora = '{$cliente['Estado']}'");
            $ncm = $ncm->fetch_assoc();
            
            if(!empty($ncm["CST_V"])){
                $infoProduto['Icms_Sub'] = $ncm["Icms_Fora_V"] > 0 ? $ncm["Icms_Dentro_V"] : $ncm["Icms_Fora_V"];
                $infoProduto['Aliquota_Icms'] = $ncm["Icms_Fora_V"] > 0 ? $ncm["Icms_Fora_V"] : $ncm["Icms_Dentro_V"];
                $infoProduto['Mva'] = $ncm["Mva_Fora_V"];
                $infoProduto['Reducao_Icms'] = $ncm["Reducao_Fora_V"];
                $infoProduto['Reducao_BC'] = $ncm["Reducao_Dentro_V"];
                $infoProduto["Codigo_ST"] = $ncm["CST_V"];
                $infoProduto["CST_Ipi"] = $ncm["CST_Ipi_V"];
                $infoProduto["Aliquota_Ipi"] = $ncm["Aliquota_Ipi_V"];
                $infoProduto["CST_Pis"] = $ncm["CST_Pis_V"];
                $infoProduto["Aliquota_Pis"] = $ncm["Aliquota_Pis_V"];
                $infoProduto["CST_Cofins"] = $ncm["CST_Cofins_V"];
                $infoProduto["Aliquota_Cofins"] = $ncm["Aliquota_Cofins_V"];
            }
        }
        else {
            if($cliente["Estado"] != $ufUnidade){
                $infoProduto["Codigo_ST"] = $infoProduto["Codigo_ST2"];
            }
            $infoProduto['Tabela_Icms'] = $infoProduto['Tabela_Icms'] == 0 ? 1 : $infoProduto['Tabela_Icms'];
            $icmsInternoCliente = $con->query("SELECT Id, Aliquota_Interna, Aliquota{$infoProduto['Tabela_Icms']} as Aliquota,
                Icms_Sub{$infoProduto['Tabela_Icms']} as Icms_Sub, Reducao{$infoProduto['Tabela_Icms']} as Reducao,
                ReducaoBC{$infoProduto['Tabela_Icms']} as ReducaoBC
                FROM icms WHERE Estado = '{$cliente['Estado']}' AND Id_Unidade = '$idUnidade'");
            $icmsInternoCliente = $icmsInternoCliente->fetch_assoc();
            $infoProduto['Icms_Sub'] = $icmsInternoCliente["Aliquota_Interna"];
            
            if($infoProduto["Regime_ST"] == 'Normal' || $infoProduto["Codigo_ST"] == '201' || $infoProduto["Codigo_ST"] == '202'){
                $infoProduto['Aliquota_Icms'] = $icmsInternoCliente["Aliquota"];
                $infoProduto['Mva'] = $icmsInternoCliente["Icms_Sub"];
                $infoProduto['Reducao_Icms'] = $icmsInternoCliente["Reducao"];
                $infoProduto['Reducao_BC'] = $icmsInternoCliente["ReducaoBC"];
            }
        }
        $infoProduto['Codigo_ST'] = empty($infoProduto['Codigo_ST']) ? '00' : $infoProduto['Codigo_ST'];
        return $infoProduto;
    }
    public static function baixarEstoque(string $idInternoProduto, float $qtd, int $idLocalEstoque, float $precoCusto, float $precoVenda,
        int $idCfop, float $icms, float $ipi, string $origem, string $concluido, string $idExterno, int $idUnidade, float $icmsSub,
        float $mva, float $reducao
    ) {
        global $con;
    
        $id = md5($idInternoProduto.microtime());
        /* Se o produto poder gera financeiro, o produto no  bonificado. Caso contrrio o produto
         bonificado. Por isso a inverso a baixo. */
        $CfopF = $con->query("SELECT Financeiro FROM cfop WHERE Id='$idCfop'");
        $gerarFinanceiro = $CfopF->fetch_assoc()["Financeiro"];
        $bonificado = $gerarFinanceiro == "No" ? "Sim" : "No";
    
        $Prodt = $con->query("SELECT Custo, Titulo, Id_Categoria_Produto, Id_Fornecedor FROM produto WHERE Id='$idInternoProduto'");
        $Prodt = $Prodt->fetch_assoc();
    
        if ($precoVenda) {
            $precoCusto = $Prodt["Custo"];
            $valor_icms = $precoVenda * $qtd * ($icms / 100);
        }
    
        //se local de estoque for vazio, passa o id padrao
        $idLocalEstoque = empty($idLocalEstoque) ? '1' : $idLocalEstoque;
        $dataHoraAtual = date("Y-m-d H:i:s");
    
        $con->query("INSERT INTO estoque SET Id='$id', Id_Produto='$idInternoProduto', Id_Categoria_Produto='{$Prodt['Id_Categoria_Produto']}',
            Id_Fornecedor='{$Prodt['Id_Fornecedor']}', Nome_Produto='{$Prodt['Titulo']}', Qtd='$qtd', Id_Local_Estoque='$idLocalEstoque',
            Preco_Custo='$precoCusto', Preco_Venda='$precoVenda', Id_Cfop='$gerarFinanceiro', Bonificado='$bonificado', Icms='$icms', Valor_Icms='$valor_icms',
            Icms_Sub='$icmsSub', Mva='$mva', Reducao='$reducao', Origem_ST='0', Ipi='$ipi', Origem='$origem', Concluido='$concluido', Id_Externo='$idExterno',
            Id_Unidade='$idUnidade', Id_Usuario='{$_COOKIE['Id']}', Id_Usuario_Upd='{$_COOKIE['Id']}', Data_Cadastro='$dataHoraAtual', Data_Cadastro_Upd='$dataHoraAtual'");
    }
}