<?php
namespace LojaVirtual\App\Config;

use LojaVirtual\App\Config\Database\DatabaseQuery;
use LojaVirtual\App\Config\Database\Where;
use LojaVirtual\App\Config\Rota;
use LojaVirtual\App\Model\Cliente;
use LojaVirtual\App\Config\Empresa;

class AuthMiddleware
{
    public static function validate(Rota $rota)
    {
        $empresa = Empresa::dados();

        if($empresa->Obrigatorio_Login_Pedido_Site == "Sim") {
            if(!isset($rota->header()->HTTP_CUSTOM_AUTH)) {
                header("HTTP/1.1 401 Unauthorized");
                exit;
            }
            
            $idCliente = addslashes($rota->header()->HTTP_CUSTOM_AUTH);
            $cliente = Cliente::buscar(
                new DatabaseQuery(
                    [
                        new Where("Id", $idCliente)
                    ]
                )
            );
            if(!$cliente) {
                header("HTTP/1.1 401 Unauthorized");
                exit;
            }
        }
    }
}