<?php
namespace LojaVirtual\App\Config\Database;

use LojaVirtual\App\Config\Database\Consulta;
use LojaVirtual\App\Config\ErroLoja;
use PDO;

class BancoDados
{
    private static $servidor;
    private static $bancoDados;
    private static $usuario;
    private static $senha;
    private static $conexao;
    private static $idInserido;
    
    private static function iniciarConexao() {
        include "../../include/conecta.php";
        self::$servidor = $host;
        self::$bancoDados = $dbname;
        self::$usuario = $usuario;
        self::$senha = $password;
        
        try {
            self::$conexao = new PDO("mysql:host=".self::$servidor.";dbname=".self::$bancoDados, self::$usuario, self::$senha);
            //code...
        } catch (\Throwable $th) {
            new ErroLoja($th);
        }
    }
    
    private static function conectar(): PDO {
        if(!self::$conexao) {
            self::iniciarConexao();
        }
        return self::$conexao;
    }

    public static function consultar(string $consulta, ?array $valores = null, $utf8 = true)
    {
        try {
            $conexao = self::conectar();
            $objetoConsulta = new Consulta($consulta, $valores);
            $conexao->exec("SET CHARACTER SET ".($utf8 ? "utf8mb4" : "latin1"));
            $consultar = $conexao->prepare($objetoConsulta->getConsulta());
            $consultar->execute($objetoConsulta->getValores());
            
            if($consultar->errorInfo()[1] !== null) {
                throw new \PDOException($consultar->errorInfo()[2]);
            }
    
            self::$idInserido = $conexao->lastInsertId();
            return $consultar; 
        } catch (\Throwable $th) {
            new ErroLoja($th);
        }
    }

    public static function idInserido()
    {
        return self::$idInserido;
    }
}