<?php
namespace LojaVirtual\App\Config\Database;

class Consulta
{
    private $consulta;
    private $valores;

    public function __construct(string $consulta, ?array $valores = null)
    {
        $this->consulta = $consulta;
        $this->valores = $valores ?? [];
        $this->juntarValores();
    }

    private function juntarValores()
    {
        foreach ($this->valores as $index => $value) {
            if(is_array($value)) {
                $this->valores[$index] = implode(',', $value);
            }
        }
    }

    public function getConsulta()
    {
        return $this->consulta;

    }

    public function getValores()
    {
        return $this->valores;
    }
}