<?php
namespace LojaVirtual\App\Controller;

use LojaVirtual\App\Config\Database\DatabaseQuery;
use LojaVirtual\App\Config\Database\OrderBy;
use LojaVirtual\App\Config\Rota;
use LojaVirtual\App\Model\Categoria;

class CategoriaController
{
    public static function listarCategorias(Rota $route)
    {
        $categorias = Categoria::buscarTodas(
            new DatabaseQuery(
                [],
                [
                    new OrderBy(
                        "Titulo",
                        "ASC"
                    )
                ]
            ), ["Id", "Titulo"]);
        header("Content-Type: application/json");
        echo json_encode($categorias);
    }
}