<?php
namespace LojaVirtual\App\Controller;

use LojaVirtual\App\Config\Database\BancoDados;
use LojaVirtual\App\Config\Empresa;
use LojaVirtual\App\Config\Rota;
use PDO;

class EmpresaController
{
    public static function logoEmpresa()
    {
        $dadosEmpresa = Empresa::dados(["Titulo_Site", "Logo_Site", "Favicon_Site", "Fone1", "Email", "Obrigatorio_Login_Pedido_Site", "Tipo_Site"], true);
        $urlLogo = "../../unidade/site/{$dadosEmpresa->Logo_Site}";
        $base64Logo = file_exists($urlLogo) ? base64_encode(file_get_contents($urlLogo)) : '';
        $explodeLogo = explode(".", $dadosEmpresa->Logo_Site);
        $mimeTypeLogo = file_exists($urlLogo) ? "image/".end($explodeLogo) : '';
        $urlFavicon = "../../unidade/site/{$dadosEmpresa->Favicon_Site}";
        $base64Favicon = file_exists($urlFavicon) ? base64_encode(file_get_contents($urlFavicon)) : '';
        $explodeFavicon = explode(".", $dadosEmpresa->Favicon_Site);
        $mimeTypeFavicon = file_exists($urlFavicon) ? "image/".end($explodeFavicon) : '';

        header("Content-Type: application/json");
        echo json_encode([
            "logo"=> [
                "base64"=> $base64Logo,
                "mimeType"=> $mimeTypeLogo,
            ],
            "favicon"=> [
                "base64"=> $base64Favicon,
                "mimeType"=> $mimeTypeFavicon,
            ],
            "titulo"=> $dadosEmpresa->Titulo_Site,
            "fone"=> $dadosEmpresa->Fone1,
            "email"=> $dadosEmpresa->Email,
            "loginObrigatorio"=> $dadosEmpresa->Obrigatorio_Login_Pedido_Site,
            "tipoSite"=> $dadosEmpresa->Tipo_Site
        ]);
    }

    public static function banners()
    {
        $getBanners = BancoDados::consultar("SELECT Id, Foto, Ordem, Tipo FROM site_banner");
        $banners = $getBanners->fetchAll(PDO::FETCH_OBJ);

        foreach($banners as $indice => $banner) {
            $banners[$indice] = (object)[
                "id"=> (int)$banner->Id,
                "foto"=> md5($banner->Foto),
                "ordem"=> (int)$banner->Ordem,
                "tipo"=> $banner->Tipo
            ];
        }

        header("Content-Type: application/json");
        echo json_encode($banners);
    }

    public static function exibirBanner(Rota $rota)
    {
        $md5NomeImagem = addslashes($rota->getParameters()->hashFoto);
        $getImagem = BancoDados::consultar("SELECT Foto FROM site_banner WHERE md5(Foto) = ?", [$md5NomeImagem]);
        if($getImagem->rowCount() < 1) return;

        $nomeImagem = $getImagem->fetchObject()->Foto;
        $urlImagem = "../../unidade/site/{$nomeImagem}";

        if(!file_exists($urlImagem)) return;

        $conteudoImagem = file_get_contents($urlImagem);
        $explodeNomeImagem = explode(".", $nomeImagem);
        $mimeTypeBanner = "image/".end($explodeNomeImagem);

        header("Content-Type: $mimeTypeBanner");
        echo $conteudoImagem;
    }
}