<?php
namespace LojaVirtual\App\Model\Frete;

use LojaVirtual\App\Config\Database\BancoDados;

class Pacote
{
    public $altura;
    public $largura;
    public $comprimento;
    public $peso;

    public function __construct(float $altura, float $largura, float $comprimento, float $peso)
    {
        $this->altura = $altura;
        $this->largura = $largura;
        $this->comprimento = $comprimento;
        $this->peso = $peso;
    }
}
class Frete
{
    public static function buscarPacotePedido(float $altura, float $largura, float $comprimento, float $peso): Pacote
    {
        $getPacote = BancoDados::consultar("SELECT * FROM pacote_site WHERE Altura >= ? AND Largura >= ? AND Comprimento >= ?
            AND Capacidade >= ? ORDER BY Capacidade LIMIT 1", [$altura, $largura, $comprimento, $peso]);

        if($getPacote->rowCount() < 1) {
            $getPacote = BancoDados::consultar("SELECT * FROM pacote_site ORDER BY Capacidade DESC LIMIT 1");
        }
        $dadosPacote = $getPacote->fetchObject();
        $pacote = new Pacote(
            $dadosPacote->Altura,
            $dadosPacote->Largura,
            $dadosPacote->Comprimento,
            $peso
        );

        return $pacote;
    }
    
    public static function calcular(string $cepOrigem, string $cepDestino, array $dimensoesPacote)
    {
        $pacote = Frete::buscarPacotePedido($dimensoesPacote['altura'], $dimensoesPacote['largura'], $dimensoesPacote['comprimento'],
            $dimensoesPacote['peso']
        );
        $dadosFrete = SuperFrete::calcular($cepOrigem, $cepDestino, $pacote);
        return $dadosFrete;
    }

    public static function salvarCotacao(int $id, float $valor, string $plataforma, string $cpfCnpj)
    {
        $salvarCotacao = BancoDados::consultar(
            "INSERT INTO cotacao_frete_site SET CpfCnpj_Cliente = ?, Id_Cotacao = ?, Valor = ?, Plataforma = ?",
            [$cpfCnpj, $id, $valor, $plataforma]
        );
        return $salvarCotacao->rowCount() > 0;
    }
    public static function getValorCotacao(int $idCotacao, string $cpfCnpj)
    {
        $plataforma = "SuperFrete";
        $getCotacao = BancoDados::consultar("SELECT Valor FROM cotacao_frete_site WHERE Id_Cotacao = ? AND CpfCnpj_Cliente = ?", [$idCotacao, $cpfCnpj]);
        $dadosCotacao = $getCotacao->fetchObject();
        return (float)$dadosCotacao->Valor;
    }

    public static function excluirCotacoesCliente(string $cpfCnpj)
    {
        $excluirCotacoes = BancoDados::consultar("DELETE FROM cotacao_frete_site WHERE CpfCnpj_Cliente =?", [$cpfCnpj]);
        return $excluirCotacoes->rowCount() > 0;
    }
}