<?php
namespace LojaVirtual\App\Model\Frete;

use LojaVirtual\App\Config\Database\BancoDados;
use LojaVirtual\App\Config\Empresa;
use LojaVirtual\App\Model\Frete\Pacote;

class SuperFrete
{
    public static function calcular(string $cepOrigem, string $cepDestino, Pacote $pacote)
    {
        $token = Empresa::dados(["Token_Frete_Site"])->Token_Frete_Site;
        $url = "https://sandbox.superfrete.com/api/v0/calculator";
        $dados = json_encode([
            "from"=> [
                "postal_code"=> $cepOrigem
            ],
            "to"=> [
                "postal_code"=> $cepDestino
            ],
            "services"=> "1,2,17",
            "options"=> [
                "own_hand"=> false,
                "receipt"=> false,
                "insurance_value"=> 0,
                "use_insurance_value"=> false
            ],
            "package"=> [
                "weight"=> $pacote->peso,
                "length"=> $pacote->comprimento,
                "width"=> $pacote->largura,
                "height"=> $pacote->altura
            ]
        ]);

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_HTTPHEADER => [
                'User-Agent: Minha Loja Api (alexandre@pontti.com.br)',
                'Content-Type: application/json',
                "Authorization: Bearer $token"
            ],
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $dados
        ]);

        $response = curl_exec($curl);
        curl_close($curl);

        return json_decode($response);
    }
}