<?php
namespace LojaVirtual\App\Rotas;

use LojaVirtual\App\Config\AuthMiddleware;
use LojaVirtual\App\Config\Rota;
use LojaVirtual\App\Controller\ClienteController;

class RotasClientes
{
    public function __construct(Rota $rota)
    {
        $rota->post("/clientes", null, function($rota){
            ClienteController::criarCliente($rota);
        });
        $rota->post("/login", null, function($rota){
            ClienteController::login($rota);
        });
        $rota->get("/clientes/enderecos", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::enderecosCliente($rota);
        });
        $rota->post("/clientes/enderecos", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::cadastrarEndereco($rota);
        });
        $rota->get("/clientes/enderecos/:{idEndereco}", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::detalhesEndereco($rota);
        });
        $rota->put("/clientes/enderecos/:{idEndereco}", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::atualizarEndereco($rota);
        });
        $rota->patch("/clientes/enderecos/:{idEndereco}", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::atualizarEnderecoPadrao($rota);
        });
        $rota->delete("/clientes/enderecos/:{idEndereco}", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::excluirEndereco($rota);
        });
        $rota->get("/clientes/enderecos/padrao", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::enderecoPadrao($rota);
        });
        $rota->get("/clientes/pedidos", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::pedidosCliente($rota);
        });
        $rota->get("/clientes/pedidos/:{idPedido}/detalhes", function($rota){AuthMiddleware::validate($rota);}, function($rota){
            ClienteController::detalhesPedido($rota);
        });
    }
}