<?php
namespace LojaVirtual\App\Rotas;

use LojaVirtual\App\Config\AuthMiddleware;
use LojaVirtual\App\Config\Rota;
use LojaVirtual\App\Controller\PagamentoController;

class RotasPagamentos
{
    public function __construct(Rota $rota)
    {
        $rota->get('/pagamentos/tiposPagamento', null, function($rota) {
            PagamentoController::tiposPagamento();
        });
        $rota->get('/pagamentos/autenticacao', function($rota) {AuthMiddleware::validate($rota);}, function($rota) {
            PagamentoController::tokenAutenticacaoPagamento();
        });
        // $rota->post('/pagamentos', function($rota) {AuthMiddleware::validate($rota);}, function($rota) {
        //     PagamentoController::processarPagamento($rota);
        // });
        $rota->post('/pagamentos/mercado_pago/webhooks', null, function($rota) {
            PagamentoController::atualizacaoPagamentoMP($rota);
        });
    }
}