<?php
namespace LojaVirtual\App\Rotas;

use LojaVirtual\App\Config\Rota;
use LojaVirtual\App\Controller\ProdutoController;

class RotasProdutos
{
    public function __construct(Rota $rota)
    {
        $rota->get('/produtos', null, function($rota) {
            ProdutoController::listarProdutos($rota);
        });
        $rota->get('/produtos/:{idProduto}', null, function($rota) {
            ProdutoController::detalhesProduto($rota);
        });
        $rota->get('/produtos/:{idProduto}/variacoes', null, function($rota) {
            ProdutoController::listarVariacoes($rota);
        });
        $rota->post('/produtos/precos', null, function($rota) {
            ProdutoController::valoresProdutos($rota);
        });

        $rota->get('/produtos/filtros', null, function($rota) {
            ProdutoController::buscarFiltros();
        });

        $rota->get('/produtos/destaques', null, function() {
            ProdutoController::listarProdutosDestaques();
        });
    }
}