<?php

namespace LojaVirtual\Loads;

class AutoLoad
{
    public function __construct()
    {
        $this->incluirArquivos();
    }
    public static function arquivos(string $diretorio)
    {
        $diretorios = dir(realpath(__DIR__."/../$diretorio"));
        $arquivos = [];

        while (($arquivoDiretorio = $diretorios->read()) !== false) {
            if ($arquivoDiretorio != "." && $arquivoDiretorio != "..") {
                if (is_file("$diretorio/$arquivoDiretorio")) {
                    array_push($arquivos, "$diretorio/$arquivoDiretorio");
                } else {
                    $subdiretorios = dir("$diretorio/$arquivoDiretorio");
                        
                    while(($subdiretorio = $subdiretorios->read()) !== false) {
                        if(is_file("$diretorio/$arquivoDiretorio/$subdiretorio")) {
                            array_push($arquivos, "$diretorio/$arquivoDiretorio/$subdiretorio");
                        }
                    }
                }
            }
        }
        $diretorios->close();
        sort($arquivos);
        return $arquivos;
    }

    private function incluirArquivos()
    {
        $diretorios = [
            "config",
            "utils",
            "model/type",
            "model",
            "controller",
        ];

        foreach($diretorios as $diretorio) {
            $arquivos = AutoLoad::arquivos("app/$diretorio");
            foreach ($arquivos as $arquivo) {
                if($arquivo != "app/model/pedido.php") {
                    require_once $arquivo;

                }
            }
        }
        require_once "app/rotas/rotas.php";
    }
}
