<?php
namespace MercadoPago;

class AutoLoad {
    public function __construct()
    {
        $this->incluirArquivos();
    }
    
    public static function arquivos(string $diretorio)
    {
        $path = realpath(__DIR__.$diretorio);
        $diretorios = dir($path);
        $arquivos = [];

        while(($diretorio = $diretorios->read()) !== false) {
            if($diretorio != "." && $diretorio != "..") {
                if(is_file("$path/$diretorio")) {
                    array_push($arquivos, "$path/$diretorio");
                }
                else {
                    $subdiretorios = dir("$path/$diretorio");
                        
                    while(($subdiretorio = $subdiretorios->read()) !== false) {
                        if(is_file("$path/$diretorio/$subdiretorio")) {
                            array_push($arquivos, "$path/$diretorio/$subdiretorio");
                        }
                        else {
                            $subdiretorio2 = dir("$path/$diretorio/$subdiretorio");
                            
                            if($subdiretorio != '.' && $subdiretorio != '..') {
                                while(($arquivo = $subdiretorio2->read()) !== false) {
                                    if($arquivo != '.' && $arquivo != '..') {
                                        array_push($arquivos, "$path/$diretorio/$subdiretorio/$arquivo");
                                    }
                                }
                            }
                        }
                    };
                }
            }
        }
        $diretorios->close();
        return $arquivos;
    }

    private function incluirArquivos()
    {
        $diretorios = [
            "config",
            "entidade"
        ];

        foreach($diretorios as $diretorio) {
            $arquivos = AutoLoad::arquivos("/src/$diretorio");
            foreach ($arquivos as $arquivo) {
                require_once $arquivo;
            }
        }
    }
}

new AutoLoad();