<?php
namespace MercadoPago\Src\Config\Http;

class Request {
    private static $curl;

    public static function post(string $url, array $cabecalho, ?string $dados = '') {
        if(!$dados) {
            array_push($cabecalho, "Content-Length: 0");
        }
        $configuracoesRequisicao = [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_HTTPHEADER => $cabecalho
        ];
        if($dados !== null) {
            $configuracoesRequisicao[CURLOPT_POSTFIELDS] = $dados;
        }

        self::$curl = curl_init();
        curl_setopt_array(self::$curl, $configuracoesRequisicao);
          
        $response = curl_exec(self::$curl);
        $cabecalhoResposta = curl_getinfo(self::$curl);
        curl_close(self::$curl);
        
        if(substr($cabecalhoResposta["http_code"], 0, 1) == 5) {
            self::salvarErro($url, "POST", $cabecalhoResposta["http_code"], $response);
        }

        return (object)[
            "headers"=> $cabecalhoResposta,
            "body"=> json_decode($response) ?? $response
        ];
    }

    private static function salvarErro(string $url, string $metodo, string $codigoHttp, string $body) {
        $abrirArquivo = fopen(realpath(__DIR__."/../../../log_erros.txt"), "a");
        $dataAtual = date("d/m/Y H:i:s");
        fwrite($abrirArquivo, "Data: $dataAtual\r\nEndpoint: $url\r\nMetodo: $metodo\r\nCodigo HTTP: $codigoHttp\r\nCorpo: $body\r\n\r\n");
        fclose($abrirArquivo);
    }
}