<?php
namespace Sicacred\App\Config;
include "$diretorio/../config/Unidade.php";
include "$diretorio/../config/http/Api.php";
include "$diretorio/../config/http/Request.php";
include "$diretorio/integration/DecisorEntidade.php";
use Exception;
use Sicacred\App\Config\Unidade;
use Sicacred\App\Config\Http\Request;
use Sicacred\App\Config\Http\Api;
use Sicacred\App\Model\Integration\DecisorEntidade;

class Autenticacao {
    private $token;
    private $tipo;

    /**
     * @param string $tipo Envio ou Recebimento
     */
    public function __construct(string $tipo) {
        $this->tipo = $tipo;
        if($this->tipo == "Recebimento") {
            $this->gerarTokenRecebimento();
        }
        else {
            $this->gerarTokenEnvio();
        }
    }

    private function gerarTokenRecebimento() {
        $unidade = new Unidade();
        $api = new Api();
        $url = "$api->urlBase/api/SicaIntegration/Autenticar";
        $dados = new DecisorEntidade(
            $unidade->usuario(),
            $unidade->codigoErp(),
            $unidade->cpf(),
            $unidade->senha(),
            true
        );
        $request = Request::post($url, "", $dados->toString(), "json");
        if(isset($request->body->Token)) {
            $this->token = $request->body->Token;
        }
        else {
            throw new Exception($request->body->MensagemErro, 1);
        }
    }
    
    private function gerarTokenEnvio() {
        $unidade = new Unidade();
        $api = new Api();
        $url = "$api->urlBase/api/gettoken";
        $dados = "grant_type=password&username={$unidade->usuario()}&codigoerp={$unidade->codigoErp()}&password={$unidade->senha()}";
        $request = Request::post($url, null, $dados, "x-www-form-urlencoded");
        if(isset($request->body->access_token)) {
            $this->token = $request->body->access_token;
        }
        else {
            throw new Exception($request->body->MensagemErro, 1);
        }
    }

    public function token(): string {
        return $this->token;
    }
}
?>