<?php
namespace Sicacred\App\Model;
$diretorio = str_replace('\\', '/', __DIR__);
include "$diretorio/../config/Autenticacao.php";
include "integration/SicaConsultaDatasResponse.php";
include "integration/SicaIntegracaoResponse.php";
include "integration/DtoSicaConsultaDatas.php";
use Sicacred\App\Config\Unidade;
use Sicacred\App\Config\Autenticacao;
use Sicacred\App\Config\Http\Request;
use Sicacred\App\Config\Http\Api;
use Sicacred\App\Model\Integration\SicaConsultaDatasResponse;
use Sicacred\App\Model\Integration\SicaIntegracaoResponse;
use Sicacred\App\Model\Integration\DtoSicaConsultaDatas;
use Sicacred\App\Model\Integration\DtoSicaIntegrator;

class Sicacred {

    public function __construct() {}

    /**
     * Analisar cliente function
     *
     * @param float $valor Valor a ser analisado
     * @param string $documento CPF OU CNPJ do cliente a ser analisado
     * @param bool $consultarSpc True ou False
     * @return object
     */
    public static function analisarCliente($valor, $documento, $consultarSpc): object {
        $autenticacao = new Autenticacao("Recebimento");
        $api = new Api();
        $dados = json_encode([
            "Token"=> $autenticacao->token(),
            "ValorAnalise"=> $valor,
            "Documento"=> $documento,
            "ConsultaSpc"=> $consultarSpc
        ]);
        $request = Request::post("$api->urlBase/api/SicaIntegration/SicaDC", $autenticacao->token(), $dados, "json");
        return $request->body;
    }
    
    public static function consultarDatas(): SicaConsultaDatasResponse {
        $unidade = new Unidade();
        $autenticacao = new Autenticacao("Envio");
        $api = new Api();
        $dados = new DtoSicaConsultaDatas($unidade->producao(), $unidade->codigoFonte(), $unidade->usuario(), $unidade->senha());
        $request = Request::post("$api->urlBase/api/SicaIntegration/ConsultaDatas", $autenticacao->token(), $dados->toString(), "json");
        return new SicaConsultaDatasResponse($request->body);
    }

    /**
     * Enviar dados dos clientes
     *
     * @param DtoSicaIntegrator $dados
     * @return SicaIntegracaoResponse
     */
    public static function postFile(DtoSicaIntegrator $dados): SicaIntegracaoResponse {
        $autenticacao = new Autenticacao("Envio");
        $api = new Api();
        $request = Request::post("$api->urlBase/api/SicaIntegration/PostFile", $autenticacao->token(), $dados->toString(), "json");
        return new SicaIntegracaoResponse($request->body);
    }
}
?>