<?php
namespace Sicacred\App\Model\Integration;

class SicaCli {
    public $CODFONTE;
    public $COD_CLI;
    public $DT_CAD;
    public $R_SOCIAL;
    public $N_FANTAS;
    public $CNPJ_CPF;
    public $END_CLI;
    public $BAIRRO;
    public $CIDADE;
    public $UF;
    public $CEPCLI;
    public $FONE1;
    public $EMAIL;
    public $SITUACAO;
    public $LIMITE;

    /**
     * @param string $CODFONTE Codigo fonte da empresa
     * @param string $COD_CLI Codigo do cliente no sistema
     * @param string $DT_CAD Data de cadastro
     * @param string $R_SOCIAL Razao_Social
     * @param string $N_FANTAS Nome fantasia
     * @param string $CNPJ_CPF CNPJ ou CPF do cliente
     * @param string $END_CLI Endereco do cliente
     * @param string $BAIRRO 
     * @param string $CIDADE
     * @param string $UF
     * @param string $CEPCLI
     * @param string $FONE1
     * @param string $EMAIL
     * @param string $SITUACAO Ativo, Inativo, Negativo ou Bloqueado
     * @param float $LIMITE Limite de credito do cliente na empresa
     */
    public function __construct(string $CODFONTE, string $COD_CLI, string $DT_CAD, string $R_SOCIAL, string $N_FANTAS, string $CNPJ_CPF,
        string $END_CLI, string $BAIRRO, string $CIDADE, string $UF, string $CEPCLI, string $FONE1, string $EMAIL, string $SITUACAO,
        float $LIMITE
    ) {
        $this->CODFONTE = substr($CODFONTE, 0, 7);
        $this->COD_CLI = substr($COD_CLI, 0, 15);
        $this->DT_CAD = substr($DT_CAD, 0, 10);
        $this->R_SOCIAL = substr($R_SOCIAL, 0, 100);
        $this->N_FANTAS = substr($N_FANTAS, 0, 100);
        $this->CNPJ_CPF = substr($CNPJ_CPF, 0, 18);
        $this->END_CLI = substr($END_CLI, 0, 120);
        $this->BAIRRO = substr($BAIRRO, 0, 60);
        $this->CIDADE = substr($CIDADE, 0, 60);
        $this->UF = substr($UF, 0, 2);
        $this->CEPCLI = substr($CEPCLI, 0, 10);
        $this->FONE1 = substr($FONE1, 0, 20);
        $this->EMAIL = substr($EMAIL, 0, 80);
        $this->SITUACAO = substr($SITUACAO, 0, 20);
        $this->LIMITE = $LIMITE;
    }
}
?>