<?php
namespace Sicacred\App\Model\Integration;

class SicaCpr {
    public $CODFONTE;
    public $COD_CPR;
    public $COD_CLI;
    public $DT_CPR;
    public $VL_CPR;
    public $FOI_PRAZ;
    public $CodFmpFte;

    /**
     * @param string $CODFONTE Codigo fonte da empresa
     * @param string $COD_CPR Codigo da Compra, documento de saida, numero e serie da nota fiscal ou um codigo gerado pelo sistema
     * @param string $COD_CLI Codigo do cliente
     * @param string $DT_CPR Data da compra
     * @param string $VL_CPR Valor da compra
     * @param string $FOI_PRAZ Compra a prazo(S ou N)
     * @param string $CodFmpFte Forma de Pagamento da Compra
     */
    public function __construct(string $CODFONTE, string $COD_CPR, string $COD_CLI, string $DT_CPR, string $VL_CPR, string $FOI_PRAZ, string $CodFmpFte) {
        $this->CODFONTE = substr($CODFONTE, 0, 7);
        $this->COD_CPR = substr($COD_CPR, 0, 20);
        $this->COD_CLI = substr($COD_CLI, 0, 15);
        $this->DT_CPR = substr($DT_CPR, 0, 10);
        $this->VL_CPR = (float) substr($VL_CPR, 0, (strpos($VL_CPR, ".") + 3));
        $this->FOI_PRAZ = substr($FOI_PRAZ, 0, 1);
        $this->CodFmpFte = substr($CodFmpFte, 0, 10);
    }
}
?>