<?php
namespace Sicacred\App\Model\Integration;

class SicaDoc {
    public $CODFONTE;
    public $COD_DOC;
    public $COD_CLI;
    public $DT_EMI;
    public $DT_VENC;
    public $DT_PGTO;
    public $VL_DOC;
    public $VL_PGT;
    public $CodFmpFte;

    /**
     * @param string $CODFONTE Codigo fonte da empresa
     * @param string $COD_DOC Codigo do Documento
     * @param string $COD_CLI Codigo do cliente
     * @param string $DT_EMI Data de emissao
     * @param string $DT_VENC Data de vencimento
     * @param string $DT_PGTO Data de pagamento
     * @param float $VL_DOC Valor do documento
     * @param float $VL_PGT Valor pago
     * @param string $CodFmpFte Tipo do Documento
     */
    public function __construct(string $CODFONTE, string $COD_DOC, string $COD_CLI, string $DT_EMI, string $DT_VENC, string $DT_PGTO,
        string $VL_DOC, string $VL_PGT, string $CodFmpFte
    ) {
        $this->CODFONTE = substr($CODFONTE, 0, 7);
        $this->COD_DOC = substr($COD_DOC, 0, 30);
        $this->COD_CLI = substr($COD_CLI, 0, 15);
        $this->DT_EMI = substr($DT_EMI, 0, 10);
        $this->DT_VENC = substr($DT_VENC, 0, 10);
        $this->DT_PGTO = substr($DT_PGTO, 0, 10);
        $this->VL_DOC = (float) substr($VL_DOC, 0, (strpos($VL_DOC, ".") + 3));
        $this->VL_PGT = (float) substr($VL_PGT, 0, (strpos($VL_PGT, ".") + 3));
        $this->CodFmpFte = substr($CodFmpFte, 0, 10);
    }
}
?>