<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
?>
<!DOCTYPE html>
<html>
<head>
    <title>Remessa Sicacred</title>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tableless.css" />
    <style>
    form {
        display: flex;
        width: 100%;
        min-height: 100vh;
        margin: 0 !important;
        align-items: center;
        flex-direction: column;
    }

    form>div {
        width: 95%;
    }

    .d-flex {
        display: flex;
    }

    .flex-column {
        flex-direction: column;
    }

    .justify-between {
        justify-content: space-between;
    }

    .w-100 {
        width: 100%;
    }

    input,
    select {
        padding: 5px;
        margin-top: 7px;
    }

    .header-form {
        display: flex;
        width: 100%;
        margin: 20px 0;
        justify-content: center;
        align-items: center;
        padding: 20px 0;
        border-radius: 5px;
    }

    .body-form>div:first-child {
        margin-bottom: 25px;
        padding: 10px 5px;
        border: solid 1px #424258;
        border-radius: 5px;
    }

    label {
        font-weight: bolder;
    }
    </style>
</head>
<body>
    <form class="envolve" id="arquivosNfe" method="post">
        <legend class="d-flex" style="width:95%">
            <div class="header-form">
                <h2 style="color:white">Arquivos</h2>
            </div>
        </legend>
        <div class="body-form">
            <div class="d-flex justify-between">
                <label>
                    <input type="radio" name="tipo" value="nfe">
                    NF-e
                </label>
                <label>
                    <input type="radio" name="tipo" value="nfce">
                    NFC-e
                </label>
                <label>
                    <input type="radio" name="tipo" value="mdfe">
                    MDF-e
                </label>
            </div>
            <div class="d-flex justify-between">
                <div class="d-flex flex-column" style="width:55%;">
                    <label>Empresa</label>
                    <select name="unidade">
                        <option disabled selected>Selecione</option>
                        <?php
                        $getUnidades = $con->query("SELECT Titulo, Cnpj FROM unidade WHERE Ativo = 'Sim'");
                        while ($unidade = $getUnidades->fetch_assoc()) { ?>
                        <option value="<?php echo preg_replace("/[^0-9]/", "", $unidade['Cnpj']); ?>">
                            <?php echo "{$unidade['Titulo']} - {$unidade['Cnpj']}"; ?></option>
                        <?php } ?>
                    </select>
                </div>
                <div class="d-flex flex-column" style="width:35%">
                    <label>Tipo do arquivo</label>
                    <select name="tipoArquivo">
                        <option disabled selected>Selecione</option>
                        <option value="PDF">PDF</option>
                        <option value="XML">XML</option>
                    </select>
                </div>
            </div>
            <div class="d-flex justify-between" style="margin-top:15px;">
                <div class="d-flex flex-column" style="width:55%;">
                    <label>Ms</label>
                    <?php
                    if (!$_POST["Mes"])
                        $_POST["Mes"] = date('m');

                    $vetor = array(
                        '01' => 'Janeiro', '02' => 'Fevereiro',
                        '03' => 'Maro', '04' => 'Abril',
                        '05' => 'Maio', '06' => 'Junho',
                        '07' => 'Julho', '08' => 'Agosto',
                        '09' => 'Setembro', '10' => 'Outubro',
                        '11' => 'Novembro', '12' => 'Dezembro'
                    );
                    select_tela("Mes", "Mes", $_POST["Mes"], $vetor);
                    ?>
                </div>
                <div class="d-flex flex-column" style="width:35%">
                    <label>Ano</label>
                    <?php
                    if ($_POST["Ano"] == '')
                        $_POST["Ano"] = date('Y');

                    $vetor = array((date('Y') - 4) => (date('Y') - 4),
                        (date('Y') - 3) => (date('Y') - 3),
                        (date('Y') - 2) => (date('Y') - 2),
                        (date('Y') - 1) => (date('Y') - 1),
                        date('Y') => date('Y'),
                        (date('Y') + 1) => (date('Y') + 1),
                        (date('Y') + 2) => (date('Y') + 2)
                    );
                    select_tela("Ano", "Ano", $_POST["Ano"], $vetor, '');
                    ?>
                </div>
            </div>
        </div>
        <div class="d-flex" style="justify-content: center;">
            <button class="botao" type="submit" style="margin-top:45px">Continuar</button>
        </div>
    </form>
    <script>
    document.getElementById("arquivosNfe").addEventListener("submit", async function(e) {
        e.preventDefault();

        if (!document.querySelector("input[name=tipo]:checked")) {
            alert("Selecione o tipo");
            return;
        }
        if (document.querySelector("select[name=unidade]").value == "Selecione") {
            alert("Selecione um empresa");
            return;
        }
        if (document.querySelector("select[name=tipoArquivo]").value == "Selecione") {
            alert("Selecione o tipo do arquivo");
            return;
        }
        if (document.querySelector("select[name=Mes]").value == "Selecione") {
            alert("Selecione o ms");
            return;
        }
        if (document.querySelector("select[name=Ano]").value == "Selecione") {
            alert("Selecione o ano");
            return;
        }
        let tipo = document.querySelector("input[name=tipo]:checked").value;
        let empresa = document.querySelector("select[name=unidade]").value;
        let ano = document.querySelector("select[name=Ano]").value;
        let mes = document.querySelector("select[name=Mes]").value;
        let url = window.location.href.split("/");
        url.pop();
        url = url.join("/");

        if (document.querySelector("select[name=tipoArquivo]").value == "PDF") {
            url = `${url}/?dir=${tipo}/${empresa}/producao/pdf/${ano}${mes}`;
        } else {
            let multiEmpresa = "<?=MULTI_EMPRESA;?>";
            if(multiEmpresa == 'Sim') {
                url = `${url}/?dir=${tipo}/${empresa}/producao/enviadas/aprovadas/${ano}${mes}`;
            }
            else {
                url = `${url}/?dir=${tipo}/producao/enviadas/aprovadas/${ano}${mes}`;
            }
        }
        window.location.href = url;
    })
    </script>
</body>
</html>