<?php

use Bling\App\Config\Utils\Bling;
use Bling\App\Model\CampoCustomizado;
use Bling\App\Model\CategoriaPaiProduto;
use Bling\App\Model\Produto;
use Bling\App\Model\Type\Product\CampoCustomizadoProduto;
use Bling\App\Model\Type\Product\CategoriaProdutoLoja;
use Bling\App\Model\Type\Product\CategoriaProdutoLojaDTO;
use Bling\App\Model\Type\Product\Dimensao;
use Bling\App\Model\Type\Product\FiltroCategoriaProdutoLoja;
use Bling\App\Model\Type\Product\ImagemProduto;
use Bling\App\Model\Type\Product\ImagensProduto;
use Bling\App\Model\Type\Product\MidiaProduto;
use Bling\App\Model\Type\Product\ProdutoEstoque;
use Bling\App\Model\Type\Product\VideoProduto;

include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php';
include "../integracao/bling/load.php";

$request = file_get_contents('php://input');
$request = json_decode($request);

if($_SERVER['REQUEST_METHOD'] == 'POST') {
    if($request->atualizarPor == 'produto') {
        $codigoProduto = addslashes($request->produto->codigo);
        $nomeProduto = addslashes($request->produto->nome);
    
        $dadosProduto = $con->query("SELECT Id, Codigo, Titulo, Descricao, Preco1, Medida, Ncm, Cest, Gtin, Estoque_Minimo, Estoque_Maximo,
            Peso_Liquido, Peso_Bruto, Altura, Largura, Codigo_Barras, Caminho_Foto, Foto, Foto2, Foto3, Qtd_Caixa, Obs, Id_Bling,
            (SELECT Titulo FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Fornecedor,
            (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto) AS Id_Categoria_Marketplace,
            (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto_Filho) AS Id_Subcategoria_Marketplace,
            (SELECT Id_Bling FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Id_Fornecedor_Marketplace,
            (SELECT COUNT(Id) FROM produto WHERE Id_Produto_Pai = produto.Id) AS Qtd_Produto_Filho,
            (SELECT Titulo FROM fabricante WHERE Id = produto.Id_Fabricante) AS Fabricante
            FROM produto
            WHERE Ativo = 'Sim' AND Marketplace = 'Sim' AND Codigo = '$codigoProduto' AND Titulo = '$nomeProduto'");
        $dadosProduto = $dadosProduto->fetch_assoc();
        
        $imagensProduto = [];
        if($dadosProduto["Foto"] != "") {
            $dadosProduto['Codigo'] = str_replace(".", "", $dadosProduto['Codigo']);
            array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto"]}"));
            for($i = 2; $i <= 5; $i++) {
                if(isset($dadosProduto["Foto$i"]) && $dadosProduto["Foto$i"] != "") {
                    array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto$i"]}"));
                }
            }
        }
    
        $midiaProduto = new MidiaProduto(
            new ImagensProduto($imagensProduto),
            new VideoProduto("")
        );
        $categoriasProduto = [new CategoriaProdutoLojaDTO((int)$dadosProduto['Id_Categoria_Marketplace'])];
        if($dadosProduto['Id_Subcategoria_Marketplace'] != null) {
            array_push($categoriasProduto, new CategoriaProdutoLojaDTO((int)$dadosProduto['Id_Subcategoria_Marketplace']));
        }
        $camposCustomizadosProduto = [];
        foreach ($request->campos as $campo) {
            array_push($camposCustomizadosProduto, new CampoCustomizadoProduto(
                $campo->id,
                $campo->valor
            ));
        }
        $produto = new Produto(
            Bling::isoToUtf8($dadosProduto['Titulo']),
            "P",
            "A",
            $dadosProduto['Qtd_Produto_Filho'] > 0 ? "V" : "S",
            Bling::isoToUtf8($dadosProduto['Descricao']),
            $midiaProduto,
            $dadosProduto["Peso_Bruto"] > 0 ? $dadosProduto["Peso_Bruto"] : 0.01,
            new Dimensao(
                $dadosProduto['Largura'] > 0 ? $dadosProduto["Largura"] : 0.01,
                $dadosProduto["Altura"] > 0 ? $dadosProduto["Altura"] : 0.01,
                0.01
            ),
            $dadosProduto['Fabricante'] ?? Bling::isoToUtf8("No informado"),
            $dadosProduto['Gtin'],
            $dadosProduto['Fornecedor'],
            $dadosProduto['Codigo'],
            $dadosProduto['Preco1'],
            new CategoriaPaiProduto($dadosProduto['Id_Categoria_Marketplace']),
            new ProdutoEstoque($dadosProduto['Estoque_Minimo'], $dadosProduto['Estoque_Maximo']),
            $dadosProduto['Medida'],
            false,
            $dadosProduto['Peso_Liquido'],
            1,
            Bling::isoToUtf8($dadosProduto['Obs']),
            1,
            $dadosProduto['Qtd_Caixa'],
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            $camposCustomizadosProduto
        );
        $produto->setId((int)$dadosProduto['Id_Bling']);
    
        $atualizarProduto = Produto::atualizar($produto);
        $response = [
            "status"=> $atualizarProduto === true ? "ok" : "erro",
            "mensagem"=> $atualizarProduto === true ? "" : Bling::isoToUtf8("No foi possvel atualizar os campos")
        ];

        if($atualizarProduto !== true) {
            $response['erro'] = $atualizarProduto;
        }

        echo json_encode($response);
    }
    else {
        $idCategoria = addslashes($request->idCategoria);
        $idCategoriaBling = $con->query("SELECT Id_Bling FROM categoria_produto WHERE Id = '$idCategoria'");
        $idCategoriaBling = $idCategoriaBling->fetch_assoc()['Id_Bling'];
        $modulos = CampoCustomizado::modulos();

        foreach ($modulos as $modulo) {
            if($modulo->modulo == "Produtos") {
                $categoriasMarketplace = CategoriaProdutoLoja::buscarTodas(
                    new FiltroCategoriaProdutoLoja(
                        1,
                        100,
                        (int)$marketplace,
                        $idCategoriaBling
                    )
                );
                $categoriaLoja = $categoriasMarketplace[0];
                $camposCustomizadosProdutos = CampoCustomizado::camposModulos($modulo->id);
                $idsCamposCustomizados = array_column($camposCustomizadosProdutos, "id");
                $idsCamposAtualizar = array_column($request->campos, "id");
                $idsCamposNaoAtualizados = array_diff($idsCamposCustomizados, $idsCamposAtualizar);

                $getProdutos = $con->query("SELECT Id, Codigo, Titulo, Descricao, Preco1, Medida, Ncm, Cest, Gtin, Estoque_Minimo, Estoque_Maximo,
                    Peso_Liquido, Peso_Bruto, Altura, Largura, Codigo_Barras, Caminho_Foto, Foto, Foto2, Foto3, Qtd_Caixa, Obs, Id_Bling,
                    (SELECT Titulo FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Fornecedor,
                    (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto) AS Id_Categoria_Marketplace,
                    (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto_Filho) AS Id_Subcategoria_Marketplace,
                    (SELECT Id_Bling FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Id_Fornecedor_Marketplace,
                    (SELECT COUNT(Id) FROM produto WHERE Id_Produto_Pai = produto.Id) AS Qtd_Produto_Filho,
                    (SELECT Titulo FROM fabricante WHERE Id = produto.Id_Fabricante) AS Fabricante
                    FROM produto
                    WHERE Ativo = 'Sim' AND Marketplace = 'Sim' AND Id_Categoria_Produto = '$idCategoria' AND Id_Bling IS NOT NULL AND Id_Bling != ''");

                $camposCustomizadosProduto = [];
                $qtdProdutosAtualizados = 0;

                foreach ($request->campos as $campo) {
                    $dadosCampoCustomizado = CampoCustomizado::buscar($campo->id);
                    $campoCustomizado = new CampoCustomizado(
                        $dadosCampoCustomizado->nome,
                        null,
                        null,
                        $campo->valor
                    );
                    $campoCustomizado->setId($campo->id);
                    CampoCustomizado::atualizar($campoCustomizado);

                    array_push($camposCustomizadosProduto, new CampoCustomizadoProduto(
                        $campo->id,
                        $campo->valor
                    ));
                }

                while($dadosProduto = $getProdutos->fetch_assoc()) {
                    $imagensProduto = [];
                    if($dadosProduto["Foto"] != "") {
                        $dadosProduto['Codigo'] = str_replace(".", "", $dadosProduto['Codigo']);
                        array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto"]}"));
                        for($i = 2; $i <= 5; $i++) {
                            if(isset($dadosProduto["Foto$i"]) && $dadosProduto["Foto$i"] != "") {
                                array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto$i"]}"));
                            }
                        }
                    }
                
                    $midiaProduto = new MidiaProduto(
                        new ImagensProduto($imagensProduto),
                        new VideoProduto("")
                    );

                    $customizadosProduto = $camposCustomizadosProduto;
                    $produtoBling = Produto::buscar((int)$dadosProduto['Id_Bling']);
                    foreach ($produtoBling->camposCustomizados as $campoCustomizadoProduto) {
                        if(in_array($campoCustomizadoProduto->idCampoCustomizado, $idsCamposNaoAtualizados)) {
                            array_push($customizadosProduto, new CampoCustomizadoProduto(
                                $campoCustomizadoProduto->idCampoCustomizado,
                                $campoCustomizadoProduto->valor
                            ));
                        }
                    }

                    $produto = new Produto(
                        Bling::isoToUtf8($dadosProduto['Titulo']),
                        "P",
                        "A",
                        $dadosProduto['Qtd_Produto_Filho'] > 0 ? "V" : "S",
                        Bling::isoToUtf8($dadosProduto['Descricao']),
                        $midiaProduto,
                        $dadosProduto["Peso_Bruto"] > 0 ? $dadosProduto["Peso_Bruto"] : 0.01,
                        new Dimensao(
                            $dadosProduto['Largura'] > 0 ? $dadosProduto["Largura"] : 0.01,
                            $dadosProduto["Altura"] > 0 ? $dadosProduto["Altura"] : 0.01,
                            0.01
                        ),
                        $dadosProduto['Fabricante'] ?? Bling::isoToUtf8("No informado"),
                        $dadosProduto['Gtin'],
                        $dadosProduto['Fornecedor'],
                        $dadosProduto['Codigo'],
                        $dadosProduto['Preco1'],
                        new CategoriaPaiProduto($dadosProduto['Id_Categoria_Marketplace']),
                        new ProdutoEstoque($dadosProduto['Estoque_Minimo'], $dadosProduto['Estoque_Maximo']),
                        $dadosProduto['Medida'],
                        false,
                        $dadosProduto['Peso_Liquido'],
                        1,
                        Bling::isoToUtf8($dadosProduto['Obs']),
                        1,
                        $dadosProduto['Qtd_Caixa'],
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        $customizadosProduto
                    );
                    $produto->setId((int)$dadosProduto['Id_Bling']);
                    $atualizarProduto = Produto::atualizar($produto);
                    if($atualizarProduto === true) {
                        $qtdProdutosAtualizados++;
                    }
                }
                
                $response = [
                    "status"=> $qtdProdutosAtualizados > 0 ? "ok" : "erro",
                    "mensagem"=> $qtdProdutosAtualizados > 0 ? "Campos atualizados com sucesso" : Bling::isoToUtf8("No foi possvel atualizar os campos")
                ];
            }
        }
    }
    echo json_encode($response);
}
else {
    header("HTTP/1.1 405 Method Not Allowed");
}
?>