<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php';
include_once '../menu_movimento.php';

?>
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Gw - Gesto Web</title>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN ;?>/tableless.css" />
    <link rel="stylesheet" type="text/css" href="../js/autocomplete/jquery.autocomplete.css" />
    <link rel="stylesheet" type="text/css" href="../js/autocomplete/lib/thickbox.css" />
    <link rel="stylesheet" href="assets/css/style.css">
    <script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
    <?php include '../include/script_cabeca.php'; ?>
    <!-- <script type="text/javascript" language="javascript" src="../js/script.js"></script> -->
    <style>
        input[type=text], select {
            height: 30px;
            padding: 5px;
        }
        input[type=radio] {
            height: 16px;
            width: 16px;
        }
        #formProduto label.busca:hover, #formProduto input[type=radio] {
            cursor: pointer;
            opacity: .7;
        }
        .lojas {
            padding: 20px;
            border-radius: 6px;
            background: white;
            box-shadow: 0px 4px 25px -17px rgb(0, 0, 1);
        }
        #formProduto > .d-flex {
            gap: .4rem;
        }
        #formProduto > .d-flex:not(:nth-child(2)) {
            width: max(26%, 335px);
        }
        #formProduto button[type=submit] {
            align-self: end;
        }
        form button[type=submit]:disabled {
            cursor: progress;
        }

    </style>
</head>
<body>
    <div class="container envolve">
        <div class="d-flex flex-column align-content-center justify-content-center gap-3 w-80">
            <h2>Campos Customizados Produto</h2>
            <div class="d-flex flex-column gap-2">
                <div class="lojas d-flex flex-column gap-2">
                    <h3>Pesquisar Campos</h3>
                    <form class="row flex-wrap gap-2" id="formProduto" method="post">
                        <div class="d-flex flex-column">
                            <span class="font-bold">Marketplace</span>
                            <?php
                            $unidadeLoja = ESCOLHER_EMPRESA == "Sim" && $_POST['unidadeLoja'] ? addslashes($_POST['unidadeLoja']) : $_SESSION['Unidade'];
                            $marketplaces = $con->query("SELECT Titulo, Codigo FROM bling_loja WHERE Id_Unidade = '$unidadeLoja'");
                            ?>
                            <select name="marketplace">
                                <option value="" selected disabled>Selecione</option>
                                <?php
                                while ($marketplace = $marketplaces->fetch_assoc()) {?>
                                    <option value="<?=$marketplace['Codigo'];?>"><?="{$marketplace['Codigo']} - {$marketplace['Titulo']}";?></option>
                                    <?php
                                }?>
                            </select>
                        </div>
                        <div class="d-flex flex-column">
                            <span class="font-bold">Buscar Por</span>
                            <div class="row" style="gap: 2rem;">
                                <label class="busca">
                                    <input type="radio" name="buscarPor" checked value="categoria">
                                    Categoria
                                </label>
                                <label class="busca">
                                    <input type="radio" name="buscarPor" value="produto">
                                    Produto
                                </label>
                            </div>
                        </div>
                        <div class="d-flex flex-column" id="pesquisaCategoria">
                            <span class="font-bold">Categoria</span>
                            <?php
                            $categorias = $con->query("SELECT Id, Titulo FROM categoria_produto WHERE Ativo = 'Sim' AND Marketplace = 'Sim' AND
                                Id_Bling IS NOT NULL AND Id_Bling != ''");
                            ?>
                            <select name="categoria">
                                <option value="" selected disabled>Selecione</option>
                                <?php while($categoria = $categorias->fetch_assoc()) {?>
                                    <option value="<?= $categoria['Id'];?>"><?= $categoria['Titulo'];?></option>
                                    <?php
                                } ?>
                            </select>
                        </div>
                        <div class="d-flex flex-column d-none" id="pesquisaProduto">
                            <span class="font-bold">Produto</span>
                            <input type="text" name="produto" list="produtos" autocomplete="off" id="produto">
                            <datalist id="produtos"></datalist>
                        </div>
                        <button class="botao" type="submit">Buscar Campos</button>
                    </form>
                    <div class="d-flex flex-column gap-2 d-none" id="listaCamposCustomizados">
                        <h3>Campos Customizados</h3>
                        <form id="formCamposCustomizados" class="d-flex flex-column gap-3" style="margin-top: -15px;">
                            <div class="d-flex flex-wrap" style="gap: .4rem;" id="camposCustomizados">
                            </div>
                            <div class="d-flex justify-content-center">
                                <button class="botao" type="submit">Salvar</button>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="row">
                    <button class="botao" onclick="history.back(1)">Voltar</button>
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript" language="javascript" src="../js/autocomplete/lib/jquery.bgiframe.min.js"></script>
    <script type="text/javascript" language="javascript" src="../js/autocomplete/lib/jquery.ajaxQueue.js"></script>
    <script type="text/javascript" language="javascript" src="../js/autocomplete/lib/thickbox-compressed.js"></script>
    <script type="text/javascript" language="javascript" src="../js/autocomplete/jquery.autocomplete.js"></script>
    <script>
        $(document).ready(function() {
            $("#produto").autocomplete("pesquisar_produtos.php", {
                width: 340,
                selectFirst: true,
                scroll: false,
                cacheLength: 100,
                max: 100
            });
            $("#formProduto input[name=buscarPor]").change(function() {
                let buscarPor = $(this).val();
                if(buscarPor == "categoria") {
                    $("#formProduto #pesquisaCategoria").removeClass("d-none");
                    $("#formProduto #pesquisaProduto").addClass("d-none");
                }
                else {
                    $("#formProduto #pesquisaProduto").removeClass("d-none");
                    $("#formProduto #pesquisaCategoria").addClass("d-none");
                }
            });

            $("#formProduto").submit(function(e) {
                e.preventDefault();
                let marketplace = $(this).find("select[name=marketplace]").val();
                let buscarPor = $(this).find("input[name=buscarPor]:checked").val();
                let categoria = $(this).find("select[name=categoria]").val();
                let produto = $(this).find("input[name=produto]").val();
                let btnSubmit = $(this).find("button[type=submit]");
                let splitProduto = produto.split(" : ");
                let codigoProduto = splitProduto[0];
                let nomeProduto = splitProduto[1];

                if(marketplace.length == 0) {
                    alert("Selecione o marketplace");
                    return;
                }
                if(buscarPor == "categoria" && categoria.length == 0) {
                    alert("Selecione uma categoria");
                    return;
                }
                if(buscarPor == "produto" && produto.length == 0) {
                    alert("Selecione um produto");
                    return;
                }

                $(btnSubmit).attr("disabled", true).html("Aguarde...");

                $.post("buscar_campos.php", {
                        marketplace,
                        buscarPor,
                        categoria,
                        codigoProduto,
                        nomeProduto
                    },
                    function(response) {
                        $("#camposCustomizados").html(``);
                        $(btnSubmit).removeAttr("disabled").html("Buscar Campos");
                        $("#listaCamposCustomizados").removeClass("d-none");
                        let campos = JSON.parse(response);

                        campos.map(campo => {
                            $("#camposCustomizados").append(`
                                <div class="d-flex flex-column" style="gap: .4rem;">
                                    <span class="font-bold">${campo.nome}</span>
                                    <input type="text" name="${campo.id}" autocomplete="off" value="${campo.placeholder}" ${campo.obrigatorio ? 'required' : ''}>
                                </div>
                            `)
                        })
                    }
                );
            });

            $("#formCamposCustomizados").submit(function(e) {
                e.preventDefault();
                let produto = $("#formProduto input[name=produto]").val();
                let splitProduto = produto.split(" : ");
                let btnSubmit = $(this).find("button[type=submit]");
                $(btnSubmit).attr("disabled", true).html("Aguarde...");

                let dados = {
                    marketplace: $("#formProduto select[name=marketplace]").val(),
                    atualizarPor: $("#formProduto input[name=buscarPor]:checked").val(),
                    idCategoria: $("#formProduto select[name=categoria]").val(),
                    produto: {
                        codigo: splitProduto[0],
                        nome: splitProduto[1],
                    },
                    campos: Array.from($(this).find("input")).map(input => {
                        return {
                            id: parseInt($(input).attr('name')),
                            valor: $(input).val(),
                        }
                    })
                }

                $.ajax(
                    {
                        url: "atualizar_campos_customizados.php",
                        accepts: {
                            json: 'application/json'
                        },
                        dataType: 'json',
                        contentType: 'application/json',
                        type: 'POST',
                        data: JSON.stringify(dados),
                        success: function(response) {
                            $(btnSubmit).removeAttr("disabled").html("Salvar");
                            if(response.status == 'ok') {
                                $("#formProduto")[0].reset();
                                $("#formProduto #pesquisaCategoria").removeClass("d-none");
                                $("#formProduto #pesquisaProduto").addClass("d-none");
                                $("#camposCustomizados").html('');
                            }
                            alert(response.mensagem);
                        }
                    },
                );
            })
        });
    </script>
</body>
</html>