<?php
include_once '../../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../../include/ver_sessao.php';
include_once '../../menu_movimento.php';
include "../../integracao/bling/load.php";
use Bling\App\Model\CategoriaPaiProduto;
use Bling\App\Model\CategoriaProduto;
use Bling\App\Model\Contato;
use Bling\App\Model\Deposito;
use Bling\App\Model\DepositoProdutoDTO;
use Bling\App\Model\Endereco;
use Bling\App\Model\Estoque;
use Bling\App\Model\EstoqueProdutoDTO;
use Bling\App\Model\Produto;
use Bling\App\Model\Type\Adress\DadosEndereco;
use Bling\App\Model\Type\Contact\TipoContato;
use Bling\App\Model\Type\Product\CategoriaLoja;
use Bling\App\Model\Type\Product\CategoriaProdutoLoja;
use Bling\App\Model\Type\Product\CategoriaProdutoLojaDTO;
use Bling\App\Model\Type\Product\Dimensao;
use Bling\App\Model\Type\Product\FornecedorDTO;
use Bling\App\Model\Type\Product\FornecedorProduto;
use Bling\App\Model\Type\Product\FornecedorProdutoLojaDTO;
use Bling\App\Model\Type\Product\idCategoriaProduto;
use Bling\App\Model\Type\Product\ImagemProduto;
use Bling\App\Model\Type\Product\ImagensProduto;
use Bling\App\Model\Type\Product\LojaProdutoLojaDTO;
use Bling\App\Model\Type\Product\MidiaProduto;
use Bling\App\Model\Type\Product\ProdutoEstoque;
use Bling\App\Model\Type\Product\ProdutoFornecedorDTO;
use Bling\App\Model\Type\Product\ProdutoLoja;
use Bling\App\Model\Type\Product\ProdutoLojaDTO;
use Bling\App\Model\Type\Product\VideoProduto;
use Bling\App\Model\CampoCustomizado;

if($_SERVER['REQUEST_METHOD'] == 'POST') {
    /**
     * @param string|string[] $texto
     */
    function isoToUtf8($texto) {
        if(is_string($texto)) {
            return mb_convert_encoding($texto, 'UTF-8', "ISO-8859-1");
        }
        elseif(is_array($texto)) {
            $arrayTextos = [];
            foreach($texto as $indice => $string) {
                $arrayTextos[$indice] = is_string($string) ? mb_convert_encoding($string, 'UTF-8', "ISO-8859-1") : $string;
            }
            return $arrayTextos;
        }
    }

    switch($_POST['exportar']) {
        case 'fornecedores':
            $getIdTipoFornecedor = $con->query("SELECT Id_Bling FROM bling_tipo_contato WHERE Titulo = 'Fornecedor'");
            $idTipoFornecedor = $getIdTipoFornecedor->fetch_assoc()['Id_Bling'];
            $fornecedores = $con->query("SELECT Id, Codigo, Titulo, Razao_Social, Cpf_Cnpj, Email, Rua, Numero, Complemento, Cep, Bairro,
                Cidade, Estado, Estadual, Natureza, Fone1, Nao_Contribuinte_Icms FROM fornecedor
                WHERE tipo = 'F' AND Ativo = 'Sim' AND Marketplace = 'Sim' AND (Id_Bling IS NULL OR Id_Bling = '')");
            $qtdFornecedoresExportados = 0;

            while($dadosFornecedor = $fornecedores->fetch_assoc()) {
                $tipoFornecedor = $dadosFornecedor['Natureza'] == "PJ" ? "J" : "F";
                $fornecedorContribuinteIcms = $dadosFornecedor['Estadual'] != '' ? '1' : '9';
                $fornecedor = new Contato(
                    $dadosFornecedor['Razao_Social'],
                    $dadosFornecedor['Codigo'],
                    'A',
                    $dadosFornecedor['Cpf_Cnpj'],
                    $tipoFornecedor,
                    $dadosFornecedor['Fone1'],
                    '',
                    $dadosFornecedor['Email'],
                    [new TipoContato($idTipoFornecedor)],
                    $fornecedorContribuinteIcms,
                    new Endereco(
                        new DadosEndereco($dadosFornecedor['Bairro'], $dadosFornecedor['Cidade'], $dadosFornecedor['Estado'],
                            $dadosFornecedor['Cep'], $dadosFornecedor['Numero'], $dadosFornecedor['Complemento']
                        )
                    ),
                    $dadosFornecedor['Titulo'],
                    $dadosFornecedor['Estadual'],
                );
                $cadastrarFornecedor = $fornecedor->cadastrar();

                if(isset($cadastrarFornecedor->id)) {
                    $con->query("UPDATE fornecedor SET Id_Bling = '$cadastrarFornecedor->id' WHERE Id = '{$dadosFornecedor['Id']}'");
                    $qtdFornecedoresExportados++;
                }
            }
            if($qtdFornecedoresExportados > 0) {?>
                <script>alert("Fornecedores exportados com sucesso");</script>
                <?php
            }
            break;
        case 'categorias':
            $categorias = $con->query("SELECT Id, Titulo, Id_Pai FROM categoria_produto
                WHERE Ativo = 'Sim' AND Marketplace = 'Sim' AND (Id_Bling IS NULL OR Id_Bling = '') AND Tipo = 'Pode vender'");
            $qtdCategoriasExportadas = 0;
            $getLojas = $con->query("SELECT Codigo FROM bling_loja");
            $lojas = $getLojas->fetch_all(MYSQLI_ASSOC);

            while($dadosCategoria = $categorias->fetch_assoc()) {
                $categoriaPai = null;
                if($dadosCategoria['Id_Pai'] > 0) {
                    $getCategoriaPai = $con->query("SELECT Id_Bling FROM categoria_produto WHERE Id = '{$dadosCategoria['Id_Pai']}'");
                    $getCategoriaPai = $getCategoriaPai->fetch_assoc();
                    $categoriaPai = new CategoriaPaiProduto($getCategoriaPai['Id_Bling']);
                }
                $categoria = new CategoriaProduto(isoToUtf8($dadosCategoria['Titulo']), $categoriaPai);
                $cadastrarCategoria = $categoria->cadastrar();

                if(isset($cadastrarCategoria->id)) {
                    $con->query("UPDATE categoria_produto SET Id_Bling = '$cadastrarCategoria->id' WHERE Id = '{$dadosCategoria['Id']}'");

                    foreach($lojas as $loja) {
                        $categoriaLoja = new CategoriaProdutoLoja(
                            new CategoriaLoja($loja['Codigo']),
                            isoToUtf8($dadosCategoria['Titulo']),
                            "$cadastrarCategoria->id",
                            new idCategoriaProduto($cadastrarCategoria->id)
                        );
                        $cadastrarCategoriaLoja = $categoriaLoja->cadastrar();
                        if(isset($cadastrarCategoriaLoja->id)) {
                            $con->query("INSERT INTO bling_categoria_produto_loja SET Id_Categoria_Bling = '$cadastrarCategoria->id',
                                Id_Categoria_Loja = '$cadastrarCategoriaLoja->id'");
                        }
                    }
                    $qtdCategoriasExportadas++;
                }
            }
            if($qtdCategoriasExportadas > 0) {?>
                <script>alert("Categorias exportadas com sucesso");</script>
                <?php
            }
            break;
        case 'produtos':
            $produtos = $con->query("SELECT Id, Codigo, Titulo, Descricao, Preco1, Medida, Ncm, Cest, Gtin, Estoque_Minimo, Estoque_Maximo,
                Peso_Liquido, Peso_Bruto, Altura, Largura, Codigo_Barras, Caminho_Foto, Foto, Foto2, Foto3, Qtd_Caixa, Obs,
                (SELECT Titulo FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Fornecedor,
                (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto) AS Id_Categoria_Marketplace,
                (SELECT Id_Bling FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto_Filho) AS Id_Subcategoria_Marketplace,
                (SELECT Id_Bling FROM fornecedor WHERE Id = produto.Id_Fornecedor) AS Id_Fornecedor_Marketplace,
                (SELECT COUNT(Id) FROM produto WHERE Id_Produto_Pai = produto.Id) AS Qtd_Produto_Filho,
                (SELECT Titulo FROM fabricante WHERE Id = produto.Id_Fabricante) AS Fabricante
                FROM produto
                WHERE Ativo = 'Sim' AND Marketplace = 'Sim' AND (Id_Bling IS NULL OR Id_Bling = '') AND 
                (SELECT Tipo FROM categoria_produto WHERE Id = produto.Id_Categoria_Produto) = 'Pode vender' AND Tipo_Produto = 'P'") or die($con->error);
            $qtdProdutosExportados = 0;
            $getLojas = $con->query("SELECT Id, Codigo FROM bling_loja");
            $lojas = $getLojas->fetch_all(MYSQLI_ASSOC);

            while($dadosProduto = $produtos->fetch_assoc()) {
                $imagensProduto = [];
                if($dadosProduto["Foto"] != "") {
                    $dadosProduto['Codigo'] = str_replace(".", "", $dadosProduto['Codigo']);
                    array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto"]}"));
                    for($i = 2; $i <= 5; $i++) {
                        if(isset($dadosProduto["Foto$i"]) && $dadosProduto["Foto$i"] != "") {
                            array_push($imagensProduto, new ImagemProduto("https://{$dadosProduto["Caminho_Foto"]}/produto/fotos/{$dadosProduto['Codigo']}/original/{$dadosProduto["Foto$i"]}"));
                        }
                    }
                }

                $midiaProduto = new MidiaProduto(
                    new ImagensProduto($imagensProduto),
                    new VideoProduto("")
                );
                $categoriasProduto = [new CategoriaProdutoLojaDTO((int)$dadosProduto['Id_Categoria_Marketplace'])];
                if($dadosProduto['Id_Subcategoria_Marketplace'] != null) {
                    array_push($categoriasProduto, new CategoriaProdutoLojaDTO((int)$dadosProduto['Id_Subcategoria_Marketplace']));
                }
                $produto = new Produto(
                    isoToUtf8($dadosProduto['Titulo']),
                    "P",
                    "A",
                    $dadosProduto['Qtd_Produto_Filho'] > 0 ? "V" : "S",
                    isoToUtf8($dadosProduto['Descricao']),
                    $midiaProduto,
                    $dadosProduto["Peso_Bruto"] > 0 ? $dadosProduto["Peso_Bruto"] : 0.01,
                    new Dimensao(
                        $dadosProduto['Largura'] > 0 ? $dadosProduto["Largura"] : 0.01,
                        $dadosProduto["Altura"] > 0 ? $dadosProduto["Altura"] : 0.01,
                        0.01
                    ),
                    $dadosProduto['Fabricante'] ?? isoToUtf8("No informado"),
                    $dadosProduto['Gtin'],
                    $dadosProduto['Fornecedor'],
                    $dadosProduto['Codigo'],
                    $dadosProduto['Preco1'],
                    new CategoriaPaiProduto($dadosProduto['Id_Categoria_Marketplace']),
                    new ProdutoEstoque($dadosProduto['Estoque_Minimo'], $dadosProduto['Estoque_Maximo']),
                    $dadosProduto['Medida'],
                    false,
                    $dadosProduto['Peso_Liquido'],
                    1,
                    $dadosProduto['Obs'],
                    1,
                    $dadosProduto['Qtd_Caixa']
                );
                $cadastrarProduto =  $produto->cadastrar();
                if(isset($cadastrarProduto->id)) {
                    $con->query("UPDATE produto SET Id_Bling = '$cadastrarProduto->id' WHERE Id = '{$dadosProduto['Id']}'");
                    $fornecedorProduto = new FornecedorProduto(
                        new ProdutoFornecedorDTO($cadastrarProduto->id),
                        new FornecedorDTO((int)$dadosProduto['Id_Fornecedor_Marketplace'])
                    );
                    $cadastrarProdutoFornecedor = $fornecedorProduto->cadastrar();

                    if(isset($cadastrarProdutoFornecedor->id)) {
                        $con->query("INSERT INTO bling_produto_fornecedor SET Id = '$cadastrarProdutoFornecedor->id', Id_Produto_Bling = '$cadastrarProduto->id',
                            Id_Fornecedor_Bling = '{$dadosProduto['Id_Fornecedor_Marketplace']}'");
                        foreach($lojas as $loja) {
                            $produtoLoja = new ProdutoLoja(
                                "", //$dadosProduto['Codigo'],
                                new ProdutoLojaDTO($cadastrarProduto->id),
                                new LojaProdutoLojaDTO((int)$loja['Codigo']),
                                $dadosProduto['Preco1'],
                                null,
                                $categoriasProduto,
                                new FornecedorProdutoLojaDTO($cadastrarProdutoFornecedor->id)
                            );
                            $cadastrarProdutoLoja = $produtoLoja->cadastrar();
                            if(isset($cadastrarProdutoLoja->id)) {
                                $con->query("INSERT INTO bling_produto_loja SET Id_Produto_Bling = '$cadastrarProduto->id', Id_Produto_Loja = '$cadastrarProdutoLoja->id',
                                    Id_Loja = '{$loja['Id']}'");
                            }
                        }
                    }
                    $qtdProdutosExportados++;
                }
            }
            if($qtdProdutosExportados > 0) {?>
                <script>alert("Produtos exportados com sucesso");</script>
                <?php
            }
            break;
        case 'estoque':
            $locaisEstoque = $con->query("SELECT Id, Titulo, Id_Bling FROM local_estoque WHERE Ativo = 'Sim' AND Tipo IN('Vendas','Ambos')");
            $qtdEstoquesExportados = 0;

            while ($localEstoque = $locaisEstoque->fetch_assoc()) {
                if(!$localEstoque['Id_Bling'] || $localEstoque['Id_Bling'] == '') {
                    $deposito = new Deposito(isoToUtf8($localEstoque['Titulo']), 1, false, false);
                    $cadastrarDeposito = $deposito->cadastrar();

                    if(isset($cadastrarDeposito->id)) {
                        $con->query("UPDATE local_estoque SET Id_Bling = '$cadastrarDeposito->id' WHERE Id = '{$localEstoque['Id']}'");
                        $localEstoque['Id_Bling'] = $cadastrarDeposito->id;
                    }
                }
                $getEstoqueProdutos = $con->query("SELECT SUM(estoque.Qtd) AS Qtd, produto.Id_Bling AS Id_Produto_Bling FROM estoque
                    INNER JOIN produto ON produto.Id = estoque.Id_Produto
                    WHERE estoque.concluido = 'Sim' AND estoque.Id_Local_Estoque = '{$localEstoque['Id']}' AND (produto.Id_Bling IS NOT NULL AND produto.Id_Bling != '')
                    GROUP BY estoque.Id_Produto");
                $estoqueProdutos = $getEstoqueProdutos->fetch_all(MYSQLI_ASSOC);
                
                foreach ($estoqueProdutos as $estoqueProduto) {
                    $estoque = new Estoque(
                        new EstoqueProdutoDTO((int)$estoqueProduto['Id_Produto_Bling']),
                        new DepositoProdutoDTO((int)$localEstoque['Id_Bling']),
                        "B",
                        $estoqueProduto['Qtd']
                    );
                    $exportarEstoque = $estoque->cadastrar();
                    if(isset($exportarEstoque->id)) {
                        $qtdEstoquesExportados++;
                    }
                }
            }
            if($qtdEstoquesExportados > 0) {?>
                <script>alert("Estoque exportado com sucesso");</script>
                <?php
            }
            break;
    }
}
?>
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Gw - Gesto Web</title>
    <link rel="stylesheet" type="text/css" href="../../estilo/<?php echo SKIN ;?>/tableless.css" />
    <link rel="stylesheet" href="../assets/css/style.css">
    <script type="text/javascript" language="javascript" src="../../js/jquery.js"></script>
    <?php include '../../include/script_cabeca.php'; ?>
    <style>
        select {
            height: 30px;
            padding: 5px;
        }
        .dados {
            padding: 20px;
            border-radius: 6px;
            background: white;
            box-shadow: 0px 4px 25px -17px rgb(0, 0, 1);
        }
        .dados ol {
            padding-left: 20px;
            display: grid;
            gap: 8px;
        }
        .dados li label:hover {
            cursor: pointer;
            opacity: 0.7;
        }
        .dados ol input[type="radio"] {
            cursor: pointer;
        }
    </style>
</head>
<body>
    <div class="container envolve">
        <div class="d-flex flex-column align-content-center justify-content-center gap-3 w-80">
            <h2>Exportar Dados</h2>
            <form class="dados d-flex flex-column gap-2" method="POST">
                <div class="row gap-4">
                    <div class="d-flex flex-column" style="gap: .6rem;">
                        <span class="font-bold">Selecione uma opo</span>
                        <ol>
                            <li>
                                <label>
                                    <input type="radio" name="exportar" value="fornecedores">
                                    Fornecedores
                                </label>
                            </li>
                            <li>
                                <label>
                                    <input type="radio" name="exportar" value="categorias">
                                    Categorias
                                </label>
                            </li>
                            <li>
                                <label>
                                    <input type="radio" name="exportar" value="produtos">
                                    Produtos
                                </label>
                            </li>
                            <li>
                                <label>
                                    <input type="radio" name="exportar" value="estoque">
                                    Estoque
                                </label>
                            </li>
                        </ol>
                    </div>
                </div>
                <div>
                    <button class="botao">Enviar</button>
                </div>
            </form>
            <div class="row">
                <button class="botao" onclick="history.back(1)">Voltar</button>
            </div>
        </div>
    </div>
    <script>
        $(document).ready(function() {
            $("form.dados").submit(function(e) {
                if($(this).find("input[name=exportar]:checked").length < 1) {
                    e.preventDefault();
                    alert("Nenhuma opo selecionada");
                }
            })
        });
    </script>
</body>
</html>