<?php
// requisio da classe PHPlot
require_once 'phplot.php';

// Array com dados de Ano x ndice de fecundidade Brasileira 1940-2000
// Valores por dcada
$data = array(
             array('1940' , 6.2 ), 
             array('1950' , 6.2 ),
             array('1960' , 6.3 ),
             array('1970' , 5.8 ),
             array('1980' , 4.4 ),
             array('1991' , 2.9 ),
             array('2000' , 2.3 )
             );     
# Cria um novo objeto do tipo PHPlot com 500px de largura x 350px de altura                 
$plot = new PHPlot(500 , 350);     
  
// Organiza Grfico -----------------------------
$plot->SetTitle('Taxa de fecundidade no Brasil 1940-2000');
# Preciso de uma casa decimal
$plot->SetPrecisionY(1);
# tipo de Grfico em barras (poderia ser linepoints por exemplo)
$plot->SetPlotType("bars");
# Tipo de dados que preenchero o Grfico text(label dos anos) e data (valores de porcentagem)
$plot->SetDataType("text-data");
# Adiciona ao grfico os valores do array
$plot->SetDataValues($data);
// -----------------------------------------------
  
// Organiza eixo X ------------------------------
# Seta os traos (grid) do eixo X para invisvel
$plot->SetXTickPos('none');
# Texto abaixo do eixo X
$plot->SetXLabel("Fonte: Censo Demogrfico 2000, Fecundidade e Mortalidade Infantil, Resultados\n Preliminares da Amostra IBGE, 2002");
# Tamanho da fonte que varia de 1-5
$plot->SetXLabelFontSize(2);
$plot->SetAxisFontSize(2);
// -----------------------------------------------
  
// Organiza eixo Y -------------------------------
# Coloca nos pontos os valores de Y
$plot->SetYDataLabelPos('plotin');
// -----------------------------------------------
  
// Desenha o Grfico -----------------------------
$plot->DrawGraph();
// -----------------------------------------------
?>
<?php
/*
//incluindo a classe phplot
include('phplot-5.0.4/phplot.php');
//Matriz utilizada para gerar os graficos 
$data = array(
  array('Jan', 40, 2, 4), array('Fev', 30, 3, 4), array('Mar', 20, 4, 4),
  array('Abr', 10, 5, 4), array('Mai',  3, 6, 4), array('Jun',  7, 7, 4),
  array('Jul', 10, 8, 4), array('Ago', 15, 9, 4), array('Set', 20, 5, 4),
  array('Out', 18, 4, 4), array('Nov', 16, 7, 4), array('Dez', 14, 3, 4),
);
#Instancia o objeto e setando o tamanho do grafico na tela
$plot = new PHPlot(600,400);
#Tipo de borda, consulte a documentacao para ver opcoes
$plot->SetImageBorderType('plain');
#Tipo de grafico, nesse caso barras, existem diversos(pizza...)
$plot->SetPlotType('bars');
#Tipo de dados, nesse caso texto que esta no array
$plot->SetDataType('text-data');
#Setando os valores com os dados do array
$plot->SetDataValues($data);
#Titulo do grafico
$plot->SetTitle('Cadastro de usurios no Site');
# Legenda, nesse caso serao tres pq o array possui 3 valores que serao apresentados
$plot->SetLegend(array('Estudantes','Colunistas', 'Desenvolvedores'));
# Metodos utilizados para marcar labes, necessario mas nao se aplica neste ex. (manual) :
$plot->SetXTickLabelPos('none');
$plot->SetXTickPos('none');
#Gera o grafico na tela
$plot->DrawGraph();
*/
?>