<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL

$verificaPix = $con->query("SELECT * FROM tipo_pagamento WHERE Pix = 'Sim' LIMIT 1 ");
$retornoTipoPagamento = mysqli_fetch_assoc($verificaPix);

$_POST["chave"] = $retornoTipoPagamento["Chave_Pix"];
$_POST["beneficiario"] = $retornoTipoPagamento["Titular_Pix"];
$_POST["cidade"] = $retornoTipoPagamento["Cidade_Titular"];
$_POST["descricao"] = $retornoTipoPagamento["Descricao_Cobranca"];
$_POST["identificador"] = $retornoTipoPagamento["Identificador_Pix"];


if (!isset($_GET["doacao"])) {
   if (isset($_POST["chave"]) && isset($_POST["beneficiario"]) && isset($_POST["cidade"])) {
      $chave_pix = strtolower($_POST["chave"]);
      $beneficiario_pix = $_POST["beneficiario"];
      $cidade_pix = $_POST["cidade"];
      if (isset($_POST["descricao"])) {
         $descricao = $_POST["descricao"];
      } else {
         $descricao = '';
      }
      if ((!isset($_POST["identificador"])) || (empty($_POST["identificador"]))) {
         $identificador = "***";
      } else {
         $identificador = $_POST["identificador"];
         if (strlen($identificador) > 25) {
            $identificador = substr($identificador, 0, 25);
         }
      }
      $gerar_qrcode = true;
   }
}

if (is_numeric($_POST["valor"])) {
   $valor_pix = preg_replace("/[^0-9.]/", "", $_POST["valor"]);
} else {
   $valor_pix = "0.00";
}
?>

<!doctype html>
<html lang="pt-br">

<head>
    <title>Gerador de QR Code do PIX</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description"
        content="Gerador gratuito de QR Code e BR Code do Pix. Gere o seu QR Code ou a linha digitvel do Pix Copia e Cola.">
    <meta name="keywords" content="pix, qrcode pix, qr code, br code, brcode pix, pix copia e cola" />
    <!-- <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous"> -->
    <!-- <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script> -->
    <!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js" type="text/javascript"></script> -->
    <!-- <script src="https://kit.fontawesome.com/0f8eed42e7.js" crossorigin="anonymous"></script> -->
    <script>
    function copiar() {
        var copyText = document.getElementById("brcodepix");
        copyText.select();
        copyText.setSelectionRange(0, 99999); /* For mobile devices */
        document.execCommand("copy");
        document.getElementById("clip_btn").innerHTML = '<i class="fas fa-clipboard-check"></i>';
    }

    function reais(v) {
        v = v.replace(/\D/g, "");
        v = v / 100;
        v = v.toFixed(2);
        return v;
    }

    function mascara(o, f) {
        v_obj = o;
        v_fun = f;
        setTimeout("execmascara()", 1);
    }

    function execmascara() {
        v_obj.value = v_fun(v_obj.value);
    }
    $(function() {
        $('[data-toggle="tooltip"]').tooltip()
    })
    </script>
    <script async src="https://www.googletagmanager.com/gtag/js?id=G-E6M96X7Y2Y"></script>
    <script>
    window.dataLayer = window.dataLayer || [];

    function gtag() {
        dataLayer.push(arguments);
    }
    gtag('js', new Date());

    gtag('config', 'G-E6M96X7Y2Y');
    </script>
    <style>
    a {
        text-decoration: none;
    }

    p {
        text-align: center;
    }
    </style>
</head>

<body>
    <?php
   if ($gerar_qrcode) {
      include "phpqrcode/qrlib.php";
      include "funcoes_pix.php";
      $px[00] = "01";
      $px[26][00] = "br.gov.bcb.pix";
      $px[26][01] = $chave_pix;
      if (!empty($descricao)) {
         $tam_max_descr = 99 - (4 + 4 + 4 + 14 + strlen($chave_pix));
         if (strlen($descricao) > $tam_max_descr) {
            $descricao = substr($descricao, 0, $tam_max_descr);
         }
         $px[26][02] = $descricao;
      }
      $px[52] = "0000";
      $px[53] = "986";
      if ($valor_pix > 0) {
         $px[54] = $valor_pix;
      }
      $px[58] = "BR";
      $px[59] = $beneficiario_pix;
      $px[60] = $cidade_pix;
      $px[62][05] = $identificador;
      $pix = montaPix($px);
      $pix .= "6304";
      $pix .= crcChecksum($pix);
      $linhas = round(strlen($pix) / 120) + 1;
   ?>
    <p>
        
        <?php
      ob_start();
      QRCode::png($pix, null, 'M', 5);
      $imageString = base64_encode(ob_get_contents());
      ob_end_clean();
      echo '<img src="data:image/png;base64,' . $imageString . '"></p>';
   }
      ?>
</body>

</html>