<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once 'ver_cookie.php'; //Verifica se a sesso est ativa
// error_reporting(E_ALL);
// ini_set('display_errors', 'On');
include "app/model/Categoria.php";
include "app/model/Produto.php";
use App\Model\Categoria;
use App\Model\Produto;

if($_SERVER['REQUEST_METHOD']=="POST"){
    switch($_POST['tabela']){
        case "Categorias":
            $getCategorais = $con->query("SELECT Id, Titulo FROM categoria_produto WHERE Id_Ifood IS NULL AND Ifood='Sim'");
            $categorias = mysqli_fetch_all($getCategorais, MYSQLI_ASSOC);
            $qtdCategoriasCadastradas = 0;

            foreach($categorias as $categoria) {
                $cadastrarCategoria = Categoria::cadastrar([
                    "name"=> $categoria['Titulo'],
                    "externalCode"=> $categoria['Id'],
                    "template"=> "DEFAULT",
                    "status"=> "AVAILABLE"
                ]);
                if($cadastrarCategoria) {
                    $qtdCategoriasCadastradas++;
                }
            }
            echo $qtdCategoriasCadastradas > 0 ? "Categorias cadastradas" : "Nenhuma categoria cadastrada";
            break;
        case "Produtos":
            $getProdutos = $con->query("SELECT p.Id, p.Titulo, p.Descricao, p.Preco1, p.Caminho_Foto, p.Codigo, c.Id_Ifood Categoria_Ifood 
            FROM produto p 
            INNER JOIN categoria_produto c ON c.Id = p.Id_Categoria_Produto 
            WHERE p.Ifood='Sim' AND p.Id_Ifood IS NULL");
            $produtos = mysqli_fetch_all($getProdutos, MYSQLI_ASSOC);
            $qtdProdutosCadastrados = 0;

            foreach ($produtos as $produto) {
                $teste = base64_encode(file_get_contents(Produto::montaImagem($produto['Caminho_Foto'], $produto['Codigo'], $produto['Id'])));
                $cadastrarProduto = Produto::cadastrar([
                    "name"=> $produto['Titulo'],
                    "description"=> $produto['Descricao'],
                    "externalCode"=> $produto['Id'],
                    "image"=> Produto::montaImagem($produto['Caminho_Foto'], $produto['Codigo'], $produto['Id']),
                    "serving"=> "NOT_APPLICABLE",
                    "price"=> $produto['Preco1'],
                    "category"=> $produto['Categoria_Ifood']
                ]);
                if($cadastrarProduto) {
                    $qtdProdutosCadastrados++;
                }
            }
            echo $qtdProdutosCadastrados > 0 ? "Produtos cadastrados" : "Nenhum produto cadastrado";
        break;
    }
}
?>
<html>
<head>
<style>
    * {
        padding: 0;
        margin: 0;
        box-sizing: border-box;
    }
    body {
        background-color: #163758;
        font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
    }
    .titulo {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
        border: 1px solid #fff;
        border-radius: 5px;
        background-color: #FF8C00;
        color: #000;
        padding: 25px 10px;
        margin-bottom: 25px;
    }
    input[type=radio] {
        width: 18px;
        height: 18px;
        margin: auto;
        accent-color: #FF8C00;
    }
    button {
        padding: 1% 2%;
        cursor: pointer;
        width: 70px;
        height: 30px;
        border: none;
        border-radius: 4px;
    }
    .btn-cancelar {
        color: #fff;
        background-color: #dd4b39;
    }
    .btn-cancelar:hover {
        background-color: #c9302c;
    }
    ol li {
        color:white;
    }
</style>
</head>
<body>
    <div style="display:flex;flex-direction:column;align-items:center;padding-top:25px">
        <div class="titulo">
            <h1>Exportao Ifood</h1>
        </div>
        <span style="font-size: 24px;color:white">Selecione a opo que deseja Exportar:</span>
        <form id="exportar" method="post" action="" style="margin-top:20px;display:flex;flex-direction:column;align-items:center;width:90%;">
            <div style="display: flex;width: 70%;justify-content: center;border: solid 1px white;border-radius: 5px;padding: 10px;">
                <ol>
                    <li>
                        <input type="radio" name="tabela" value="Categorias" id="tabelaCategorias">
                        <label for="tabelaCategorias" style="font-size:19px">Categorias</label>
                    </li>
                    <li>
                        <input type="radio" name="tabela" value="Produtos" id="tabelaProdutos">
                        <label for="tabelaProdutos" style="font-size:19px">Produtos</label>
                    </li>
                </ol>
            </div>
            <div style="margin-top:25px;display:flex;justify-content:center;gap:1rem">
                <button type="submit" id="enviar">Enviar</button>
                <button class="btn-cancelar" type="button" onclick="window.location.href='transferencia_ifood.php'">Cancelar</button>
            </div>
        </form>
    </div>
    <script>
        document.getElementById("enviar").onclick = (event) => {
            event.target.innerHTML = "Aguarde...";
            event.target.disabled = true;
        }
    </script>
</body>
</html>