<?php
include '../../include/conecta.php';
include '../ver_cookie.php';
include '../funcoesPhp_novo.php';

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $observacao = addslashes(trim($_POST['observacao']));
    if ($observacao != '') {
        $horario = date("Y-m-d H:i:s");
        $con->query("INSERT INTO produto_observacao_restaurante SET Data_Cadastro = '$horario', Id_Usuario = '{$_COOKIE['Id']}', Observacao = '$observacao',
            Id_Unidade = '{$_COOKIE['Unidade']}'");
        if ($con->affected_rows > 0) {
            $lancamento = $con->query("SHOW TABLE STATUS FROM $dbname LIKE 'produto_observacao_restaurante'");
            $lancamento = mysqli_fetch_assoc($lancamento);
            $lancamento = $lancamento['Auto_increment'];

            logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], 'Cozinha', 'Cadastrou observao', $lancamento);
        } else {
            echo "<script>alert('No foi possvel cadastrar essa observao');</script>";
        }
    }
} elseif ($_SERVER['REQUEST_METHOD'] == 'DELETE') {
    $idObservacao = addslashes($_GET['id']);
    $con->query("DELETE FROM produto_observacao_restaurante WHERE Id = '$idObservacao'");

    if ($con->affected_rows > 0) {
        logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], 'Cozinha', 'Excluiu observao', $idObservacao);
    }

    echo json_encode([
        "status" => $con->affected_rows > 0 ? "ok" : "erro",
        "mensagem" => $con->affected_rows > 0 ? "" : mb_convert_encoding("No foi possvel excluir essa observao\n $con->error", 'UTF-8', 'ISO-8859-1')
    ]);
    exit;
}

?>
<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Observao Pr-definida</title>
    <style type="text/css">
        * {
            margin: 0;
            padding: 0;
            box-sizing: border-box;
        }

        body {
            background-color: #163758;
            font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
        }

        .container {
            display: flex;
            flex-direction: column;
            padding: 1.7rem .5rem;
            gap: 2rem;
        }

        .container>.titulo {
            top: 60;
            position: relative;
            display: flex;
            justify-content: center;
            align-items: center;
            border: 1px solid #ffffff;
            border-radius: 5px;
            background-color: #FF8C00;
            color: #000000;
            width: 100%;
            height: 86px;
        }

        .container>.conteudo {
            display: flex;
            flex-direction: column;
            color: #ffffff;
            gap: .7rem;
        }

        .conteudo>.observacoes {
            display: flex;
            flex-direction: column;
            background-color: #ffffff;
            border-radius: 4px;
            max-height: 250px;
            overflow: auto;
        }

        .observacoes>.observacao {
            display: flex;
            height: 35px;
            color: #000000;
            justify-content: space-between;
            align-items: center;
            padding: 5px;
        }

        .observacoes>.observacao:hover {
            background-color: #F5F3FF;
        }

        .observacoes>.observacao:not(:first-child) {
            border-top: solid 1px #C4C3F1;
        }

        .observacao>button {
            color: #FF0000;
            cursor: pointer;
            padding: 0 2px;
            border: none;
            background-color: transparent;
        }

        .observacao>button:hover {
            opacity: 0.7;
        }

        .observacao>button>img {
            width: 15px;
            height: 15px;
        }

        form.cadastro-observacao {
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        form.cadastro-observacao input[type="text"] {
            width: 80%;
            height: 40px;
            padding: 5px;
        }

        form.cadastro-observacao button {
            height: 40px;
            padding: 0 8px;
            cursor: pointer;
        }

        .rodape {
            display: flex;
            justify-content: center;
        }

        .rodape>button {
            color: #fff;
            height: 40px;
            padding: 0 20px;
            background-color: #dd4b39;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .rodape>button:hover {
            background-color: #c9302c;
        }
    </style>
</head>

<body>
    <div class="container">
        <div class="titulo">
            <h1>Observaes Pr-definidas</h1>
        </div>
        <div class="conteudo">
            <h3>Observaes Produtos</h3>
            <div class="observacoes">
                <?php
                $observacoes = $con->query("SELECT Id, Observacao FROM produto_observacao_restaurante WHERE Id_Unidade = '{$_COOKIE['Unidade']}'");
                $observacoes = $observacoes->fetch_all(MYSQLI_ASSOC);

                foreach ($observacoes as $observacao) { ?>
                    <div class="observacao" id-observacao="<?= $observacao['Id']; ?>">
                        <span><?= $observacao['Observacao']; ?></span>
                        <button type="button" class="excluir">
                            <img src="../../imagem/lixeira-delivery.png">
                        </button>
                    </div>
                <?php
                } ?>
            </div>
            <h3>Nova Observao</h3>
            <form class="cadastro-observacao" method="post">
                <input type="text" name="observacao" required minlength="2" maxlength="255">
                <button>Adicionar</button>
            </form>
        </div>
        <div class="rodape">
            <button onclick="location.href='./funcoes_comanda.php';">Voltar</button>
        </div>
    </div>
    <script src="../../js/jquery-3.3.1.min.js"></script>
    <script>
        $(".observacao .excluir").click(function() {
            let confirmacao = confirm("Deseja excluir esta observao?");
            if (confirmacao) {
                let observacao = $(this).parents(".observacao");
                let id = $(observacao).attr("id-observacao");

                $.ajax({
                    url: `cadastro_observacoes_produto.php?id=${id}`,
                    method: "DELETE",
                    data: {
                        id: id
                    },
                    success: function(response) {
                        let {
                            status,
                            mensagem
                        } = JSON.parse(response);
                        if (status == 'ok') {
                            $(observacao).remove()
                        } else {
                            alert(mensagem);
                        }
                    }
                }, );
            }
        });

        $(".cadastro-observacao").submit(function(e) {
            e.preventDefault();
            if ($(this).find("input[name=observacao]").val().trim() != '') {
                e.currentTarget.submit();
            }
        })
    </script>
</body>

</html>