<?php
include_once '../../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../ver_cookie.php'; //Verifica se a sesso est ativa
include_once '../funcoesPhp.php'; //Inclue a pgina con todas as funes a ser usada.


if ($_SERVER['REQUEST_METHOD'] == 'POST') {

    $mesaOrigem = addslashes($_POST['mesaOrigem']);
    $mesaDestino = addslashes($_POST['mesaDestino']);
    $motivo = utf8_decode($_POST['motivo']);

    if ($mesaOrigem == "Selecione") {
        echo json_encode(["status" => "erro", "mensagem" => "Mesa origem  obrigatria"]);
        return;
    }
    if ($mesaDestino == "Selecione") {
        echo json_encode(["status" => "erro", "mensagem" => "Mesa destino  obrigatria"]);
        return;
    }

    /**
     * Transferncia de itens
     *
     * @param int $mesaOrigem Id da mesa de origem
     * @param int $mesaDestino Id da mesa de destino
     * @param array $vendaOrigem
     * @param array $vendaDestino
     * @param array $itens Itens a serem transferidos
     * @param string $motivo Motivo da transferncia
     * @return int Nmero de itens transferidos
     */
    function transferirItens($mesaOrigem, $mesaDestino, $vendaOrigem, $vendaDestino, $itens, $motivo = "")
    {
        global $con;
        $taxas = $con->query("SELECT Taxa_Servico_Restaurante FROM opcao");
        $taxas = mysqli_fetch_assoc($taxas);
        $qtdItensTransferido = 0;

        foreach ($itens as $item) {
            $transferirItem = $con->query("UPDATE venda_produto SET Id_Venda = '" . $vendaDestino['Id'] . "', Motivo_Transferencia = '$motivo' WHERE Id='$item'");
            $itemTransferido = $transferirItem;

            if ($itemTransferido) {
                $totalVendaOrigem = 0;
                $totalVendaDestino = 0;

                //Mesa Origem
                $vendaProdutoOrigem = $con->query("SELECT SUM(Qtd) Qtd, Preco FROM venda_produto WHERE Id_Venda='" . $vendaOrigem['Id'] . "' GROUP BY Id_Produto, Preco");
                while ($produto = mysqli_fetch_assoc($vendaProdutoOrigem)) {
                    $totalVendaOrigem += ($produto['Qtd'] * $produto['Preco']);
                }

                if ($totalVendaOrigem == 0) {
                    $con->query("UPDATE venda SET Status='Cancelado', Motivo='Transferncia total de itens'
                    WHERE Id='" . $vendaOrigem['Id'] . "'");
                } else {
                    $descontoPercOrigem = ($totalVendaOrigem * $vendaOrigem['Desconto']) / 100;
                    $totalVendaOrigem -= ($descontoPercOrigem + $vendaOrigem['Desconto_Real']);

                    if ($vendaOrigem['Aplicar_Taxa_Couvert_Artistico'] == "Sim" && $vendaOrigem['Taxa_Couvert_Artistico'] > 0) {
                        $totalVendaOrigem += $vendaOrigem['Taxa_Couvert_Artistico'];
                    }

                    $taxaServicoOrigem = 0;
                    if ($vendaOrigem['Aplicar_Taxa_Servico_Restaurante'] == "Sim" && $taxas['Taxa_Servico_Restaurante'] > 0) {
                        $taxaServicoOrigem = $totalVendaOrigem / $taxas['Taxa_Servico_Restaurante'];
                        $totalVendaOrigem += $taxaServicoOrigem;
                        $taxaServicoOrigem = str_replace(".", "", $taxaServicoOrigem);
                        $taxaServicoOrigem = str_replace(",", ".", $taxaServicoOrigem);
                    }
                    $totalVendaOrigem = str_replace(".", "", $totalVendaOrigem);
                    $totalVendaOrigem = str_replace(",", ".", $totalVendaOrigem);
                    $con->query("UPDATE venda SET Valor_Original='$totalVendaOrigem', Taxa_Servico_Restaurante='$taxaServicoOrigem',
                    Motivo = CONCAT(Motivo, '//', '$motivo') WHERE Id='" . $vendaOrigem['Id'] . "'");
                }

                //Mesa Destino
                $vendaProdutoDestino = $con->query("SELECT SUM(Qtd) Qtd, Preco FROM venda_produto WHERE Id_Venda='" . $vendaDestino['Id'] . "' GROUP BY Id_Produto, Preco");
                while ($produto = mysqli_fetch_assoc($vendaProdutoDestino)) {
                    $totalVendaDestino += ($produto['Qtd'] * $produto['Preco']);
                }

                $descontoPercDestino = ($totalVendaDestino * $vendaDestino['Desconto']) / 100;
                $totalVendaDestino -= ($descontoPercDestino + $vendaDestino['Desconto_Real']);

                if ($vendaDestino['Aplicar_Taxa_Couvert_Artistico'] == "Sim" && $vendaDestino['Taxa_Couvert_Artistico'] > 0) {
                    $totalVendaDestino += $vendaDestino['Taxa_Couvert_Artistico'];
                }

                $taxaServicoDestino = 0;
                if ($vendaDestino['Aplicar_Taxa_Servico_Restaurante'] == "Sim" && $taxas['Taxa_Servico_Restaurante'] > 0) {
                    $taxaServicoDestino = $totalVendaDestino / $taxas['Taxa_Servico_Restaurante'];
                    $totalVendaDestino += $taxaServicoDestino;
                    $taxaServicoDestino = str_replace(".", "", $taxaServicoDestino);
                    $taxaServicoDestino = str_replace(",", ".", $taxaServicoDestino);
                }
                $totalVendaDestino = str_replace(".", "", $totalVendaDestino);
                $totalVendaDestino = str_replace(",", ".", $totalVendaDestino);
                $con->query("UPDATE venda SET Valor_Original='$totalVendaDestino', Taxa_Servico_Restaurante='$taxaServicoDestino' WHERE Id='" . $vendaDestino['Id'] . "'");

                $qtdItensTransferido++;
            }
        }

        return $qtdItensTransferido;
    }

    $vendaOrigem = $con->query("SELECT Id, Valor_Original, Aplicar_Taxa_Servico_Restaurante, Aplicar_Taxa_Couvert_Artistico,
    Taxa_Couvert_Artistico, Desconto, Desconto_Real,Lancamento FROM venda WHERE Id='$mesaOrigem' AND Status='Aberto'");
    $vendaDestino = $con->query("SELECT Id, Valor_Original, Aplicar_Taxa_Servico_Restaurante, Aplicar_Taxa_Couvert_Artistico,
    Taxa_Couvert_Artistico, Desconto, Desconto_Real,Lancamento FROM venda WHERE Id='$mesaDestino' AND Status='Aberto'");

    $vendaOrigem = mysqli_fetch_assoc($vendaOrigem);
    $vendaDestino = mysqli_fetch_assoc($vendaDestino);

    if ($_POST['tipoTransferencia'] == "itens") {
        $itens = $_POST['itens'];
        $qtdItensTransferidos = transferirItens($mesaOrigem, $mesaDestino, $vendaOrigem, $vendaDestino, $itens, $motivo);

        logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], "Comanda", "Transferncia - Origem", $vendaOrigem['Lancamento']);
        logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], "Comanda", "Transferncia - Destino", $vendaDestino['Lancamento']);

        echo json_encode(["qtdItensTransferidos" => $qtdItensTransferidos]);
        return;
    } else if ($_POST['tipoTransferencia'] == "mesa") {
        $getItens = $con->query("SELECT Id FROM venda_produto WHERE Id_Venda='" . $vendaOrigem['Id'] . "'");
        $itens = [];
        while ($item = mysqli_fetch_assoc($getItens)) {
            array_push($itens, $item['Id']);
        }
        $qtdItensTransferidos = transferirItens($mesaOrigem, $mesaDestino, $vendaOrigem, $vendaDestino, $itens, $motivo);

        logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], "Comanda", "Transferncia - Origem", $vendaOrigem['Lancamento']);
        logUsuario($_SERVER['REMOTE_ADDR'], $_COOKIE['Login'], $_COOKIE['Email'], $_COOKIE['Unidade'], "Comanda", "Transferncia - Destino", $vendaDestino['Lancamento']);

        echo json_encode(["qtdItensTransferidos" => $qtdItensTransferidos]);
        return;
    }
}
?>
<html>

<head>
    <style type="text/css">
        body {
            background-color: #163758;
            color: #fff;
            font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif !important;
        }

        .titulo {
            text-align: center;
            border: 1px solid #fff;
            border-radius: 5px;
            background-color: #FF8C00;
            color: #000;
            display: flex;
            width: 100%;
            justify-content: center;
        }

        .subtitulo {
            font-size: 20px;
        }

        .btn {
            padding: 1% 2%;
            cursor: pointer;
            box-shadow: none;
        }

        .btn_cancelar {
            color: fff;
            background-color: #dd4b39;
            border: none;
            border-radius: 4px;
        }

        .btn_cancelar:hover {
            color: #fff;
            background-color: #c9302c;
            border-color: #ac2925;
        }

        .btn_cadastar {
            border: none;
            border-radius: 4px;
        }

        .btn_cadastar:hover {
            background-color: #c1bebe;
        }

        select {
            width: 20%;
            height: 30px;
            margin-top: 10px;
        }

        .motivo {
            resize: none;
            margin-top: 10px;
            width: 80%;
            padding: 10px
        }

        .d-flex {
            display: flex;
        }

        .d-none {
            display: none;
        }

        .flex-column {
            flex-direction: column;
        }

        .justify-content-center {
            justify-content: center;
        }

        .align-items-center {
            align-items: center;
        }

        .w-100 {
            width: 100%;
        }

        .opcoes-transferencia {
            display: flex;
            width: 100%;
            justify-content: space-evenly;
            margin-top: 10px;
        }

        .opcoes-transferencia div input[type=radio] {
            width: 18px;
            height: 18px;
            margin: auto;
            accent-color: #FF8C00;
        }

        form select {
            width: 100%;
        }

        .origem-destino {
            width: max(30%, 200px);
            margin: auto;
        }

        #lista-itens {
            flex-wrap: wrap;
            margin: 5px;
        }

        #lista-itens .item {
            margin: 15px 15px 0 0;
            padding: 10px 20px;
            border-radius: 5px;
            width: 260px;
            background: #fff;
            color: #000;
        }

        #lista-itens .item input[type=number] {
            width: 60px;
            text-align: center;
        }
    </style>
</head>

<body>
    <br>
    <div class="d-flex flex-column align-items-center">
        <div class="titulo">
            <h1 style="font-weight: bold;">Transferncia</h1>
        </div>
        <br>
        <div class="d-flex justify-content-center" style="width:170px;margin-bottom: 40px">
            <div class="d-flex flex-column align-items-center w-100" style="margin-top: 20px">
                <span class="subtitulo">Transferir</span>
                <div class="opcoes-transferencia">
                    <div class="d-flex flex-column">
                        <input type="radio" name="transferir" id="transferirMesa" value="mesa">
                        <label for="transferirMesa">Comanda</lab>
                    </div>
                    <div class="d-flex flex-column">
                        <input type="radio" name="transferir" id="transferirItens" value="itens">
                        <label for="transferirItens">Itens</lab>
                    </div>
                </div>
            </div>
        </div>
        <div class="d-none w-100" id="transferenciaMesa">
            <form class="d-flex flex-column w-100">
                <div class="d-flex flex-column origem-destino">
                    <span class="subtitulo">Comanda Origem</span>
                    <select name="mesaOrigem">
                        <option disabled selected>Selecione</option>
                        <?php
                        $mesas = $con->query("SELECT venda.Id, venda.Numero_Comanda FROM venda
                        WHERE venda.Status='Aberto' ORDER BY venda.Numero_Comanda");
                        while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                            <option value="<?= $mesa['Id'] ?>"><?= $mesa['Numero_Comanda'] ?></option>
                        <?php } ?>
                    </select>
                </div>
                <div class="d-flex flex-column origem-destino" style="margin-top: 10px">
                    <span class="subtitulo">Comanda Destino</span>
                    <select name="mesaDestino">
                        <option disabled selected>Selecione</option>
                        <?php
                        $mesas = $con->query("SELECT venda.Id, venda.Numero_Comanda FROM venda
                            WHERE venda.Status='Aberto' ORDER BY venda.Numero_Comanda");
                        while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                            <option value="<?= $mesa['Id'] ?>"><?= $mesa['Numero_Comanda'] ?></option>
                        <?php } ?>
                    </select>
                </div>
                <div class="d-flex flex-column w-100 align-items-center" style="margin-top: 10px">
                    <span class="subtitulo">Motivo</span>
                    <br>
                    <textarea name="motivo" rows="3" class="motivo"></textarea>
                </div>
                <br>
                <div align="center" style="margin-top: 20px">
                    <button class="btn btn_cadastar">Salvar</button>
                    <button class="btn btn_cancelar" type="button" onclick="window.close();">Cancelar</button>
                </div>
                <input type="hidden" name="tipoTransferencia" value="mesa">
            </form>
        </div>
        <div class="d-none w-100" id="transferenciaItens">
            <form class="d-flex flex-column w-100">
                <div class="d-flex" style="justify-content:space-evenly;flex-wrap:wrap;">
                    <div class="d-flex flex-column origem-destino">
                        <span class="subtitulo">Comanda Origem</span>
                        <select name="mesaOrigem">
                            <option disabled selected>Selecione</option>
                            <?php
                            $mesas = $con->query("SELECT venda.Id, venda.Numero_Comanda FROM venda
                            WHERE venda.Status='Aberto' ORDER BY venda.Numero_Comanda");
                            while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                                <option value="<?= $mesa['Id'] ?>"><?= $mesa['Numero_Comanda'] ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="d-flex flex-column origem-destino">
                        <span class="subtitulo">Comanda Destino</span>
                        <select name="mesaDestino">
                            <option disabled selected>Selecione</option>
                            <?php
                            $mesas = $con->query("SELECT venda.Id, venda.Numero_Comanda FROM venda
                            WHERE venda.Status='Aberto' ORDER BY venda.Numero_Comanda");
                            while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                                <option value="<?= $mesa['Id'] ?>"><?= $mesa['Numero_Comanda'] ?></option>
                            <?php } ?>
                        </select>
                    </div>
                </div>
                <div class="d-flex flex-column" style="width: 80%;margin: 10px auto">
                    <span class="subtitulo">Produtos</span>
                    <div class="d-flex" id="lista-itens">
                    </div>
                </div>
                <div class="d-flex flex-column w-100 align-items-center" style="margin-top: 10px">
                    <span class="subtitulo">Motivo</span>
                    <br>
                    <textarea name="motivo" rows="3" class="motivo"></textarea>
                </div>
                <br>
                <div class="d-flex justify-content-center " style="margin-top: 20px">
                    <button class="btn btn_cadastar">Salvar</button>
                    <button class="btn btn_cancelar" type="button" onclick="window.close();">Cancelar</button>
                </div>
                <input type="hidden" name="tipoTransferencia" value="itens">
            </form>
        </div>
    </div>
    <div class="modal fade" id="modalObsItem" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" style="color:black">Observao do item</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close" style="margin-top:-25px">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p id="obsProduto" style="color:black;"></p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                    <!-- <button type="button" class="btn btn-primary">Understood</button> -->
                </div>
            </div>
        </div>
    </div>
    <script language="javascript" type="text/javascript" src="../../js/jquery-3.3.1.min.js"></script>
    <script>
        $("select[name=mesaOrigem]").change(function() {
            let mesaSelecionada = $(this).find("option:selected").attr("value");
            $("select[name=mesaDestino] option").removeAttr("disabled");
            $(`select[name=mesaDestino] option[value=${mesaSelecionada}]`).attr("disabled", true);
        });

        $("select[name=mesaDestino]").change(function() {
            let mesaSelecionada = $(this).find("option:selected").attr("value");
            $("select[name=mesaOrigem] option").removeAttr("disabled");
            $(`select[name=mesaOrigem] option[value=${mesaSelecionada}]`).attr("disabled", true);
        })

        $("input[name=transferir]").change(function() {
            $("form")[0].reset();
            $("form")[1].reset();

            if ($(this).val() == "mesa") {
                $("#transferenciaMesa").removeClass("d-none").addClass("d-flex");
                $("#transferenciaItens").removeClass("d-flex").addClass("d-none");
            } else {
                $("#lista-itens").html("");
                $("#transferenciaMesa").removeClass("d-flex").addClass("d-none");
                $("#transferenciaItens").removeClass("d-none").addClass("d-flex");
            }
        });

        $("#transferenciaItens form select[name=mesaOrigem]").change(function() {
            let idMesa = $(this).find("option:selected").val();
            $.post("produtos_comanda.php", {
                    idMesa
                },
                function(data) {
                    let itens = JSON.parse(data);
                    $("#lista-itens").html("")

                    itens.map(item => {
                        $("#lista-itens").append(`
                        <div class="item">
                            <input type="checkbox" name="itens[${item.Id}]" id="item-${item.Id}" value="${item.Id}">
                            <label for="item-${item.Id}" style="font-weight:normal;display:inline">${item.Titulo}</label>
                            <div class="d-flex flex-column">
                                <span>Qtd. Total: ${item.Qtd}</span>
                                <div class="d-flex" style="justify-content:space-between">
                                    <div>
                                        <span>Qtd: </span>
                                        <input type="number" value="1" min="1" max="${item.Qtd}">
                                    </div>
                                    <div>
                                        <a href="javascript:void(0)" data-toggle="modal" data-target="#modalObsItem" class="visualizarObs">
                                            <img src="../../imagem/lupa-arredondada.png" width="18px" height="18px">
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    `);
                    })
                })
        });

        $("body").on("click", ".visualizarObs", function() {
            let idVendaProduto = $(this).parents(".item").find("input[type=checkbox]").val();
            $.get("observacao_produto.php", {
                    idVendaProduto
                },
                function(data) {
                    let response = JSON.parse(data);
                    $("#obsProduto").html(response.Obs_Produto);
                })
        });

        $("form").submit(function(e) {
            e.preventDefault();
            if ($(this).find("select[name=mesaOrigem]").find("option:selected").val() == "Selecione") {
                alert("Selecione a mesa de origem");
                return;
            }
            if ($(this).find("select[name=mesaDestino]").find("option:selected").val() == "Selecione") {
                alert("Selecione a mesa de destino");
                return;
            }

            if ($(this).find("input[name=tipoTransferencia]").val() == "itens") {
                let produtosMarcados = Array.from($(this).find("input[type=checkbox]")).filter(produto => produto.checked);
                if (produtosMarcados.length == 0) {
                    alert("Selecione no mnimo um item");
                    return;
                }
            }

            $.ajax({
                method: "POST",
                data: $(this).serialize(),
                success: function(data) {
                    let response = JSON.parse(data);
                    alert(`${response.qtdItensTransferidos} ${response.qtdItensTransferidos > 1 ? 'itens transferidos' : 'item transferido'}`);

                    if (response.qtdItensTransferidos > 0) {
                        window.opener.location.reload();
                        window.close();
                    }
                }
            });
        });
    </script>
    <link rel="stylesheet" type="text/css" href="../../tef/css/bootstrap.min.css">
    <script src="../../js/bootstrap-3.3.7/bootstrap.min.js"></script>
</body>

</html>