<?php
include '../../include/conecta.php';
include '../ver_cookie.php';
include '../funcoesPhp_novo.php';

$configOrganizacao = $con->query("SELECT Agrupar_Pedido_Cozinha FROM opcao");
$configOrganizacao = $configOrganizacao->fetch_assoc()['Agrupar_Pedido_Cozinha'];

if($configOrganizacao == 'Produto') {
    $sqlConfirmados = "SELECT cozinha_produto.Id, 
        cliente.Titulo Cliente, 
        venda.Lancamento, 
        venda.Numero_Comanda, 
        enda.Origem,
        venda.Data_Preparo, 
        venda.Hora_Prevista_Preparo, 
        mesa_cadastro.Titulo Numero_Mesa, 
        venda_produto.Obs_Produto, 
        produto.Titulo Produto
        FROM (SELECT Id,Id_Venda_Produto,Status FROM cozinha_produto) as cozinha_produto
        INNER JOIN (SELECT Id,Id_Produto,Id_Venda,Cancelado,Data_Cadastro_Upd FROM venda_produto) as venda_produto ON venda_produto.Id = cozinha_produto.Id_Venda_Produto
        INNER JOIN (SELECT Id,Titulo FROM produto) as produto on produto.Id = venda_produto.Id_Produto
        INNER JOIN (SELECT Id,Lancamento,Numero_Comanda,Origem,Data_Preparo,Hora_Prevista_Preparo,Id_Mesa,Data_Cadastro_Upd FROM venda) as venda ON venda.Id = venda_produto.Id_Venda";
}
else {
    $sqlConfirmados = "SELECT venda.Id, cliente.Titulo Cliente, venda.Lancamento, 
    venda.Numero_Comanda, venda.Origem, 
    venda.Data_Preparo,
    venda.Hora_Prevista_Preparo, mesa_cadastro.Titulo Numero_Mesa 
    FROM (SELECT Id,Lancamento,Numero_Comanda,Origem,Data_Preparo,Hora_Prevista_Preparo,Id_Mesa,Data_Cadastro_Upd FROM venda) as venda";
}

$sqlConfirmados .= " LEFT JOIN (SELECT Id,Titulo,Razao_Social FROM cliente) as cliente ON cliente.Id = venda.Id_Cliente
    LEFT JOIN (SELECT Id,Titulo FROM mesa_cadastro) as mesa_cadastro ON mesa_cadastro.Id = venda.Id_Mesa
    WHERE (venda.Origem = 'Comanda' OR venda.Origem = 'Mesa') AND venda.Data_Preparo <= DATE(NOW())";

if($configOrganizacao == 'Produto') {
    $sqlConfirmados .= " AND cozinha_produto.Status = 'Confirmado' AND venda_produto.Cancelado = 'No' ORDER BY venda_produto.Data_Cadastro_Upd";
}
else {
    $sqlConfirmados .= " AND (SELECT COUNT(cozinha_produto.Id) 
        FROM cozinha_produto 
        INNER JOIN venda_produto ON venda_produto.Id = cozinha_produto.Id_Venda_Produto
        WHERE cozinha_produto.Status = 'Confirmado' AND venda_produto.Id_Venda = venda.Id AND venda_produto.Cancelado = 'No') > 0
        ORDER BY venda.Data_Cadastro_Upd DESC, venda.Lancamento, TIME(venda.Hora_Prevista_Preparo)";
}
$getPedidos = $con->query($sqlConfirmados) or die($con->error);
$pedidos = $getPedidos->fetch_all(MYSQLI_ASSOC);

foreach($pedidos as $chave => $pedido) {
    $pedidos[$chave]['Horario'] = formatarData('d/m/Y H:i', "{$pedido['Data_Preparo']} {$pedido['Hora_Prevista_Preparo']}");
    $pedidos[$chave]['Cliente'] = mb_convert_encoding($pedido['Cliente'], 'UTF-8', 'ISO-8859-1');
    $pedidos[$chave]['Numero_Mesa'] = mb_convert_encoding($pedido['Numero_Mesa'], 'UTF-8', 'ISO-8859-1');
    $pedidos[$chave]['Obs_Produto'] = mb_convert_encoding($pedido['Obs_Produto'], 'UTF-8', 'ISO-8859-1');
    $pedidos[$chave]['Produto'] = mb_convert_encoding($pedido['Produto'], 'UTF-8', 'ISO-8859-1');
}

echo json_encode([
    "organizacao"=> $configOrganizacao,
    "pedidos"=> $pedidos
]);
?>