<?php
include_once '../../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../ver_cookie.php'; //Verifica se a sesso est ativa
include "../../integracao/ifood/load.php";

use Ifood\App\Model\Categoria;
use Ifood\App\Model\Produto;

if($_SERVER['REQUEST_METHOD'] == "POST") {
    $response = [];

    if($_POST['acao'] == "Importar") {
        switch ($_POST['transferir']) {
            case "Categorias":
                $importarCategorias = Categoria::importar();
                $response = [
                    "status"=> $importarCategorias > 0 ? "ok" : "erro",
                    "mensagem"=>  $importarCategorias > 0 ? "Categorias importadas" : "Nenhuma categoria importada"
                ];
                break;
            case "Produtos":
                $importarProdutos = Produto::importar();
                $response = [
                    "status"=> $importarProdutos > 0 ? "ok" : "erro",
                    "mensagem"=> $importarProdutos > 0 ? "Produtos importados" : "Nenhum produto importado"
                ];
                break;
        }
    } else {
        switch ($_POST['transferir']) {
            case "Categorias":
                $getCategorais = $con->query("SELECT Id, Titulo FROM categoria_produto WHERE Ativo = 'Sim' AND Id_Ifood IS NULL AND Ifood='Sim'");
                $categorias = $getCategorais->fetch_all(MYSQLI_ASSOC);
                $qtdCategoriasCadastradas = 0;
    
                foreach ($categorias as $categoria) {
                    $cadastrarCategoria = Categoria::cadastrar([
                        "name" => mb_convert_encoding($categoria['Titulo'], "UTF-8", "ISO-8859-1"),
                        "externalCode" => $categoria['Id'],
                        "template" => "DEFAULT",
                        "status" => "AVAILABLE"
                    ]);
                    if ($cadastrarCategoria) {
                        $qtdCategoriasCadastradas++;
                    }
                }
                $response = [
                    "status"=> $qtdCategoriasCadastradas > 0 ? "ok" : "erro",
                    "mensagem"=> $qtdCategoriasCadastradas > 0 ? "Categorias exportadas com sucesso" : "Nenhuma categoria exportada"
                ];
                break;
            case "Produtos":
                $getTabelaPreco = $con->query("SELECT Id_Tabela_Preco_Ifood FROM unidade WHERE Id = '{$_COOKIE['Unidade']}'");
                $idTabelaPreco = $getTabelaPreco->fetch_assoc()['Id_Tabela_Preco_Ifood'];
                $tabelaPreco = $con->query("SELECT Valor FROM produto_tabela WHERE Id = '$idTabelaPreco'");
                $tabelaPreco = (int)$tabelaPreco->fetch_assoc()['Valor'];
                $getProdutos = $con->query("SELECT produto.Id, produto.Titulo, produto.Descricao_Ifood, produto.Preco$tabelaPreco, produto.Foto, produto.Codigo,
                    produto.Caminho_Foto, produto.Peso_Liquido, produto.Obs, categoria_produto.Id_Ifood Categoria_Ifood FROM produto
                    INNER JOIN categoria_produto ON categoria_produto.Id = produto.Id_Categoria_Produto
                    WHERE produto.Ativo = 'Sim' AND produto.Ifood = 'Sim' AND produto.Id_Ifood IS NULL
                    AND categoria_produto.Ifood = 'Sim' AND categoria_produto.Id_Ifood IS NOT NULL") or die($con->error);
                $produtos = $getProdutos->fetch_all(MYSQLI_ASSOC);
                $qtdProdutosCadastrados = 0;
    
                foreach ($produtos as $produto) {
                    $imagemProduto = Produto::montaImagem($produto['Caminho_Foto'], $produto['Foto'], $produto['Codigo']);
                    $descricaoProduto = strlen($produto['Descricao_Ifood']) == 0 ? "." : mb_convert_encoding($produto['Descricao_Ifood'], "UTF-8", "ISO-8859-1");
                    $produtoIfood = [
                        "name"=> mb_convert_encoding($produto['Titulo'], "UTF-8", "ISO-8859-1"),
                        "description"=> $descricaoProduto,
                        "externalCode"=> $produto['Id'],
                        "image"=> $imagemProduto,
                        "serving"=> "NOT_APPLICABLE",
                        "price"=> (float)$produto["Preco$tabelaPreco"],
                        "category"=> $produto['Categoria_Ifood'],
                        "weight"=> [
                            "quantity"=> (float)$produto['Peso_Liquido'],
                            "unit"=> 'g'
                        ],
                        "multipleImages"=> [],
                    ];
                    if(!empty($produto['Obs'])) {
                        $produtoIfood["additionalInformation"] = mb_convert_encoding($produto['Obs'], "UTF-8", "ISO-8859-1");
                    }
                    $cadastrarProduto = Produto::cadastrar($produtoIfood);
                    if ($cadastrarProduto) {
                        $qtdProdutosCadastrados++;
                    }
                }
                $response = [
                    "status"=> $qtdProdutosCadastrados > 0 ? "ok" : "erro",
                    "mensagem"=> $qtdProdutosCadastrados > 0 ? "Produtos cadastrados" : "Nenhum produto cadastrado"
                ];
                break;
        }
    }
    echo json_encode($response);
}