<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once 'ver_cookie.php'; //Verifica se a sesso est ativa

switch ($_SERVER['REQUEST_METHOD']) {
    case 'GET':
        $exibir = isset($_GET['exibir']) ? addslashes($_GET['exibir']) : "Todas";
        $sql = "SELECT Id, Titulo, Qtd_Maxima_Pessoas, Qtd_Atual_Pessoas, Reservada, Ativo FROM mesa_cadastro ORDER BY Id";
        $sql .= $exibir == "Ativa" ? " WHERE Ativo='Sim'" : ($exibir == "Inativa" ? " WHERE Ativo='No'" : '');
        break;

    case 'POST':
        $idMesa = addslashes($_POST['idMesa']);
        $mesa = $con->query("SELECT Titulo, Ativo, Responsavel, Reservada, Qtd_Atual_Pessoas FROM mesa_cadastro WHERE Id = $idMesa");
        $mesa = mysqli_fetch_assoc($mesa);
        $mesa['Responsavel'] = utf8_encode($mesa['Responsavel']);
        $mesa['Ativo'] = utf8_encode($mesa['Ativo']);
        $mesa['Reservada'] = utf8_encode($mesa['Reservada']);
        echo json_encode($mesa && $mesa['Qtd_Atual_Pessoas'] == 0 ? $mesa : []);
        exit();
        break;

    case 'PUT':
        $request = file_get_contents('php://input');
        $request = json_decode($request);
        $idMesa = addslashes($request->idMesa);
        $ativo = utf8_decode($request->ativo);
        $reservada = utf8_decode($request->reservada);
        $responsavel = utf8_decode($request->responsavel);

        $con->query("SELECT Id FROM mesa_cadastro WHERE Id='$idMesa' AND Qtd_Atual_Pessoas = 0");
        if ($con->affected_rows > 0) {
            $con->query("UPDATE mesa_cadastro SET Ativo='$ativo', Reservada='$reservada', Responsavel='$responsavel' WHERE Id='$idMesa'");
            echo json_encode(["mesaAtualizada" => $con->affected_rows > 0 ? true : false]);
        } else {
            echo json_encode(["mesaAtualizada" => false, "erro" => json_encode($request)]);
        }
        exit();
        break;
}
?>
<html>

<head>
    <style type="text/css">
        body {
            background-color: #163758;
            font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
        }

        .titulo {
            text-align: center;
            border: 1px solid #fff;
            border-radius: 5px;
            background-color: #FF8C00;
            color: #000;
        }

        .btn-cancelar {
            color: #fff;
            background-color: #dd4b39;
            border-radius: 4px;
            border: none;
            padding: 5px 10px;
        }

        .btn-cancelar:hover {
            background-color: #c9302c;
        }

        .btn-cadastar:hover {
            background-color: #c1bebe;
        }

        .mesa {
            background-color: #fff;
            width: 150px;
            height: 60px;
            display: flex;
            flex-direction: column;
            align-items: flex-start;
            margin: 10px 5px 0 5px;
            position: relative;
            padding: 5px 10px;
            cursor: pointer;
            border: none;
            border-radius: 4px;
        }

        .mesa>img.status_mesa {
            width: 17px;
            height: 17px;
            position: absolute;
            right: 10px;
        }

        .mesa-ocupada {
            opacity: 0.6;
            color: #464641;
            cursor: not-allowed;
        }

        .inputs {
            display: flex;
        }
    </style>
</head>

<body>
    <br>
    <div>
        <div class="titulo">
            <center>
                <h1>Manuteno Mesa</h1>
            </center>
        </div>
        <br>
        <br>
        <form style="padding-left: 15px;margin-bottom:30px;display:flex;align-items:center" id="exibir">
            <h3 style="color:#ffff;">Exibir:</h3>
            <select name="exibir" style="height:30px;margin: 10px 0 0 20px;">
                <option value="Todas" <?= isset($_GET['exibir']) && $_GET['exibir'] == "Todas" ? "selected" : ""; ?>>Todas</option>
                <option value="Ativa" <?= isset($_GET['exibir']) && $_GET['exibir'] == "Ativa" ? "selected" : ""; ?>>Ativa</option>
                <option value="Inativa" <?= isset($_GET['exibir']) && $_GET['exibir'] == "Inativa" ? "selected" : ""; ?>>Inativa</option>
            </select>
        </form>
        <div>
            <div style="display:flex;justify-content:space-around;flex-wrap:wrap;">
                <?php
                $mesas = $con->query($sql);
                while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                    <button type="button" mesa="<?= $mesa['Id']; ?>" class="mesa <?= $mesa['Qtd_Atual_Pessoas'] > 0 ? 'mesa-ocupada' : ''; ?>">
                        <?php if ($mesa['Reservada'] == "Sim") { ?>
                            <img src="../imagem/mesa_reservada.png" class="status_mesa">
                        <?php } elseif ($mesa['Ativo'] == "No") { ?>
                            <img src="../imagem/mesa_inativa.png" class="status_mesa">
                        <?php } elseif ($mesa['Ativo'] == "Sim" && $mesa['Qtd_Atual_Pessoas'] == 0) { ?>
                            <img src="../imagem/mesa_disponivel.png" class="status_mesa">
                        <?php } elseif ($mesa['Qtd_Atual_Pessoas'] > 0) { ?>
                            <img src="../imagem/mesa_ocupada.png" class="status_mesa">
                        <?php } ?>
                        <span style="font-size: 17px;">Mesa <?= $mesa["Titulo"]; ?></span>
                        <span style="font-size:14px"><?= $mesa['Qtd_Maxima_Pessoas'] ?> lugares</span><br>
                    </button>
                <?php } ?>
            </div>
            <div style="display:flex;justify-content:center;margin-top: 30px;">
                <div style="width: 300px;display:flex;justify-content:space-evenly;">
                    <button class="btn-cancelar" onclick="window.location.href='funcoes_mesa_novo.php?acao=entrar'">Voltar</button>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="manutencaoMesa" tabindex="-1" aria-hidden="true">
        <div class="modal-dialog">
            <form class="modal-content">
                <div class="modal-header">
                    <h3 class="modal-title" id="tituloMesa">Mesa</h3>
                    <button type="button" class="close" style="margin-top: -30px" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div style="display:flex;justify-content:center">
                        <div>
                            <p>Ativa</p>
                            <div class="inputs">
                                <div>
                                    <input type="radio" name="ativo" id="ativoSim" value="Sim">
                                    <label for="ativoSim" style="font-weight:normal">Sim</label>
                                </div>
                                <div style="margin-left:30px">
                                    <input type="radio" name="ativo" id="ativoNao" value="No">
                                    <label for="ativoNao" style="font-weight:normal">No</label>
                                </div>
                            </div>
                        </div>
                        <div style="margin-left:50px">
                            <p>Reservada</p>
                            <div class="inputs">
                                <div>
                                    <input type="radio" name="reservada" id="reservaSim" value="Sim">
                                    <label for="reservaSim" style="font-weight:normal">Sim</label>
                                </div>
                                <div style="margin-left:30px">
                                    <input type="radio" name="reservada" id="reservaNao" value="No">
                                    <label for="reservaNao" style="font-weight:normal">No</label>
                                </div>
                            </div>
                        </div>
                        <div style="margin-left:50px;visibility:hidden;" id="responsavelReserva">
                            <p>Responsvel</p>
                            <input type="text" class="form-control" name="responsavel" maxlength="60">
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <input type="hidden" name="idMesa">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                    <button class="btn btn-primary" style="width: 80px;">Salvar</button>
                </div>
            </form>
        </div>
    </div>

    <link rel="stylesheet" type="text/css" href="../tef/css/bootstrap.min.css">
    <script src="../js/jquery-3.3.1.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous"></script>
    <script src="../js/bootstrap.min.js"></script>
    <script>
        $(".mesa").click(function() {
            if ($(this).hasClass("mesa-ocupada")) {
                alert("Mesa ocupada");
            } else {
                let idMesa = $(this).attr("mesa");
                $(`#manutencaoMesa form`)[0].reset();
                $(`#manutencaoMesa form #responsavelReserva`).css({
                    visibility: 'hidden'
                });
                $(`#manutencaoMesa form input[name=reservada][value=Sim]`).removeAttr('disabled');

                $.post("manutencao_mesa.php", {
                    idMesa
                }, function(response) {
                    let mesa = JSON.parse(response);

                    $("#manutencaoMesa").modal("show");
                    $("#manutencaoMesa form input[name=idMesa]").val(idMesa)
                    $("#manutencaoMesa #tituloMesa").html(`Mesa ${mesa.Titulo}`);
                    $(`#manutencaoMesa form input[name=ativo][value=${mesa.Ativo}]`).prop("checked", true);
                    $(`#manutencaoMesa form input[name=reservada][value=${mesa.Reservada}]`).prop("checked", true);
                    $(`#manutencaoMesa form input[name=responsavel]`).val(mesa.Responsavel);

                    if (mesa.Reservada == "Sim") {
                        $(`#manutencaoMesa form #responsavelReserva`).css({
                            visibility: 'visible'
                        });
                    }
                    if (mesa.Ativo == "No") {
                        $(`#manutencaoMesa form input[name=reservada][value=Sim]`).attr('disabled', true);
                    }
                })
            }
        });

        $(`#manutencaoMesa form input[name=reservada]`).change(function() {
            if ($(this).val() == "Sim") {
                $(`#manutencaoMesa form #responsavelReserva`).css({
                    visibility: 'visible'
                });
            } else {
                $(`#manutencaoMesa form #responsavelReserva`).css({
                    visibility: 'hidden'
                });
                $(`#manutencaoMesa form input[name=responsavel]`).val('');
            }
        });

        $(`#manutencaoMesa form input[name=ativo]`).change(function() {
            if ($(this).val() == "No") {
                $(`#manutencaoMesa form input[name=reservada][value=No]`).prop('checked', true);
                $(`#manutencaoMesa form input[name=reservada][value=Sim]`).attr('disabled', true);
                $(`#manutencaoMesa form #responsavelReserva`).css({
                    visibility: 'hidden'
                });
                $(`#manutencaoMesa form input[name=responsavel]`).val('');
            } else {
                $(`#manutencaoMesa form input[name=reservada][value=Sim]`).removeAttr('disabled');
            }
        });

        $(`#manutencaoMesa form`).submit(function(event) {
            event.preventDefault();
            let idMesa = $(this).find("input[name='idMesa']").val();
            let ativo = $(this).find("input[name='ativo']:checked").val();
            let reservada = $(this).find("input[name='reservada']:checked").val();
            let data = JSON.stringify({
                idMesa,
                ativo,
                reservada,
                responsavel: $(this).find("input[name='responsavel']").val(),
            });

            $.ajax({
                method: 'PUT',
                data: data,
                success: function(data) {
                    let response = JSON.parse(data);
                    if (response.mesaAtualizada) {
                        $("#manutencaoMesa").modal("hide");
                        let mesa = $(`.mesa[mesa=${idMesa}]`)[0];
                        if (reservada == "Sim") {
                            $(mesa).find(".status_mesa").attr("src", "../imagem/mesa_reservada.png");
                        } else {
                            switch (ativo) {
                                case "Sim":
                                    $(mesa).find(".status_mesa").attr("src", "../imagem/mesa_disponivel.png");
                                    break;
                                case "No":
                                    $(mesa).find(".status_mesa").attr("src", "../imagem/mesa_inativa.png");
                                    break;
                            }
                        }
                        window.opener.location.reload();
                    }
                }
            })
        });

        $("form#exibir select[name=exibir]").change(function() {
            $("form#exibir").submit();
        })
    </script>
</body>

</html>