<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once 'menu_movimento.php';
include_once 'ver_cookie.php'; //Verifica se a sesso est ativa
include_once 'funcoesPhp.php'; //Inclue a pgina con todas as funes a ser usada.
?>
<html>
<head>
    <style type="text/css">
        body {
            background-color: #163758;
            color: #fff;
            font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif !important;
        }

        .titulo {
            text-align: center;
            border: 1px solid #fff;
            border-radius: 5px;
            background-color: #FF8C00;
            color: #000;
            display: flex;
            width: 100%;
            justify-content: center;
        }

        .subtitulo {
            font-size: 20px;
        }

        .btn {
            padding: 1% 2%;
            cursor: pointer;
            box-shadow: none;
        }

        .btn_cancelar {
            color: fff;
            background-color: #dd4b39;
            border: none;
            border-radius: 4px;
        }

        .btn_cancelar:hover {
            color: #fff;
            background-color: #c9302c;
            border-color: #ac2925;
        }

        .btn_cadastar {
            border: none;
            border-radius: 4px;
        }

        .btn_cadastar:hover {
            background-color: #c1bebe;
        }

        select {
            width: 20%;
            height: 30px;
            margin-top: 10px;
        }

        .motivo {
            resize: none;
            margin-top: 10px;
            width: 80%;
            padding: 10px
        }

        .d-flex {
            display: flex;
        }

        .d-block {
            display: block;
        }

        .d-none {
            display: none;
        }

        .flex-column {
            flex-direction: column;
        }

        .justify-content-center {
            justify-content: center;
        }

        .align-items-center {
            align-items: center;
        }

        .w-100 {
            width: 100%;
        }

        .opcoes-transferencia {
            display: flex;
            width: 100%;
            justify-content: space-evenly;
            margin-top: 10px;
        }

        .opcoes-transferencia div input[type=radio] {
            width: 18px;
            height: 18px;
            margin: auto;
            accent-color: #FF8C00;
        }

        form select {
            width: 100%;
        }

        .origem-destino {
            width: max(30%, 200px);
            margin: auto;
        }

        #lista-itens {
            flex-wrap: wrap;
            margin: 5px;
        }

        #lista-itens .item {
            margin: 15px 15px 0 0;
            padding: 10px 20px;
            border-radius: 5px;
            width: 260px;
            background: #fff;
            color: #000;
        }

        #lista-itens .item input[type=number] {
            width: 60px;
            text-align: center;
        }
    </style>
</head>
<body>
    <div class="d-flex flex-column align-items-center">
        <div class="titulo">
            <h1 style="font-weight: bold;">Impresses Mesa</h1>
        </div>
        <br>
        <div class="d-flex justify-content-center" style="width:50%;margin-bottom: 40px">
            <div class="d-flex flex-column align-items-center w-100" style="margin-top: 20px">
                <span class="subtitulo">Tipo Impresso</span>
                <div class="opcoes-transferencia">
                    <div class="d-flex flex-column">
                        <input type="radio" name="impressao" id="impressaoParcial" value="parcial">
                        <label for="impressaoParcial">Parcial</lab>
                    </div>
                    <div class="d-flex flex-column">
                        <input type="radio" name="impressao" id="impressaoCozinha" value="cozinha">
                        <label for="impressaoCozinha">Cozinha</lab>
                    </div>
                    <div class="d-flex flex-column">
                        <input type="radio" name="impressao" id="impressaoDetalhada" value="detalhada">
                        <label for="impressaoDetalhada">Detalhada</lab>
                    </div>
                </div>
            </div>
        </div>
        <div class="d-none w-100" id="Imp_Parcial">
            <div align="center">
                <span class="subtitulo">Impresso Parcial</span>
                <br>
                <select name="" id="mesa" style="width:40%;font-size:16px;height:30px">
                    <option disabled selected>Selecione</option>
                    <?php
                    $mesas = $con->query("SELECT Id, Titulo FROM mesa_cadastro WHERE Qtd_Atual_Pessoas > 0 ORDER BY Id");
                    while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                        <option value="<?= $mesa['Id'] ?>">Mesa <?= $mesa['Titulo'] ?></option>
                    <?php } ?>
                </select>
            </div>
            <div align="center" class="w-100" style="margin-top: 20px;">
                <button class="btn btn_cadastar" id="imprimir_parcial">Imprimir</button>
                <button class="btn btn_cancelar" onclick="window.close();">Cancelar</button>
            </div>
        </div>
        <div class="d-none w-100" id="Imp_Cozinha">
            <div align="center">
                <span class="subtitulo">Impresso Cozinha</span>
                <br>
                <select name="" id="comanda_cozinha" style="width:40%;font-size:16px;height:30px">
                    <option disabled selected>Selecione</option>
                    <?php
                    $mesas = $con->query("SELECT Id, Titulo FROM mesa_cadastro WHERE Qtd_Atual_Pessoas > 0 ORDER BY Id");
                    while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                        <option value="<?= $mesa['Id'] ?>">Mesa <?= $mesa['Titulo'] ?></option>
                    <?php } ?>
                </select>
            </div>
            <div align="center" class="w-100" style="margin-top: 20px;">
                <button class="btn btn_cadastar" id="imprimir_cozinha">Imprimir</button>
                <button class="btn btn_cancelar" onclick="window.close();">Cancelar</button>
            </div>
        </div>
        <div class="d-none w-100" id="Imp_Detalhada">
            <div align="center">
                <span class="subtitulo">Impresso Detalhada</span>
                <br>
                <select name="" id="comanda_detalhada" style="width:40%;font-size:16px;height:30px">
                    <option disabled selected>Selecione</option>
                    <?php
                    $mesas = $con->query("SELECT Id, Titulo FROM mesa_cadastro WHERE Qtd_Atual_Pessoas > 0 ORDER BY Id");
                    while ($mesa = mysqli_fetch_assoc($mesas)) { ?>
                        <option value="<?= $mesa['Id'] ?>">Mesa <?= $mesa['Titulo'] ?></option>
                    <?php } ?>
                </select>
            </div>
            <div align="center" class="w-100" style="margin-top: 20px;">
                <button class="btn btn_cadastar" id="imprimir_detalhada">Imprimir</button>
                <button class="btn btn_cancelar" onclick="window.close();">Cancelar</button>
            </div>
        </div>
    </div>
    <script language="javascript" type="text/javascript" src="../js/jquery-3.3.1.min.js"></script>
    <script>
        $("input[name=impressao]").change(function() {
            if ($(this).val() == "parcial") {
                $("#Imp_Parcial").removeClass("d-none").addClass("d-block");
                $("#Imp_Cozinha").removeClass("d-block").addClass("d-none");
                $("#Imp_Detalhada").removeClass("d-block").addClass("d-none");
            } else if ($(this).val() == "cozinha") {
                $("#Imp_Parcial").removeClass("d-block").addClass("d-none");
                $("#Imp_Cozinha").removeClass("d-none").addClass("d-block");
                $("#Imp_Detalhada").removeClass("d-block").addClass("d-none");
            } else {
                $("#Imp_Parcial").removeClass("d-block").addClass("d-none");
                $("#Imp_Cozinha").removeClass("d-block").addClass("d-none");
                $("#Imp_Detalhada").removeClass("d-none").addClass("d-block");
            }
        });

        let btnImprimir = document.getElementById('imprimir_parcial');
        btnImprimir.addEventListener('click', function() {
            let mesa = document.getElementById('mesa').value;
            window.open(`impressao_parcial_menu.php?mesa=${mesa}&parcial=Sim`, '_blank', 'width=400,height=600,top=20,left=250,scrollbars=yes');
            window.close();
        });

        let btnImprimir2 = document.getElementById('imprimir_cozinha');
        btnImprimir2.addEventListener('click', function() {
            let comanda2 = document.getElementById('comanda_cozinha').value;
            window.open(`impressao_cozinha.php?mesa=${comanda2}`, '_blank', 'width=400,height=600,top=20,left=250,scrollbars=yes');
            window.close();
        });

        let btnImprimir3 = document.getElementById('imprimir_detalhada');
        btnImprimir3.addEventListener('click', function() {
            let comanda3 = document.getElementById('comanda_detalhada').value;
            window.open(`impressao_mesa_detalhada.php?mesa=${comanda3}`, '_blank', 'width=400,height=600,top=20,left=250,scrollbars=yes');
            window.close();
        });
    </script>
</body>

</html>