$(document).ready(function() {
    $(".modal").on("click", function (e) {
        if(e.target.classList.contains("modal-dialog")) {
            $(this).find("input").val('');
            $(this).find(".modal-header > h3").html('');
            $(this).css({'display': 'none', 'z-index': -1});
        }
    });

    $("#cliente").on("keyup", async function(e) {
        let cliente = e.target.value;
        if(cliente.length >= 4) {
            $("#clientes").html('');
            $.post("./buscar_clientes.php", {cliente}, function(response) {
                let {clientes} = JSON.parse(response);

                clientes.map(cliente => {
                    $("#clientes").append(`
                        <option id-cliente="${cliente.Id}" value="${cliente.Codigo} : ${cliente.Titulo}">${cliente.Codigo} : ${cliente.Titulo}</option>
                    `)
                })
            })
        }
        else {
            $("#clientes").html('')
        }
    });

    $("#cliente").on("change", function(e) {
        let cliente = $(this).val();
        $("input[name=IdCliente]").val($(`#clientes option[value="${cliente}"]`).attr("id-cliente"));
    });

    $("#categoria").on("change", function(e) {
        let categoria = $(this).val();
        let idCliente = $("input[name=IdCliente]").val();
        $("#pesquisarProdutos").css('display', 'flex').html('');

        if(idCliente.length == 0) {
            alert("Indique o cliente");
            $(this).val('');
            return;
        }

        $.post("./buscar_produtos.php",
            {
                categoria,
                idCliente
            },
            function(response){
                let { produtos } = JSON.parse(response);
                produtos.map(produto => {
                    $("#pesquisarProdutos").append(`
                        <div class="produtoPesquisado" id-produto="${produto.Id}">
                            <div class="tituloProduto">
                                ${produto.Codigo} : ${produto.Titulo}
                            </div>
                            <div class="acoesProduto">
                                <span>R$ ${Number(produto.Preco).toLocaleString("pt-BR", {maximumFractionDigits: 2, minimumFractionDigits: 2})}</span>
                                <div class="qtdProduto">
                                    <button type="button" data-acao="subtrair">-</button>
                                    <input type="text" value="1" class="valorQtd">
                                    <button type="button" data-acao="somar">+</button>
                                </div>
                                <input type="checkbox">
                            </div>
                        </div>
                    `);
                })
        });
    });

    $("body").on("click", ".produtoPesquisado .qtdProduto > button[type=button]", function() {
        let qtdProduto = Number($(this).parents(".qtdProduto").find(".valorQtd").val());
        let acao = $(this).attr("data-acao");
        
        if(acao == "subtrair" && qtdProduto > 1 || acao == "somar") {
            qtdProduto =  acao == "subtrair" ? qtdProduto - 1 : qtdProduto + 1;
            $(this).parents(".qtdProduto").find(".valorQtd").val(qtdProduto);
        }
    });

    $("body").on("click", ".produtoPesquisado .acoesProduto > input[type=checkbox]", function() {
        let input = $(this);
        let idProduto = $(this).parents(".produtoPesquisado").attr("id-produto");
        let qtdProduto = $(this).parents(".produtoPesquisado").find(".valorQtd").val();
        let idCliente = $("input[name=IdCliente]").val();
        let idVenda = $("input[name=Codigo_Venda]").val();
        let idUnidade = $("#empresa").val();
        let lancamento = $("input[name=Lancamento]").val();
        let produtoAdicionado = $(`.bloco-produtos .card-produto[id-produto="${idProduto}"]`).length;

        if(produtoAdicionado) {
            $(this).parents(".produtoPesquisado").remove();
            alert("Produto j adicionado");
        }
        else {
            $.post("./criar_linha.php", {
                    idProduto,
                    idCliente,
                    qtdProduto,
                    idVenda,
                    idUnidade,
                    lancamento
                },
                function(response) {
                    let retorno = JSON.parse(response);
    
                    if(retorno.status == 'erro') {
                        input.prop('checked', false);
                        alert(retorno.mensagem);
                    }
                    else {
                        let venda = retorno.venda;
                        let produto = retorno.produto;
                        let totalPago = parseFloat($("#totalPago").attr("data-valor"));
                        let totalPendente = venda.total > totalPago ? venda.total - totalPago : 0;
                        let troco = totalPago > venda.total ? totalPago - venda.total : 0; 

                        $(".bloco-produtos").append(`
                            <div class="card-produto" id-venda-produto="${produto.vendaProduto}">
                                <div class="produto">${produto.codigo} : ${produto.titulo}</div>
                                <div class="qtd">${produto.qtd}</div>
                                <div class="preco">R$${produto.total}</div>
                            </div>
                        `);
                        input.parents(".produtoPesquisado").remove();

                        $("#totalVenda").attr('data-valor', venda.total).html(venda.total.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                        $("#valorPendente").html(totalPendente.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                        $("#troco").html(troco.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                    }
                }
            );
        }
    });

    $("body").on("click", ".card-produto", function() {
        let idVendaProduto = $(this).attr("id-venda-produto");

        $.get(`./buscar_informacoes_produto.php?idVendaProduto=${idVendaProduto}`,
            function(response) {
                let retorno = JSON.parse(response);
                if(retorno?.status) {
                    alert(retorno.mensagem);
                }
                else {
                    let {produto} = retorno;
                    $("#modalProduto .modal-header > h3").html(`${produto.Codigo} : ${produto.Titulo}`);
                    $("#modalProduto input[name=preco]").val(produto.Preco);
                    $("#modalProduto input[name=qtdProduto]").val(produto.Qtd);
                    $("#modalProduto input[name=desconto]").val(produto.Desconto);
                    $("#modalProduto input[name=descontoReal]").val(produto.Desconto_Real);
                    $("#modalProduto input[name=idVendaProduto]").val(idVendaProduto);
                    $("#modalProduto select[name=idTabelaPreco]").val(produto.Id_Tabela_Preco);
                    $("#modalProduto input[name=observacao]").val(produto.Obs_Produto);

                    if(parseFloat(produto.Qtd) <= 1) {
                        $("#modalProduto #quantidadeProduto button[data-sinal='-']").html("<img src='../../imagem/lixeira-delivery.png' id='excluirProduto'>");
                    }
                }
            }
        )
        $(".modal").css({'display': 'block', 'z-index': 1});
    });

    $("#fecharProduto").on("click", function() {
        $("#modalProduto").css({'display': 'none', 'z-index': -1});
    });

    $("#modalProduto select[name=idTabelaPreco]").on("change", function() {
        let idTabelaPreco = $(this).val();
        let idVendaProduto = $(this).parents("form").find("input[name=idVendaProduto]").val();

        $.get(`./preco_tabela_produto.php?idTabelaPreco=${idTabelaPreco}&idVendaProduto=${idVendaProduto}`,
            function(response) {
                let { Preco } = JSON.parse(response);
                $("#modalProduto input[name=preco]").val(Preco);
            }
        )
    });

    $("#quantidadeProduto button").click(function() {
        let sinal = $(this).attr("data-sinal");
        let botaoMenos = $("#quantidadeProduto button[data-sinal='-']");
        let quantidade = parseFloat($("#modalProduto input[name=qtdProduto]").val().replace(".", "").replace(",", "."));
        quantidade = sinal == "-" ? (quantidade - 1 > 0 ? quantidade - 1 : quantidade) : quantidade + 1;

        if($(this).find("#excluirProduto").length > 0) {
            let idVendaProduto = $("#modalProduto form input[name=idVendaProduto]").val();
            let cancelarProduto = confirm("Tem certeza que deseja remover esse item?");

            if (cancelarProduto) {
                $.post("./cancelar_produto.php",
                    {
                        idVendaProduto,
                    },
                    function(response) {
                        let { status, valorCancelado, mensagem } = JSON.parse(response);
                        if(status == "ok") {
                            let valorPago = parseFloat($("input[name=valorPago]").val().replace("R$", ""));
                            $(`.card-produto[id-venda-produto='${idVendaProduto}']`).remove();

                            if($(`.bloco-produtos .card-produto`).length > 0) {
                                $("input[name=valorPago]").val((valorPago - valorCancelado).toLocaleString('pt-BR', {minimumFractionDigits: 2, maximumFractionDigits: 2}));
                            }
                            else {
                                $("input[name=valorPago]").val('0,00');
                                // $("#tipoPagamento").val('');
                                // $()
                            }
                            $("#modalProduto").css({'display': 'none', 'z-index': -1});
                            $("#modalProduto form")[0].reset();
                        }
                        else {
                            alert(mensagem);
                        }
                    }
                )
            }
        } else {
            if(quantidade <= 1) {
                $(this).html("<img src='../../imagem/lixeira-delivery.png' id='excluirProduto'>");
            } else {
                if($(botaoMenos).find("#excluirProduto").length > 0) {
                    $(botaoMenos).html("<span>-</span>");
                }
            }
        }
        $("#modalProduto input[name=qtdProduto]").val(quantidade.toLocaleString("pt-BR", {maximumFractionDigits: 2}));
    });

    $("#modalProduto #formSalvarProduto").on("submit", function(e) {
        e.preventDefault();
        let data = $(this).serialize();
        let form = $(this);

        $.post("./atualizar_venda_produto.php", data, function(response) {
            let { status, mensagem, venda } = JSON.parse(response);
            
            if(status == 'erro') {
                alert(mensagem);
            }
            else {
                let idVendaproduto = $(form).find("input[name=idVendaProduto]").val();
                let novoPreco = Number($(form).find('input[name=preco]').val().replace('.', '').replace(',', '.'));
                let novaQtd = Number($(form).find('input[name=qtdProduto]').val().replace('.', '').replace(',', '.'));
                let percentualDesconto = Number($(form).find('input[name=desconto]').val().replace('.', '').replace(',', '.'));
                let novoTotalProduto = novaQtd * novoPreco;
                let descontoPercentual = percentualDesconto > 0 ? (novoTotalProduto * percentualDesconto) / 100 : 0;
                let descontoReal = Number($(form).find('input[name=descontoReal]').val().replace('.', '').replace(',', '.'));
                novoTotalProduto -= descontoPercentual + descontoReal;
                let cardProduto = $(`.card-produto[id-venda-produto="${idVendaproduto}"]`);

                let totalPago = parseFloat($("#totalPago").attr("data-valor"));
                let totalPendente = venda.total > totalPago ? venda.total - totalPago : 0;
                let troco = totalPago > venda.total ? totalPago - venda.total : 0; 

                $(cardProduto).find(".qtd").html($(form).find('input[name=qtdProduto]').val());
                $(cardProduto).find(".preco").html(novoTotalProduto.toLocaleString("pt-BR", {style: "currency", currency: "BRL"}));

                $("#totalVenda").attr('data-valor', venda.total).html(venda.total.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                $("#valorPendente").html(totalPendente.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                $("#troco").html(troco.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
                
                $("#modalProduto").css({'display': 'none', 'z-index': -1});
                $("#modalProduto input").val('');
                $("#modalProduto .modal-header > h3").html('');
            }
        });
    });

    $("#adicionarPagamento").click(function() {
        let botaoPagamento = $(this);
        let tipoPagamento = $("#tipoPagamento").val();
        let valorPago = parseFloat($("#valorPago").val().replace(".", "").replace(",", "."));
        
        if(tipoPagamento !== null && valorPago > 0) {
            $(botaoPagamento).attr("disabled", true);
            $.get(`../detalhes_tipo_pagamento.php?id=${tipoPagamento}`, function(response) {
                let { Titulo } = JSON.parse(response);
                let indicePagamento = $("#pagamentos .pagamento").length;
                let totalPago = parseFloat($("#totalPago").attr("data-valor")) + valorPago;
                let totalVenda = parseFloat($("#totalVenda").attr("data-valor"));
                let totalPendente = totalVenda - totalPago > 0 ? totalVenda - totalPago : 0;
                let troco = totalPago > totalVenda ? totalPago - totalVenda : 0; 
    
                $("#pagamentos").append(`
                    <div class="pagamento">
                        <span>${Titulo}</span>
                        <span>R$ ${valorPago.toLocaleString("pt-BR", {minimumFractionDigits: 2, maximumFractionDigits: 2})}</span>
                        <input name="pagamentos[${indicePagamento}][id]" value="${tipoPagamento}" type="hidden">
                        <input name="pagamentos[${indicePagamento}][valor]" value="${valorPago}" type="hidden">
                    </div>
                `);
                $("#tipoPagamento").val('Selecione');
                $("#valorPago").val('');
                $(botaoPagamento).removeAttr("disabled");
                
                $("#totalPago").attr("data-valor", totalPago).html((totalPago).toLocaleString("pt-BR", {style: "currency", currency: "BRL"}));
                $("#valorPendente").html(totalPendente.toLocaleString("pt-BR", {style: "currency", currency: "BRL"}));
                $("#troco").html(troco.toLocaleString("pt-BR", {style: 'currency', currency: "BRL"}));
            });
        }
    });
})

function gerarParcelas() {
    let idTipoPagamento = $("#tipoPagamento").val();
    let valorPago = $("input[name=valorPago]").val().replace("R$", "");

    $.post("../gerar_parcelas_pagamento.php", {
            idTipoPagamento,
            valorPago
        },
        function(data) {
            let response = JSON.parse(data);
            $(".parcelas").html("");

            if(response.erro) {
                alert(response.mensagem);
            }
            else {
                response.parcelas.forEach((parcela, index) => {
                    $(".parcelas").append(`
                        <div class="parcela">
                            <div class="vencimento-parcela">
                                <label>${index + 1} Vencimento</label>
                                <input type="text" value="${parcela.dataVencimento}" name="parcelas[${index}][dataVencimento]">
                            </div>
                            <div class="valor-parcela">
                                <label>Valor</label>
                                <input type="text" value="${parcela.valor}" name="parcelas[${index}][valor]">
                            </div>
                        </div>
                    `);
                });
            }
        }
    )
}