<?php
/**
 * Valida descontos do vendedor
 *
 * @param array $descontosVendedor
 * @param float $descontoPercentual Desconto a ser aplicado
 * @param float $descontoReal Desconto a ser aplicado
 * @param array $produtosVenda
 * @return bool
 */
function validarDesconto($descontosVendedor, $descontoPercentual, $descontoReal, $produtosVenda) : bool {
    if($descontosVendedor['Desconto_Pedido'] > 0 && $descontoPercentual > $descontosVendedor['Desconto_Pedido']) {
        return false;
    }
    if($descontoReal > 0) {
        foreach($produtosVenda as $produto) {
            $preco = $produto['Preco'] * $produto['Qtd'];
            if($preco > 0.01){
                if($descontoPercentual > 0) {
                    $preco -= ($preco * $descontoPercentual) / 100;
                }
                $descontoPermitido = $descontosVendedor['Desconto_Produto'] > 0 ? ($preco * $descontosVendedor['Desconto_Produto']) / 100 : ($preco - 0.01);
                $descontoReal = $descontoReal <= $descontoPermitido ? 0 : $descontoReal - $descontoPermitido;
            }
        }
        if($descontoReal > 0) {
            return false;
        }
    }
    else {
        if($descontoReal > 0) {
            return false;
        }
    }
    return true;
}
?>