<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include '../include/funcoesPhp.php';
include './funcoesPhp.php';

$getIdUnidade = $con->query("SELECT Id, Cnpj FROM unidade WHERE Sede = 'Matriz' ORDER BY Data_Cadastro");
$dadosUnidade = $getIdUnidade->fetch_assoc();
$idUnidade = $dadosUnidade['Id'];
$cnpjEmpresa = preg_replace("/[^0-9]/", "", $dadosUnidade['Cnpj']);
$qtdSliders = 6;
$qtdBannersPromocionais = 3;
$qtdBannersAvisos = 2;

if ($_SERVER['REQUEST_METHOD'] == "POST") {
    $qtdProdutosCadastrados = 0;

    if(!file_exists("../unidade/site")) {
        mkdir("../unidade/site", 0777, true);
    }
    $sliders = montarDadosArquivo("sliders");
    $bannersPromocionais = montarDadosArquivo("bannersPromocionais");
    $bannersAvisos = montarDadosArquivo("bannersAvisos");
    $cadastrarSliders = cadastrarDados($sliders, "Slide", $cnpjEmpresa);
    $cadastrarBannersPromocionais = cadastrarDados($bannersPromocionais, "Banner_Promocional", $cnpjEmpresa);
    $cadastrarBannersAvisos = cadastrarDados($bannersAvisos, "Banner_Aviso", $cnpjEmpresa);
    $qtdProdutosCadastrados += $cadastrarSliders + $cadastrarBannersPromocionais + $cadastrarBannersAvisos;

    logUsuario($_SERVER['REMOTE_ADDR'], $_SESSION['Login'], $_SESSION['Email'], $_SESSION['Unidade'], "Banner Site", "Cadastro");

    if($qtdProdutosCadastrados > 0) {
        echo "<script>alert('Dados atualizados com sucesso!');</script>";
    }
}
?>
<html>
<head>
    <title>Gw - Gesto Web</title>
    <?php include 'cabecalho.php'; ?>
    <link rel="stylesheet" href="./style.css">
</head>

<body>
    <div class="conteudo">
        <fieldset class="envolve">
            <legend>Banners</legend>
                <form class="d-flex flex-column gap-4" method="post" action="" enctype="multipart/form-data">
                    <div class="d-flex flex-column gap-2">
                        <h2 class="titulo-bloco">Sliders</h2>
                        <div class="sliders" data-imagem-padrao="../imagem/dimensoes_sliders.jpg">
                            <?php
                            $getSliders = $con->query("SELECT Foto, Ordem, Tipo FROM site_banner WHERE Tipo = 'Slide' ORDER BY Ordem");
                            $sliders = $getSliders->fetch_all(MYSQLI_ASSOC);
                            $qtdSlidersCadastrados = $getSliders->num_rows;

                            foreach($sliders as $indice => $slide) {?>
                                <div class="slide">
                                    <img src="../unidade/site/<?=$slide['Foto'];?>" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="slide_<?=$indice;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="sliders[<?=$indice;?>]" accept="image/*" id="slide_<?=$indice;?>">
                                    </div>
                                    <button type="button" class="btn-excluir">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[sliders][<?=$indice;?>][cadastrado]" value="true">
                                </div>
                                <?php
                            }
                            for($i = $qtdSlidersCadastrados + 1; $i <= $qtdSliders; $i++) {?>
                                <div class="slide">
                                    <img src="../imagem/dimensoes_sliders.jpg" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="slide_<?=$i;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="sliders[<?=$i;?>]" accept="image/*" id="slide_<?=$i;?>">
                                    </div>
                                    <button type="button" class="btn-excluir d-none">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[sliders][<?=$i;?>][cadastrado]" value="false">
                                </div>
                                <?php
                            }?>
                        </div>
                    </div>
                    <div class="d-flex flex-column gap-2">
                        <h2 class="titulo-bloco">Banners Promocionais</h2>
                        <div class="sliders" data-imagem-padrao="../imagem/dimensoes_banner_promocional.jpg">
                            <?php
                            $getBanners = $con->query("SELECT Foto, Ordem, Tipo FROM site_banner WHERE Tipo = 'Banner_Promocional' ORDER BY Ordem");
                            $banners = $getBanners->fetch_all(MYSQLI_ASSOC);
                            $qtdBennersCadastrados = $getBanners->num_rows;
                            
                            foreach($banners as $indice => $banner) {?>
                                <div class="slide">
                                    <img src="../unidade/site/<?=$banner['Foto'];?>" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="banner_promocional_<?=$indice;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="bannersPromocionais[<?=$indice;?>]" accept="image/*" id="banner_promocional_<?=$indice;?>">
                                    </div>
                                    <button type="button" class="btn-excluir">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[bannersPromocionais][<?=$indice;?>][cadastrado]" value="true">
                                </div>
                                <?php
                            }
                            for($i = $qtdBennersCadastrados + 1; $i <= $qtdBannersPromocionais; $i++) {?>
                                <div class="slide">
                                    <img src="../imagem/dimensoes_banner_promocional.jpg" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="banner_promocional_<?=$i;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="bannersPromocionais[<?=$i;?>]" accept="image/*" id="banner_promocional_<?=$i;?>">
                                    </div>
                                    <button type="button" class="btn-excluir d-none">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[bannersPromocionais][<?=$i;?>][cadastrado]" value="false">
                                </div>
                                <?php
                            }?>
                        </div>
                    </div>
                    <div class="d-flex flex-column gap-2">
                        <h2 class="titulo-bloco">Banners Avisos</h2>
                        <div class="sliders" data-imagem-padrao="../imagem/dimensoes_banner_aviso.jpg" style="grid-template-columns:repeat(2, 1fr)">
                            <?php
                            $getBanners = $con->query("SELECT Foto, Ordem, Tipo FROM site_banner WHERE Tipo = 'Banner_Aviso' ORDER BY Ordem");
                            $banners = $getBanners->fetch_all(MYSQLI_ASSOC);
                            $qtdBennersCadastrados = $getBanners->num_rows;

                            foreach($banners as $indice => $banner) {?>
                                <div class="slide">
                                    <img src="../unidade/site/<?=$banner['Foto'];?>" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="banner_aviso_<?=$indice;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="bannersAvisos[<?=$indice;?>]" accept="image/*" id="banner_aviso_<?=$indice;?>">
                                    </div>
                                    <button type="button" class="btn-excluir">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[bannersAvisos][<?=$indice;?>][cadastrado]" value="true">
                                </div>
                                <?php
                            }
                            for($i = $qtdBennersCadastrados + 1; $i <= $qtdBannersAvisos; $i++) {?>
                                <div class="slide">
                                    <img src="../imagem/dimensoes_banner_aviso.jpg" class="imagem-slide">
                                    <div class="form-group">
                                        <label for="banner_aviso_<?=$i;?>" class="file-input">
                                            <img src="../imagem/novo-arquivo.png" alt="icone arquivo"/>
                                            Escolher Arquivo
                                        </label>
                                        <input type="file" class="d-none" name="bannersAvisos[<?=$i;?>]" accept="image/*" id="banner_aviso_<?=$i;?>">
                                    </div>
                                    <button type="button" class="btn-excluir d-none">
                                        <img src="../imagem/lixeira-delivery.png" alt="">
                                    </button>
                                    <input type="hidden" name="cadastros[bannersAvisos][<?=$i;?>][cadastrado]" value="false">
                                </div>
                                <?php
                            }?>
                        </div>
                    </div>
                    <div class="d-flex justify-content-center w-100 gap-4" style="margin-top:50px">
                        <button type="button" class="botao align-self-start" type="button" value="Voltar" onclick="window.history.go(-1); return false">Voltar</button>
                        <button class="botao" type="submit">Salvar</button>
                    </div>
                </form>
        </fieldset>
    </div>
</body>
</html>