﻿var authenticationRequest = {
    // authenticationKey: 'D0553CA155C343C592CA87D29E6D1EA',
};

var checkouts;
var checkout;

var onAuthenticationSuccess = function (response) {
    // console.log('Autenticado com sucesso');
    // pesquisaPdv();
};

var onAuthenticationError = function (error) {
    console.log('Código: ' + error.reasonCode + '<br>' + error.reason);
    alert(error.reason);
};

var onPendingPayments = function (response) {
    console.log(response);

};
async function autenticar() {
    if(!authenticationRequest.authenticationKey) {
        let chaveAutenticacao;
        let path = window.location.pathname.split('/');
        let url = path[3] == 'comanda' ? "../../tef/chave_autenticacao.php" : "../tef/chave_autenticacao.php";

        await $.get(url, {}, function(data) {
            let response = JSON.parse(data);
            chaveAutenticacao = response.chave;
        })
        if(!chaveAutenticacao) {
            alert("Não foi possível realizar a autenticação");
            return;
        }
        authenticationRequest.authenticationKey = chaveAutenticacao;
        checkout = await CapptaCheckout.authenticate(authenticationRequest, onAuthenticationSuccess, onAuthenticationError, onPendingPayments);
    }
}

var multiplePaymentsSessionInProgress = false;

var onPaymentSuccess = function (response) {
    console.log(response);
};
var onPaymentError = function (error) {
    console.log(error);
};

function pagamentoDebito({valorVenda, chaveSolicitacao = "", pagamentoRealizado, erroPagamento}) {
    checkout.debitPayment({ amount: parseFloat(valorVenda), chaveSolicitacao }, pagamentoRealizado, erroPagamento);
}

function pagamentoCredito({valorVenda, tipoParcelamento, qtdParcelas, chaveSolicitacao = "", pagamentoRealizado, erroPagamento}) {
    var creditRequest = {
        amount: parseFloat(valorVenda),
        requestKey: chaveSolicitacao,
        installments: qtdParcelas,
        installmentType: tipoParcelamento
    };

    checkout.creditPayment(creditRequest, pagamentoRealizado, erroPagamento);
}

function cancelarPagamento({senhaAdm, codigoAdmTransacao, chaveSolicitacao = "", pagamentoCancelado, erroCancelar}) {

    var paymentReversalRequest = {
        administrativePassword: senhaAdm,
        administrativeCode: codigoAdmTransacao,
        requestKey: chaveSolicitacao
    };
    
    CapptaCheckout.paymentReversal(paymentReversalRequest, pagamentoCancelado, erroCancelar);
}

function resolvePendingTransaction() {
    var data = {
        administrativeCode: $('#resolvePendingAdministrativeCode').val(),
        action: parseInt($('#resolvePending input:checked').val())
    }

    const sucesso = (response) => {
        console.log(response)
    }

    var erro = function (error) {
        console.log(error);
    }

    checkout.resolvePendingTransaction(data, sucesso, erro);
}

function buscaTransacao(idTransacao) {
    var data = { requestKey: idTransacao }
    checkout.getPaymentTransaction(data, onPaymentSuccess, onPaymentError);
}

function solicitarDadosPinpad(tipoEntrada, successo, erro) {
    checkout.getPinpadInformation({ inputType: tipoEntrada }, successo, erro);
}

function pesquisaPdv() {
    var success = function (response) {
        checkouts = response.checkouts;
    };

    var error = function (response) {
        console.log(response.reason);
    };

    checkout.getCheckouts(success, error);
}

function setarPdv(cnpj) {
    var success = function (response, cnpj) {
        // console.log("PDV ativado com sucesso");
    };

    var error = function (response) {
        console.log(response);
    };

    checkout.setCheckout(cnpj, success, error);
}

function infoPdv(cnpj) {
    var checkout = buscaCnpjAtivo(checkouts, cnpj);
    console.log(`Estabelecimento: ${checkout.TradingName}<br>CNPJ: ${checkout.MerchantCnpj}<br>PDV: ${checkout.CheckoutNumber}`);
}

function buscaCnpjAtivo(checkouts, cnpj) {
    return checkouts.find(function (item) {
        return item.MerchantCnpj === cnpj;
    });
}