$(document).ready(function () {
    $("#Cnpj").focus();

    let produtosConfirmados = [];
    $("#form-inserir").submit(function (e) {
        e.preventDefault();
        produtosConfirmados = [];

        Array.from($(this).find("input[name*=qtd]")).map(input => {
            if ($(input).val() != '' && Number($(input).val().replace(",", "")) > 0) {
                let medida = $(input).parents(".div-table-row-1").find(".medida").html();
                let idProduto = $(input).parents(".div-table-row-1").find("input[name*=idProduto]").val();
                let nome = $(input).parents(".div-table-row-1").find(".produto").html();

                produtosConfirmados.push({
                    nome: nome,
                    medida: medida,
                    qtd: $(input).val(),
                    idProduto: idProduto,
                })
            }

        })

        produtosConfirmados.map((produto, indice) => {
            $("#resumoPedido").append(`
                <div class="div-table-row-3 d-flex justify-content-center">
                    <div class='div-table-col-3 font-1 '>${produto.nome}</div>
                    <div class='div-table-col-5 font-1'>${produto.medida}</div>
                    <div class='div-table-col-4 font-1'>${produto.qtd}</div>
                    <input type="hidden" name="idProduto-${indice}" value="${produto.idProduto}">
                </div>
            `)
        })
        $(this).find("input").attr("disabled", true);
    });
    $("#cadastro").click(function () {
        $(this).attr('disabled', true);

        $.post({
            url: "./registrarPedido.php",
            data: {
                produtosConfirmados
            },
        }, function (response) {
            $("#cadastro").removeAttr('disabled');
            let { status, mensagem } = JSON.parse(response);
            alert(mensagem);

            if (status == 'ok') {
                $("#form-inserir")[0].reset();
                $("#form-inserir input").removeAttr('disabled');
                $("#btn-inserir input[type=submit]").removeAttr('disabled');
                $("#resumoPedido .div-table-row-3").remove();
            }
        })
    });
})

var btn = document.querySelector("#refresh");
btn.addEventListener("click", function () {
    $("#resumoPedido .div-table-row-3").remove();
    $("#form-inserir").find("input").removeAttr("disabled");
});

$("#form-inserir input[name*=qtd]").keypress(function (e) {
    somenteNumeros(e)
})

function somenteNumeros(e) {
    let charCode = (e.which) ? e.which : e.keyCode
    if (charCode > 31 && ((charCode < 48 && (charCode != 44)) || charCode > 57))
        e.preventDefault();
}