<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
include_once '../menu_movimento.php';

$venda = listar("SELECT venda.Id,
    venda.Lancamento,
    venda.Status,
    venda.Data_Venda,
    venda.Obs as 'Obs_Venda',
    venda.Valor_Original,
    venda.Valor_Pago,
    venda.Desconto,
    venda.Desconto_Real,
    venda.Frete,
    venda.Valor_Frete,
    venda.Id_Unidade,
    venda.Texto_Proposta1,
    venda.Texto_Proposta2,
    venda.Texto_Proposta3,
    venda.Texto_Proposta4,
    cliente.Titulo as 'Cliente',
    cliente.Razao_Social,
    cliente.Email,
    cliente.Natureza,
    cliente.Cpf_Cnpj,
    cliente.Rua,
    cliente.Numero,
    cliente.Cep,
    cliente.Bairro,
    cliente.Estado,
    cliente.Fone1,
    cliente.Contato,
    cliente.Endereco,
    cliente.Ponto_Referencia,
    cliente.Obs as 'Obs_Cliente',
    cliente.Codigo,
    cliente.Razao_Social,
    cidade_ibge.Titulo as Cidade,
    funcionario.Titulo as 'Funcionario',
    vendedor.Titulo as 'Vendedor',
    tipo_pagamento.Titulo as 'Tipo_Pagamento'
    FROM venda
    LEFT JOIN (SELECT Id,Titulo,Email,Natureza,Cpf_Cnpj,Estadual,Rua,Numero,Cep,Bairro,Estado,Fone1,Obs,Id_Cidade,Razao_Social,Contato,Endereco,Ponto_Referencia,Codigo FROM cliente) as cliente ON cliente.Id = venda.Id_Cliente
    LEFT JOIN (SELECT Id,Titulo FROM cidade_ibge) as cidade_ibge ON cidade_ibge.Id = cliente.Id_Cidade
    LEFT JOIN (SELECT Id,Titulo FROM funcionario) as funcionario ON funcionario.Id = venda.Id_Funcionario
    LEFT JOIN (SELECT Id,Titulo FROM funcionario) as vendedor ON venda.Id_Vendedor = vendedor.Id
    LEFT JOIN (SELECT Id,Titulo FROM tipo_pagamento) as tipo_pagamento ON tipo_pagamento.Id = venda.Id_Tipo_Pagamento
    WHERE venda.Id = '" . $_GET["id_venda"] . "'
   order by venda.Lancamento DESC");


$_GET["Unidade"] = $venda[0]["Id_Unidade"];

?>
<?php ob_start(); /* Inicia o fluxo */ ?>
<html>

<head>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tabela_imp.css" />
    <script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
    <?php include '../include/script_cabeca.php'; ?>
    <script type="text/javascript" language="javascript" src="../js/script.js"></script>
    <script type="text/javascript" language="javascript" src="../js/meiomask/meiomask.js"></script>
    <script type="text/javascript" language="javascript" src="../js/meiomask/<?php
                                                                                if (PAIS == "USA") {
                                                                                    echo "mascaras-usa";
                                                                                } else {
                                                                                    echo "mascaras";
                                                                                }
                                                                                ?>.js"></script>
</head>

<body>
    <?php include "../include/cabecalho_pedido.php"; ?>
    <table width="100%">

        <tr>
            <td colspan="9" style='color:black;font-variant:small-caps;font-size: 18px; background-color:lightgray;' align="left">
                <b>Oramento - <?php echo $venda[0]["Lancamento"] . '/' . date('Y'); ?>
            </td>
        </tr>
    </table>
    <table width="100%">
        <tr>
            <td colspan="9" style='font-variant:small-caps;font-size: 12px'>
                Produto(s)
            </td>
        </tr>
        <tr>
            <td colspan="9" style='font-size: 12px' align="left">
                <span style='font-variant:small-caps;font-size: 10px'>Item</span>
            </td>
            <td colspan="2" style='font-size: 12px' align="right">
                <span style='font-variant:small-caps;font-size: 10px'>Total</span>
            </td>
        </tr>
        <?php
        $venda_pro = listar("SELECT DISTINCT venda_produto.Id,
                                        venda_produto.Preco as 'Preco_Venda',
 					                    venda_produto.Qtd as 'Qtd_Venda',
 					                    venda_produto.Desconto as 'Desconto_Venda',
                                        venda_produto.Desconto_Real,
 					                    produto.Titulo as 'Produto',
 					                    produto.Descricao,
                                        produto.Medida,
 					                    produto.Codigo,
                                        produto.Foto,
                                        produto.Tipo_Produto,
                                        local_estoque.Titulo as Local_Estoque
 					from venda_produto
 					left join (SELECT Id,Titulo,Descricao,Codigo,Medida,Foto,Tipo_Produto FROM produto) as produto ON produto.Id = venda_produto.Id_Produto
                                        left join (SELECT Id,Titulo FROM local_estoque) as local_estoque ON local_estoque.Id = venda_produto.Id_Local_Estoque
 					where venda_produto.Id_Venda = '" . $_GET["id_venda"] . "'
                    AND produto.Tipo_Produto = 'P'
                                        ORDER BY venda_produto.Data_Cadastro ");
        ?>
        <?php $x = 1;
        foreach ($venda_pro as $chave) {
        ?>
            <tr>
                <td colspan="9" style='font-size: 12px;' align="left">
                    <span style='font-variant:small-caps;font-size: 10px'><?php echo $chave["Codigo"] . ": " . $chave["Produto"]; ?></span>
                </td>
                <td colspan="2" style='font-size: 12px' align="right">
                    <span style='font-variant:small-caps;font-size: 10px'>
                        <?php echo number_format((($chave['Qtd_Venda'] * $chave['Preco_Venda']) - (($chave['Qtd_Venda'] * $chave['Preco_Venda']) * ($chave['Desconto_Venda'] / 100))) - $chave['Desconto_Real'], 2, ',', '.'); ?></span>
                </td>
            </tr>
        <?php
            $Total += (($chave["Preco_Venda"] * $chave["Qtd_Venda"]) -
                (($chave["Preco_Venda"] * $chave["Qtd_Venda"]) * ($chave["Desconto_Venda"] / 100))) - $chave['Desconto_Real'];
            $x++;
        }
        ?>
        <tr>
            <?php
            $cod_auto2 = mysqli_query($con, "SELECT tipo_pagamento.Titulo
                                                        FROM (SELECT Id,Id_Venda,Id_Tipo_Pagamento,Ordem FROM venda_tipo_pagamento) as venda_tipo_pagamento
                                                        LEFT JOIN (SELECT Id,Titulo FROM tipo_pagamento) as tipo_pagamento ON tipo_pagamento.Id = venda_tipo_pagamento.Id_Tipo_Pagamento
                                                        WHERE venda_tipo_pagamento.Id_Venda = '" . $_GET["id_venda"] . "'
                                                        ORDER BY venda_tipo_pagamento.Ordem");
            $ex_tip = '';
            while ($valor1 = mysqli_fetch_assoc($cod_auto2)) {
                $ex_tip .= $valor1["Titulo"] . " ,";
            }
            $ex_tip = substr($ex_tip, 0, -2);
            ?>
            <td colspan="11" style='font-size: 12px' align="right">
                <span style='font-variant:small-caps;font-size: 10px'><?php $tgProdutos = number_format((($Total - ($Total * ($venda[0]["Desconto"] / 100))) - $venda[0]["Desconto_Real"]), 2, ',', '.');
                                                                        echo "<b>Total Produto(s):   </b>" . $tgProdutos; ?></span>
            </td>
        </tr>
    </table>

    <?php
    $venda_servico = listar("SELECT DISTINCT venda_produto.Id,
                                        venda_produto.Preco as 'Preco_Venda',
 					                    venda_produto.Qtd as 'Qtd_Venda',
 					                    venda_produto.Desconto as 'Desconto_Venda',
                                        venda_produto.Desconto_Real,
 					                    produto.Titulo as 'Produto',
 					                    produto.Descricao,
                                        produto.Medida,
 					                    produto.Codigo,
                                        produto.Foto,
                                        produto.Tipo_Produto,
                                        local_estoque.Titulo as Local_Estoque
                                        FROM venda_produto
                                        LEFT JOIN (SELECT Id,Titulo,Descricao,Codigo,Medida,Foto,Tipo_Produto FROM produto) as produto ON produto.Id = venda_produto.Id_Produto
                                        LEFT JOIN (SELECT Id,Titulo FROM local_estoque) as local_estoque ON local_estoque.Id = venda_produto.Id_Local_Estoque
 					                    WHERE venda_produto.Id_Venda = '" . $_GET["id_venda"] . "'
                                        AND produto.Tipo_Produto = 'S'
                                        ORDER BY venda_produto.Data_Cadastro ");
    if (!empty($venda_servico)) {
    ?>
        <table width="100%">
            <tr>
                <td colspan="9" style='font-variant:small-caps;font-size: 12px'>
                    Servio(s)
                </td>
            </tr>
            <tr>
                <td colspan="8" style='font-size: 12px' align="left">
                    <span style='font-variant:small-caps;font-size: 10px'>Item</span>
                </td>
                <td colspan="2" style='font-size: 12px' align="right">
                    <span style='font-variant:small-caps;font-size: 10px'>Total</span>
                </td>
            </tr>

            <?php $y = 1;
            foreach ($venda_servico as $chave2) {
            ?>

                <tr>
                    <td colspan="8" style='font-size: 12px' align="left">
                        <span style='font-variant:small-caps;font-size: 10px'><?php echo $chave2["Codigo"] . ": " . $chave2["Produto"]; ?></span>
                    </td>
                    <td colspan="2" style='font-size: 12px'>
                        <span style='font-variant:small-caps;font-size: 10px' align="right">
                            <?php echo number_format((($chave2['Qtd_Venda'] * $chave2['Preco_Venda']) - (($chave2['Qtd_Venda'] * $chave2['Preco_Venda']) * ($chave2['Desconto_Venda'] / 100))) - $chave2['Desconto_Real'], 2, ',', '.'); ?></span>
                    </td>
                </tr>
            <?php
                $TotalServico += (($chave2["Preco_Venda"] * $chave2["Qtd_Venda"]) -
                    (($chave2["Preco_Venda"] * $chave2["Qtd_Venda"]) * ($chave2["Desconto_Venda"] / 100))) - $chave2['Desconto_Real'];
                $y++;
            }

            ?>
            <tr>
                <?php
                $cod_auto2 = mysqli_query($con, "SELECT tipo_pagamento.Titulo
                                                        FROM (SELECT Id,Id_Venda,Id_Tipo_Pagamento,Ordem FROM venda_tipo_pagamento) as venda_tipo_pagamento
                                                        LEFT JOIN (SELECT Id,Titulo FROM tipo_pagamento) as tipo_pagamento ON tipo_pagamento.Id = venda_tipo_pagamento.Id_Tipo_Pagamento
                                                        WHERE venda_tipo_pagamento.Id_Venda = '" . $_GET["id_venda"] . "'
                                                        ORDER BY venda_tipo_pagamento.Ordem");
                $ex_tip = '';
                while ($valor1 = mysqli_fetch_assoc($cod_auto2)) {
                    $ex_tip .= $valor1["Titulo"] . " ,";
                }
                $ex_tip = substr($ex_tip, 0, -2);
                ?>
                <td colspan="11" style='font-size: 12px' align="right">
                    <span style='font-variant:small-caps;font-size: 10px'><?php $tgServicos = number_format((($TotalServico - ($TotalServico * ($venda[0]["Desconto"] / 100))) - $venda[0]["Desconto_Real"]), 2, ',', '.');
                                                                            echo '<b>Total Servios</b>:   ' . $tgServicos ?></span>
                </td>
            </tr>
        </table>
    <?php } ?>
    <table width="100%">
        <tr>
            <td colspan="9">&nbsp;</td>
            <td colspan="2" style='font-variant:small-caps;font-size: 12px; background-color:lightgray;' align="right">
                <?php echo 'Total: ' . valor_exibir($Total + $TotalServico); ?>
            </td>
        </tr>
        <tr>
            <td colspan="11" style='font-variant:small-caps;font-size: 12px; background-color:white;' align="left">
                &nbsp; 
            </td>
        </tr>
        <tr>
            <td colspan="11" style='font-variant:small-caps;font-size: 12px; background-color:white;' align="left">
                &nbsp; 
            </td>
        </tr>
        <tr>
            <td colspan="11" style='font-variant:small-caps;font-size: 12px; background-color:lightgray;' align="left">
                Condies de Fornecimento
            </td>
        </tr>
        <tr>
            <td colspan="11" style='font-variant:small-caps;font-size: 12px;'>
                Pagamento: <?= $venda[0]["Texto_Proposta1"] ?><br>
                Validade da proposta: <?= $venda[0]["Texto_Proposta2"] ?><br>
                Prazo de entrega: <?= $venda[0]["Texto_Proposta3"] ?><br>
                <?= $venda[0]["Texto_Proposta4"] ?><br>
            </td>
        </tr>
        <br><br>
    </table>
    <table width="98%" align="left" style='font-variant:small-caps;font-size: 12px'>
        <tr>
            <td align="center"><?php echo $empresa[0]["Cidade"] . ', ' . data_exibir($venda[0]["Data_Venda"]) ?></td>
        </tr>
    </table>
    <br><br>
    <table width="98%" align="center" style='font-variant:small-caps;font-size: 12px'>
        <tr>
            <td align="left">___________________________________</td>
        </tr>
        <tr>
            <td align="left" style='font-variant:small-caps;font-size: 12px'>
                <?php echo $empresa[0]["Titulo"]; ?>
            </td>
        </tr>
    </table>
    <br><br>
    <table width="98%" align="center" style='font-variant:small-caps;font-size: 12px'>
        <tr>
            <td align="left">___________________________________</td>
        </tr>
        <tr>
            <td align="left" style='font-variant:small-caps;font-size: 12px'>
                <?php echo $venda[0]["Razao_Social"]; ?>
            </td>
        </tr>
    </table>
</body>

</html>
<?php
$html = ob_get_contents();
ob_end_clean();

include_once "../include/pdf_opcao.php";
?>