<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
include_once '../include/ver_sessao.php'; //Verifica se a sesso est ativa
include_once '../include/funcoesPhp.php';
include_once '../menu_movimento.php';


$condicoes = [];

if (!empty($_GET["De"])) {
    $de = data_banco($_GET["De"]) . " 00:00:00";
    $condicoes[] = "venda.Data_Venda >= '$de'";
}

if (!empty($_GET["Ate"])) {
    $ate = data_banco($_GET["Ate"]) . " 23:59:59";
    $condicoes[] = "venda.Data_Venda <= '$ate'";
}

$data = '';
if (!empty($condicoes)) {
    $data = "AND " . implode(' AND ', $condicoes);
}

?>
<html>

<head>
    <title>Gw - Gesto Web</title>
    <link rel="stylesheet" type="text/css" href="../estilo/<?php echo SKIN; ?>/tabela_imp.css" />
    <script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
    <?php include '../include/script_cabeca.php'; ?>
    <script type="text/javascript" language="javascript" src="../js/script.js"></script>
    <script type="text/javascript" language="javascript" src="../js/meiomask/meiomask.js"></script>
    <script type="text/javascript" language="javascript" src="../js/meiomask/<?php
    if (PAIS == "USA") {
        echo "mascaras-usa";
    } else {
        echo "mascaras";
    }
    ?>.js"></script>
    <script type="text/javascript" language="javascript">
        window.onload = function () {
            window.print();
        }
    </script>
</head>

<body>
    <table width="98%" align="center">
        <tr>
            <td>
                <?php include "../include/cabecalho_relatorio.php"; ?>
            </td>
        </tr>
        <tr>
            <td>
                <font face="verdana" size="2"><i>Painel Vendas</i></font>
            </td>
        </tr>

        <tr>
            <td>
                <table width="100%" style="margin-top: 1px;" class="tabela">
                    <tr class="azul-claro">
                        <td>Total Ordens Abertas</td>
                        <td>Total Peas Abertas</td>
                        <td>Total Servios Abertos</td>
                    </tr>
                    <?php
                    $color = ($color == "#F5F5F5") ? "#E8E8E8" : "#F5F5F5";
                    ?>
                    <tr bgcolor="<?php echo $color; ?>">
                        <td>
                            <?php
                            $pedidoAberto = mysqli_query($con, "SELECT COUNT(Id) AS Total_Pedidos FROM venda WHERE Status = 'Aberto' $data");
                            $retornoCaltuloPedido = mysqli_fetch_assoc($pedidoAberto);
                            echo $retornoCaltuloPedido['Total_Pedidos'];
                            ?>
                        </td>
                        <td>
                            <?php
                            $calculaPedido = mysqli_query($con, "SELECT COUNT(Peca) AS Total_Pedidos FROM venda_produto LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda WHERE venda.Status = 'Aberto' $data");
                            $retornoCaltuloPedido = mysqli_fetch_assoc($calculaPedido);
                            echo $retornoCaltuloPedido['Total_Pedidos'];
                            ?>
                        </td>
                        <td>
                            <?php
                            $calculaProdutos = mysqli_query($con, "SELECT SUM(Total) AS Total_Pedidos FROM (
                                                                            SELECT COUNT(Id_Produto) AS Total FROM venda_produto LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda WHERE venda.Status = 'Aberto' $data
                                                                            UNION ALL
                                                                            SELECT COUNT(Id_Produto2) AS Total FROM venda_produto LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda WHERE venda.Status = 'Aberto' $data
                                                                            UNION ALL
                                                                            SELECT COUNT(Id_Produto3) AS Total FROM venda_produto LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda WHERE venda.Status = 'Aberto' $data
                                                                        ) AS resultado");
                            $retornoProdutos = mysqli_fetch_assoc($calculaProdutos);
                            echo $retornoProdutos['Total_Pedidos'];
                            ?>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td>
                <table width="100%" class="tabela">
                    <?php
                    if ($_GET["Ok"]) {
                        $venda = mysqli_query($con, "SELECT venda.Id, 
                            venda.Lancamento,
                            venda.Status,
                            venda.Data_Venda,
                            venda.Data_Conclusao,
                            cliente.Codigo as Codigo_Cliente,
                            cliente.Titulo as Cliente,
                            cliente.Razao_Social,
                            funcionario.Titulo as 'Funcionario',
                            vendedor.Titulo as 'Marcador'
                            FROM venda
                            LEFT JOIN (SELECT Id,Id_Produto,Id_Venda FROM venda_produto WHERE 1=1 $cfop) as venda_produto ON venda_produto.Id_Venda = venda.Id
                            LEFT JOIN (SELECT Id,Titulo FROM funcionario) as vendedor ON vendedor.Id = venda.Id_Vendedor
                            LEFT JOIN (SELECT Id,Titulo FROM funcionario) as funcionario ON funcionario.Id = venda.Id_Funcionario
                            LEFT JOIN (SELECT Id,Codigo,Titulo,Razao_Social FROM cliente) as cliente ON venda.Id_Cliente = cliente.Id
                            WHERE 1=1
                            $data 
                            $usuario_p 
                            $Cliente 
                            $venda_produto 
                            $Usuario
                            group by venda.Lancamento
                            order by venda.Lancamento");
                        while ($chave = mysqli_fetch_assoc($venda)) {
                            ?>
                            <tr class="azul-claro">
                                <td>OS N: <b><?php echo $chave["Lancamento"] ?></b></td>
                                <td colspan="2">Cliente:
                                    <b>
                                        <?php
                                        if (CLIENTE_RAZAO_SOCIAL == 'Sim') {
                                            echo $chave["Codigo_Cliente"] . " : " . $chave["Razao_Social"];
                                        } else {
                                            echo $chave["Codigo_Cliente"] . " : " . $chave["Cliente"];
                                        }
                                        ?>
                                    </b>
                                </td>
                                <td>Data: <b><?php echo data_exibir($chave["Data_Venda"]) ?></b></td>
                                <td>Marcador: <b><?php echo htmlspecialchars($chave["Marcador"]) ?></b></td>
                            </tr>
                            <tr>
                                <td>Cdigo</td>
                                <td colspan="2">Produto</td>
                                <td>Pea</td>
                                <td>Qtd</td>
                            </tr>
                            <?php
                            $produto = mysqli_query($con, "SELECT produto.Titulo,
                            produto.Codigo,
                            venda_produto.Qtd,
                            produto.Titulo,
                            peca.Titulo Peca
                            from venda_produto
                            left join (SELECT Id,Titulo,Codigo FROM produto) as produto ON produto.Id = venda_produto.Id_Produto
                            left join (SELECT Id,Titulo,Codigo FROM produto) as peca ON peca.Id = venda_produto.Peca
                            where venda_produto.Id_Venda = '" . $chave["Id"] . "'
                            $venda_produto
                            ORDER BY venda_produto.Data_Cadastro");
                            $color = "#F5F5F5";
                            while ($valor = mysqli_fetch_assoc($produto)) {
                                $color = ($color == "#F5F5F5") ? "#E8E8E8" : "#F5F5F5";
                                ?>
                                <tr bgcolor="<?php echo $color; ?>">
                                    <td><?php echo $valor["Codigo"] ?></td>
                                    <td colspan="2"><?php echo $valor["Titulo"] ?></td>
                                    <td><?php echo $valor["Peca"] ?></td>
                                    <td><?php echo valor_exibir($valor["Qtd"]) ?></td>
                                </tr>
                                <?php
                            }
                        }
                    }
                    ?>
                </table>
            </td>
        </tr>
    </table>
</body>

</html>