<!DOCTYPE html>
<html lang="pt-br">

<head>
    <title>Consertos</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="../jg_login/css/style_site.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous">
        </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
        integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous">
        </script>

    <script>
        $(document).ready(function () {
            var timeout;

            $('#ordemServico').on('input', function () {
                var ordemServico = $(this).val();
                console.log('Ordem de servio digitada: ' + ordemServico);

                clearTimeout(timeout);
                if (ordemServico) {
                    timeout = setTimeout(function () {
                        $.ajax({
                            url: 'buscar_ordem.php',
                            method: 'POST',
                            data: { ordemServico: ordemServico },
                            dataType: 'json',
                            success: function (response) {
                                console.log(response);
                                if (response.success) {
                                    $('#formularioBusca').fadeIn();
                                    $('#ordemBusca').val(response.Lancamento);
                                    $('#mensagemErro').fadeOut();
                                } else {
                                    $('#formularioBusca').fadeOut();
                                    $('#mensagemErro').text('Ordem de servio no encontrada.').fadeIn();
                                }
                            },
                            error: function (xhr, status, error) {
                                console.log('Erro ao fazer a requisio: ' + error);
                                $('#formularioBusca').fadeOut();
                                $('#mensagemErro').text('Erro ao buscar ordem de servio.').fadeIn();
                            }
                        });
                    }, 300);
                } else {
                    $('#formularioBusca').fadeOut();
                    $('#mensagemErro').fadeOut();
                }
            });
        });
    </script>
</head>

<body>
    <div class="container align-middle">
        <div class="row">
            <div class="col text-center">
                <img src="../imagem/_login_logo.png" alt="Logo" class="imagem" style="width: 400px;">
                <h4>Atualizao de Servio</h4>
            </div>
        </div>

        <div class="row">
            <div class="col text-center">
                <form name="formLogin" method="post" action="">
                    <div class="form-group">
                        <label for="ordemServico">Informe a Ordem de Servio</label>
                        <input type="text" name="ordemServico" id="ordemServico"
                            value="<?php echo $_POST['ordemServico'] ?>" class="input form-control" required>
                    </div>
                </form>
                
                <p id="mensagemErro" style="color: red; display: none;"></p>

                <div id="formularioBusca" style="display: none;">
                    <hr>
                    <h5>Detalhes da Ordem de Servio</h5>
                    <form>
                        <?php
                        include('../include/conecta.php');
                        include_once '../include/funcoesPhp.php';
                        include_once '../menu_movimento.php';
                        include('../phpqrcode/qrlib.php');

                        $buscarPeca = mysqli_query($con, "SELECT venda_produto.Peca
                            FROM venda_produto
                            LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda
                            WHERE venda.Lancamento = '1'
                            LIMIT 1");

                        if (!$buscarPeca) {
                            die("Erro na consulta SQL: " . mysqli_error($con));
                        }


                        if (mysqli_num_rows($buscarPeca) > 0) {
                            while ($retornoPeca = mysqli_fetch_assoc($buscarPeca)) {
                                ?>
                                <div class="row">
                                    <div style="text-align: center;" class="col-md-12">
                                        <div class="form-group">
                                            <label for="Peca"><b>Pea</b></label>
                                            <div class="form-control" readonly>
                                                <b><?php echo $retornoPeca["Peca"]; ?></b>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <?php
                                    $buscarItensVendas = mysqli_query($con, "SELECT produto.Titulo as Servico,
                                                                                                    produto2.Titulo as Servico2,
                                                                                                    produto3.Titulo as Servico3,
                                                                                                    venda_produto.Peca,
                                                                                                    venda_produto.Id_Funcionario,
                                                                                                    venda_produto.Id_Funcionario2,
                                                                                                    venda_produto.Id_Funcionario3,
                                                                                                    venda_produto.Id,
                                                                                                    venda_produto.Id_Produto,
                                                                                                    venda_produto.Id_Produto2,
                                                                                                    venda_produto.Id_Produto3,
                                                                                                    venda_produto.Descricao_Servico,
                                                                                                    venda_produto.Descricao_Servico2,
                                                                                                    venda_produto.Descricao_Servico3,
                                                                                                    funcionario.Titulo as Profissional,
                                                                                                    funcionario2.Titulo as Profissional2,
                                                                                                    funcionario3.Titulo as Profissional3
                                                                                            FROM venda_produto
                                                                                            LEFT JOIN venda ON venda.Id = venda_produto.Id_Venda
                                                                                            LEFT JOIN produto ON produto.Id = venda_produto.Id_Produto
                                                                                            LEFT JOIN produto as produto2 ON produto2.Id = venda_produto.Id_Produto2
                                                                                            LEFT JOIN produto as produto3 ON produto3.Id = venda_produto.Id_Produto3
                                                                                            LEFT JOIN funcionario ON venda_produto.Id_Funcionario = funcionario.Id
                                                                                            LEFT JOIN funcionario as funcionario2 ON venda_produto.Id_Funcionario2 = funcionario2.Id
                                                                                            LEFT JOIN funcionario as funcionario3 ON venda_produto.Id_Funcionario3 = funcionario3.Id
                                                                                            WHERE venda.Lancamento = '1' ") or die("Erro na consulta SQL: " . mysqli_error($con));
                                    if (mysqli_num_rows($buscarItensVendas) === 0) {
                                    }
                                    while ($retornoItensVendas = mysqli_fetch_assoc($buscarItensVendas)) {

                                        $_POST["Profissional"] = $retornoItensVendas["Id_Funcionario"];

                                        ?>
                                        <div class="col-md-4">
                                            <div class="form-group">
                                                <label for="Servico">Servio:</label>
                                                <div class="form-control" readonly><?php echo $retornoItensVendas["Servico"]; ?>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-3">
                                            <div class="form-group">
                                                <label for="Peca">Descrio Servio:</label>
                                                <div class="form-control" readonly>
                                                    <?php echo $retornoItensVendas["Descricao_Servico"]; ?>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-3">
                                            <label for="Profissional">Profissional</label>
                                            <div class="campo" style="width: 200px">
                                                <?php
                                                echo select_banco(
                                                    "SELECT Id, Titulo from funcionario
                                                    where Ativo = 'Sim'
                                                    $func order by Titulo",
                                                    "Profissional",
                                                    "Profissional",
                                                    $_POST["Profissional"],
                                                    '',
                                                    "form-control"
                                                );
                                                ?>
                                            </div>
                                        </div>
                                        <div class="col-md-2">
                                            <div class="form-group">
                                                <label for="Servico">&nbsp;</label>
                                                <?php
                                                QRcode::png("https://" . $_SERVER["SERVER_NAME"] . "/" . CLIENTE_EMAIL . "/" . 'venda27/painel_consertos_costureira.php' . "?id_linha=" . $retornoItensVendas['Id'] . "&id_produto=" . $retornoItensVendas['Id_Produto'], 'img_qrcode' . $ab . '.png', QR_ECLEVEL_L, 2);
                                                echo '<img src="img_qrcode' . $ab . '.png" class="qrcodeimg"/>';
                                                ?>
                                            </div>
                                        </div>
                                        <?php if ($retornoItensVendas["Id_Produto2"] != '') { ?>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="Servico">Servio:</label>
                                                    <div class="form-control" readonly><?php echo $retornoItensVendas["Servico2"]; ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="form-group">
                                                    <label for="Peca">Descrio Servio:</label>
                                                    <div class="form-control" readonly>
                                                        <?php echo $retornoItensVendas["Descricao_Servico2"]; ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <label for="Profissional2">Profissional</label>
                                                <div class="campo" style="width: 200px">
                                                    <?php
                                                    echo select_banco(
                                                        "SELECT Id, Titulo from funcionario
                                                    where Ativo = 'Sim'
                                                    $func order by Titulo",
                                                        "Profissional2",
                                                        "Profissional2",
                                                        $_POST["Profissional2"],
                                                        '',
                                                        "form-control"
                                                    );
                                                    ?>
                                                </div>
                                            </div>
                                            <div class="col-md-2">
                                                <div class="form-group">
                                                    <label for="Servico">&nbsp;</label>
                                                    <?php
                                                    QRcode::png("https://" . $_SERVER["SERVER_NAME"] . "/" . CLIENTE_EMAIL . "/" . 'venda27/painel_consertos_costureira.php' . "?id_linha=" . $retornoItensVendas['Id'] . "&id_produto2=" . $retornoItensVendas['Id_Produto2'], 'img_qrcode' . $ab . '.png', QR_ECLEVEL_L, 2);
                                                    echo '<img src="img_qrcode' . $ab . '.png" class="qrcodeimg"/>';
                                                    ?>
                                                </div>
                                            </div>
                                        <?php } ?>
                                        <?php if ($retornoItensVendas["Id_Produto3"] != '') { ?>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="Servico">Servio:</label>
                                                    <div class="form-control" readonly><?php echo $retornoItensVendas["Servico3"]; ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="form-group">
                                                    <label for="Peca">Descrio Servio:</label>
                                                    <div class="form-control" readonly>
                                                        <?php echo $retornoItensVendas["Descricao_Servico3"]; ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <label for="Profissional3">Profissional</label>
                                                <div class="campo" style="width: 200px">
                                                    <?php
                                                    echo select_banco(
                                                        "SELECT Id, Titulo from funcionario
                                                    where Ativo = 'Sim'
                                                    $func order by Titulo",
                                                        "Profissional3",
                                                        "Profissional3",
                                                        $_POST["Profissional3"],
                                                        '',
                                                        "form-control"
                                                    );
                                                    ?>
                                                </div>
                                            </div>
                                            <div class="col-md-2">
                                                <div class="form-group">
                                                    <label for="Servico">&nbsp;</label>
                                                    <?php
                                                    QRcode::png("https://" . $_SERVER["SERVER_NAME"] . "/" . CLIENTE_EMAIL . "/" . 'venda27/painel_consertos_costureira.php' . "?id_linha=" . $retornoItensVendas['Id'] . "&id_produto3=" . $retornoItensVendas['Id_Produto3'], 'img_qrcode' . $ab . '.png', QR_ECLEVEL_L, 2);
                                                    echo '<img src="img_qrcode' . $ab . '.png" class="qrcodeimg"/>';
                                                    ?>
                                                </div>
                                            </div>
                                        <?php }
                                    }
                                    ?>
                                    <input type="submit" name="Salvar" value="Atualizar" id="Salvar"
                                        class="btn btn-primary btn-lg btn-block">
                                </div>
                                <?php
                            }
                        }
                        ?>
                    </form>
                </div>
            </div>
        </div>
    </div>
</body>

</html>