<!DOCTYPE html>
<html lang="pt">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Seleo de Imagens</title>
    <style>
        /* Estilos para o menu personalizado */
        .dropdown {
            position: relative;
            display: inline-block;
            width: 200px;
            font-family: Arial, sans-serif;
        }

        .dropdown-button {
            width: 100%;
            padding: 10px;
            background-color: #f1f1f1;
            border: 1px solid #ccc;
            text-align: left;
            cursor: pointer;
        }

        .dropdown-content {
            display: none;
            position: absolute;
            background-color: white;
            border: 1px solid #ccc;
            width: 100%;
            max-height: 200px;
            overflow-y: auto;
            z-index: 1;
        }

        .dropdown-content img {
            width: 20px;
            height: 20px;
            vertical-align: middle;
            margin-right: 10px;
        }

        .dropdown-content div {
            padding: 10px;
            cursor: pointer;
            display: flex;
            align-items: center;
        }

        .dropdown-content div:hover {
            background-color: #f1f1f1;
        }

        .dropdown:hover .dropdown-content {
            display: block;
        }

        .dropdown-content div.selected {
            background-color: #d1e7dd;
        }
    </style>
</head>
<body>
    <div class="dropdown">
        <div class="dropdown-button">Selecione uma imagem</div>
        <div class="dropdown-content">
            <div id="1" onclick="selectOption(this)">
                <img src="https://via.placeholder.com/20" alt="Imagem 1"> Imagem 1
            </div>
            <div id="2" onclick="selectOption(this)">
                <img src="https://via.placeholder.com/20/0000FF/808080?text=2" alt="Imagem 2"> Imagem 2
            </div>
            <div id="3" onclick="selectOption(this)">
                <img src="https://via.placeholder.com/20/FF0000/FFFFFF?text=3" alt="Imagem 3"> Imagem 3
            </div>
        </div>
    </div>

    <script>
        function selectOption(element) {
            const button = document.querySelector('.dropdown-button');
            const items = document.querySelectorAll('.dropdown-content div');

            // Atualiza o texto do boto para o item selecionado
            button.innerHTML = element.innerHTML;

            // Marca o item como selecionado
            items.forEach(item => item.classList.remove('selected'));
            element.classList.add('selected');
        }
    </script>
</body>
</html>
