<?php
include_once '../include/conecta.php'; //Conecta com a nosso banco de dados MySQL
ini_set('session.gc_maxlifetime', 60 * 120);
include_once '../include/ver_sessao.php';

if(isset($_GET['token'])) {
    function dataExportacao(string $data) {
        $explodeData = explode("-", $data);
        return "{$explodeData[2]}{$explodeData[1]}{$explodeData[0]}";
    }
    $token = addslashes($_GET['token']);
    $decodeDados = base64_decode($token);
    $dados = json_decode($decodeDados);
    $colunaCliente = CLIENTE_RAZAO_SOCIAL == "Sim" ? "Razao_Social" : "Titulo";
    $idsVendas = implode("','", $dados->vendas);
    $getVendas = mysqli_query($con, "SELECT Id, Id_Cliente, Lancamento, Data_Venda, Data_Entrega, Obs, Id_Transportadora,
        (SELECT Cnpj FROM unidade WHERE Id = venda.Id_Unidade) AS Cnpj_Unidade FROM venda
        WHERE Id IN('$idsVendas')") or die($con->error);
    $vendas = mysqli_fetch_all($getVendas, MYSQLI_ASSOC);
    $lancamentosVendas = array_column($vendas, "Lancamento");
    $nomeArquivo = implode("_", $lancamentosVendas).".txt";
    $abrirArquivo = fopen($nomeArquivo, 'w+');
    
    foreach($vendas as $venda) {
        $dataVenda = dataExportacao($venda['Data_Venda']);
        $dataEntrega = $venda['Data_Entrega'] != "0000-00-00" ? dataExportacao($venda['Data_Entrega']) : "";
        $transportadora = mysqli_query($con, "SELECT Cpf_Cnpj FROM fornecedor WHERE Id = '{$venda['Id_Transportadora']}'");
        $transportadora = mysqli_fetch_assoc($transportadora);
        $cpfCnpjTransportadora = preg_replace("/[^0-9]/", "", $transportadora['Cpf_Cnpj']);
    
        $cliente = mysqli_query($con, "SELECT Cpf_Cnpj, $colunaCliente Titulo, Email, Rua, Numero, Complemento, Bairro, Codigo_Cidade, Cidade,
            Estado, Cep, Codigo_Pais, Pais, Fone1, Estadual FROM cliente WHERE Id = '{$venda['Id_Cliente']}'");
        $cliente = mysqli_fetch_assoc($cliente);
        $cpfCnpjCliente = preg_replace("/[^0-9]/", "", $cliente['Cpf_Cnpj']);
        $cnpjEmpresa = preg_replace("/[^0-9]/", "", $venda['Cnpj_Unidade']);
        
        $linhaCliente = "6;D;$cpfCnpjCliente;{$cliente['Titulo']};{$cliente['Email']};{$cliente['Rua']};{$cliente['Numero']};{$cliente['Complemento']};{$cliente['Bairro']};{$cliente['Codigo_Cidade']};{$cliente['Cidade']};{$cliente['Estado']};{$cliente['Cep']};{$cliente['Codigo_Pais']};{$cliente['Pais']};{$cliente['Fone1']};{$cliente['Estadual']};";
        $linhaVenda = "1;{$venda['Lancamento']};;;;$cnpjEmpresa;$dataVenda;;$dataEntrega;;;{$venda['Obs']};;;$cpfCnpjTransportadora;$cpfCnpjCliente;;1;;";
    
        fwrite($abrirArquivo, "$linhaCliente\r\n$linhaVenda\r\n");
    
        $getProdutosVenda = mysqli_query($con, "SELECT produto.Codigo, venda_produto.Qtd, produto.Medida, venda_produto.Preco, venda_produto.Obs_Produto,
            venda_produto.Lote, venda_produto.Data_Validade FROM produto
            INNER JOIN venda_produto ON venda_produto.Id_Produto = produto.Id
            WHERE venda_produto.Id_Venda = '{$venda['Id']}' AND venda_produto.Cancelado = 'No'");
        
        while($produto = mysqli_fetch_assoc($getProdutosVenda)) {
            $posicaoPonto = strpos($produto['Qtd'], ".");
            $qtdProduto = $produto['Qtd'];
            if($posicaoPonto !== false) {
                $numerosDecimais = substr("$qtdProduto", $posicaoPonto + 1);
                $numerosDecimais = str_pad($numerosDecimais, 4, '0');
                $qtdProduto = substr($qtdProduto, 0, $posicaoPonto) . $numerosDecimais;
            }
            else {
                $qtdProduto .= "0000"; 
            }
            $preco = number_format($produto['Preco'], 4, ",", "");
            $totalProduto = number_format($produto['Preco'] * $produto['Qtd'], 2, ",", "");
            $explodeDataValidade = explode("-", $produto['Data_Validade']);
            $dataValidade = "{$explodeDataValidade[2]}/{$explodeDataValidade[1]}/{$explodeDataValidade[0]}";
            $mesAnoValidade = "{$explodeDataValidade[1]}/{$explodeDataValidade[0]}";
            $linhaProduto = "2;{$produto['Codigo']};$qtdProduto;{$produto['Medida']};$preco;$totalProduto;{$produto['Obs_Produto']};{$produto['Lote']};2;;$dataValidade;$mesAnoValidade;";
            fwrite($abrirArquivo, "$linhaProduto\r\n");
        }
    }
    fclose($abrirArquivo);
    mysqli_query($con, "UPDATE venda SET Exportado = 'Sim' WHERE Id IN('$idsVendas') AND Exportado = 'No'");
    header("Content-Type: application/octet-stream");
    header("Content-Disposition: attachment; filename=$nomeArquivo");
    header('Content-Description: File Transfer');
    header('Content-Transfer-Encoding: binary');
    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
    header('Pragma: public');
    header('Expires: 0');
    readfile($nomeArquivo);
    unlink($nomeArquivo);
}
else {?>
    <script>window.close()</script>
    <?php
}
?>