<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Classe responsável pela configuração das keys do WordPress, uma única 
 * instância da key será usada (Singleton).
 * WPKeys é a abreviação de WordPress Keys
 * 
 * @author PonttiWEB
 */
namespace App\Config\ConfigWPKeys;
use App\Model\Conn\Conn;
use Automattic\WooCommerce\Client;
use Automattic\WooCommerce\HttpClient\HttpClientException;

class ConfigWPKeys{
    
    private static $instance;
    private static $url;
    private static $consumer_key;
    private static $consumer_secret;
    private static $version;
    private static $clienteWoocommerce;
    
    private function __construct() {}
    
    private static function setKeys(String $url = null, String $consumer_key = null, String $consumer_secret = null) {
        $getConfig = Conn::getInstance()->query("SELECT Site_Url, Site_Key, Site_Secret FROM opcao");
        $dadosConfig = mysqli_fetch_assoc($getConfig);
        self::$url = $url ?? $dadosConfig['Site_Url'];
        self::$consumer_key = $consumer_key ?? $dadosConfig['Site_Key'];
        self::$consumer_secret = $consumer_secret ?? $dadosConfig['Site_Secret'];
        self::$version = 'wc/v3';
    }
    
    public static function getInstance(String $url = null, String $consumer_key = null, 
        String $consumer_secret = null, String $version = null) {
        
        if(!isset(self::$instance)){
            ConfigWPKeys::setKeys($url, $consumer_key, $consumer_secret);
            self::$instance = new ConfigWPKeys();
            self::$clienteWoocommerce = new Client(
                    $url ?? self::$url, 
                    $consumer_key ?? self::$consumer_key, 
                    $consumer_secret ?? self::$consumer_secret,
                [
                    'version' => self::$version,
                ]
            );
        }
        return self::$clienteWoocommerce;
    }   
}