<?php
namespace App\Config\ConfigWebhook;

use App\Config\ConfigWPKeys\ConfigWPKeys;

class ConfigWebhook {

    public function __construct() {}

    public static function webhookAtualizacoesCompra(String $urlLoja, String $consumer_key, String $consumer_secret) {
        // global $_SERVER;
        $diretorioEmpresa = explode("/", $_SERVER['REQUEST_URI'])[1];
        $url = $_SERVER['HTTP_ORIGIN']."/".$diretorioEmpresa;
        $webhooks = ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->get('webhooks');
        $webhookExiste = false;

        foreach($webhooks as $webhook) {
            if($webhook->topic == "order.updated") {
                if($webhook->delivery_url == "$url/site_importacao/webhooks/compras/status_compra.php") {
                    $webhookExiste = true;
                }
                else {
                    ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->delete("webhooks/$webhook->id");
                }
            }
        }

        if(!$webhookExiste) {
            $cadastrarWebHook = ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->post('webhooks', [
                'name' => 'Order updated',
                'topic' => 'order.updated',
                'delivery_url' => "$url/site_importacao/webhooks/compras/status_compra.php",
                "hooks"=> [
                    "woocommerce_order_edit_status",
                    "woocommerce_order_status_changed"
                ],
            ]);
            return ($cadastrarWebHook->id) ? true : false;
        }
        return false;
    }

    public static function webhookCriacaoCompra(String $urlLoja, String $consumer_key, String $consumer_secret) {
        $diretorioEmpresa = explode("/", $_SERVER['REQUEST_URI'])[1];
        $url = $_SERVER['HTTP_ORIGIN']."/".$diretorioEmpresa;
        $webhooks = ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->get('webhooks');
        $webhookExiste = false;

        foreach($webhooks as $webhook) {
            if($webhook->topic == "order.created") {
                if($webhook->delivery_url == "$url/site_importacao/webhooks/compras/criar_compra.php") {
                    $webhookExiste = true;
                }
                else {
                    ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->delete("webhooks/$webhook->id");
                }
            }
        }

        if(!$webhookExiste) {
            $cadastrarWebHook = ConfigWPKeys::getInstance($urlLoja, $consumer_key, $consumer_secret)->post('webhooks', [
                'name' => 'Order created',
                'topic' => 'order.created',
                'delivery_url' => "$url/site_importacao/webhooks/compras/criar_compra.php",
            ]);
            return ($cadastrarWebHook->id) ? true : false;
        }
        return false;
    }
}