<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
namespace App\Controller\Cliente;

use App\Model\Conn\Conn;
use \App\Config\ConfigWPKeys\ConfigWPKeys;
use DateTime;
require_once __DIR__ ."/../config/ConfigFuncionario.php";
use \App\Config\ConfigFuncionario\ConfigFuncionario;
/**
 * Classe responsável pela importação dos clientes do WP para o GW
 *
 * @author PonttiWEB
 */
class Cliente {
    
    public function __construct() {}

    public function selectTodosClientesWP($pagina = 2, $porPagina = 100) {
        try {
            $clientes = ConfigWPKeys::getInstance()->get("customers", ["per_page"=> $porPagina]);

            do {
                $request = ConfigWPKeys::getInstance()->get("customers?page=$pagina&per_page=$porPagina");
                for ($i=0; $i < sizeof($request); $i++) {
                    array_push($clientes, $request[$i]);
                }
                $pagina++;
            }
            while(!empty($request));
            
            return $clientes;          
        } catch (HttpClientException $e) {
            echo '<pre><code>' . print_r($e->getMessage(), true) . '</code><pre>'; // Error message.
            echo '<pre><code>' . print_r($e->getRequest(), true) . '</code><pre>'; // Last request data.
            echo '<pre><code>' . print_r($e->getResponse(), true) . '</code><pre>'; // Last response data.
        }
    }
    
    public function criaCliente() {
        $data = [
            'email' => 'arua@example.com',
            'first_name' => 'Arua Cliente',
            'last_name' => 'Arua Cliente',
            'username' => 'arua.cliente',
            'billing' => [
                'first_name' => 'Arua',
                'last_name' => 'Cliente',
                'company' => '',
                'address_1' => 'rua 69',
                'address_2' => '',
                'city' => 'Paulista',
                'state' => 'PE',
                'postcode' => '53441280',
                'country' => 'BR',
                'email' => 'arua@example.com',
                'phone' => '(555) 555-5555'
            ],
            'shipping' => [
                'first_name' => 'Arua Cliente',
                'last_name' => 'Arua Cliente',
                'company' => '',
                'address_1' => 'rua 69',
                'address_2' => '',
                'city' => 'Paulista',
                'state' => 'PE',
                'postcode' => '53441280',
                'country' => 'BR'
            ]
        ];

        print_r(ConfigWPKeys::getInstance()->post('customers', $data));
    }
    
    /**
     * Método de inserção de clientes no sistema GW.
     */
    public function insertClientesGW() {
        Conn::getInstance()->set_charset("utf8mb4");
        $todosClientes = $this->selectTodosClientesWP();
        // echo json_encode($todosClientes);
        $sql = "INSERT INTO cliente ("
                . "Id_Usuario, "
                . "Titulo, "
                . "Id, "
                . "Codigo, "
                . "Email, "
                . "Endereco, "
                . "Rua, "
                . "Cep, "
                . "Cidade, "
                . "Estado, "
                . "Pais, "
                . "Fone1, "
                . "Endereco_Cobranca, "
                . "Cep_Cobranca, "
                . "Cidade_Cobranca, "
                . "Estado_Cobranca, "
                . "Id_Cliente_Pai, "
                . "Data_Cadastro, "
                . "Data_Cadastro_Upd, "
                . "Id_Unidade, "
                . "Id_Cfop,"
                . "Natureza, "
                . "Cpf_Cnpj) "
                . "VALUES ";

        $idUsuario = $this->selectIdUsuario();
        $codigoCliente = $this->buscaCodigoCliente();
        $i = 1;
        foreach($todosClientes as $cliente){
            $clienteCadastrado = $this->selectIdClientePai($cliente->id);
            $usuarioLogado = $_SESSION["Login"];
            $getIdUnidadeUsuario = Conn::getInstance()->query("SELECT Id_Unidade FROM usuario WHERE Login = '$usuarioLogado'");
            $idUnidadeUsuarioLogado = mysqli_fetch_assoc($getIdUnidadeUsuario)['Id_Unidade'];
            $getUfUnidade = Conn::getInstance()->query("SELECT Estado FROM unidade WHERE Id=$idUnidadeUsuarioLogado");
            $ufUnidade = mysqli_fetch_assoc($getUfUnidade)['Estado'];
            $idCfop = $cliente->billing->state == $ufUnidade ? 289 : 440;
            
            if(!$clienteCadastrado) {
                $cpfCnpj = "";
                $natureza = $cliente->billing->persontype == "J" ? "PJ" : "PF";
                foreach ($cliente->meta_data as $metaData) {
                    if($metaData->key == "billing_cpf" && $metaData->value != "") {
                        $cpfCnpj =  str_replace([".","-","/"],["","",""], $metaData->value);
                        $natureza = "PF";
                        break;
                    }
                    elseif($metaData->key == "billing_cnpj" && $metaData->value != "") {
                        $cpfCnpj =  str_replace([".","-","/"],["","",""], $metaData->value);
                        $natureza = "PJ";
                        break;
                    }
                }

                $sql.= "(";
                $sql.= "'".$idUsuario[0]['Id']."', "; //Id Usuário
                $sql.= "'".$cliente->first_name." ".$cliente->last_name."', "; //Titulo
                $sql.= "'".md5($cliente->id.microtime())."', "; //Id
                $sql.= "'".strval($codigoCliente+$i)."', "; //Codigo
                $sql.= "'".$cliente->email."', "; //Email
                $sql.= "'".$cliente->shipping->address_1."', "; //Endereco
                $sql.= "'".$cliente->shipping->address_1."', "; //Rua
                $sql.= "'".$cliente->shipping->postcode."', "; //Cep
                $sql.= "'".$cliente->shipping ->city."', "; //Cidade
                $sql.= "'".$cliente->shipping->state."', "; //Estado
                $sql.= "'".$cliente->shipping->country."', "; //País
                $sql.= "'".$cliente->billing->phone."', "; //Fone1
                $sql.= "'".$cliente->billing->address_1."', "; //Endereco_Cobranca
                $sql.= "'".$cliente->billing->postcode."', "; //Cep_Cobranca
                $sql.= "'".$cliente->billing->city."', "; //Cidade_Cobranca
                $sql.= "'".$cliente->billing->state."', "; //Estado_Cobranca
                $sql.= "'".$cliente->id."', "; //Id_Cliente_Pai 
                //OBS.:ficou acertado que o campo Id_Cliente_Pai deverá armazenar os IDs dos clientes do WordPress
                $sql.= "'".date("Y-m-d H:i:s")."', '".date("Y-m-d H:i:s")."',";
                $sql.= "'1', "; //Id_Unidade
                $sql.= "$idCfop,";
                $sql.= "'".$natureza."', ";
                $sql.= "'".$cpfCnpj."' ";

                if($i == count($todosClientes)){
                    $sql.=")";
                }
                else{
                    $sql.="), ";
                    $i++;
                }
            }
        }
        Conn::executaQueryInsert($sql);
        echo Conn::getInstance()->affected_rows > 0 ? "Clientes importados com sucesso </br>" : "Nenhum cliente foi importado </br>";
    }
    
    /**
     * Método de seleção de Id do cliente
     * @param type $idCliente
     * @return boolean
     */
    private function selectIdClientePai($idCliente) {
         $sql = "SELECT Id_Cliente_Pai FROM cliente WHERE Id_Cliente_Pai = ?";
         $id = Conn::executaQuerySelectParam($sql, $idCliente);
         if(empty($id)){
             return false;
         }else{
             return true;
         }
    }
     
    private function selectIdUsuario() {
        $sql = "SELECT Id FROM usuario WHERE Login = 'suporte'";
        return Conn::executaQuerySelect($sql);
    }
    
    public function buscaCodigoCliente(){
        $sql = "SELECT Codigo FROM cliente ORDER BY Data_Cadastro DESC LIMIT 1";
        
        $codigo = Conn::executaQuerySelect($sql);
        if($codigo == null|| empty($codigo)){
            return 0;
        }
            
        return $codigo[0]["Codigo"];
    }

    public function importaClientesCompras() {
        Conn::getInstance()->set_charset("utf8mb4");

        // Cadastro do funcionário de importação
        new ConfigFuncionario();

        $todosClientes = $this->selectTodosClientesWP();
        $idUsuario = $this->selectIdUsuario();
        $codigoCliente = $this->buscaCodigoCliente();
        $i = 1;
        $qtdClientesImportados = 0;
        foreach($todosClientes as $cliente){
            $usuarioLogado = $_SESSION["Login"];
            $getIdUnidadeUsuario = Conn::getInstance()->query("SELECT Id_Unidade FROM usuario WHERE Login = '$usuarioLogado'");
            $idUnidadeUsuarioLogado = mysqli_fetch_assoc($getIdUnidadeUsuario)['Id_Unidade'];
            $getUfUnidade = Conn::getInstance()->query("SELECT Estado FROM unidade WHERE Id=$idUnidadeUsuarioLogado");
            $ufUnidade = mysqli_fetch_assoc($getUfUnidade)['Estado'];
            $clienteCadastrado = $this->selectIdClientePai($cliente->id);
            $idCfop = $cliente->billing->state == $ufUnidade ? 289 : 440;
            $cpfCnpj = "";
            $natureza = $cliente->billing->persontype == "J" ? "PJ" : "PF";
            
            if(!$clienteCadastrado) {
                $idUsuarioCad = $idUsuario[0]['Id'];
                $idCliente = md5($cliente->id.microtime());
                $codigo = strval($codigoCliente+$i);
                $tamanhoCodigo = strlen($codigo);
                for ($j=4; $j > $tamanhoCodigo; $j--) { 
                    $codigo = "0$codigo";
                }

                foreach ($cliente->meta_data as $metaData) {
                    if($metaData->key == "billing_cpf" && $metaData->value != "") {
                        $cpfCnpj =  str_replace([".","-","/"],["","",""], $metaData->value);
                        $natureza = "PF";
                        break;
                    }
                    elseif($metaData->key == "billing_cnpj" && $metaData->value != "") {
                        $cpfCnpj =  str_replace([".","-","/"],["","",""], $metaData->value);
                        $natureza = "PJ";
                        break;
                    }
                }

                $nomeCliente = $cliente->first_name. " ".$cliente->last_name;
                $sql = "INSERT INTO cliente SET Id_Usuario = '$idUsuarioCad', Id_Usuario_Upd = '$idUsuarioCad', Titulo = '$nomeCliente',
                Id = '$idCliente', Codigo = '$codigo', Email = '$cliente->email', Endereco = '".$cliente->shipping->address_1."',
                Rua = '".$cliente->shipping->address_1."', Cep = '".$cliente->shipping->postcode."', Cidade='".$cliente->shipping->city."',
                Estado = '".$cliente->shipping->state."', Pais = '".$cliente->shipping->country."', Fone1 = '".$cliente->billing->phone."',
                Endereco_Cobranca = '".$cliente->shipping->address_1."', Cep_Cobranca = '".$cliente->billing->postcode."',
                Cidade_Cobranca = '".$cliente->billing->city."', Estado_Cobranca = '".$cliente->billing->state."', Id_Cliente_Pai = '$cliente->id',
                Data_Cadastro = NOW(), Data_Cadastro_Upd = NOW(), Id_Unidade = '$idUnidadeUsuarioLogado', Id_Cfop='$idCfop', Natureza='$natureza',
                Cpf_Cnpj='$cpfCnpj'";

                Conn::getInstance()->query($sql);

                if(Conn::getInstance()->affected_rows > 0) {
                    $qtdClientesImportados++;
                }
                $i++;
            }
            else {
                $getIdCliente = Conn::getInstance()->query("SELECT Id FROM cliente WHERE Id_Cliente_Pai='$cliente->id'");
                $idCliente = mysqli_fetch_assoc($getIdCliente)['Id'];
            }
            $comprasCliente = $this->buscaComprasClienteWp($cliente->id);

            foreach ($comprasCliente as $compra) {
                $compraCadastrada = Conn::getInstance()->query("SELECT Id FROM venda WHERE Id_Loja_Virtual='$compra->id'");

                if(!$compraCadastrada->num_rows > 0) {
                    $getIdFuncionario = Conn::getInstance()->query("SELECT Id FROM funcionario WHERE Titulo = 'Loja virtual'");
                    $idFuncionario = mysqli_fetch_assoc($getIdFuncionario)['Id'];

                    $idCompra = md5($compra->id.microtime());
                    $dataCompra = date_format(new DateTime($compra->date_created), "Y-m-d");
                    $dataPagamento = date_format(new DateTime($compra->date_paid), "Y-m-d");
                    $getMetodoPagamento = Conn::getInstance()->query("SELECT Codigo FROM tipo_pagamento WHERE Titulo='LOJA VIRTUAL'");
                    $metodoPagamento = mysqli_fetch_assoc($getMetodoPagamento)['Codigo'];
                    $sql = "INSERT INTO venda SET Id='$idCompra', Id_Usuario='$idFuncionario', Id_Usuario_Upd='$idFuncionario',
                    Data_Cadastro='$compra->date_created', Data_Cadastro_Upd='$compra->date_modified', Desconto='$compra->discount_total',
                    Valor_Frete='$compra->shipping_total', Data_Venda='$dataCompra', Id_Funcionario='$idFuncionario',
                    Id_Cliente='$idCliente', Id_Tipo_Pagamento='$metodoPagamento',Status='Aberto', Valor_Original='$compra->total',
                    Valor_Pago='$compra->total', Obs='$compra->customer_note', Id_Cfop='$idCfop', Id_Vendedor='$idFuncionario',
                    Id_Unidade='$idUnidadeUsuarioLogado', Id_Loja_Virtual='$compra->id', Numero_Pedido='$compra->id', Site='Sim',
                    Status_Loja_Virtual='Pagamento pendente'";

                    Conn::getInstance()->query($sql);

                    if(Conn::getInstance()->affected_rows > 0) {
                        $qtdClientesImportados++;
                        foreach($compra->line_items as $itemCompra) {
                            $this->cadastraProdutoVendaWp($idCompra, $itemCompra, $idFuncionario, $idCfop, $idCliente, $idUnidadeUsuarioLogado);
                        }
                    }
                }
            }
        }
        echo $qtdClientesImportados > 0 ? "Importacao realizada com sucesso </br>" : "Nenhuma importacao foi realizada </br>";
    }

    public function buscaComprasWp() {
        $pagina = 2;
        $compras = ConfigWPKeys::getInstance()->get("orders", ["per_page"=> 100]);
        do {
            $request = ConfigWPKeys::getInstance()->get("orders?per_page=100&page=$pagina");
            for ($i=0; $i < sizeof($request); $i++) { 
                array_push($compras, $request[$i]);
            }
            $pagina++;
        } while (!empty($request));

        return $compras;
    }

    public function buscaComprasClienteWp($idClienteWp) {
        $compras = $this->buscaComprasWp();
        $comprasCliente = [];
        foreach ($compras as $compra) {
            if($compra->customer_id == $idClienteWp) {
                array_push($comprasCliente, $compra);
            }
        }
        return $comprasCliente;
    }

    public function cadastraProdutoVendaWp($idVendaGw, $itemCompraWp, $idFuncionario, $idCfop, $idCliente, $idUnidade) {
        $idItemCompra = md5($itemCompraWp->id.microtime());
        $buscaIdLocalEstoque = Conn::getInstance()->query("SELECT Id_Local_Estoque, Id_Unidade FROM estoque WHERE Id_Produto='$itemCompraWp->variation_id'");
        $localEstoqueProduto = mysqli_fetch_assoc($buscaIdLocalEstoque);
        $idLocalEstoqueProduto = $localEstoqueProduto['Id_Local_Estoque'];

        $buscaIdProdutoGw = Conn::getInstance()->query("SELECT Id, Titulo, Id_Categoria_Produto, Id_Categoria_Produto_Filho, Id_Fornecedor
        FROM produto WHERE Id_Loja_Virtual=$itemCompraWp->variation_id");
        $produtoGw = mysqli_fetch_assoc($buscaIdProdutoGw);
        $idProdutoGw = $produtoGw['Id'];
        $descricaoProduto = $produtoGw['Titulo'];
        $idCategoriaProduto = $produtoGw['Id_Categoria_Produto'];
        $idCategoriaProdutoFilho = $produtoGw['Id_Categoria_Produto_Filho'];
        $idFornecedor = $produtoGw['Id_Fornecedor'];

        Conn::getInstance()->query("INSERT INTO venda_produto SET Id='$idItemCompra', Id_Venda='$idVendaGw', Id_Produto='$idProdutoGw',
        Preco='$itemCompraWp->price', Qtd='$itemCompraWp->quantity', Id_Local_Estoque='$idLocalEstoqueProduto', Id_Unidade='$idUnidade',
        Id_Funcionario='$idFuncionario', Id_Cfop='$idCfop', Id_Usuario='$idFuncionario', Id_Usuario_Upd='$idFuncionario', Data_Cadastro=NOW(),
        Data_Cadastro_Upd=NOW(), C_Produto='$descricaoProduto', Id_Categoria_Produto='$idCategoriaProduto',
        Id_Categoria_Produto_Filho='$idCategoriaProdutoFilho', Preco_Tabela='$itemCompraWp->price', Id_Fornecedor='$idFornecedor',
        Frete='$itemCompraWp->total_tax', Id_Cliente='$idCliente'");
    }
}