<?php

/**
 * Description of Produto
 *
 * @author PonttiWEB
 */

namespace App\Controller\Produto;

use App\Model\Conn\Conn;
use \App\Config\ConfigWPKeys\ConfigWPKeys;
use mysqli;

class Produto {

    /**
     * Esse metodo  responsvel pela chamada de querys referentes a
     * updates de produtos (WP significa WordPress)
     * @param String $id id do produto a ser atualizado
     * @param String $param parmetro(s) a serem atualizados;
     */

    
    
    public function __construct() {
//        $this->conn = Conn::getInstance();
//        $this->keys = ConfigWPKeys::getInstance();
    }
    
    public function updateProduto() {
        // error_reporting(E_ALL);
        // ini_set('display_errors', 'On');
        Conn::getInstance()->set_charset("utf8mb4");
        $config = Conn::getInstance()->query("SELECT Categoria_Loja_Virtual, Id_Tabela_Preco_Loja, Gerenciar_Estoque_Loja FROM opcao");
        $config = mysqli_fetch_assoc($config);
        $gerenciarEstoque = $config['Gerenciar_Estoque_Loja'];
        $idTabelaPreco = Conn::getInstance()->query("SELECT Valor FROM produto_tabela WHERE Id='".$config['Id_Tabela_Preco_Loja']."'");
        $tabelaPreco = mysqli_fetch_assoc($idTabelaPreco)['Valor'];
        $tabelaPreco = intval($tabelaPreco);
        $colunaCategoria = $config['Categoria_Loja_Virtual'] == "Categoria" ? "Id_Categoria_Produto" : "Id_Categoria_Produto_Filho";
        $getProdutos = Conn::getInstance()->query("SELECT produto.Id, produto.Titulo, produto.Caracteristica as Descricao2, produto.Preco$tabelaPreco Preco,
        produto.Descricao, produto.Id_Categoria_Loja_Virtual AS Id_Categoria_Produto, produto.Codigo, produto.Caminho_Foto, produto.Id_Loja_Virtual,
        produto.Grade_Cor, produto.Grade_Tamanho, produto.Grade_Genero, produto.Grade_Especificacao, produto.Id_Produto_Pai_Virtual, produto.Preco_Promocional_Loja,
        produto.Inicio_Promocao_Loja, produto.Fim_Promocao_Loja, produto.Foto2, produto.Foto3, produto.Foto4, produto.Flag_Kit,
        (SELECT SUM(Qtd) FROM estoque WHERE Concluido='Sim' AND Id_Unidade=(SELECT Id FROM unidade WHERE Sede='Matriz') AND Id_Produto = produto.Id) Qtd FROM produto
        WHERE (produto.Id_Loja_Virtual IS NOT NULL AND produto.Id_Loja_Virtual != '') AND produto.Site='Sim' AND produto.Ativo='Sim' AND 
        (produto.$colunaCategoria = 0 OR (SELECT COUNT(c.Id) FROM categoria_produto c WHERE c.Id=produto.$colunaCategoria 
        AND c.Ativo='Sim' AND c.Site='Sim') > 0) ORDER BY produto.Id_Produto_Pai, produto.Data_Cadastro ASC");

        $produtos = mysqli_fetch_all($getProdutos, MYSQLI_ASSOC);
        $qtdProdutosImportados = 0;
        $idTermosVirtual = [];
        $atributosVirtuais = ConfigWPKeys::getInstance()->get("products/attributes");
        $produtosAtualizados = [];
        foreach ($atributosVirtuais as $indice => $valor) {
            $idTermosVirtual[$atributosVirtuais[$indice]->name] = $atributosVirtuais[$indice]->id;
        }
        
        for ($i = 0; $i < sizeof($produtos); $i++){
            $produtos[$i]['Descricao2'] = (!$produtos[$i]['Descricao2'] || empty($produtos[$i]['Descricao2'])) ? $produtos[$i]['Titulo'] : $produtos[$i]['Descricao2'];
            $produtos[$i]["Codigo"] = str_replace("-", "", $produtos[$i]["Codigo"]);

            if($produtos[$i]['Flag_Kit'] == 'S' && $produtos[$i]["Preco"] == 0) {
                $totalKit = 0;
                $produtosKit = Conn::getInstance()->query("SELECT produto_kit.Qtd, produto_kit.Desconto, produto.Preco1 FROM produto_kit
                LEFT JOIN (SELECT Id, Preco1 FROM produto) produto ON produto.Id = produto_kit.Id_Produto_Kit WHERE produto_kit.Id_Produto = '{$produtos[$i]['Id']}'");
                while($kit = mysqli_fetch_assoc($produtosKit)) {
                    if($kit['Desconto'] > 0) {
                        $descontoPrecoKit = (($kit['Qtd'] * $kit['Preco1']) * $kit['Desconto']) / 100;
                        $totalKit += ($kit['Qtd'] * $kit['Preco1']) - $descontoPrecoKit;
                    }
                    else {
                        $totalKit += $kit['Preco1'];
                    }
                    $totalKit = str_replace(['.', ','], ['', '.'], $totalKit);
                }
                $produtos[$i]['Preco'] = $totalKit;
            }
            $corProduto = explode(",", $produtos[$i]['Grade_Cor']);
            for($cor=0; $cor < sizeof($corProduto); $cor++) {
                $corProduto[$cor] = ucfirst(mb_strtolower(trim($corProduto[$cor])));
            }

            $tamanhoProduto = explode(",", $produtos[$i]['Grade_Tamanho']);
            for($tamanhoPrdt=0; $tamanhoPrdt < sizeof($tamanhoProduto); $tamanhoPrdt++) {
                $tamanhoProduto[$tamanhoPrdt] = ucfirst(mb_strtolower(trim($tamanhoProduto[$tamanhoPrdt])));
            }

            $generoProduto = explode(",", $produtos[$i]['Grade_Genero']);
            for($generoPrdt=0; $generoPrdt < sizeof($generoProduto); $generoPrdt++) {
                $generoProduto[$generoPrdt] = ucfirst(mb_strtolower(trim($generoProduto[$generoPrdt])));
            }

            $especificacaoProduto = explode(",", $produtos[$i]['Grade_Especificacao']);
            for($especificacaoPrdt=0; $especificacaoPrdt < sizeof($especificacaoProduto); $especificacaoPrdt++) {
                $especificacaoProduto[$especificacaoPrdt] = ucfirst(mb_strtolower(trim($especificacaoProduto[$especificacaoPrdt])));
            }

            $produto = [
                "name" =>  ucfirst(mb_strtolower($produtos[$i]['Titulo'])),
                "type" => ($produtos[$i]["Id_Produto_Pai_Virtual"] == "" || !$produtos[$i]["Id_Produto_Pai_Virtual"]) && (!empty($produtos[$i]['Grade_Cor']) || 
                !empty($produtos[$i]['Grade_Tamanho']) || !empty($produtos[$i]['Grade_Genero']) || !empty($produtos[$i]['Grade_Especificacao'])) ? "variable" : "simple",
                "regular_price" => $produtos[$i]['Preco'],
                "description" =>  ucfirst(mb_strtolower($produtos[$i]['Descricao2'])),
                "short_description" =>  ucfirst(mb_strtolower($produtos[$i]['Descricao2'])),
                'manage_stock'=> $gerenciarEstoque == "Sim",
                "sale_price" => $produtos[$i]['Preco_Promocional_Loja'] > 0 ? $produtos[$i]['Preco_Promocional_Loja'] : "",
                "categories" => [
                    ["id" => intval($produtos[$i]["Id_Categoria_Produto"])]
                ]
            ];

            if($produtos[$i]["Id_Produto_Pai_Virtual"] == "" || !$produtos[$i]["Id_Produto_Pai_Virtual"]) {
                $produto["images"] = [
                    ["src" => $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"], $produtos[$i]["Id"])]
                ];
            }
            if(!empty($produtos[$i]["Foto2"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-2', $produtos[$i]["Id"])
                ]);
            }

            if(!empty($produtos[$i]["Foto3"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-3', $produtos[$i]["Id"])
                ]);
            }

            if(!empty($produtos[$i]["Foto4"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-4', $produtos[$i]["Id"])
                ]);
            }

            if($gerenciarEstoque == "Sim") {
                $produto['stock_quantity'] = empty($produtos[$i]['Qtd']) || $produtos[$i]['Qtd'] < 1  ? 0 : $produtos[$i]['Qtd'];
            }
            else {
                $produto["stock_status"] = "instock";
                $produto["in_stock"] = true;
            }

            $produto["date_on_sale_from"] = $produtos[$i]['Inicio_Promocao_Loja'] && $produtos[$i]['Inicio_Promocao_Loja'] != "0000-00-00" ? 
            $produtos[$i]['Inicio_Promocao_Loja'] : "";
            $produto["date_on_sale_to"] = $produtos[$i]['Fim_Promocao_Loja'] && $produtos[$i]['Fim_Promocao_Loja'] != "0000-00-00" ? 
            $produtos[$i]['Fim_Promocao_Loja'] : "";

            if($produtos[$i]["Id_Produto_Pai_Virtual"] == "" || !$produtos[$i]["Id_Produto_Pai_Virtual"]) {
                $produto['images'] = [
                    ["src" => 
                        $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"], $produtos[$i]["Id"])
                    ]
                ];
                $produto['attributes'] = [];
                if($idTermosVirtual['Cor'] && $corProduto[0] != '') {
                    array_push($produto['attributes'],
                        [
                            "id"=> $idTermosVirtual['Cor'],
                            "name"=> "Cor",
                            "position"=> 1,
                            "visible"=> true,
                            "variation"=> true,
                            "options"=> $corProduto
                        ]
                    );
                }

                if($idTermosVirtual['Tamanho'] && $tamanhoProduto[0] != '') {
                    array_push($produto['attributes'], 
                        [
                        "id"=> $idTermosVirtual['Tamanho'],
                        "name"=> "Tamanho",
                        "position"=> 2,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $tamanhoProduto
                        ]
                    );
                }

                if($idTermosVirtual['Tipo'] && $generoProduto[0] != '') {
                    array_push($produto['attributes'],
                        [
                            "id"=> $idTermosVirtual['Tipo'],
                            "name"=> "Tipo",
                            "position"=> 3,
                            "visible"=> true,
                            "variation"=> true,
                            "options"=> $generoProduto
                        ]
                    );
                }

                if($idTermosVirtual['Especificacao'] && $especificacaoProduto[0] != '') {
                    array_push($produto['attributes'],
                        [
                            "id"=> $idTermosVirtual['Especificacao'],
                            "name"=> "Especificacao",
                            "position"=> 4,
                            "visible"=> true,
                            "variation"=> true,
                            "options"=> $especificacaoProduto
                        ]
                    );
                }

                $produtoPai = $this->buscaUnicoProdutoWp($produtos[$i]["Id_Loja_Virtual"]);
                $produtosAtualizados[$produtos[$i]["Id_Loja_Virtual"]]['attributes'] = $produtoPai->attributes;
            }
            else {
                $produto['image']["src"] = $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"], $produtos[$i]["Id"]);
                if($especificacaoProduto[0] != '') {
                    if(!isset($produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3])) {
                        $produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3] = (object) [
                            "id"=> $idTermosVirtual['Especificacao'],
                            "name"=> "Especificacao",
                            "position"=> 4,
                            "visible"=> true,
                            "variation"=> true
                        ];
                    }
    
                    if(isset($produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3]->options)) {
                        $produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3]->options = array_merge(
                            $produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3]->options,
                            $especificacaoProduto
                        );
                    }
                    else {
                        $produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes'][3]->options = $especificacaoProduto;
                    }
                    ConfigWPKeys::getInstance()->put("products/".$produtos[$i]["Id_Produto_Pai_Virtual"], [
                        "attributes"=> $produtosAtualizados[$produtos[$i]['Id_Produto_Pai_Virtual']]['attributes']
                    ]);
                }

                $produto['attributes'] = [];

                if($idTermosVirtual['Cor'] && trim($produtos[$i]['Grade_Cor']) != '') {
                    $produto['attributes'][0] = [
                        "id"=> $idTermosVirtual['Cor'],
                        "name"=> "Cor",
                        "option"=> $produtos[$i]['Grade_Cor']
                    ];
                }
                if($idTermosVirtual['Tamanho'] && trim($produtos[$i]['Grade_Tamanho']) != '') {
                   $produto['attributes'][1] = [
                        "id"=> $idTermosVirtual['Tamanho'],
                        "name"=> "Tamanho",
                        "option"=> $produtos[$i]['Grade_Tamanho']
                    ];
                }
                if($idTermosVirtual['Tipo'] && trim($produtos[$i]['Grade_Genero']) != '') {
                    $produto['attributes'][2] = [
                        "id"=> $idTermosVirtual['Tipo'],
                        "name"=> "Tipo",
                        "option"=> $produtos[$i]['Grade_Genero']
                    ];
                }
                if($idTermosVirtual['Especificacao'] && trim($produtos[$i]['Grade_Especificacao']) != '') {
                    $produto['attributes'][3] = [
                        "id"=> $idTermosVirtual['Especificacao'],
                        "name"=> "Especificacao",
                        "option"=> $produtos[$i]['Grade_Especificacao']
                    ];
                }
            }

            $url = $produtos[$i]["Id_Produto_Pai_Virtual"] == "" ? 'products/'.$produtos[$i]["Id_Loja_Virtual"] : 
            'products/'.$produtos[$i]["Id_Produto_Pai_Virtual"]."/variations/".$produtos[$i]["Id_Loja_Virtual"];

            ConfigWPKeys::getInstance()->put($url, $produto);
            $lastResponse = ConfigWPKeys::getInstance()->http->getResponse();
            $produtoVirtual = json_decode($lastResponse->getBody());

            if(isset($produtoVirtual->id)) {
                $qtdProdutosImportados++;
            }
        }

        echo $qtdProdutosImportados > 0 ? "Produtos atualizados com sucesso </br>" : "Nenhum produto foi atualizado </br>";
        
    }
    
    
    public function selectTodosProdutosWP() {
        try {
            // Array of response results.
            $results = ConfigWPKeys::getInstance()->get('products');
            // Example: ['customers' => [[ 'id' => 8, 'created_at' => '2015-05-06T17:43:51Z', 'email' => ...
            echo '<pre><code>' . print_r($results, true) . '</code><pre>'; // JSON output.            
        } catch (HttpClientException $e) {
            echo '<pre><code>' . print_r($e->getMessage(), true) . '</code><pre>'; // Error message.
            echo '<pre><code>' . print_r($e->getRequest(), true) . '</code><pre>'; // Last request data.
            echo '<pre><code>' . print_r($e->getResponse(), true) . '</code><pre>'; // Last response data.
        }
    }
    
    private function limpaString($text) {
        $text = mb_convert_encoding($text, "UTF-8", "latin1");
        return $text;
    }
    
    public function insertProdutoWP() {
        // error_reporting(E_ALL);
        // ini_set('display_errors', 'On');
        Conn::getInstance()->set_charset("utf8mb4");
        $this->updateProdutoCategoria("0", "15");
        $configCategoria = Conn::getInstance()->query("SELECT Categoria_Loja_Virtual FROM opcao");
        $configCategoria = mysqli_fetch_assoc($configCategoria)['Categoria_Loja_Virtual'];
        $configCategoria = $configCategoria == "Categoria" ? "=" : "!=";
        $buscaCategoriasGw = Conn::getInstance()->query("SELECT Id, Id_Loja_Virtual FROM categoria_produto WHERE Id_Pai $configCategoria 0");
        $configEstoque = Conn::getInstance()->query("SELECT Gerenciar_Estoque_Loja FROM opcao");
        $gerenciarEstoque = mysqli_fetch_assoc($configEstoque)['Gerenciar_Estoque_Loja'];

        while($categoria = mysqli_fetch_assoc($buscaCategoriasGw)) {
            $this->updateProdutoCategoria($categoria["Id"], $categoria["Id_Loja_Virtual"]);
        }
        
        $produtos = $this->selectProdutoQtd();
        $qtdProdutosImportados = 0;
        $idTermosVirtual = [];
        $atributosVirtuais = ConfigWPKeys::getInstance()->get("products/attributes");
        foreach ($atributosVirtuais as $indice => $valor) {
            $idTermosVirtual[$atributosVirtuais[$indice]->name] = $atributosVirtuais[$indice]->id;
        }
        $produtosCadastrados = [];
        
        for ($i = 0; $i < sizeof($produtos); $i++){
            $produtos[$i]['Descricao2'] = (!$produtos[$i]['Descricao2'] || empty($produtos[$i]['Descricao2'])) ? $produtos[$i]['Titulo'] : $produtos[$i]['Descricao2'];
            $produtos[$i]["Codigo"] = str_replace("-", "", $produtos[$i]["Codigo"]);

            if($produtos[$i]['Flag_Kit'] == 'S' && $produtos[$i]["Preco"] == 0) {
                $totalKit = 0;
                $produtosKit = Conn::getInstance()->query("SELECT produto_kit.Qtd, produto_kit.Desconto, produto.Preco1 FROM produto_kit
                LEFT JOIN (SELECT Id, Preco1 FROM produto) produto ON produto.Id = produto_kit.Id_Produto_Kit WHERE produto_kit.Id_Produto = '{$produtos[$i]['Id']}'");
                while($kit = mysqli_fetch_assoc($produtosKit)) {
                    if($kit['Desconto'] > 0) {
                        $descontoPrecoKit = (($kit['Qtd'] * $kit['Preco1']) * $kit['Desconto']) / 100;
                        $totalKit += ($kit['Qtd'] * $kit['Preco1']) - $descontoPrecoKit;
                    }
                    else {
                        $totalKit += $kit['Preco1'];
                    }
                    $totalKit = str_replace(['.', ','], ['', '.'], $totalKit);
                }
                $produtos[$i]['Preco'] = $totalKit;
            }
            $corProduto = explode(",", $produtos[$i]['Grade_Cor']);
            for($cor=0; $cor < sizeof($corProduto); $cor++) {
                if($cor == 0 && empty(trim($corProduto[$cor]))) {
                    $corProduto = [];
                    break;
                }
                $corProduto[$cor] = ucfirst(mb_strtolower(trim($corProduto[$cor])));
            }

            $tamanhoProduto = explode(",", $produtos[$i]['Grade_Tamanho']);
            for($tamanhoPrdt=0; $tamanhoPrdt < sizeof($tamanhoProduto); $tamanhoPrdt++) {
                if($tamanhoPrdt == 0 && empty(trim($tamanhoProduto[$tamanhoPrdt]))) {
                    $tamanhoProduto = [];
                    break;
                }
                $tamanhoProduto[$tamanhoPrdt] = ucfirst(mb_strtolower(trim($tamanhoProduto[$tamanhoPrdt])));
            }

            $generoProduto = explode(",", $produtos[$i]['Grade_Genero']);
            for($generoPrdt=0; $generoPrdt < sizeof($generoProduto); $generoPrdt++) {
                if($generoPrdt == 0 && empty(trim($generoProduto[$generoPrdt]))) {
                    $generoProduto = [];
                    break;
                }
                $generoProduto[$generoPrdt] = ucfirst(mb_strtolower(trim($generoProduto[$generoPrdt])));
            }

            $especificacaoProduto = explode(",", $produtos[$i]['Grade_Especificacao']);
            for($especificacaoPrdt=0; $especificacaoPrdt < sizeof($especificacaoProduto); $especificacaoPrdt++) {
                if($especificacaoPrdt == 0 && empty(trim($especificacaoProduto[$especificacaoPrdt]))) {
                    $especificacaoProduto = [];
                    break;
                }
                $especificacaoProduto[$especificacaoPrdt] = ucfirst(mb_strtolower(trim($especificacaoProduto[$especificacaoPrdt])));
            }

            if(!isset($produtosCadastrados[$produtos[$i]['Id']]) && $produtos[$i]['Id_Produto_Pai'] == "") {
                $produto = [
                    "name" =>  ucfirst(mb_strtolower($produtos[$i]['Titulo'])),
                    "type" => !empty($produtos[$i]['Grade_Cor']) || !empty($produtos[$i]['Grade_Tamanho']) ||
                        !empty($produtos[$i]['Grade_Genero']) || !empty($produtos[$i]['Grade_Especificacao']) ? "variable" : "simple",
                    "regular_price" => $produtos[$i]['Preco'],
                    "description" =>  ucfirst(mb_strtolower($produtos[$i]['Descricao2'])),
                    "short_description" =>  ucfirst(mb_strtolower($produtos[$i]['Descricao2'])),
                    'manage_stock'=> $gerenciarEstoque == "Sim",
                    "sale_price" => $produtos[$i]['Preco_Promocional_Loja'] > 0 ? $produtos[$i]['Preco_Promocional_Loja'] : "",
                    "categories" => [
                        ["id" => intval($produtos[$i]["Id_Categoria_Produto"])],
                        ["id" => intval($produtos[$i]["Id_Categoria_Produto"])]
                    ],
                    "images" => [
                        ["src" => $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"], $produtos[$i]["Id"])],
                    ],
                    "attributes"=> [],
                    // "default_attributes"=>[]
                ];

                if(!empty($produtos[$i]["Foto2"])) {
                    array_push($produto['images'], [
                        "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-2', $produtos[$i]["Id"])
                    ]);
                }

                if(!empty($produtos[$i]["Foto3"])) {
                    array_push($produto['images'], [
                        "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-3', $produtos[$i]["Id"])
                    ]);
                }

                if(!empty($produtos[$i]["Foto4"])) {
                    array_push($produto['images'], [
                        "src"=> $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"].'-4', $produtos[$i]["Id"])
                    ]);
                }

                if($gerenciarEstoque == "Sim") {
                    $produto['stock_quantity'] = empty($produtos[$i]['Qtd']) || $produtos[$i]['Qtd'] < 1  ? 0 : $produtos[$i]['Qtd'];
                }
                else {
                    $produto["stock_status"] = "instock";
                    $produto["in_stock"] = true;
                }
    
                $produto["date_on_sale_from"] = $produtos[$i]['Inicio_Promocao_Loja'] && $produtos[$i]['Inicio_Promocao_Loja'] != "0000-00-00" ? 
                $produtos[$i]['Inicio_Promocao_Loja'] : "";
                $produto["date_on_sale_to"] = $produtos[$i]['Fim_Promocao_Loja'] && $produtos[$i]['Fim_Promocao_Loja'] != "0000-00-00" ? 
                $produtos[$i]['Fim_Promocao_Loja'] : "";

                if(isset($idTermosVirtual['Cor']) && sizeof($corProduto) > 0) {
                    array_push($produto['attributes'], [
                        "id"=> $idTermosVirtual['Cor'],
                        "name"=> "Cor",
                        "position"=> 1,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $corProduto
                    ]);
                }
                
                if(isset($idTermosVirtual['Tamanho']) && sizeof($tamanhoProduto) > 0) {
                    array_push($produto['attributes'], [
                        "id"=> $idTermosVirtual['Tamanho'],
                        "name"=> "Tamanho",
                        "position"=> 2,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $tamanhoProduto
                    ]);
                }

                if(isset($idTermosVirtual['Tipo']) && sizeof($generoProduto) > 0) {
                    array_push($produto['attributes'], [
                        "id"=> $idTermosVirtual['Tipo'],
                        "name"=> "Tipo",
                        "position"=> 3,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $generoProduto
                    ]);
                }

                if(isset($idTermosVirtual['Especificacao']) && sizeof($especificacaoProduto) > 0) {
                    array_push($produto['attributes'], [
                        "id"=> $idTermosVirtual['Especificacao'],
                        "name"=> "Especificacao",
                        "position"=> 4,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $especificacaoProduto
                    ]);
                }

                ConfigWPKeys::getInstance()->post('products', $produto);
                $lastResponse = ConfigWPKeys::getInstance()->http->getResponse();
                $produtoVirtual = json_decode($lastResponse->getBody());
                
                $produtosCadastrados[$produtos[$i]['Id']] = [
                    "id"=> $produtoVirtual->id,
                    "attributes"=> $produtoVirtual->attributes,
                    "variations"=> $produtoVirtual->variations
                ];

                $this->inserirId($produtosCadastrados[$produtos[$i]['Id']]['id'], $produtos[$i]["Id"]);
                $qtdProdutosImportados++;
            }
            else {
                if(!isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['id'])) {
                    $idVirtualProdutoPai = $this->buscaIdVirtualProdutoPai($produtos[$i]['Id_Produto_Pai']);
                    $produtoPaiVirtual = $this->buscaUnicoProdutoWp($idVirtualProdutoPai);
                    $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']] = [
                        "id"=> $idVirtualProdutoPai,
                        "attributes"=> $produtoPaiVirtual->attributes
                    ];

                    // Verifica se o produto filho possui alguma cor que no existe no produto pai
                    if(sizeof($corProduto) > 0 && sizeof($idTermosVirtual['Cor']) > 0) {
                        if(!isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0])) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0] = (object) [
                                "id"=> $idTermosVirtual['Cor'],
                                "name"=> "Cor",
                                "position"=> 1,
                                "visible"=> true,
                                "variation"=> true
                            ];
                        }
    
                        if(isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0]->options)) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0]->options = array_merge(
                                $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0]->options,
                                $corProduto
                            );
                        }
                        else {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][0]->options = $corProduto;
                        }
                    }

                    // Verifica se o produto filho possui algum tamanho que no existe no produto pai
                    if(sizeof($tamanhoProduto) > 0 && isset($idTermosVirtual['Tamanho'])) {
                        if(!isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1])) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1] = (object) [
                                "id"=> $idTermosVirtual['Tamanho'],
                                "name"=> "Tamanho",
                                "position"=> 2,
                                "visible"=> true,
                                "variation"=> true
                            ];
                        }
    
                        if(isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1]->options)) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1]->options = array_merge(
                                $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1]->options,
                                $tamanhoProduto
                            );
                        }
                        else {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][1]->options = $tamanhoProduto;
                        }
                    }

                    // Verifica se o produto filho possui algum genero que no existe no produto pai
                    if(sizeof($generoProduto) > 0 && isset($idTermosVirtual['Tipo'])) {
                        if(!isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2])) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2] = (object) [
                                "id"=> $idTermosVirtual['Tipo'],
                                "name"=> "Tipo",
                                "position"=> 3,
                                "visible"=> true,
                                "variation"=> true
                            ];
                        }
    
                        if(isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2]->options)) {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2]->options = array_merge(
                                $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2]->options,
                                $generoProduto
                            );
                        }
                        else {
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][2]->options = $generoProduto;
                        }
                    }
                }
                // Verifica se o produto filho possui alguma especificao que no existe no produto pai
                if(sizeof($especificacaoProduto) > 0 && isset($idTermosVirtual['Especificacao'])) {
                    if(!isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3])) {
                        $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3] = (object) [
                            "id"=> $idTermosVirtual['Especificacao'],
                            "name"=> "Especificacao",
                            "position"=> 4,
                            "visible"=> true,
                            "variation"=> true
                        ];
                    }

                    if(isset($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3]->options)) {
                        $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3]->options = array_merge(
                            $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3]->options,
                            $especificacaoProduto
                        );
                    }
                    else {
                        $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes'][3]->options = $especificacaoProduto;
                    }
                    ConfigWPKeys::getInstance()->put("products/".$produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['id'], [
                        "attributes"=> $produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['attributes']
                    ]);
                }

                $variacoesProdutos = [];
    
                //Cria variaes dos tamanhos
                if(sizeof($tamanhoProduto) > 0 && isset($idTermosVirtual['Tamanho'])) {
                    for($tamanhoProdutoAtual = 0; $tamanhoProdutoAtual < sizeof($tamanhoProduto); $tamanhoProdutoAtual++) {
                        array_push($variacoesProdutos,
                            [
                                'id' => $idTermosVirtual['Tamanho'],
                                'option' => "$tamanhoProduto[$tamanhoProdutoAtual]"
                            ]
                        );
                    }
                }
    
                //Cria variaes dos tipos
                if(sizeof($generoProduto) > 0 && isset($idTermosVirtual['Tipo'])) {
                    for($generoProdutoAtual = 0; $generoProdutoAtual < sizeof($generoProduto); $generoProdutoAtual++) {
                        array_push($variacoesProdutos,
                            [
                                'id' => $idTermosVirtual['Tipo'],
                                'option' => "$generoProduto[$generoProdutoAtual]"
                            ]
                        );
                    }
                }

                //Cria variaes das especificaes
                if(sizeof($especificacaoProduto) > 0 && isset($idTermosVirtual['Especificacao'])) {
                    for($especificacaoProdutoAtual = 0; $especificacaoProdutoAtual < sizeof($especificacaoProduto); $especificacaoProdutoAtual++) {
                        array_push($variacoesProdutos,
                            [
                                'id' => $idTermosVirtual['Especificacao'],
                                'option' => "$especificacaoProduto[$especificacaoProdutoAtual]"
                            ]
                        );
                    }
                }
    
                //Cria variaes das cores
                for($corAtual = 0; $corAtual < sizeof($corProduto); $corAtual++) {
                    array_push($variacoesProdutos, 
                        [
                            'id' => $idTermosVirtual['Cor'],
                            'option' => "$corProduto[$corAtual]"
                        ]
                    );
    
                    $criarVariacaoProduto = $this->criarVariacaoProduto($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['id'], [
                        'regular_price' => $produtos[$i]['Preco'],
                        'image' => [
                            'src' => $this->montaImagemUrl($produtos[$i]["Caminho_Foto"], $produtos[$i]["Codigo"], $produtos[$i]["Id"])
                        ],
                        'attributes' => $variacoesProdutos,
                        'manage_stock'=> true,
                        'stock_quantity'=>  $produtos[$i]['Qtd'] ?? 0,
                    ]);
                    
                    if($criarVariacaoProduto->id) {
                        array_push($produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['variations'], $criarVariacaoProduto->id);
                        Conn::getInstance()->query("UPDATE produto SET Id_Loja_Virtual='$criarVariacaoProduto->id',
                        Id_Produto_Pai_Virtual='".$produtosCadastrados[$produtos[$i]['Id_Produto_Pai']]['id']."' WHERE Id='".$produtos[$i]["Id"]."'");
                        
                        $qtdProdutosImportados++;
                    }
                }
            }
        }

        echo $qtdProdutosImportados > 0 ? "Produtos importados com sucesso </br>" : "Nenhum produto foi importado </br>";
    }
    
    private function inserirId($idWP, $idGW){
        
        $sql = "UPDATE produto SET Id_Loja_Virtual = ? "//id wordpress
                . "WHERE Id = ?";//id gw
        return Conn::executaQueryUpdate($sql, strval($idWP), strval($idGW));
    }
    
    private function selectProdutoPontti(){
        $config = Conn::getInstance()->query("SELECT Categoria_Loja_Virtual, Id_Tabela_Preco_Loja FROM opcao");
        $config = mysqli_fetch_assoc($config);
        $idTabelaPreco = Conn::getInstance()->query("SELECT Valor FROM produto_tabela WHERE Id='".$config['Id_Tabela_Preco_Loja']."'");
        $tabelaPreco = mysqli_fetch_assoc($idTabelaPreco)['Valor'];
        $tabelaPreco = intval($tabelaPreco);
        $configCategoria = $config['Categoria_Loja_Virtual'];
        $colunaCategoria = $configCategoria == "Categoria" ? "Id_Categoria_Produto" : "Id_Categoria_Produto_Filho";
        $sql = "SELECT Id, Titulo, Caracteristica as Descricao2, Preco$tabelaPreco Preco, Descricao, Id_Categoria_Loja_Virtual AS Id_Categoria_Produto, Codigo,
        Caminho_Foto, Grade_Cor, Grade_Tamanho, Grade_Genero, Grade_Especificacao, Id_Produto_Pai, Preco_Promocional_Loja, Inicio_Promocao_Loja,
        Fim_Promocao_Loja, Foto2, Foto3, Foto4, Flag_Kit FROM produto WHERE (Id_Loja_Virtual IS NULL OR Id_Loja_Virtual = '') AND Site='Sim' AND Ativo='Sim' AND 
        (produto.$colunaCategoria = 0 OR (SELECT COUNT(c.Id) FROM categoria_produto c WHERE c.Id=produto.$colunaCategoria 
        AND c.Ativo='Sim' AND c.Site='Sim') > 0) ORDER BY Id_Produto_Pai, Data_Cadastro ASC";

        return Conn::executaQuerySelect($sql);
    }
    
    public function selectProdutoQtd($update = false) {
        $listaProdutos = $this->selectProdutoPontti();
        $listaComQtd = array();
        foreach ($listaProdutos as $produto){
            $sql = "SELECT SUM(estoque.Qtd) Qtd FROM produto LEFT JOIN estoque ON estoque.Id_Produto = produto.Id WHERE 
            estoque.Concluido='Sim' AND estoque.Id_Unidade=(SELECT Id FROM unidade WHERE Sede='Matriz') AND produto.Id ='".$produto['Id']."'";
            $estoqueProduto = Conn::getInstance()->query($sql);
            $produto['Qtd'] = intval(mysqli_fetch_assoc($estoqueProduto)["Qtd"]);
            array_push($listaComQtd, $produto);
        }
        
        return $listaComQtd;
    }
    
    public function montaImagemUrl($caminhoFoto, $codigoProduto, $idProduto) {
        stream_context_set_default( [
            'ssl' => [
                'verify_peer' => false,
                'verify_peer_name' => false,
            ],
        ]);
        // $codigoProduto =  str_replace('-', '', $codigoProduto);
        $codigoProduto =  str_replace(['.', ','], '', $codigoProduto);
        if(!empty($caminhoFoto)){
            $url = "https://$caminhoFoto/produto/fotos/$codigoProduto/original/$idProduto.png";
        }
        else{
            return "https://$caminhoFoto/woocommerce/assets/img/produto-sem-imagem.jpg";
        }
        
        $urlValida = get_headers($url);
        if($urlValida[0] == "HTTP/1.1 200 OK" || $urlValida[0] == "HTTP/1.0 200 OK"){
            return $url;
        }
        $url = "https://".$caminhoFoto."/produto/fotos/".$codigoProduto."/original/".$idProduto.".jpg";
        $urlValida = get_headers($url);
        
        if($urlValida[0] == "HTTP/1.1 200 OK" || $urlValida[0] == "HTTP/1.0 200 OK"){
            return $url;
        }
        else{
            $url = "https://".$caminhoFoto."/produto/fotos/".$codigoProduto."/original/".$idProduto.".jpeg";
        }
        $urlValida = get_headers($url);
        if($urlValida[0] == "HTTP/1.1 200 OK" || $urlValida[0] == "HTTP/1.0 200 OK"){
            return $url;
        }
        else{
            return "https://$caminhoFoto/woocommerce/assets/img/produto-sem-imagem.jpg";
        }
    }
    
    public function updateProdutoCategoria($idCategoria, $idLojaVirtual){
        $configCategoria = Conn::getInstance()->query("SELECT Categoria_Loja_Virtual FROM opcao");
        $configCategoria = mysqli_fetch_assoc($configCategoria)['Categoria_Loja_Virtual'];
        $colunaCategoria = $configCategoria == "Categoria" ? "Id_Categoria_Produto" : "Id_Categoria_Produto_Filho";
        $sql = "UPDATE produto SET Id_Categoria_Loja_Virtual = ? WHERE $colunaCategoria = ?";

        if($idLojaVirtual == null || empty($idLojaVirtual )){
            $idLojaVirtual = "15"; //ID de Sem categoria woocommerce
        }
        Conn::executaQueryUpdate($sql, $idLojaVirtual, $idCategoria);
    }

    public function criarAtributo($tipoAtributo) {
        $data = [
            'name' => "$tipoAtributo",
            'slug' => "pa_$tipoAtributo",
            'type' => 'select',
            'order_by' => 'menu_order',
            'has_archives' => true
        ];
        $cadastrarAtributo = ConfigWPKeys::getInstance()->post("products/attributes", $data);
        return isset($cadastrarAtributo->id) ? true : false;
    }

    public function buscaUnicoProdutoWp($idProdutoWp) {
        return ConfigWPKeys::getInstance()->get("products/$idProdutoWp");
    }

    public function criarVariacaoProduto($idProdutoLojaVirtual, $data) {
        return ConfigWPKeys::getInstance()->post("products/$idProdutoLojaVirtual/variations", $data);
    }

    public function criarTermoAtributo($valor, $idTermo) {
        $data = [
            'name'=> $valor
        ];
        return ConfigWPKeys::getInstance()->post("products/attributes/$idTermo/terms", $data);
    }
    
    public function buscaTermosAtributo($idAtributo) {
        $paginaAtributo = 1;
        $termos = [];
        do {
            $request = ConfigWPKeys::getInstance()->get("products/attributes/$idAtributo/terms?per_page=100&page=$paginaAtributo");
            for ($i=0; $i < sizeof($request); $i++) { 
                array_push($termos, $request[$i]->name);
            }
            $paginaAtributo++;
        } while (!empty($request));
        return $termos;
    }

    public function exportarTodosAtributos() {
        $conexao = Conn::getInstance();
        $conexao->set_charset("utf8mb4");
        $idTermosVirtual = [];
        $atributosVirtuais = ConfigWPKeys::getInstance()->get("products/attributes");
        foreach ($atributosVirtuais as $indice => $valor) {
            $idTermosVirtual[$atributosVirtuais[$indice]->name]['id'] = $atributosVirtuais[$indice]->id;
            $idTermosVirtual[$atributosVirtuais[$indice]->name]['termos'] = $this->buscaTermosAtributo($atributosVirtuais[$indice]->id);
        }

        $sql = "SELECT Id, Titulo, Tipo FROM produto_tamanho WHERE Id_Atributo_Loja_Virtual IS NULL OR Id_Atributo_Loja_Virtual = 0";
        $buscaEspecificacoes = $conexao->query($sql);
        $qtdTermosImportados = 0;

        while($especificacao = mysqli_fetch_assoc($buscaEspecificacoes)) {
            $especificacao['Tipo'] = ($especificacao['Tipo'] == "Numero" || $especificacao['Tipo'] == "Letra") ? "Tamanho" : $especificacao['Tipo']; 
            $idAtributo = $idTermosVirtual[$especificacao['Tipo']]['id'];
            if(in_array(ucfirst(mb_strtolower($especificacao['Titulo'])), $idTermosVirtual[$especificacao['Tipo']]["termos"])) {
                $idTermo = $especificacao['Id'];
                $conexao->query("UPDATE produto_tamanho SET Id_Atributo_Loja_Virtual='$idAtributo' WHERE Id='$idTermo'");
            }
            else {
                $titulo = (strlen($especificacao['Titulo']) <= 2) ? strtoupper($especificacao['Titulo']) : ucfirst(mb_strtolower($especificacao['Titulo']));
                $idEspecificacao = $especificacao['Id'];
                $criaAtributo = $this->criarTermoAtributo($titulo, $idAtributo);
                if(isset($criaAtributo->id)) {
                    $qtdTermosImportados++;
                    $conexao->query("UPDATE produto_tamanho SET Id_Atributo_Loja_Virtual='$idAtributo' WHERE Id='$idEspecificacao'");
                    array_push($idTermosVirtual[$especificacao['Tipo']]['termos'], ucfirst(mb_strtolower($especificacao['Titulo']))); 
                }
            }
        }

        echo ($qtdTermosImportados > 0) ? "Cores importadas com sucesso </br>" : "Nenhuma cor foi importada </br>";
    }

    public function exportarTodosTamanhos() {
        $conexao = Conn::getInstance();
        $buscaTiposEspecificacoes = $conexao->query("SELECT DISTINCT Tipo FROM produto_tamanho WHERE Id_Atributo_Loja_Virtual IS NULL OR
        Id_Atributo_Loja_Virtual = ''");
        $qtdEspecificacoesCad = 0;

        while($tipoEspecificacao = mysqli_fetch_assoc($buscaTiposEspecificacoes)) {
            $tipo = ucfirst(strtolower($tipoEspecificacao['Tipo']));
            $tipo = ($tipo == "Numero" || $tipo == "Letra") ? "Tamanho" : $tipo;
            $especificacaoCadastrada = false;
            $buscaEspecificacao = ConfigWPKeys::getInstance()->get("products/attributes");
            
            for ($i=0; $i < sizeof($buscaEspecificacao); $i++) { 
                if($buscaEspecificacao[$i]->name == $tipo) {
                    $especificacaoCadastrada = true;
                }
            }

            if(!$especificacaoCadastrada) {
                $criarEspecificacao = $this->criarAtributo($tipo);
                if($criarEspecificacao) {
                    $qtdEspecificacoesCad++;
                }
            }
        }

        echo $qtdEspecificacoesCad > 0 ? "Tamanhos importados com sucesso </br>" : "Nenhum tamanho foi importado </br>";
    }

    public function buscaIdVirtualProdutoPai($idProdutoPai) {
        $conexao = Conn::getInstance();
        $getId = $conexao->query("SELECT Id_Loja_Virtual FROM produto WHERE Id='$idProdutoPai'");
        return mysqli_fetch_assoc($getId)['Id_Loja_Virtual'];
    }

    public static function inativarProdutoLoja($idInternoProduto) {
        $conexao = Conn::getInstance();
        $idProduto = $conexao->query("SELECT Id_Loja_Virtual FROM produto WHERE Id='$idInternoProduto' AND Id_Loja_Virtual IS NOT NULL 
        AND Id_Loja_Virtual !=''");
        if($idProduto->num_rows > 0) {
            $idProduto = mysqli_fetch_assoc($idProduto)['Id_Loja_Virtual'];
            ConfigWPKeys::getInstance()->put("products/$idProduto", [
                "status"=> "pending"
            ]);
        }
    }

    public static function ativarProdutoLoja($idInternoProduto) {
        $conexao = Conn::getInstance();
        $idProduto = $conexao->query("SELECT Id_Loja_Virtual FROM produto WHERE Id='$idInternoProduto' AND Id_Loja_Virtual IS NOT NULL 
        AND Id_Loja_Virtual !=''");
        if($idProduto->num_rows > 0) {
            $idProduto = mysqli_fetch_assoc($idProduto)['Id_Loja_Virtual'];
            ConfigWPKeys::getInstance()->put("products/$idProduto", [
                "status"=> "publish"
            ]);
        }
    }

    /**
     *
     * @param string $idProduto id interno
     * @return bool
     */
    public function atualizar($idProduto) {
        Conn::getInstance()->set_charset("utf8mb4");
        $config = Conn::getInstance()->query("SELECT Categoria_Loja_Virtual, Id_Tabela_Preco_Loja FROM opcao");
        $config = mysqli_fetch_assoc($config);
        $idTabelaPreco = Conn::getInstance()->query("SELECT Valor FROM produto_tabela WHERE Id='".$config['Id_Tabela_Preco_Loja']."'");
        $tabelaPreco = mysqli_fetch_assoc($idTabelaPreco)['Valor'];
        $tabelaPreco = intval($tabelaPreco);
        $sql = "SELECT produto.Id, produto.Titulo, produto.Caracteristica as Descricao2, produto.Preco$tabelaPreco Preco, produto.Descricao,
        produto.Id_Categoria_Loja_Virtual AS Id_Categoria_Produto, produto.Codigo, produto.Caminho_Foto, produto.Id_Loja_Virtual, produto.Grade_Cor,
        produto.Grade_Tamanho, produto.Grade_Genero, produto.Grade_Especificacao, produto.Id_Produto_Pai_Virtual, produto.Preco_Promocional_Loja,
        produto.Inicio_Promocao_Loja, produto.Fim_Promocao_Loja, produto.Foto2, produto.Foto3, produto.Foto4, produto.Flag_Kit,
        (SELECT SUM(Qtd) FROM estoque WHERE Concluido='Sim' AND Id_Unidade=(SELECT Id FROM unidade WHERE Sede='Matriz') AND Id_Produto = produto.Id) Qtd FROM produto
        WHERE produto.Site='Sim' AND produto.Ativo='Sim' AND produto.Id='$idProduto'";
        $produtoInterno = Conn::getInstance()->query($sql);
        $produtoInterno = mysqli_fetch_assoc($produtoInterno);

        if($produtoInterno['Flag_Kit'] == 'S' && $produtoInterno["Preco"] == 0) {
            $totalKit = 0;
            $produtosKit = Conn::getInstance()->query("SELECT produto_kit.Qtd, produto_kit.Desconto, produto.Preco1 FROM produto_kit
            LEFT JOIN (SELECT Id, Preco1 FROM produto) produto ON produto.Id = produto_kit.Id_Produto_Kit WHERE produto_kit.Id_Produto = '{$produtoInterno['Id']}'");
            while($kit = mysqli_fetch_assoc($produtosKit)) {
                if($kit['Desconto'] > 0) {
                    $descontoPrecoKit = (($kit['Qtd'] * $kit['Preco1']) * $kit['Desconto']) / 100;
                    $totalKit += ($kit['Qtd'] * $kit['Preco1']) - $descontoPrecoKit;
                }
                else {
                    $totalKit += ($kit['Qtd'] * $kit['Preco1']);
                }
            }
            $totalKit = str_replace(['.', ','], ['', '.'], $totalKit);
            $produtoInterno['Preco'] = $totalKit;
        }
        
        $configEstoque = Conn::getInstance()->query("SELECT Gerenciar_Estoque_Loja FROM opcao");
        $gerenciarEstoque = mysqli_fetch_assoc($configEstoque)['Gerenciar_Estoque_Loja'];
        $idTermosVirtual = [];
        $atributosVirtuais = ConfigWPKeys::getInstance()->get("products/attributes");
        foreach ($atributosVirtuais as $indice => $valor) {
            $idTermosVirtual[$atributosVirtuais[$indice]->name] = $atributosVirtuais[$indice]->id;
        }

        $produtoInterno['Descricao2'] = (!$produtoInterno['Descricao2'] || empty($produtoInterno['Descricao2'])) ? $produtoInterno['Titulo'] : $produtoInterno['Descricao2'];

        $corProduto = explode(",", $produtoInterno['Grade_Cor']);
        for($cor=0; $cor < sizeof($corProduto); $cor++) {
            if($cor == 0 && empty(trim($corProduto[$cor]))) {
                $corProduto = [];
                break;
            }
            $corProduto[$cor] = ucfirst(mb_strtolower(trim($corProduto[$cor])));
        }

        $tamanhoProduto = explode(",", $produtoInterno['Grade_Tamanho']);
        for($tamanhoPrdt=0; $tamanhoPrdt < sizeof($tamanhoProduto); $tamanhoPrdt++) {
            if($tamanhoPrdt == 0 && empty(trim($tamanhoProduto[$tamanhoPrdt]))) {
                $tamanhoProduto = [];
                break;
            }
            $tamanhoProduto[$tamanhoPrdt] = ucfirst(mb_strtolower(trim($tamanhoProduto[$tamanhoPrdt])));
        }

        $generoProduto = explode(",", $produtoInterno['Grade_Genero']);
        for($generoPrdt=0; $generoPrdt < sizeof($generoProduto); $generoPrdt++) {
            if($generoPrdt == 0 && empty(trim($generoProduto[$generoPrdt]))) {
                $generoProduto = [];
                break;
            }
            $generoProduto[$generoPrdt] = ucfirst(mb_strtolower(trim($generoProduto[$generoPrdt])));
        }

        $especificacaoProduto = explode(",", $produtoInterno['Grade_Especificacao']);
        for($especificacaoPrdt=0; $especificacaoPrdt < sizeof($especificacaoProduto); $especificacaoPrdt++) {
            if($especificacaoPrdt == 0 && empty(trim($especificacaoProduto[$especificacaoPrdt]))) {
                $especificacaoProduto = [];
                break;
            }
            $especificacaoProduto[$especificacaoPrdt] = ucfirst(mb_strtolower(trim($especificacaoProduto[$especificacaoPrdt])));
        }

        $produto = [
            "name" =>  ucfirst(mb_strtolower($produtoInterno['Titulo'])),
            "type" => ($produtoInterno["Id_Produto_Pai_Virtual"] == "" || !$produtoInterno["Id_Produto_Pai_Virtual"]) && (!empty($produtoInterno['Grade_Cor']) || 
            !empty($produtoInterno['Grade_Tamanho']) || !empty($produtoInterno['Grade_Genero']) || !empty($produtoInterno['Grade_Especificacao'])) ? "variable" : "simple",
            "regular_price" => $produtoInterno['Preco'],
            "description" =>  ucfirst(mb_strtolower($produtoInterno['Descricao2'])),
            "short_description" =>  ucfirst(mb_strtolower($produtoInterno['Descricao2'])),
            'manage_stock'=> $gerenciarEstoque == "Sim",
            "sale_price" => $produtoInterno['Preco_Promocional_Loja'] > 0 ? $produtoInterno['Preco_Promocional_Loja'] : "",
            "categories" => [
                ["id" => intval($produtoInterno["Id_Categoria_Produto"])]
            ],
        ];

        if($gerenciarEstoque == "Sim") {
            $produto['stock_quantity'] = empty($produtoInterno['Qtd']) || $produtoInterno['Qtd'] < 1  ? 0 : $produtoInterno['Qtd'];
        }
        else {
            $produto["stock_status"] = "instock";
            $produto["in_stock"] = true;
        }

        $produto["date_on_sale_from"] = $produtoInterno['Inicio_Promocao_Loja'] && $produtoInterno['Inicio_Promocao_Loja'] != "0000-00-00" ? 
        $produtoInterno['Inicio_Promocao_Loja'] : "";
        $produto["date_on_sale_to"] = $produtoInterno['Fim_Promocao_Loja'] && $produtoInterno['Fim_Promocao_Loja'] != "0000-00-00" ? 
        $produtoInterno['Fim_Promocao_Loja'] : "";
        
        if(!$produtoInterno["Id_Produto_Pai_Virtual"] || $produtoInterno["Id_Produto_Pai_Virtual"] == '') {
            $produto['images'] = [
                ["src" => 
                    $this->montaImagemUrl($produtoInterno["Caminho_Foto"], $produtoInterno["Codigo"], $produtoInterno["Id"])
                ]
            ];
            if(!empty($produtoInterno["Foto2"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtoInterno["Caminho_Foto"], $produtoInterno["Codigo"].'-2', $produtoInterno["Id"])
                ]);
            }

            if(!empty($produtoInterno["Foto3"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtoInterno["Caminho_Foto"], $produtoInterno["Codigo"].'-3', $produtoInterno["Id"])
                ]);
            }

            if(!empty($produtoInterno["Foto4"])) {
                array_push($produto['images'], [
                    "src"=> $this->montaImagemUrl($produtoInterno["Caminho_Foto"], $produtoInterno["Codigo"].'-4', $produtoInterno["Id"])
                ]);
            }

            $produto['attributes'] = [];
            if($idTermosVirtual['Cor'] && $corProduto[0] != '') {
                array_push($produto['attributes'],
                    [
                        "id"=> $idTermosVirtual['Cor'],
                        "name"=> "Cor",
                        "position"=> 1,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $corProduto
                    ]
                );
            }

            if($idTermosVirtual['Tamanho'] && $tamanhoProduto[0] != '') {
                array_push($produto['attributes'], 
                    [
                    "id"=> $idTermosVirtual['Tamanho'],
                    "name"=> "Tamanho",
                    "position"=> 2,
                    "visible"=> true,
                    "variation"=> true,
                    "options"=> $tamanhoProduto
                    ]
                );
            }

            if($idTermosVirtual['Tipo'] && $generoProduto[0] != '') {
                array_push($produto['attributes'],
                    [
                        "id"=> $idTermosVirtual['Tipo'],
                        "name"=> "Tipo",
                        "position"=> 3,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $generoProduto
                    ]
                );
            }

            if($idTermosVirtual['Especificacao'] && $especificacaoProduto[0] != '') {
                array_push($produto['attributes'],
                    [
                        "id"=> $idTermosVirtual['Especificacao'],
                        "name"=> "Especificacao",
                        "position"=> 4,
                        "visible"=> true,
                        "variation"=> true,
                        "options"=> $especificacaoProduto
                    ]
                );
            }
            $produtoPai = $this->buscaUnicoProdutoWp($produtoInterno["Id_Loja_Virtual"]);
            $produtosAtualizados[$produtoInterno["Id_Loja_Virtual"]]['attributes'] = $produtoPai->attributes;
        }
        else {
            $produto['image']["src"] = $this->montaImagemUrl($produtoInterno["Caminho_Foto"], $produtoInterno["Codigo"], $produtoInterno["Id"]);
            if(sizeof($especificacaoProduto) > 0) {
                if(!isset($produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3])) {
                    $produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3] = (object) [
                        "id"=> $idTermosVirtual['Especificacao'],
                        "name"=> "Especificacao",
                        "position"=> 4,
                        "visible"=> true,
                        "variation"=> true
                    ];
                }

                if(isset($produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3]->options)) {
                    $produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3]->options = array_merge(
                        $produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3]->options,
                        $especificacaoProduto
                    );
                }
                else {
                    $produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes'][3]->options = $especificacaoProduto;
                }
                ConfigWPKeys::getInstance()->put("products/".$produtoInterno["Id_Produto_Pai_Virtual"], [
                    "attributes"=> $produtosAtualizados[$produtoInterno['Id_Produto_Pai_Virtual']]['attributes']
                ]);
            }

            if(!empty(trim($produtoInterno['Grade_Cor']))) {
                $produto['attributes'][0] = [
                    "id"=> $idTermosVirtual['Cor'],
                    "name"=> "Cor",
                    "option"=> $produtoInterno['Grade_Cor']
                ];
            }
            if(!empty(trim($produtoInterno['Grade_Tamanho']))) {
                $produto['attributes'][1] = [
                    "id"=> $idTermosVirtual['Tamanho'],
                    "name"=> "Tamanho",
                    "option"=> $produtoInterno['Grade_Tamanho']
                ];
            }
            if(!empty(trim($produtoInterno['Grade_Genero']))) {
                $produto['attributes'][2] = [
                    "id"=> $idTermosVirtual['Tipo'],
                    "name"=> "Tipo",
                    "option"=> $produtoInterno['Grade_Genero']
                ];
            }
            if(!empty(trim($produtoInterno['Grade_Especificacao']))) {
                $produto['attributes'][3] = [
                    "id"=> $idTermosVirtual['Especificacao'],
                    "name"=> "Especificacao",
                    "option"=> $produtoInterno['Grade_Especificacao']
                ];
            }
        }
        $url = $produtoInterno["Id_Produto_Pai_Virtual"] == "" ? 'products/'.$produtoInterno["Id_Loja_Virtual"] : 
        'products/'.$produtoInterno["Id_Produto_Pai_Virtual"]."/variations/".$produtoInterno["Id_Loja_Virtual"];

        ConfigWPKeys::getInstance()->put($url, $produto);
        $lastResponse = ConfigWPKeys::getInstance()->http->getResponse();
        $produtoVirtual = json_decode($lastResponse->getBody());

        return isset($produtoVirtual->id) ? true : false;
    }

    public static function atualizarEstoque(string $idProdutoGw) {
        Conn::getInstance()->set_charset("utf8mb4");
        $infoProduto = Conn::getInstance()->query("SELECT SUM(estoque.Qtd) Qtd_Estoque, produto.Id_Loja_Virtual, produto.Id_Produto_Pai_Virtual FROM estoque
            INNER JOIN produto ON produto.Id = estoque.Id_Produto 
            WHERE estoque.Id_Produto = '$idProdutoGw' AND estoque.Concluido = 'Sim'");
        $infoProduto = $infoProduto->fetch_assoc();
        $produto = [
            'stock_quantity' => empty($infoProduto['Qtd_Estoque']) || $infoProduto['Qtd_Estoque'] < 1  ? 0 : $infoProduto['Qtd_Estoque']
        ];

        $url = !$infoProduto['Id_Produto_Pai_Virtual'] ? "products/{$infoProduto['Id_Loja_Virtual']}" :
            "products/{$infoProduto['Id_Produto_Pai_Virtual']}/variations/{$infoProduto['Id_Loja_Virtual']}";
        ConfigWPKeys::getInstance()->put($url, $produto);
        $lastResponse = ConfigWPKeys::getInstance()->http->getResponse();
        $produtoVirtual = json_decode($lastResponse->getBody());

        return isset($produtoVirtual->id) ? true : false;
    }
}