<?php
namespace App\Controller\Rotas;
require "app/config/Rota.php";
require "app/config/ConfigWebhook.php";
use App\Config\Rota\Rota;
use App\Controller\Categoria\Categoria;
use App\Controller\Cliente\Cliente;
use App\Controller\Venda\Venda;
use App\Controller\Produto\Produto;
use App\Config\ConfigWebhook\ConfigWebhook;

class Rotas {
    public function __construct(){
    }

    public function renderizaHtml() {
        $rota = new Rota();
        
        switch($rota->getRota()) {
            case "categorias":
                include "app/view/categorias/index.php";
                break;
            case "categorias/importar":
                $categoria = new Categoria();
                $categoria->inserirCategoriaWP();   //chamada de importação
                break;
            case "produtos/categorias/atualizar":
                $categoria = new Categoria();
                $categoria->updateCategoriaProduto();   //chamada de importação
                break;
            case "produtos":
                include "app/view/produtos/index.php";
                break;
            case "produtos/importar":
                $produto = new Produto();
                $produto->insertProdutoWP();    //chamada de importação
            break;
            case "produtos/atualizar":
                $produto = new Produto();
                $produto->updateProduto();
                break;
            case "clientes":
                include "app/view/clientes/index.php";
                break;
            case "clientes/importar":
                $cliente = new Cliente();
                $cliente->insertClientesGW();   //insere os cliente, executar antes da inserção das vendas.
                break;
            case "clientes/importar/vendas":
                $cliente = new Cliente();
                $cliente->importaClientesCompras();
                break;
            case "vendas":
                include "app/view/vendas/index.php";
                break;
            case "vendas/importar":
                $venda = new Venda();
                $venda->impotarVendasGW();
                break;
            case "produtos/atributos":
                include "app/view/produtos/atributos/index.php";
                break;
            case "produtos/atributos/importar":
                $produto = new Produto();
                $produto->exportarTodosAtributos();
                break;
            case "produtos/tamanhos":
                include "app/view/produtos/tamanhos/index.php";
                break;
            case "produtos/tamanhos/importar":
                $produto = new Produto();
                $produto->exportarTodosTamanhos();
                break;
            case "configuracoes/webhooks/compras/atualizacoes":
                ConfigWebhook::webhookAtualizacoesCompra();
                break;
        }
    }
}
?>