<?php

namespace App\Model\Conn;
/**
 * Classe relativa a conexão com a base de dados.
 *
 * @author PonttiWEB
 */
include __DIR__."/../../../include/conecta.php";
use mysqli;
class Conn {
    
    private static $servername;
    private static $username ;
    private static $password;
    private static $dbName;
    public static $instance;
    
    
    private function __construct(){}
    
    /**
     * Método para o gerenciamento de parâmetros de acesso ao banco de dados.
     */
    private function setParam(){
        global $con;
        $getCon = $con->query("SELECT Site_Host, Site_User, Site_Pass, Site_Banco FROM opcao");
        $dadosConfig = mysqli_fetch_assoc($getCon);
        self::$servername = $dadosConfig['Site_Host'];
        self::$username = $dadosConfig['Site_User'];
        self::$password = $dadosConfig['Site_Pass'];
        self::$dbName = $dadosConfig['Site_Banco'];
        
    }

    /**
     * Método gera conexão caso não exista uma instâcia do contrário ele retorna
     * a instância da conexão (Singleton).
     * @return Conn
     */
    public function getInstance(){
        Conn::setParam();
        // Create connection
        if(!isset(self::$instance)){
            self::$instance = new mysqli(self::$servername, self::$username, 
                self::$password, self::$dbName);
        }else{
//            die("Conexão Ok");
            return self::$instance;
        }

        // Check connection
        if (self::$instance->connect_error) {
            die("Conexão Falhou: " . self::$instance->connect_error);
        }
//        die("Conexão Ok");
        return self::$instance;
    }
    
    function executaQuerySelect(String $sql){
        $resultArray = array();
        $result = Conn::getInstance()->query($sql);
        
        while($row = mysqli_fetch_assoc($result)) {
            array_push($resultArray, $row);
            //$resultArray += $row;
        }
        return $resultArray;
        
    }
    
    function executaQuerySelectParam(String $sql, String $id){
        $resultArray = array();
        $stmt = Conn::getInstance()->prepare($sql);
        $stmt->bind_param("s", $id);
        $stmt->execute();
        
        $result = $stmt->get_result();
        
        while($row = mysqli_fetch_assoc($result)) {
            array_push($resultArray, $row);
        }
//        $stmt->close();
        return $resultArray;  
    }
    
    function executaQueryUpdate(String $sql, String $param_1, String $param_2){
//    $resultArray = array();
        try{
        $stmt = Conn::getInstance()->prepare($sql);
        $stmt->bind_param("ss", $param_1, $param_2);
        
        $stmt->execute();
//        $stmt->close();        
        } catch (mysqli_sql_exception $e){
            echo $e;
        }
    }
    
    function executaQueryInsert($sql){
        try{
            Conn::getInstance()->prepare($sql);
            Conn::getInstance()->query($sql);
//            Conn::getInstance()->close();
        } catch (mysqli_sql_exception $e){
            echo $e;
        }
    }
}